var appModule = angular.module('starter', ['ionic', 'oc.lazyLoad', 'ngSet_focus', 'app_service', 'sv_district', 'ngChange_event', 'ngfavour', 'ngCordova', 'ionicLazyLoad', 'ngAttention', 'ngUserInfo', 'ngPublic'])
  .run(function($ionicPlatform, $http, $rootScope, $timeout, $ionicPopup, $ionicLoading, $cordovaAppVersion, $cordovaToast, $ionicHistory, $location, $timeout, $state, appService, $cordovaLocalNotification, $cordovaBadge, $interval, $window, $cordovaBrowser) {
    /* datas */
    $rootScope.newVersion;
    $rootScope.curVersion;
    var userInfo = $window.localStorage.getItem("userInfo"); //用户信息
    var user = userInfo && JSON.parse(userInfo);
    var noticeWebsocket/* , policyWebsocket, myMsgWebsocket */;
    $rootScope.notificationReminder = function(option, callback) {
      var id = id || 1;
      $cordovaLocalNotification.schedule(option);
      $cordovaLocalNotification.click(callback);
    }
    /*** 旧通知 websocket 8099
     * 无心跳
    */
    var creatNoticeWebsocket = function() {
      try {
        noticeWebsocket = new WebSocket(noticeSocketServer);
        noticeWebsocket.onerror = function() {
          console.log("连接发生错误")
        };
        noticeWebsocket.onopen = function(event) {
          console.log(event);
        }
        noticeWebsocket.onmessage = function(event) {
          $rootScope.notificationReminder({
            id: 2,
            title: '新消息提示',
            text: event.data,
            icon: $.pic + urlMap.defaultImg
          });
        }
        noticeWebsocket.onclose = function() {
          console.log('关闭消息websocket');
        }
      } catch (e) { console.log(e) }
    }
    var myMessageCountTimer;
    $rootScope.myMessageCountFn = function(newCount) {
      if (newCount > -1) {
        $rootScope.myMessageTotalCount = newCount;
        $window.cordova && $cordovaBadge.set(newCount);
        var userid = user && user.id;
        if (userid) {
          var lastMsgc = $window.localStorage.getItem('mymsgc' + userid);
          if (lastMsgc < newCount)
            $rootScope.notificationReminder({
              id: 3,
              title: '您有' + newCount + '条留言回复未查看',
              text: "点击进入知政app【个人中心】中查看。"
            }, function() {
              $state.go('myLeaveMsg')
            });
          $window.localStorage.setItem('mymsgc' + (user && user.id), newCount);
        }
      }
    }
    $rootScope.getMyMsgcount = function(userid) {
      $http.get(urlMap.appMsgCount + '?userId=' + userid, {
        cache: false
      }).then(function(data) {
        var mcount = data.data && data.data[0];
        $rootScope.myMessageCountFn(mcount);
        console.log('用户消息数:' + mcount);
      }, function() { });
    };
    $rootScope.creatMyMsgWebsocket = function(userid) {
      myMessageCountTimer && $interval.cancel(myMessageCountTimer);
      if (!userid) {
        $rootScope.myMessageCountFn(0);
        return;
      }
      $rootScope.getMyMsgcount(userid);
      // myMessageCountTimer = $interval(function() { $rootScope.getMyMsgcount(userid) }, 60000); //每60秒执行
    }
    var submitDeviceInfo = function(device) {
      var submitedDevice = $window.localStorage.getItem('perpetual.submitedDevice'), _date = new Date().toDateString(), browser = navigator && navigator.userAgent;
      if (!device || submitedDevice == _date) return;
      var widthHeightPex = {};
      widthHeightPex.innerWidth = $window.innerWidth;
      widthHeightPex.innerHeight = $window.innerHeight;
      widthHeightPex.dPixelRatio = $window.devicePixelRatio;
      widthHeightPex.userAgent = browser;
      device.widthHeightPex = JSON.stringify(widthHeightPex);
      device.userId = user && user.id;
      device.userName = user && user.userName;
      appService.postData(urlMap.submitDeviceInfo, device, function(result) {
        var _date = new Date().toDateString();
        if (result && result[0] == 1) $window.localStorage.setItem('perpetual.submitedDevice', _date);
        console.log('device记录成功');
      })
    }
    function showNewPolicy(uuid) {
      if (!uuid) return;
      $http.get('http://' + host + '/thapp/policy/getPolicyNumByTime?userId=' + uuid)
        .then(function(data) {
          console.log('未读政策数:', data && data.data && data.data.num);
          if (!!data.data && parseInt(data.data.num) > 0) {
            $rootScope.notificationReminder({
              id: 1,
              summary: '新政策通知',
              title: "又有" + data.data.num + "条最新政策发布！",
              text: "点击进入知政app【政策】中查看。",
              icon: $.pic + urlMap.defaultImg
            }, function(notification) {
              $state.go('policy', { typeflag: 4 }, {
                reload: true
              });
            });
          }
        });
    }
    $window.document.addEventListener('deviceready', function() {
      console.log('deviceready');
      var isOut = false;
      /* 注册后退键 */
      $ionicPlatform.registerBackButtonAction(function(e) {
        var state = $ionicHistory.viewHistory().currentView.stateName
        /* if ($location.path() == '/home' ||
          $ionicHistory.viewHistory().currentView.stateName == 'home' ||
          location.hash == "#/home"
        ) */
        if (state == 'home' || state == 'ttbHomepage') {
          if (isOut) {
            // ionic.Platform.exitApp();
            navigator.Backbutton.goHome(function() { }, function() { });
          } else {
            isOut = true;
            $cordovaToast.showShortCenter("再点击一次退出!");
            $timeout(function() {
              isOut = false;
            }, 2000);
          }
        } else {
          $rootScope.$broadcast('backButtonOn', {
            cstate: state
          });
          $rootScope.viewGoback()
          /*  $ionicHistory.goBack(); */
        }
      }, 101);
      if ($window.cordova && $window.cordova.plugins && $window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);
      }
      creatNoticeWebsocket();
      /* 获取device基本信息 获取未读消息*/
      if (!!$window.device) {
        submitDeviceInfo($window.device);
        showNewPolicy($window.device.uuid);
        // $interval(function() { showNewPolicy($window.device.uuid) }, 60000);
        $rootScope.promisePermissions && $rootScope.promisePermissions();
      }
      if (user && user.id) $rootScope.creatMyMsgWebsocket(user.id, true);
      else { $rootScope.myMessageCountFn(0) }
      /* 新版本检测 */
      $rootScope.checkVersion = function(inapp) {
        var taDay = new Date().getUTCDay()
        if (inapp) {
          var checkVersionDay = $window.localStorage.getItem("checkVersionDay");
          if (taDay == checkVersionDay) return
        }
        $window.localStorage.setItem("checkVersionDay", taDay);
        $cordovaAppVersion.getVersionNumber().then(function(version) {
          $rootScope.curVersion = version;
          var timestamp = new Date().getTime();
          $http.get($.download + '/vers.json?' + timestamp)
            .then(function(data) {
              /* 发现新版本 */
              var alertNewVersion = function(newVersion) {
                var el_li = '',
                  verInfo = newVersion && newVersion.verInfo,
                  releaseNotes = newVersion && newVersion.releaseNotes,
                  timestamp = newVersion && newVersion.timestamp;
                for (var i = 0; i < releaseNotes.length; i++) {
                  el_li += '<li>' + (i + 1) + '、' + releaseNotes[i] + '</li>';
                }
                var _template = '<div class="confirm-release-notes"><p>版本号：' + verInfo + '</p><h2>更新内容：</h2><ul>' + el_li + '</ul></div>';
                _template = releaseNotes.length > 0 ? _template : '<div class="confirm-release-notes"><p>版本号：' + verInfo + '</p></div>';
                // _template += '<div>请到应用宝下载最新版本</div>';
                _template +=
                  '<div class="com-flex-line column">' +
                  // '<button ng-click="hasNewApp.close()" class="button mt10">以后再说</button>' +
                  // '<button ng-click="downloadNewApp()" class="button button-positive mt10">知政APP内更新</button>' +
                  /* '<button ng-click="openUrl({address:\'https://a.app.qq.com/o/simple.jsp?pkgname=com.yjhzz.app\'})" class="button button-positive mt10">去应用宝下载最新版本in</button>' + */
                  // '<button ng-click="openYYB()" class="button button-positive mt10">去应用宝下载最新版本</button>' +
                  '</div>';
                /* $rootScope.openYYB = function() {
                  $window.open('https://a.app.qq.com/o/simple.jsp?pkgname=com.yjhzz.app')
                } */
                 /*$rootScope.hasNewApp = $ionicPopup.show({
                  title: '<strong>发现新版本</strong>',
                  template: _template,
                  scope: $rootScope
                })  */
                $ionicPopup.confirm({
                  title: '<strong>发现新版本</strong>',
                  template: _template,
                  okText: '立即更新',
                  cancelText: '以后再说'
                }).then(function(res) {
                  if(res){
                    $rootScope.downloadNewApp()
                  }
                })
                var downloading
                $rootScope.downloadNewApp = function() {
                  if(!!downloading) return
                  downloading = true
                  $ionicLoading.show({
                    template: "已经下载：0%"
                  });
                  /* 创建zz文件夹 */
                  $window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, function(fileEntry) {
                    fileEntry.getDirectory("zz", {
                      create: true,
                      exclusive: false
                    }, function(fileEntry) {
                      //下载代码
                      var fileTransfer = new FileTransfer();
                      var url = $.ctx160 + "/download/zz.apk?" + timestamp;
                      fileTransfer.download(url, fileEntry.toInternalURL() + "zz.apk", function(entry) {
                        downloading = null
                        /* alert("指定的下载位置：" + fileEntry.toInternalURL()+"zz.apk");
                        alert("保存文件的地址：" + entry.toInternalURL()); */
                        /* 打开下载下来的APP */
                        cordova.plugins.fileOpener2.open(
                          entry.toInternalURL(), //下载文件保存地址
                          'application/vnd.android.package-archive', { /* 以APK文件方式打开 */
                          error: function(err) {
                            alert(err);
                          },
                          success: function() {
                            // alert("成功")
                          }
                        });
                      }, function(err) {
                        $ionicLoading.show({
                          template: "更新包下载失败，请稍后再试"
                        });
                        $timeout(function() {
                          $ionicLoading.hide()
                          downloading = null
                        }, 2000)
                      }, true);
                      fileTransfer.onprogress = function(progress) {
                        $timeout(function() {
                          var downloadProgress = (progress.loaded / progress.total) * 100;
                          $ionicLoading.show({
                            template: "已经下载：" + Math.floor(downloadProgress) + "%"
                          });
                          if (downloadProgress > 99) {
                            $ionicLoading.hide();
                          }
                        })
                      };
                    }, function() {
                      downloading = null
                      alert("创建下载文件夹失败")
                    });
                  });
                }
              }
              var verInfo = data && data.data && data.data.verInfo || "1.1.1.0",
                releaseNotes = data && data.data && data.data.releaseNotes || [];
              $rootScope.curVersion = version;
              if (version != verInfo) {
                var newVersion = {
                  verInfo: verInfo,
                  releaseNotes: releaseNotes,
                  timestamp: timestamp
                };
                if (!$rootScope.isHomeReady) {
                  $rootScope.alertNewVersion = alertNewVersion;
                  $rootScope.newVersion = newVersion;
                  return
                };
                alertNewVersion(newVersion);
              }
            });
        });
      }
      $rootScope.checkVersion()
    }, false);

    $window.onbeforeunload = function() {
      noticeWebsocket && noticeWebsocket.close();
    }
  })
  .controller("appCtrl", ['$scope', '$rootScope', 'appService', '$ionicPopup', '$ionicScrollDelegate',
    '$ionicLoading', '$state', '$window', '$timeout', '$ionicHistory', '$ionicModal', '$interval',
    function($scope, $rootScope, appService, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $state, $window, $timeout, $ionicHistory, $ionicModal, $interval) {
      /* datas */
      $rootScope.isHomeReady;
      // $rootScope.isHomeReady = true; //测试
      $rootScope.appGuideHide;
      $scope.appGuideBgFade;
      $scope.vio = $.vio;
      $scope.pic = $.pic;
      // $scope.pict = $.pic + '/img/';
      $scope.static = $.static;
      $scope.ttHashStr = '?timestamp=' + (new Date()).getTime();
      $scope.defaultUpload = urlMap.defaultUpload;
      var submitGPSTimer;
      var submitGPS = function() {
        console.log('开始获取GPS');
        navigator.geolocation.getCurrentPosition(onSuccess, function() {
          console.error('获取GPS失败')
          if (!$scope.user) return
          submitGPSTimer = $timeout(function() {
            submitGPS()
          }, 1000)
        }, { enableHighAccuracy: true });
        function onSuccess(position) {
          if (!$scope.user) return
          submitGPSTimer = $timeout(function() {
            submitGPS()
          }, 30000)
          $scope.longitude = position.coords.longitude;
          $scope.latitude = position.coords.latitude;
          var regionIdGPS = $window.localStorage.getItem("regionIdGPS");
          var data = {
            m: 'command',
            c: 'gps',
            ac: 'gpsapi',
            phone: $scope.user.telephone,
            lon: position.coords.longitude,
            lat: position.coords.latitude,
            rids: regionIdGPS
          }
          appService.get(urlMap.submitGPS, data, function() {
            console.log('已获取位置信息')
          }, function(data, status) {
            console.log(data, status)
          })
        }
      }
      var getTTBBackLog = function() {
        var data = {
          limit: 10,
          userId: $scope.user.id,
          page: 1
        }
        appService.getData(urlMap.ttbYCgetDb, data,
          function(result) {
            if (!result.data) return
            newCount = ($rootScope.ttbBackLogCount = result.data.totalCount)
            var lastMsgc = $window.localStorage.getItem('myTTBbacklog' + $scope.user);
            if (lastMsgc < newCount)
              $rootScope.notificationReminder({
                id: 'ttbbacklog',
                title: '您有' + newCount + '件“一次办”待办事件',
                text: "点击进入知政app查看。"
              }, function() {
                $state.go('ttbOneProcess')
              });
            $window.localStorage.setItem('myTTBbacklog' + $scope.user, newCount);
          });
      }
      /* 用户角色 */
      var ttbBackLogTimer
      $scope.setChangeDistrict = function(type) {
        /***
         ** type:selectDist改变地区
         ** type:enter
        */
        $rootScope.$broadcast('changeDistrict', {
          cityId: $scope.publicCityId,
          distName: $scope.publicCityName,
          type: type
        });
        if (type == 'selectDist') $scope.getAds(); // 获取广告信息
      }
      $scope.getAds = function() {
        var data = {
          regionId: $scope.publicCityId,
          state: 1
        }
        appService.getData(urlMap.adPlace, data, function(result) {
          $scope.adObj = {}
          var list = result.data, length = result.totalElements;
          if (length > 0) {
            for (var i = 0; i < length; i++) {
              var item = list[i];
              var adName = 'adType_' + item.adType
              $scope.adObj[adName] = $scope.adObj[adName] || []
              if (item.adType == "introVideoSc_static") {
                var str = JSON.stringify({ areaId: $scope.publicCityId, path: item.url })
                $window.localStorage.setItem("introVideoSc_static", str)
              }
              $scope.adObj[adName].push(item)
            }
          }
          console.log($scope.adObj)
        })
      }
      $scope.$on('$ionicView.enter', function() {
        if (!!$scope.publicCityId) $scope.setChangeDistrict('enter');
      });
      $scope.$on('$ionicView.beforeLeave', function() {
        $scope.cancelChangeDist();
      });
      function checkAndGetPermisions(_nameList) {
        if (!($window.cordova && cordova.plugins && cordova.plugins.permissions)) {
          $rootScope.promisePermissions = checkAndGetPermisions;
          return;
        }
        var permissions = cordova.plugins.permissions;
        var list = [
          permissions.INTERNET,
          permissions.ACCESS_NETWORK_STATE,
          permissions.WRITE_EXTERNAL_STORAGE
        ];
        if (_nameList) {
          var _list = [];
          for (var i = 0; i < _nameList.length; i++) {
            _list.push(permissions[_nameList[i]])
          }
          list = list.concat(_list);
        }
        permissions.checkPermission(list, function(status) {
          if (!status.hasPermission) {
            requestPermissions();
          }
        });
        function requestPermissions() {
          permissions.requestPermissions(list, function(status) {
            if (!status.hasPermission) console.warn('权限被拒绝');
          }, function(error) {
            console.warn('权限被拒绝');
          });
        }
      }
      $window.localStorage.removeItem('perpetual.notfirstStart');
      $scope.appAgreement = $rootScope.appGuideHide = $window.localStorage && ($window.localStorage.getItem('perpetual.appAgreement') ? true : false);
      if (!$rootScope.appGuideHide) {
        $scope.appAgreementModal = {};
        /*** 
         * 协议隐私模态框 
        */
        $ionicModal.fromTemplateUrl('appAgreementServicePrivacy.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.appAgreementModal.modal = modal;
        });
        $scope.openModalAppAgreementServicePrivacy = function(type) {
          $scope.appAgreementModal.modal.show();
          $scope.appAgreementModal.content = "载入中...";
          var url;
          if (type == '1') {
            $scope.appAgreementModal.title = '服务协议';
            url = urlMap.agreement;
          } else {
            $scope.appAgreementModal.title = '隐私政策';
            url = urlMap.privacyPolicy;
          }
          appService.getData(url, {
            time: (new Date()).getTime()
          }, function(result) {
            if (result && result[0]) {
              $scope.appAgreementModal.content = result[0].contentCh;
              return;
            }
            $scope.appAgreementModal.content = "载入失败，请联系客服。";
          }, function() {
            $scope.appAgreementModal.content = "载入失败，请检查您的网络，并稍后重试";
          });
        };
        /*** 
         * 协议隐私询问框
        */
        $ionicPopup.confirm({
          title: '服务协议和隐私政策',
          template: '<p>请您务必审慎阅读、充分理解“服务协议”和“隐私政策”，包括但不限于：为了向您提供定向信息展示，内容分享等服务，我们需要收集您的设备信息、操作日志等个人信息。<br />您可阅读<a ng-click="openModalAppAgreementServicePrivacy(\'1\')">《服务协议》</a>和<a ng-click="openModalAppAgreementServicePrivacy(\'2\')">《隐私政策》</a>各条款了解详细信息，如您同意，请点击“同意”开始接受我们的服务。</p>',
          scope: $scope,
          cancelText: '暂不使用',
          okText: '同意'
        }).then(function(res) {
          if (res) {
            checkAndGetPermisions();
            $scope.appAgreement = 'open';
            $scope.appAgreementModal.modal.remove();
          } else {
            $scope.appAgreement = 0;
            ionic.Platform.exitApp();
          }
        });
        /*** 
         * 引导页轮播
        */
        if (Swiper)
          $timeout(function() {
            $scope.appGuide = new Swiper('#appGuide', {
              resistanceRatio: 0,
              pagination: {
                el: '#appGuidePagination',
              },
              on: {
                slideChange: function() {
                  try {
                    if (this.isEnd) this.pagination.$el.addClass('none');
                    else this.pagination.$el.removeClass('none');
                  } catch (e) {
                    console.log(e)
                  }
                },
                touchEnd: function() {
                  if (!!this.isEnd) {
                    $rootScope.enterApp();
                  }
                }
              }
            });
          }, 2000);
      }
      else checkAndGetPermisions();
      $rootScope.enterApp = function() {
        if (!!$rootScope.isHomeReady) return; //!测试
        if ($scope.appAgreement == 0) return;
        $rootScope.isHomeReady = true;
        if (!$rootScope.appGuideHide) {
          $window.localStorage.setItem('perpetual.appAgreement', 'appAgreement');
          $scope.appGuideBgFade = true;
          $timeout(function() {
            $rootScope.appGuideHide = true;
          }, 300);
        }
        if ($scope.appGuide) $timeout(function() {
          $scope.appGuide.destroy(true, true);
          $scope.appGuide = null;
        });
        $rootScope.alertNewVersion && $rootScope.alertNewVersion($rootScope.newVersion);
      }
      //接收通知
      /* $scope.$on("onLoadString", function(e, string) {
        $scope.routeString = string;
      }); */
      $scope.logout = function(userId) {
        var confirmPopup = $ionicPopup.confirm({
          title: '提示',
          template: '你确定要退出登录吗？',
          cancelText: '取消',
          okText: '确定'
        });
        confirmPopup.then(function(res) {
          if (res) {
            try {
              var localStorageKey = [];
              for (var i = 0; i < $window.localStorage.length; i++) {
                var keyStr = $window.localStorage.key(i);
                if (keyStr.indexOf('perpetual.') < 0) localStorageKey.push(keyStr);
              }
              for (var i = 0; i < localStorageKey.length; i++) {
                $window.localStorage.removeItem(localStorageKey[i]);
              }
            } catch (e) {
              $window.localStorage.removeItem("userInfo");
              $window.localStorage.removeItem("regionIdGPS");
            }
            initUser();
            $scope.initHomeCityName();
            $rootScope.creatMyMsgWebsocket();
            $scope.goState('personal');
          }
        });
      }
      $scope.$on("login", function(e, data) {
        var user = {
          id: data.id,
          userName: data.userName,
          portrait: !!data.portrait ? $.pic + '/' + data.portrait : $.pic + urlMap.defaultImg,
          nickName: data.nickName || data.userName,
          telephone: data.telephone,
          idCard: data.idCard,
          app_flag: data.app_flag || 0,
          cityId: data.cityId || '2205'
        };
        $window.localStorage.setItem("userInfo", JSON.stringify(user));
        initUser();
        // var regionId = $ionicHistory.backView().stateName == 'personal'?$scope.user.cityId:$scope.publicCityId
        // $scope.initHomeCityName(regionId);
        $rootScope.creatMyMsgWebsocket($scope.user.id);
      });
      /**
       * @description: loginFirst 需要登录访问
       * 用法
       * $scope.$emit('loginFirst', function () {
                //todo
          })
       */
      $scope.$on("loginFirst", function(e, thenDo, cancelDo, option) {
        if (!$scope.user) {
          option = option || {
            title: '请先登录',
            template: '该功能需要您登录后使用',
            okText: '去登录',
            cancelText: '返回'
          };
          $ionicPopup.confirm(option).then(function(res) {
            if (res) {
              $state.go('login');
            } else {
              cancelDo && cancelDo()
            }
          });
        } else {
          thenDo && thenDo();
        }
      });
      /**
       * @description: realIdFirst 需要实名访问
       * @return:
       */
      $scope.$on("realIdFirst", function(e, stateParam, thenDo, cancelDo, option) {
        $scope.$emit('loginFirst', function() {
          if (!$scope.user.idCard) {
            option = option || {
              title: '请先实名',
              template: '该功能需要实名认证后使用',
              okText: '去实名',
              cancelText: '返回'
            };
            $ionicPopup.confirm(option).then(function(res) {
              if (res) {
                $state.go('userInfo', stateParam)
              } else {
                cancelDo && cancelDo()
              }
            });
          } else {
            thenDo && thenDo();
          }
        });
      });
      /**
       * 社区角色功能 
       * */
      var evalUserRegion = function(regionId) {
        var proId = regionId.slice(0, 2),
          proName = $scope.getProName(proId),
          cityId = regionId.slice(0, 4),
          cityName = $scope.getCityName(proId, cityId),
          distId,
          distName;
        if (regionId.length == 6) {
          distId = regionId.slice(0, 6);
          distName = $scope.getDistName(cityId, distId);
        }
        return proName + ',' + cityName + (distName ? (',' + distName) : '')
      }
      $scope.$on('changeRegion', function(e, regionObj, productName) {
        $scope.lastLocation = localStorage.getItem('perpetual.' + productName + '.location');
        var regionCode = regionObj.code || $scope.publicCityId
        localStorage.setItem('perpetual.' + productName + '.location', JSON.stringify({ areaId: regionCode, productName: productName, data: regionObj }));
      });
      $scope.$on("updateUserInfo", function(e) {
        if (!$scope.user) return
        appService.getData(urlMap.getUserById, {
          id: $scope.user.id,
          time: (new Date()).getTime()
        },
          function(jsonData) {
            var obj = jsonData.resultList[0];
            $scope.user.userName = obj.userName;
            $scope.user.nickName = obj.nickName || obj.userName;
            $scope.user.portrait = $scope.user.portrait || $scope.pic + $scope.defaultUpload
            $scope.user.portraitOrgin = obj.portrait;
            $scope.user.telephone = obj.telephone;
            $scope.user.portraitImg = $scope.user.portrait = !obj.portrait ? ($.pic + urlMap.defaultImg) : ($.pic + '/' + obj.portrait + "?" + (new Date()).getTime());
            $scope.user.cityId = obj.cityId || '2205';
            $scope.user.regionNameAll = evalUserRegion($scope.user.cityId);
            $scope.user.idCard = obj.idCard;
            $scope.user.app_flag = obj.app_flag || 0;
            $window.localStorage.setItem("userInfo", JSON.stringify($scope.user));
          });
      });
      function initRole(user) {
        if (!user) {
          submitGPSTimer && $timeout.cancel(submitGPSTimer);
          ttbBackLogTimer && $interval.cancel(ttbBackLogTimer);
          console.log('停止获取: GPS, 一次办')
          return;
        }
        appService.getData(urlMap.userRoles, { userId: $scope.user.id },
          function(results) {
            var roles = results.data, regionIdGPS;
            $scope.user.roles = roles
            roles.forEach(function(role) {
              if (role.name.indexOf('ttb一次办') > -1) {
                $scope.user.ttbRole = role
                /* ttbBackLogTimer && $interval.cancel(ttbBackLogTimer);
                ttbBackLogTimer = $interval(function() { getTTBBackLog() }, 60000); */
              }
              role.menus.forEach(function(menu) {
                if (menu.path == 'zhOlmap') regionIdGPS = role.regionId
              })
            });
            if (regionIdGPS) {
              $window.localStorage.setItem("regionIdGPS", (regionIdGPS || 'notOlmap'));
              if (regionIdGPS != 'notOlmap') {
                submitGPS();
                checkAndGetPermisions([
                  'ACCESS_COARSE_LOCATION',
                  'ACCESS_FINE_LOCATION']);
              }
            }
          })
      }
      function initUser() {
        var userInfo = $window.localStorage.getItem("userInfo"); //用户信息
        $scope.user = userInfo && JSON.parse(userInfo);
        $scope.$emit("updateUserInfo");
        initRole($scope.user);
      }
      initUser();
      $scope.$on("loading", function(e, showOrHide, option) {
        if (showOrHide == 'hide') {
          $ionicLoading.hide();
          return;
        }
        var option = option || {
          template: '<ion-spinner icon="bubbles" class="spinner-light"></ion-spinner>',
          noBackdrop: true,
          duration: 5000
        };
        $ionicLoading.show(option);
      });
      $scope.$on("scanLight", function(e, callback, errCallback) {
        if ($scope.scanLight) {
          QRScanner.disableLight(function(err, status) {
            $scope.$apply(function() {
              $scope.scanLight = false
            })
          });
          return
        }
        QRScanner.enableLight(function(err, status) {
          $scope.$apply(function() {
            $scope.scanLight = true
          })
        });
      })
      $scope.$on("scanOff", function(e, callback, errCallback) {
        QRScanner.disableLight(function(err, status) {
          $scope.$apply(function() {
            $scope.scanLight = false
          })
        });
        QRScanner.hide(function(status) {
          console.log(status);
          QRScanner.destroy();
          $('html').removeClass('scan')
          $('#scanPage').css({ 'display': 'none' })
        });
      })
      $scope.$on("scanOn", function(e, callback, errCallback) {
        QRScanner.scan(displayContents);
        function displayContents(err, text) {
          $scope.$emit('scanOff')
          if (err) {
            if (errCallback) {
              errCallback()
              return
            }
            $scope.alert(err)
            console.error('err:', err);
          } else {
            callback && callback(text)
          }
        }
        QRScanner.show(function(status) {
          console.log(status);
          if ($scope.scan) {
            $('html').addClass('scan')
            $('#scanPage').css({ 'display': 'block' })
          }
        });
      });
      $scope.$on("brightness", function(e, state, success, error) {
        if (state == 'off' && !$scope.orginBrightness) return
        var brightness = cordova.plugins.brightness;
        if (!brightness) return
        if ($scope.orginBrightness || state == 'off') {
          brightness.setBrightness($scope.orginBrightness, success, error);
          $scope.orginBrightness = null
          return
        }
        brightness.getBrightness(function(orgin) {
          $scope.orginBrightness = orgin
          brightness.setBrightness(1, success, error);
        });
      });
      $rootScope.viewGoback = function(callback) {
        $ionicHistory.goBack(-1);
        // history.go(-1);
        callback && callback();
      }
      $scope.goState = function(name, params, reload) {
        if (name == 'ttbyiciban') {
          $scope.alert('维护中，敬请期待。')
          return
        }
        if (name == 'jianshezhong') {
          $scope.alert('建设中，敬请期待。')
          return
        }
        if (name == 'weihuzhong') {
          $scope.alert('维护中，敬请期待。')
          return
        }
        if (name == 'ttbHomepage' || name == 'home') {
          if ($scope.publicCityId == '2205') { /* $ionicViewSwitcher.nextDirection("enter"); */name = 'ttbHomepage' }
          if ($scope.publicCityId != '2205') { name = 'home' }
        }
        $state.go(name, params, {
          reload: !!reload
        });
      }
      $scope.goStateLogin = function(name, params, reload) {
        $scope.$emit('loginFirst', function() {
          $state.go(name, params, {
            reload: !!reload
          });
        })
      }
      $scope.ionScroll = function() {
        var scrollTop = event.detail && event.detail.scrollTop,
          $gotop = $(event.target).parents('ion-view').children('.goTop');
        if (scrollTop < 20) $gotop.hide();
        else $gotop.show();
        // console.log(scrollTop);
      }
      //置顶效果
      $scope.goTop = function(handle, top) {
        var delegate = handle ? $ionicScrollDelegate.$getByHandle(handle) : $ionicScrollDelegate;
        if (top) {
          delegate.scrollTo(null, top);
          // console.log(top)
          return;
        }
        delegate.scrollTop();
      }
      $scope.alert = function(info, title, callback) {
        $ionicPopup.alert({
          title: title || '提示框',
          template: info,
          okText: '确定'
        }).then(function(res) {
          callback && callback();
        });
      }
      /* $scope.showAlert = function () {
        //判断是否已经存在弹出对象
        if ($scope.alertPopup) { //确保页面只有一个弹出的提示框
          return false;
        } else { //如果没有就创
          $scope.alertPopup = $ionicPopup.alert({
            title: '温馨提示',
            template: '功能暂未开通，敬请期待！'
          });
          $scope.alertPopup.then(function (res) {
            if (res) {
              $scope.alertPopup = undefined;
            } else {
              $scope.alertPopup = undefined;
            }
          });
        }
      } */
      $scope.telclick = function() {
        event.stopPropagation();
      }
      $scope.evalRemotePath = function(path, picHost) {
        if (!path) return
        picHost = picHost || $scope.pic
        var reg = /^(https?\:)?\/\/[^\/]*/
        var hasHost = reg.test(path);
        if (!hasHost) path = picHost + '/' + path;
        return path
      }
      $scope.thisfileType = function(fileName) {
        var picExt = ".jpg|.jpeg|.png|";
        var vioExt = ".mp4|.3gp|.avi|";
        if (!fileName) return null
        var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
        /* 检查文件类型  */
        if (picExt.indexOf(extName + "|") != -1) return 1;
        if (vioExt.indexOf(extName + "|") != -1) return 2;
        return 'error'
      }
      $scope.goMinip = function(path, title, miniId, success, error) {
        miniId = miniId || 'gh_9ade2302ec7d'
        title = title || '即将跳转到知政小程序，是否继续'
        window.Wechat && $ionicPopup.confirm({
          template: title,
          scope: $scope,
          cancelText: '取消',
          okText: '继续'
        }).then(function(res) {
          if (res) {
            Wechat.openMiniProgram({
              userName: miniId,
              path: path,
              miniprogramType: Wechat.Mini.RELEASE
            }, function(data) {
              success && success()
            }, function(e) {
              error && error()
            });
          } else {
          }
        });
      }
    }
  ])
  /* .filter('subDate', function () { //可以注入依赖
return function (text) {
if (text) {
return text.substring(0, 10);
}
}
}); */