/****************************************
 * @description  微信登录，授权跳转此处
 * -----------------------------------------------------------------------------------------------------
 */
appModule.controller('ChooseCityController', ['$scope', '$ionicPopup', '$ionicModal', '$interval', 'appService', '$ionicHistory', '$state', '$scope', '$stateParams',
    function($scope, $ionicPopup, $ionicModal, $interval, appService, $ionicHistory, $state, $scope, $stateParams) {
        //页面加载完毕后
        $scope.$on('$ionicView.loaded', function() {
            //调用初始化省市区方法
            $scope.initChoosewxCityName();
        });

        $scope.wxCityAlert = false;//是否显示提示标识  请选择市！
        $scope.unionid = $stateParams.unionid;
        $scope.nickname = $stateParams.nickname;

        function isIntNum(val) {
            var regPos = /^[0-9]+.?[0-9]*$/; // 数字
            //var regNeg = /^\-[1-9][0-9]*$/; // 负整数
            if (regPos.test(val)) { //|| regNeg.test(val)){
                return true;
            } else {
                return false;
            }
        }

        //获取区
        $scope.changeChooseDist = function(id, name) {
            //为市变量赋值，为用户点击确定按钮做准备
            $scope.wxCityId = id;
            $scope.wxCityName = name;
            $scope.areaID = id;
            $scope.wxDist_arrs = [];
            for (d in sub_arr[id]) {
                if (null != d && '' != d) {
                    $scope.sub_str = d.slice(0, 4)
                    if (isIntNum($scope.sub_str) && $scope.sub_str == id && '' != $scope.sub_str && null != $scope.sub_str) {
                        $scope.dist_arr = {};
                        $scope.dist_arr["id"] = d;
                        $scope.dist_arr["name"] = sub_arr[id][d];
                        $scope.wxDist_arrs.push($scope.dist_arr);
                    } else {
                        continue;
                    }
                }
            }
        }

        //拼接城市
        $scope.changeChooseCity = function(id, name) {
            $scope.wxCity_arrs = [];
            $scope.wxProId = id;

            for (c in sub_array[id]) {
                if (null != c && '' != c) {
                    $scope.sub_str = c.slice(0, 2)
                    if (isIntNum($scope.sub_str) && $scope.sub_str == id && '' != $scope.sub_str && null != $scope.sub_str) {
                        $scope.city_arr = {};
                        $scope.city_arr["id"] = c;
                        $scope.city_arr["name"] = sub_array[id][c];
                        $scope.wxCity_arrs.push($scope.city_arr);
                    } else {
                        continue;
                    }
                }
            }

        }

        //初始化城市名称
        $scope.initChoosewxCityName = function() {

            $scope.wxPro_arrs = [];
            $scope.wxCity_arrs = [];
            $scope.wxDist_arrs = [];

            //默认区域
            $scope.wxChoosewxCityName = '通化市';
            $scope.wxChoosewxCityId = '2205';
            $scope.wxProId = '22';//吉林省
            $scope.wxProName = '吉林省';
            $scope.wxCityId = '2205';
            $scope.wxCityName = '通化市';

            //初始化省
            for (b in area_array) {
                $scope.wx_pro_arr = {};
                if (0 != b) {//排除 请选择 项
                    $scope.wx_pro_arr["id"] = b;
                    $scope.wx_pro_arr["name"] = area_array[b];
                    $scope.wxPro_arrs.push($scope.wx_pro_arr);
                }
            }
            //初始化显示区
            $scope.changeChooseDist($scope.wxCityId, $scope.wxCityName);
            //初始化显示市
            $scope.changeChooseCity($scope.wxProId, $scope.wxCityName);
        }

        //根据市ID查找市名称
        $scope.getWXCityName = function(proId, cityId) {
            $scope.wxChoosewxCityId = cityId;
            for (cN in sub_array[proId]) {
                if (cN == cityId) {
                    $scope.cityName = sub_array[proId][cityId];
                    $scope.publicWXCityName = sub_array[proId][cityId];
                    break;
                }
            }
        }

        //根据区ID查找区名称
        $scope.getWXDistName = function(cityId, distId) {
            $scope.publicWXCityId = distId;
            for (dN in sub_arr[cityId]) {
                if (dN == distId) {
                    $scope.publicWXCityName = sub_arr[cityId][distId];
                    break;
                }
            }
        }

        //注册失败
        $scope.showFail = function(info) {
            $scope.alert(info);
        }

        $scope.submitWXLogin = function() {
            $scope.wxPhoneAlert = true;//验证手机号标识
            $scope.phoneString = "";
            console.log($scope.wxCityId);
            // if (undefined == $scope.wxCityId) {//未选择市
            if (undefined == $scope.wxDistId && $scope.wxCityId != '2205') {//未选择地区
                $scope.wxCityAlert = true;
            } else {
                console.log('b');
                $scope.wxCityAlert = false;
                $scope.isChooseDist = false;
                //获取区
                for (d in sub_arr[$scope.wxCityId]) {
                    if (null != d && '' != d) {
                        $scope.sub_str = d.slice(0, 4)
                        if (isIntNum($scope.sub_str) && $scope.sub_str == $scope.wxCityId && '' != $scope.sub_str && null != $scope.sub_str) {
                            //遍历判断区是否被选中
                            if ($('#' + d).prop("className") == 'quxian-li-current') {
                                $scope.wxDistId = d;
                                $scope.wxChoosewxCityId = d;
                                $scope.isChooseDist = true;
                                break;
                            }
                        }
                    }
                }
                if ($scope.isChooseDist) {//有区
                    //在sub_array数组中查找名称
                    $scope.getWXCityName($scope.wxProId, $scope.wxCityId);
                    //在sub_arr数组中查找名称
                    $scope.getWXDistName($scope.wxCityId, $scope.wxDistId);
                    //初始化显示市
                    $scope.changeChooseCity($scope.wxProId, $scope.wxProName);
                    //初始化显示区
                    $scope.changeChooseDist($scope.wxCityId, $scope.cityName);
                    $scope.wxChoosewxCityId = $scope.wxDistId;
                } else {
                    //为省的名称赋值
                    $scope.getProName($scope.wxProId);
                    $scope.wxChoosewxCityId = $scope.wxProId;
                    $scope.publicWXCityName = $scope.wxProName;

                    $scope.wxChoosewxCityId_temp = $scope.wxProId;

                    if ('' != $scope.wxCityId && undefined != $scope.wxCityId) {//选择了市
                        $scope.wxChoosewxCityId = $scope.wxCityId;
                        $scope.wxChoosewxCityId_temp = $scope.wxCityId;
                        $scope.publicWXCityName = $scope.cityName;
                        //在sub_array数组中查找名称
                        $scope.getWXCityName($scope.wxProId, $scope.wxCityId);
                    } else if ('' != $scope.wxDistId && undefined != $scope.wxDistId) {//选择了区信息
                        $scope.wxChoosewxCityId = $scope.wxDistId;
                        $scope.wxChoosewxCityId_temp = $scope.wxDistId;
                        $scope.publicWXCityName = $scope.distName;
                        //在sub_array数组中查找名称
                        $scope.getWXCityName($scope.wxProId, $scope.wxCityId);
                        //在sub_arr数组中查找名称
                        $scope.getWXDistName($scope.wxCityId, $scope.wxDistId);
                    }
                }
                //验证用户填写的手机号码
                var telephone = $.trim($("#telephone").val());
                var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
                if (telephone == "") {
                    $scope.alert("手机号码不能为空！");
                    // $scope.phoneString = "手机号码不能为空";
                    return false;
                } else if (telephone.length != 11) {
                    $scope.alert('手号码的长度不够!');
                    // $scope.wxPhoneAlert = false;
                    // $scope.phoneString = "手号码的长度不够";
                    return false;
                } else if (!myreg.test(telephone)) {
                    $scope.alert('请输入有效的手机号码！');
                    // $scope.wxPhoneAlert = false;
                    // $scope.phoneString = "请输入有效的手机号码";
                    return false;
                }
                // console.log(urlMap.wxLogin);
                //提交表单
                $("#chooseForm").ajaxSubmit({
                    url: urlMap.wxLogin,
                    type: 'POST',
                    dataType: 'json',
                    success: function(data) {
                        console.log(data);
                        if (null == data.reason) { //登录成功
                            //向APP 传递事件!!
                            $scope.showFail('登录成功');
                            $scope.$emit("login", data);
                            location.href = "#/home";
                        } else if ('用户注册成功' == data.reason) {
                            //$scope.showFail(data.reason);
                            //向APP 传递事件!!
                            $scope.showFail('用户注册成功');
                            $scope.$emit("login", data);
                            location.href = "#/home";
                        } else if ('用户注册失败' == data.reason) {
                            $scope.showFail(data.reason);
                        } else {
                            $scope.showFail(data.reason);
                        }
                    },
                    error: function(xhr) {
                        console.log(xhr.responseText);
                    }
                });
            }
        }
        //发送验证码
        $scope.sendText = "发送验证码";
        $scope.sendFlag = false;
        $scope.sendWXLoginCode = function() {
            //验证手机号码
            var telephoneVal = $.trim($("#telephone").val());
            var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
            if (telephoneVal == "") {
                $scope.alert("手机号码不能为空！");
                return false;
            } else if (telephoneVal.length != 11) {
                $scope.alert('手号码的长度不够!');
                return false;
            } else if (!myreg.test(telephoneVal)) {
                $scope.alert('请输入有效的手机号码！');
                return false;
            }

            $scope.sendFlag = true;
            var second = 60;
            var timerInter = $interval(function() {
                second--;
                $scope.sendText = second + "秒后可重发";
                if (second == 0) {
                    $interval.cancel(timerInter);
                    $scope.sendText = "重发验证码";
                    $scope.sendFlag = false;
                }
            }, 1000, 60);
            //发送短信
            appService.getData(urlMap.sendCode, { 'telephone': telephoneVal, 'type': '0' }, function(jsonData) {
                if (jsonData.result == "success") {
                    /* $interval.cancel(timerInter);
                     $scope.sendText = "重发验证码";
                     $scope.sendFlag = false;*/
                    $scope.alert(jsonData.reason);
                } else {
                    $scope.alert(jsonData.reason);
                }
            })

        }
        $scope.alert = function(info) {
            $ionicPopup.alert({
                title: '提示框',
                template: info
            });
        }

        $scope.changeDistFocus = function(distid) {
            $scope.wxDistId = distid;
            $scope.areaID = distid;
        }
    }
])