appModule.controller('MarketController', ['$scope', 'appService', '$ionicScrollDelegate', '$state', '$rootScope',
  function ($scope, appService, $ionicScrollDelegate, $state, $rootScope) {
    //data
    $scope.stateName = $state.current.name;
    $scope.searchKey = 'commodity';
    $scope.pageNext = 1;
    $scope.itemArr = null;
    $scope.domore = false;
    $scope.noActiveFlag = null;
    $scope.footerActiveFlag = 3;
    //加载
    $scope.$on('$ionicView.loaded', function () {
    });
    //商品分类
    $scope.goodsType = function () {
      $scope.$emit('loading', 'show');
      appService.getData(urlMap.goodsType, {},
        function (newItems) {
          $scope.navArr = newItems;
          $scope.activeFlag = $scope.navArr[0].categoryId;
          if ($scope.noActiveFlag) $scope.queryDeal($scope.activeFlag, 1);
        });
    }
    $scope.goodsType();
    //广播 - 地域变换
    $scope.$on('changeDistrict', function (e, data) {
      if ($scope.stateName == $state.current.name) {
        $scope.queryDeal($scope.activeFlag, 1);
      }
    });
    //主方法
    $scope.queryDeal = function (tabIndex, pageIndex) {
      if (!tabIndex) {
        $scope.noActiveFlag = true;
        return;
      };
      //为二级分类赋值，便于检索传值使用
      $scope.subMenuId = tabIndex;
      $scope.activeFlag = tabIndex;
      if (pageIndex == 1) {
        $scope.itemArr = null;
        $ionicScrollDelegate.scrollTop();
      }
      $scope.$emit('loading', 'show');
      //数据列表
      appService.getData(urlMap.marketList + tabIndex, { page: pageIndex, area_id: $scope.publicCityId },
        function (jsonDataArr) {
          $scope.$emit('loading', 'hide');
          console.log("商品列表: ", jsonDataArr[0]);
          var jsonData = jsonDataArr[0].resultList;
          if (pageIndex == 1) {
            $scope.itemArr = [];
            $scope.domore = true;
          }
          if (jsonData.length != 0) {
            var dataItemArr = jsonData;
            for (var i = 0; i < dataItemArr.length; i++) {
              //增加默认新闻图片
              if (dataItemArr[i]["picName"] == "" || dataItemArr[i]["picName"] == "undefined") {
                dataItemArr[i]["picName"] = urlMap.newImg;
              }
              var vio = dataItemArr[i].picName;
              var type = dataItemArr[i].type; // 图片1视频2
              // console.log("type:  " + type);
              var portrait = dataItemArr[i].portrait;
              if (portrait != null && portrait != "") {
                dataItemArr[i].portrait = $scope.pic + "/" + portrait;
              } else {
                dataItemArr[i].portrait = $scope.pic + urlMap.defaultImg;
              }
              if (type == "1") {
                dataItemArr[i].pic = vio;
              } else if (type == "2") {
                var pic = vio.substring(0, vio.length - 3);
                pic = pic + "jpg";
                dataItemArr[i].vio = vio;
                dataItemArr[i].pic = pic;
              } else if (type == "0") {
                dataItemArr[i].pic = $scope.pic + urlMap.defaultUpload;
              }

              $scope.itemArr.push(dataItemArr[i]);
            }

            $scope.pageNext = pageIndex + 1;
            //动态刷新事件处理
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
          } else {
            $scope.domore = false;
          }
        });
    }
    //下拉刷新
    $scope.doRefresh = function () {
      $scope.queryDeal($scope.activeFlag, 1);
    }
    //上拉加载
    $scope.onInfinite = function () {
      $scope.queryDeal($scope.activeFlag, $scope.pageNext);
    }
    //跳转到详情页面 
    $scope.goDetail = function (item) {
      $scope.$emit('loginFirst', function () {
        $state.go('dealDetail', { id: item.id })
      })
    }
    $scope.goToGoods = function () {
      $scope.$emit('loginFirst', function () {
        $state.go('goods')
      })
    }
  }
])
