appModule.controller('officeSearchController',
    ['$scope', '$ionicModal', '$stateParams', 'appService', '$state', '$location', '$sce',
        function ($scope, $ionicModal, $stateParams, appService, $state, $location, $sce) {

            $scope.$on('$ionicView.loaded', function () {
                console.log("officeSearchController $ionicView.loaded");
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                console.log("officeSearchController $ionicView.beforeEnter");
                $scope.itemClassifyId = $location.search().itemClassifyId;
                $scope.officeDeptId = $location.search().officeDeptId; //搜索办事部门
            });

            $scope.myKeyup = function (e) {
                var keycode = window.event ? e.keyCode : e.which;
                console.log("keycode:" + keycode);
                //回车事件
                if (keycode == 13) {
                    $scope.getItemList(1);
                }
            }
            $scope.getItemList = function (pageIndex) {
                if ($scope.keyword != null && $scope.keyword != undefined && $scope.keyword != '') {
                    appService.getData(urlMap.officeItemPge, {
                            page: pageIndex,
                            itemClassifyId: $scope.itemClassifyId,
                            keyword: $scope.keyword,
                            deptId: $scope.officeDeptId
                        },
                        function (jsonData) {
                            $scope.guideShow = {show1: true, show2: true, show3: true,};
                            if (pageIndex == 1) {
                                $scope.items = [];
                                $scope.domore = false;
                            }
                            var itemList = jsonData.data.list;
                            if (itemList.length != 0) {
                                $scope.pageNext = pageIndex + 1;
                                $scope.items = $scope.items.concat(itemList);
                                //动态刷新事件处理
                                $scope.$broadcast('scroll.refreshComplete');
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                            } else {
                                $scope.domore = true;
                            }
                        });
                }
            }

            //下拉刷新
            $scope.doRefresh = function () {
                console.log("doRefresh");
                $scope.getItemList(1);
            }

            //上拉加载
            $scope.onInfinite = function () {
                console.log("onInfinite");
                $scope.getItemList($scope.pageNext);
            }

            $scope.goDeail = function (id) {
                if ($scope.pageType == 0) {
                    $scope.$emit("goToLogin", "#/newsDetail/" + id);
                } else if ($scope.pageType == 3) {

                    var userid = 0;
                    if ($scope.user != null) {
                        userid = $scope.user.id;
                    }
                    $scope.$emit("goToLogin", "#/entertainDetail/" + id + "/3/" + userid);
                }
            }

            // 指南
            $ionicModal.fromTemplateUrl('guide-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.guideModal = modal;
            });
            $scope.guideShowItem = function (showItem) {
                if (showItem == 'show1') {
                    $scope.guideShow.show1 = !$scope.guideShow.show1;
                } else if (showItem == 'show2') {
                    $scope.guideShow.show2 = !$scope.guideShow.show2;
                } else if (showItem == 'show3') {
                    $scope.guideShow.show3 = !$scope.guideShow.show3;
                }
            };
            $scope.guideModalOpen = function (id) {
                //
                $scope.guideModal.show();
                // 查看指南详情
                $.ajax({
                    type: "post",
                    url: urlMap.officeItemGuide,
                    data: {itemId: id, deptId: $scope.officeDeptId},
                    success: function (rs) {
                        $scope.guideItem = rs.data;
                        if (!$scope.guideItem) {
                            var alertPopup = $ionicPopup.alert({
                                title: '提示框',
                                template: '当前事项没有配置指南！'
                            });
                        } else {
                            $scope.guideItem.serviceFlowHtml = $sce.trustAsHtml($scope.guideItem.serviceFlow);
                            $scope.guideItem.approveFlowHtml = $sce.trustAsHtml($scope.guideItem.approveFlow);
                        }
                    }
                });
            }

            //当我们用到模型时，清除它！
            $scope.$on('$destroy', function () {
                $scope.guideModal.remove();
            });
        }
    ])