/****************************************
 * @description  用户注册模块
 * -----------------------------------------------------------------------------------------------------
 */
appModule.controller('RegController', ['$scope', '$ionicPopup', '$ionicModal', '$interval', 'appService', '$ionicHistory', '$state', '$rootScope',
    function ($scope, $ionicPopup, $ionicModal, $interval, appService, $ionicHistory, $state, $rootScope) {
        $(function () {
            document.addEventListener("backbutton", eventBackButton, false);

            //返回键点击响应
            function eventBackButton() {
                document.removeEventListener("backbutton", eventBackButton, false);
                // $state.go('login');
                // $state.go('home');
                $ionicHistory.goBack();
            }
            initComplexArea('seachprov1', 'seachcity1', 'seachdistrict1', area_array, sub_array, '22', '0', '0');
            changeCity(22, 'seachdistrict1', 'seachdistrict1');
            //$("#seachdistrict1").val('220521');
        });
        $scope.goBack = function () {
            $ionicHistory.goBack();
        }
        function getAreaID() {
            var area = 0;
            if ($("#seachdistrict1").val() != "0") {
                area = $("#seachdistrict1").val();
            } else if ($("#seachcity1").val() != "0") {
                area = $("#seachcity1").val();
            } else {
                area = $("#seachprov1").val();
            }
            return area;
        }
        $scope.regForm = function () {
            var f = $("#seachprov1").val();
            if ($("#seachprov1").val() != "0") {
                if (f != 11 && f != 12 && f != 31 && f != 71 && f != 50 && f != 81 && f != 82) {
                    if (($("#seachcity1").length > 0) && ($("#seachcity1").val() != "0")) {
                        areaId = $("#seachcity1").val();
                        if (($("#seachdistrict1").length > 0) && ($("#seachdistrict1").val() != "0")) {
                            areaId = $("#seachdistrict1").val();
                        } else {
                            areaId = $("#seachdistrict1").val();
                            // $scope.alert("请选择完整地区格式！");
                            // return;
                        }
                    } else {
                        $scope.alert("请选择完整地区格式！");
                        return;
                    }
                } else {
                    if ($("#seachcity1").val() == "0") {

                        $scope.alert("请选择完整地区格式！");
                        return;
                    }
                }
            } else {
                $scope.alert("请选择完整地区格式！");
                return;
            }
            var cityId = getAreaID();
            $("#cityId").val(cityId);

            if ($scope.validateUserForm()) {
                $.ajax({
                    url: urlMap.isOnlyUser,
                    type: "get",
                    async: false,
                    data: {
                        "userName": $("#regUserName").val(), "telephone": $("#telephone").val(),
                        "nickName": $("#nickName").val()
                    },
                    success: function (result) {
                        if (result.result == "fail") {
                            $scope.alert(result.reason);
                            return;
                        } else {
                            $("#regForm").ajaxSubmit({
                                url: urlMap.register,
                                type: "post",
                                dataType: "json",
                                success: function (data) {
                                    if (data.result == "success") {
                                        $scope.showHint();
                                        $("#regForm")[0].reset();
                                    } else {
                                        $scope.showFail(data.reason);
                                    }
                                },
                                error: function (xhr) {
                                    console.log(xhr);
                                    console.log(xhr.responseText);
                                }
                            });
                        }
                    },
                    error: function (error) {
                        document.write(error.responseText);
                    }
                })
            }
        }
        $scope.alert = function (info, then) {
            $ionicPopup.alert({
                title: '提示框',
                template: info,
                okText: '确定'
            }).then(function(){
                then && then()
            });
        }
        //注册成功
        $scope.showHint = function () {
            $scope.alert("注册成功",function(){
                $scope.goState('personal');
            });
        }
        //注册失败
        $scope.showFail = function (info) {
            $scope.alert(info);
        }

        $scope.isIdCard = function (card) {
            // 身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X  
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            return reg.test(card);
        }

        $scope.isEmail = function (email) {
            var regex = /^([0-9A-Za-z\-_\.]+)@([0-9a-z]+\.[a-z]{2,3}(\.[a-z]{2})?)$/g;
            return regex.test(email);
        }

        // 表单验证
        $scope.validateUserForm = function () {
            if ($.trim($("#regUserName").val()) == "") {
                $scope.alert("请输入用户名！");
                return false;
            }
            if (!(/^[a-zA-Z0-9]{4,18}$/.test($("#regUserName").val()))) {
                $scope.alert('用户名只接受4-18位的字母或数字');
                return false;
            }
            if ($.trim($("#nickName").val()) == "") {
                $scope.alert("请输入昵称！");
                return false;
            }
            if ($.trim($("#regPassWord").val()) == "") {
                $scope.alert('请输入密码！');
                return false;
            }
            /* if ($("#regPassWord").val().length > 6 || $("#passWord2").val().length > 6) {
                $scope.alert('密码过长，请输入不超过6位的密码！');
                return false;
            } */
            if (!(/^[a-zA-Z]\w{5,17}$/.test($("#regPassWord").val()))) {
                $scope.alert('请输入以字母开头的6-18位字符、数字或下划线的密码');
                return false;
            }
            if ($("#regPassWord").val() != $("#passWord2").val()) {
                $scope.alert("两次密码不一致!");
                return false;
            }
            //	   		if(!$scope.isIdCard($("#idCard").val())) { 
            //	   			$scope.alert("身份证输入不合法！");  
            //	   			return false; 
            //	   		}
            var telephone = $.trim($("#telephone").val());
            var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
            if (telephone == "") {
                $scope.alert("手机号码不能为空！");
                return false;
            } else if (telephone.length != 11) {
                $scope.alert('手号码的长度不够!');
                return false;
            } else if (!myreg.test(telephone)) {
                $scope.alert('请输入有效的手机号码！');
                return false;
            }
            /*if(!$scope.isEmail($("#email").val())) { 
            	$scope.alert("邮箱输入不合法！");  
            	return false; 
            }*/
            //	   		if(!$('#checkboxAgreement').is(':checked')) {
            //	   			$scope.alert('请阅读并勾选知政协议！'); 
            //	   			return false;  
            //	    	}

            return true;
        }
        $ionicModal.fromTemplateUrl('agreement.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
        });
        $scope.showAgreement = function ($event) {
            console.log("协议列表内容----->");

            var url = urlMap.agreement;
            $.get(url, function (result) {
                console.log(result);
                if (result != "") {
                    $scope.agreementItem = result[0];
                    $scope.modal.show($event);
                } else {
                    $scope.alert("查询错误");
                }
            });

        }
        //发送验证码 
        $scope.sendText = "发送验证码";
        $scope.sendFlag = false;
        $scope.sendCode = function () {
            //验证手机号码
            var telephoneVal = $.trim($("#telephone").val());
            var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
            if (telephoneVal == "") {
                $scope.alert("手机号码不能为空！");
                return false;
            } else if (telephoneVal.length != 11) {
                $scope.alert('手号码的长度不够!');
                return false;
            } else if (!myreg.test(telephoneVal)) {
                $scope.alert('请输入有效的手机号码！');
                return false;
            }

            $scope.sendFlag = true;
            var second = 60;
            var timerInter = $interval(function () {
                second--;
                $scope.sendText = second + "秒后可重发";
                if (second == 0) {
                    $interval.cancel(timerInter);
                    $scope.sendText = "重发验证码";
                    $scope.sendFlag = false;
                }
            }, 1000, 60);
            //发送短信
            appService.getData(urlMap.sendCode, { 'telephone': telephoneVal, 'type': '0' }, function (jsonData) {
                if (jsonData.result == "success") {
                    /* $interval.cancel(timerInter);
                     $scope.sendText = "重发验证码";
                     $scope.sendFlag = false;*/
                    $scope.alert(jsonData.reason);
                } else {
                    $scope.alert(jsonData.reason);
                }
            })

        }
    }
])

/****************************************
 * @description  用户登录模块
 * -----------------------------------------------------------------------------------------------------
 */
appModule.controller('LoginController', ['$scope', '$ionicPopup', '$state', '$rootScope', '$ionicHistory',
    function ($scope, $ionicPopup, $state, $rootScope, $ionicHistory) {

        document.addEventListener("backbutton", eventBackButton, false);

        //返回键点击响应
        function eventBackButton() {
            document.removeEventListener("backbutton", eventBackButton, false);
            $ionicHistory.goBack();
        }

        $scope.loginForm = function () {
            if ($("#loginForm").find("#userName").val() == "") {
                $scope.alert("请输入账号！");
                return;
            }
            if ($("#loginForm").find("#passWord").val() == "") {
                $scope.alert('请输入密码！');
                return;
            }

            var keyStr = "ABCDEFGHIJKLMNOP" + "QRSTUVWXYZabcdef" + "ghijklmnopqrstuv" + "wxyz0123456789+/" + "=";

            function encode64(input) {
                var output = "";
                var chr1, chr2, chr3 = "";
                var enc1, enc2, enc3, enc4 = "";
                var i = 0;
                do {
                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);
                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;
                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    } else if (isNaN(chr3)) {
                        enc4 = 64;
                    }
                    output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) + keyStr.charAt(enc4);
                    chr1 = chr2 = chr3 = "";
                    enc1 = enc2 = enc3 = enc4 = "";
                } while (i < input.length);

                return output;
            }

            var passWord = encode64($("#loginForm").find("#passWord").val());

            var url = urlMap.login + "?userName=" + $("#loginForm").find("#userName").val() + "&passWord=" + passWord;
            $.get(url, function (result) {
                // alert("用户登录成功!!");
                console.log("用户登录成功!!");
                if (result != "") {
                    //向APP 传递事件!!
                    $scope.$emit("login", result);
                    $ionicHistory.goBack(-1);
                } else {
                    $scope.alert("用户名密码错误");
                }
            });
        }

        $scope.isGoTo = function (unionid, nickname) {
            var url = urlMap.wxIsChoose + "?unionid=" + unionid + "&nickname=" + nickname;
            $.get(url, function (result) {
                if (result != "" && result != null) {
                    //向APP 传递事件!!
                    $scope.$emit("login", result);
                    $ionicHistory.goBack(-1);
                } else {
                    //跳转输入手机号和地区页面
                    window.location.href = "#/chooseCity/" + unionid + "/" + nickname;
                }
            });
        }

        //第三方 - 微信登录
        $scope.byWEIXINTologin = function () {
            // console.log('已进入angularjs方法');
            // 授权读取用户信息
            var scope = "snsapi_userinfo";
            var state = "_" + (+new Date());
            // console.log('11111111111111');
            if (typeof Wechat === "undefined") {
                // alert("Wechat plugin is not installed.");
                alert("微信模块异常, 请联系管理员");
            }
            // var scope = "snsapi_userinfo";
            // Wechat.auth(scope, function (response) {
            //     // you may use response.code to get the access token.
            //     alert(JSON.stringify(response));
            // }, function (reason) {
            //     alert("Failed: " + reason);
            // });


            //第一步：请求CODE
            Wechat.auth(scope, state, function (response) {
                // 第二步：通过code获取access_token   在这里就从微信返回了app，以下都是在app里进行的操作了
                //var url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=wx8b12f5c9ebd8b1d7&secret=c537a90937b32f995ef6e81604df5fd1&code="+response.code +"&grant_type=authorization_code";
                var url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=wx8b12f5c9ebd8b1d7&secret=c537a90937b32f995ef6e81604df5fd1&code=" + response.code + "&grant_type=authorization_code";
                $.get(url, function (result) {
                    var resultjson = $.parseJSON(result);
                    $scope.access_token = resultjson.access_token;
                    var openid = resultjson.openid;
                    //console.log('resultjson:    ');
                    //console.log(resultjson);
                    // 第三步：通过access_token调用接口
                    var url1 = "https://api.weixin.qq.com/sns/auth?access_token=" + $scope.access_token + "&openid=" + openid;
                    $.get(url1, function (result) {
                        var statusResult = $.parseJSON(result);
                        //console.log('statusResult:     ');
                        //console.log(statusResult);
                        // 第四步：检验授权凭证（access_token）是否有效
                        if ("ok" == statusResult.errmsg) {
                            var url2 = "https://api.weixin.qq.com/sns/userinfo?access_token=" + $scope.access_token + "&openid=" + openid;
                            // 获取用户个人信息（UnionID机制）
                            $.get(url2, function (result) {
                                var userinfo = $.parseJSON(result);
                                //为unionid赋值
                                //$scope.unionid=userinfo.unionid;
                                //console.log('userinfo:     ');
                                //console.log(userinfo);
                                /*userinfo.openid;
                                 userinfo.nickname;
                                 userinfo.sex;
                                 userinfo.language;
                                 userinfo.city;
                                 userinfo.province;
                                 userinfo.country;
                                 userinfo.headimgurl;
                                 userinfo.privilege;
                                 userinfo.unionid;*/
                                // 首先判断是否有unionid，如果数据库有，则直接登录
                                // var url = urlMap.wxIsChoose + "?unionid=" + $stateParams.unionid;
                                $scope.isGoTo(userinfo.unionid, userinfo.nickname);
                            })
                        } else {
                            // 请重新获取access_token
                            var url_refresh = "https://api.weixin.qq.com/sns/oauth2/refresh_token?appid=wx8b12f5c9ebd8b1d7&grant_type=refresh_token&refresh_token=" + $scope.access_token;
                            $.get(url_refresh, function (result) {
                                $scope.isGoTo(result.unionid);
                            });
                        }
                    });
                })
            }, function (reason) {
                alert("失败: " + reason);
            });
        };

        $scope.alert = function (info) {
            $ionicPopup.alert({
                title: '提示框',
                template: info,
                okText: '确定'
            });
        }
    }
])

/****************************************
 * @description  用户找回密码模块
 * -----------------------------------------------------------------------------------------------------
 */
appModule.controller('findPwdController', ['$scope', '$ionicPopup', '$ionicModal', '$interval', 'appService', '$ionicHistory', '$state',
    function ($scope, $ionicPopup, $ionicModal, $interval, appService, $ionicHistory, $state) {
        document.addEventListener("backbutton", eventBackButton, false);

        //返回键点击响应
        function eventBackButton() {
            //document.removeEventListener("backbutton", eventBackButton, false);
            $ionicHistory.goBack();
            // $state.go('login');
        }

        $scope.goBack = function () {
            eventBackButton();
        }

        // 忘记密码
        $scope.forgetPassword = function () {

            if ($scope.validatePwdForm()) {
                $.ajax({
                    url: urlMap.isUserByPhone,
                    type: "get",
                    async: false,
                    data: {
                        /*"userName": $("#pwdUserName").val(),*/
                        "telephone": $("#pwdTelephone").val(),
                        "passWord": $("#pwdPassWord").val(),
                        "code": $("#pwdVcode").val()
                    },
                    success: function (result) {
                        if (result.reason != "exist") {
                            $scope.alert("手机号码不存在！");
                            return;
                        } else {
                            $("#pwdForm").ajaxSubmit({
                                url: urlMap.forgetPassword,
                                type: "post",
                                dataType: "json",
                                success: function (data) {
                                    if (data.result == "success") {
                                        $scope.alert("修改密码成功！");
                                        $("#pwdForm")[0].reset();
                                        location.href = "#/login";
                                    } else {
                                        $scope.alert(data.reason);
                                    }
                                },
                                error: function (xhr) {
                                    console.log(xhr.responseText);
                                }
                            });
                        }
                    },
                    error: function (error) {
                        document.write(error.responseText);
                    }
                })
            }
        }


        // 表单验证
        $scope.validatePwdForm = function () {


            /*if ($.trim($("#pwdUserName").val()) == "") {
                $scope.alert("请输入用户名！");
                return false;
            }*/

            if ($.trim($("#pwdPassWord").val()) == "") {
                $scope.alert('请输入密码！');
                return false;
            }
            /* if ($("#pwdPassWord").val().length > 7 || $("#pwdPassWord2").val().length > 7) {
                $scope.alert('密码过长，请输入不超过8位的密码！');
                return false;
            } */
            if (!(/^[a-zA-Z]\w{5,17}$/.test($("#pwdPassWord").val()))) {
                $scope.alert('请输入以字母开头的6-18位字符、数字或下划线的密码');
                return false;
            }
            if ($("#pwdPassWord").val() != $("#pwdPassWord2").val()) {
                $scope.alert("两次密码不一致!");
                return false;
            }
            var telephone = $.trim($("#pwdTelephone").val());
            var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
            if (telephone == "") {
                $scope.alert("手机号码不能为空！");
                return false;
            } else if (telephone.length != 11) {
                $scope.alert('手号码的长度不够!');
                return false;
            } else if (!myreg.test(telephone)) {
                $scope.alert('请输入有效的手机号码！');
                return false;
            }

            if ($.trim($("#pwdVcode").val()) == "") {
                $scope.alert("请输入手机验证码！");
                return false;
            }

            return true;
        }


        //发送验证码 
        $scope.sendText = "发送验证码";
        $scope.sendFlag = false;
        $scope.sendCode = function () {
            //验证手机号码
            var telephoneVal = $.trim($("#pwdTelephone").val());
            var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(16[0-9]{1})|(19[0-9]{1}))+\d{8})$/;
            if (telephoneVal == "") {
                $scope.alert("手机号码不能为空！");
                return false;
            } else if (telephoneVal.length != 11) {
                $scope.alert('手号码的长度不够!');
                return false;
            } else if (!myreg.test(telephoneVal)) {
                $scope.alert('请输入有效的手机号码！');
                return false;
            }

            $scope.sendFlag = true;
            var second = 60;
            var timerInter = $interval(function () {
                second--;
                $scope.sendText = second + "秒后可重发";
                if (second == 0) {
                    $interval.cancel(timerInter);
                    $scope.sendText = "重发验证码";
                    $scope.sendFlag = false;
                }
            }, 1000, 60);
            //发送短信
            appService.getData(urlMap.sendCode, { 'telephone': telephoneVal, 'type': '1' }, function (jsonData) {
                if (jsonData.result == "success") {
                    /* $interval.cancel(timerInter);
                     $scope.sendText = "重发验证码";
                     $scope.sendFlag = false;*/
                    $scope.alert(jsonData.reason);
                } else {
                    $scope.alert(jsonData.reason);
                }
            })


        }

        $scope.alert = function (info) {
            $ionicPopup.alert({
                title: '提示框',
                template: info,
                okText: '确定'
            });
        }

    }
])
