angular.module("ngPublic", ['app_service', 'ionic'])
  .directive("headerContainer", function() {
    return {
      templateUrl: "templates/header.html",
      restrict: "E",
      replace: true,
      scope: false,
      link: function($scope, element, attrs) {
        $scope.showNavRegion = $scope.showNavRegion;
        if (attrs.fixedRegion != undefined) { //不提供地区切换
          $scope.fixedRegion = true;
        }
        if (attrs.notSearch != undefined) { //不显示搜索按钮
          $scope.notSearch = true;
        }
        $scope.barClass = attrs.class;
        if ($scope.fixedRegion) $scope.showCityDiv = null;
      }
    }
  })
  /**
   * @description: app定位导航
   * @usage: <location-nav></location-nav>
   */
  .directive("locationNav", ['appService', '$rootScope', '$ionicScrollDelegate', '$timeout', function(appService, $rootScope, $ionicScrollDelegate, $timeout) {
    return {
      restrict: 'E',
      replace: true,
      scope: false,
      templateUrl: 'templates/common-location-nav.html',
      link: function($scope, element, attrs) {
        $scope.province = { id: '22', name: '吉林省' };
        $scope.city = { id: '2205', name: '通化市', alias: '通化' };
        $scope.dist;
        $scope.publicCityId; //根据首页左上角显示的名称对应的实体ID
        $scope.publicCityName; //首页首页左上角显示的名称
        $scope.cityAlert; //是否显示 "请选择市！"
        $scope.city_arrs = [];
        $scope.dist_arrs = [];
        //定义省市区
        $scope.pro_arrs = initPro_arrs();
        function initPro_arrs() {
          var pro_arrs = [];
          for (b in area_array) {
            var pro_arr = {};
            if (!!b) { //排除 请选择 项
              pro_arr["id"] = b;
              pro_arr["name"] = area_array[b];
              pro_arrs.push(pro_arr);
            }
          }
          return pro_arrs;
        }
        $scope.$watch('province', function(n) {
          n = n || {};
          $scope.proId = n.id;
          $scope.proName = n.name;
          // console.log('省:' + n.name)
        }, true);
        $scope.$watch('city', function(n) {
          n = n || {};
          $scope.cityId = n.id;
          $scope.cityName = n.name;
          // console.log('市:' + n.name)
        }, true);
        $scope.$watch('dist', function(n) {
          n = n || {};
          $scope.distId = n.id;
          $scope.distName = n.name;
          // console.log('区:' + n.name)
        }, true);
        $scope.$watch('publicCityId', function(n) {
          // $scope.publicCityName = n == '2205' ? '通·通办' : ($scope.dist && $scope.dist.name || $scope.city.name);
          $scope.publicCityName = n == '2205' ? '通化' : ($scope.dist && $scope.dist.name || $scope.city.name);
          $scope.isTTB = n == '2205' ? 'isTTB' : null;
          $scope.curCityName = n == '2205' ? '通化' : ($scope.dist && $scope.dist.name || $scope.city.name);
          $scope.setChangeDistrict('selectDist');
          /* console.log('定位显示名:' + $scope.publicCityName);
          console.log('别名:' + $scope.curCityName);
          console.log('------'); */
        });
        $scope.initHomeCityName = function(publicCityId) {
          var publicCityId = publicCityId || $scope.publicCityId || ($scope.user && $scope.user.cityId) || $scope.city.id;
          console.log('publicCityId: ' + publicCityId);
          var proId = publicCityId.slice(0, 2),
            proName = $scope.getProName(proId),
            cityId = publicCityId.slice(0, 4),
            cityName = $scope.getCityName(proId, cityId),
            distId,
            distName;
          if (publicCityId.length == 6) {
            distId = publicCityId.slice(0, 6);
            distName = $scope.getDistName(cityId, distId);
          }
          $scope.province = { id: proId, name: proName };
          $scope.city = { id: cityId, name: cityName };
          $scope.dist = distId && { id: distId, name: distName };
          $scope.changeCity($scope.province);
          $scope.changeDist($scope.city, 'init');
          if (!!$scope.dist) $scope.selectDist($scope.dist, 'init');
          else $scope.cityDivSure('init');
        }
        $scope.changeCity = function(province) {
          // $scope.province = province;
          var id = province && province.id || $scope.province.id;
          $scope.city_arrs = [];
          for (c in sub_array[id]) {
            if (!!c && (c.slice(0, 2) == id)) {
              var city_arr = {};
              city_arr["id"] = c;
              city_arr["name"] = sub_array[id][c];
              $scope.city_arrs.push(city_arr);
            }
          }
        }
        $scope.changeDist = function(city, isInit) {
          // $scope.city = city;
          if (!isInit) $scope.dist = null;
          $timeout(function() {
            $scope.goTop('navDistList');
          })
          $scope.dist_arrs = [];
          var id = city && city.id;
          $scope.cityAlert = !!id ? false : true;
          if (!city) return;
          for (d in sub_arr[id]) {
            if (!!d && (d.slice(0, 4) == id)) {
              var dist_arr = {};
              dist_arr["id"] = d;
              dist_arr["name"] = sub_arr[id][d];
              $scope.dist_arrs.push(dist_arr);
            }
          }
        }
        $scope.selectDist = function(dist, isInit) {
          $scope.dist = dist;
          $scope.publicCityId = dist && dist.id;
          // $scope.publicCityName = dist && dist.name;
          if (!!isInit) return;
          if ($scope.distId == dist.id) { //选择了已经选中的区项
            $scope.dist = null;
            $('#' + dist.id).removeClass('quxian-li-current');
            return;
          }
          $scope.showNavRegion = false;
          $timeout(function() {
            // $scope.setChangeDistrict('selectDist');
          });
        }
        $scope.cancelChangeDist = function() {
          if ($scope.showNavRegion) {
            $scope.showNavRegion = false;
            $scope.initHomeCityName();
          }
        }
        $scope.cityDivSure = function(isInit) {
          if (!$scope.city) return;
          if (!$scope.dist) {
            $scope.publicCityId = $scope.city.id;
            // $scope.publicCityName = $scope.city.name;
          }
          if (!!isInit) return;
          $scope.showNavRegion = false;
          $timeout(function() {
            // $scope.setChangeDistrict('selectDist');
          });
        }
        $scope.cityBtnSure = function(city) {
          $scope.changeDist(city);
          $scope.cityDivSure();
        }
        $scope.getProName = function(proId) {
          for (pN in area_array) {
            if (pN == proId) {
              var proName = area_array[proId];
              break;
            }
          }
          return proName;
        }
        $scope.getCityName = function(proId, cityId) {
          for (cN in sub_array[proId]) {
            if (cN == cityId) {
              var cityName = sub_array[proId][cityId];
              break;
            }
          }
          return cityName;
        }
        $scope.getDistName = function(cityId, distId) {
          var distName;
          for (dN in sub_arr[cityId]) {
            if (dN == distId) {
              distName = sub_arr[cityId][distId];
              break;
            }
          }
          return distName;
        }
        $scope.showCityDiv = function() {
          $scope.showNavRegion = !$scope.showNavRegion;
        }
        $scope.initHomeCityName();
      }
    }
  }])
  /**
   * @description: 单标题头部
   * @usage: <header-with-title title = "功能介绍"></header-with-title>
   */
  .directive("headerWithTitle", function() {
    return {
      restrict: 'EA',
      replace: true,
      scope: true,
      templateUrl: "templates/header-with-title.html",
      link: function($scope, element, attrs) {
        var hasHeaderSearch = attrs.hasSearch,
          // headerTitle =  $scope.$eval(attrs.evalTitle) || attrs.title;
          headerTitle = attrs.title;
        $scope.headerTitle = headerTitle;
        $scope.headerClass = attrs.addClass;
        $scope.nohome = attrs.nohome == undefined ? false : true;
        $scope.hasHeaderSearch = hasHeaderSearch == undefined ? false : true;
      }
    }
  })
  .directive("footerContainer", function() {
    return {
      templateUrl: "templates/footer.html",
      restrict: "E"
    }
  })
  .directive("stationFooter", function() {
    return {
      templateUrl: "templates/station-footer.html",
      restrict: "E",
      replace: true,
      link: function($scope, element, attrs) {
        $scope.goStateLogin = function(state, params) {
          $scope.$emit('loginFirst', function() {
            $scope.goState(state, params)
          })
        }
      }
    }
  })
  /**
   * @description: 空数据展示
   * @usage: <empty-data></empty-data>
   * @usage: <empty-data hasimg></empty-data>
   * @usage: <empty-data hasimg='images/images' class="xxx">innerHTMLxxx</empty-data>
   */
  .directive("emptyData", function() {
    return {
      restrict: 'EA',
      replace: true,
      template: function(tElement, tAttrs) {
        var html = "",
          content = tElement[0].innerHTML ? tElement[0].innerHTML : "暂无数据, 敬请期待",
          imgUrl = tAttrs.hasimg == '' ? 'images/emptyData.jpg' : tAttrs.hasimg ? tAttrs.hasimg : false,
          elImg = imgUrl ? '<img src = "' + imgUrl + '" alt="暂无数据" />' : ''
          // elImg = imgUrl?
          ;
        html += '<div class="empty-datas"><div>' +
          '<dl><dd>' + elImg + '</dd>' +
          '<dt>' + content + '</dt>' +
          '</dl></div></div>';
        return html;
      }
    }
  })
  /**
   * @description: 将图片替换为可放大轮播
   * @usage: <p scroll-zoom-imgs="guideItem.approveFlowHtml"></p>
   * @usage: <ion-modal-view scroll-zoom-imgs="attr:article-has-bigimg"><p article-has-bigimg="guideItem.approveFlowHtml"></p></ion-modal-view>
   */
  .directive("scrollZoomImgs", function($compile, $sce, $document, $timeout) {
    return {
      scope: false,
      link: function($scope, element, attrs) {
        // console.log($scope.$id);
        var findParentScope = function(scope) {
          if (!scope) return false;
          if (scope.hasOwnProperty('fullscreenZoomImgs'))
            return scope;
          return findParentScope(scope.$parent);
        };
        var $pScope = findParentScope($scope);
        $scope = $pScope || $scope;
        var value = attrs.scrollZoomImgs,
          attr = value.split(','),
          wrap = attr[0].split('wrap:')[1],
          data = attr[1].split('data:')[1],
          $articleWrap, watchData;
        watchData = data;
        $scope.$on('$ionicView.beforeLeave', function() {
          var arr = $scope.imgsSwipeArr;
          if (!arr || !arr.length) return;
          for (i = 0; arr.length && i < arr.length; i++) {
            arr[i] && arr[i].destroy(true, true);
          }
        });
        $scope.$watch(
          function($scope) {
            return $scope.$eval(watchData);
          },
          function(content) {
            if (!content) {
              $articleWrap = $(element).find('[' + wrap + ']');
              $articleWrap.html('');
              return
            };
            //找到<img标签
            var reg = /<img[^>]*>/gi;
            var content = content && content.$$unwrapTrustedValue && content.$$unwrapTrustedValue(),
              images = content.match(reg);
            if (images && images.length) {
              var paginationClass = 'swiper-pagination-' + ($scope.stateName || '') + Math.floor((Math.random() * 10000) + 1);
              //解析拼接内容
              $articleImgs = $('<div class="article-big-img swiper-container" ng-show="showArticleImgs" ng-click="hideBigImage()"><ul class="swiper-wrapper"></ul><div class="swiper-pagination ' + paginationClass + '"></div></div>');
              for (var i = 0; i < images.length; i++) {
                var image = images[i],
                  first = image.substr(0, image.indexOf(' ') + 1),
                  next = image.substr(image.indexOf(' ')),
                  regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                  srcStr = image.match(regSrc)[1];
                // 将ng-click事件拼接到html中
                var final = first + ' ng-click="showBigImage(' + "'" + srcStr + "'" + ',' + i + ')"' + next;
                //为适应点击图片放大，因此将width和height属性过滤掉
                final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
                content = content.replace(image, final);
                var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + image + '</div></li>');
                $articleImgs.children('ul').append($li);
              }
              var allowTouchMove = images.length > 1 ? true : false;
              var dom = $compile($articleImgs.prop('outerHTML'))($scope);
              element.append(dom);
              var paginationV = images.length > 1 ? {
                el: '.' + paginationClass,
                dynamicBullets: true
              } : false;
              $scope.imgsSwipe = new Swiper($(dom), { //图片轮播 
                allowTouchMove: allowTouchMove,
                zoom: {
                  toggle: false,
                },
                pagination: paginationV,
              });
              $scope.imgsSwipeArr = $scope.imgsSwipeArr || [];
              $scope.imgsSwipeArr.push($scope.imgsSwipe);

              $scope.showBigImage = function(imgSrcPath, i) {
                $scope.showArticleImgs = true;
                $scope.imgsSwipe.slideTo(i, 0, false);
                if (!$scope.isUpdateSize) {
                  $scope.imgsSwipe.update();
                  $scope.isUpdateSize = true;
                }
              };
              $scope.hideBigImage = function() {
                $scope.showArticleImgs = false;
                $scope.imgsSwipe.zoom && $scope.imgsSwipe.zoom.out();
              };
            }
            $timeout(function() {
              $articleWrap = $(element).find('[' + wrap + ']');
              $articleWrap.html(content);
              $compile($articleWrap.contents())($scope);
            })
          }, true
        );
      }
    }
  })
  /**
   * @description: 滚动中固定导航元素
   * @usage: <ion-content has-fixed-nav = "anchorNav" on-scroll="ionScroll()">
   * anchorNav为导航元素的 html id 属性
   */
  .directive('hasFixedNav', ['$document', '$timeout', function($document, $timeout) {
    return {
      restrict: 'A',
      link: function($scope, $element, attrs) {
        console.log(attrs);
        $scopeP = $scope.$parent;
        var anchors = attrs.hasFixedNav.split(','), anchorTops = [], intiHeigth;
        $scopeP.scrollNavLevel = { now: 0 };
        $scope.ionScroll = function() {
          if (!intiHeigth) {
            for (var i = 0; i < anchors.length; i++) {
              var anchor = $document[0].getElementById(anchors[i]);
              if (anchor.clientHeight > 0) {
                anchorTops[i] = anchor.offsetTop;
                $scopeP.navAnchorTop = anchorTops[1];
                intiHeigth = true;
              } else {
                intiHeigth = false;
                break;
              }
            }
          }
          var scrollTop = event.detail && event.detail.scrollTop,
            $gotop = $(event.target).parents('ion-view').children('.goTop');
          if (scrollTop < 20) $gotop.hide();
          else $gotop.show();
          if (intiHeigth) {
            if (scrollTop < anchorTops[1]) $scope.$apply(function() {
              $scopeP.scrollNavLevel.now = 0;
            });
            for (var i = 0; i < anchorTops.length; i++) {
              var anchorTop = anchorTops[i];
              if (scrollTop >= anchorTop) $scope.$apply(function() {
                $scopeP.scrollNavLevel.now = i;
              });
            }
          }
          // console.log(scrollTop,$scope.scrollNavLevel.now)
        }
      }
    };
  }])
  /**
   * @description: 滚动中固定导航元素
   * @usage: <ion-content has-fixed-nav = "anchorNav" on-scroll="ionScroll()">
   * anchorNav为导航元素的 html id 属性
   */
  .directive('formRules', ['$document', '$timeout', '$ionicScrollDelegate', function($document, $timeout, $ionicScrollDelegate) {
    return {
      restrict: 'A',
      link: function($scope, $element, attrs) {
        function findScope($scope) {
          var sc = $scope.$parent;
          if (!sc.hasOwnProperty('stateName')) sc = findScope(sc)
          return sc;
        }
        $scope = findScope($scope);
        $scope.testForm = function(type, param, $el) {
          switch (type) {
            case 'idCard':
              var regExp = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
              return regExp.test(param) || '请输入正确的身份证号'
            case 'tel':
              var regExp = /^(0[0-9]{2,3}\-)?([2-9][0-9]{6,7})+(\-[0-9]{1,6})?$/
              var regExp2 = /^([1]\d{10}|([\(（]?0[0-9]{2,3}[）\)]?[-]?)?([2-9][0-9]{6,7})+(\-[0-9]{1,4})?)$/
              return regExp.test(param) || regExp2.test(param) || '联系电话格式有误'
            case 'required':
              var label = $el.attr('label')
              var label = label ? ($scope.errMsg + '“' + label + '”') : '请完整填写表单'
              return (param[0] != undefined && param[0] != null && (param[0].trim() != '') && param[1] != 'false') || label
            /* case 'formContent':
              var text = $el.text()
              return (text != undefined && text != null && (text.trim() != '')) || '请完整填写表单' */
            default: return true
          }
        }
        $scope.$on('$ionicView.enter', function() {
          $timeout(function() {
            $props = $($element[0]).find('[prop]')
            $required = $($element[0]).find('[require]')
            $required.each(function(a, el) {
              var $el = angular.element(el)
              // if($el.attr('type') == 'sex') $el = $el.find('input')
              $el.on('blur', function(e) {
                var result = $el.attr('require')
                var value = $el.val()
                if ($scope.testForm('required', [value, result], $el) != true) $el.addClass('error')
              })
              $el.on('focus', function(e) {
                $el.removeClass('error');
              })
            })
            $props.each(function(a, el) {
              var $el = angular.element(el)
              var type = $el.attr('prop')
              $el.on('blur', function(e) {
                var value = $el.val()
                if ($scope.testForm(type, value, $el) != true) $el.addClass('error')
              })
              $el.on('focus', function(e) {
                $el.removeClass('error')
                /* if (type == 'formContent') {
                  var delegateForm = $ionicScrollDelegate.$getByHandle('formScroll');
                  $timeout(function () {
                    delegateForm.resize();
                  }, 1500)
                } */
              })
              /* if(type == 'formContent'){
                $el.on('keyup', function (e) {
                  $scope.$apply(function(){
                    $scope.form.content = $el.text()
                  })
                })
                var delegateForm = $ionicScrollDelegate.$getByHandle('formScroll');
                $timeout(function(){
                  delegateForm.resize();
                },1500)
              } */
            })
          })
        })
        $scope.errMsg = '请正确填选'
        $scope.ruleAll = function(msg) {
          $scope.errMsg = msg || '请正确填选'
          $props = $($document).find('[prop]:visible')
          $required = $($document).find('[require]:visible')
          var result = true
          $required.each(function(a, el) {
            var $el = angular.element(el)
            var rs = $el.attr('require')
            var value = $el.val()
            var msg = $scope.testForm('required', [value, rs], $el)
            if (msg != true) {
              result = msg
              $el.addClass('error')
              return false
            }
          })
          if (result != true) return result
          $props.each(function(a, el) {
            var $el = angular.element(el)
            var type = $el.attr('prop')
            var value = $el.val()
            var msg = $scope.testForm(type, value, $el)
            if (msg != true) {
              result = msg
              $el.addClass('error')
              return false
            }
          })
          return result
        }
      }
    };
  }])