appModule.config(['$stateProvider', '$controllerProvider', '$urlRouterProvider', '$ionicConfigProvider', '$ocLazyLoadProvider', function($stateProvider, $controllerProvider, $urlRouterProvider, $ionicConfigProvider, $ocLazyLoadProvider) {
    appModule.controller = $controllerProvider.register;
    //安卓系统tab 置底效果
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');
    $ionicConfigProvider.scrolling.jsScrolling(true);
    //var timestamp = Date && Date.now();
    function loadSequence(files, prods) {
        // var _args = arguments[0];
        var _args = files;
        return {
            deps: ['$ocLazyLoad', '$q',
                function($ocLL, $q) {
                    var promise = $q.when(1);
                    for (var i = 0, len = _args.length; i < len; i++) {
                        promise = $ocLL.load(_args[i]);
                    }
                    return promise;
                }]
            /* deps:  function(){
              return {'load':['$ocLazyLoad', '$q',
              function ($ocLL, $q) {
                var promise = $q.when(1);
                for (var i = 0, len = _args.length; i < len; i++) {
                  promise = $ocLL.load(_args[i]);
                }
                return promise;
              }],'value': 'A'};
           } */
        };
    }
    $stateProvider
        .state('home', { //首页
            url: '/home',
            views: {
                'main': {
                    templateUrl: 'templates/home.html',
                    controller: 'HomeController'
                }
            }
        })
        .state('test', { //test log
            url: '/test',
            views: {
                "main": {
                    templateUrl: 'test.html',
                    prefetchTemplate: false,
                    controller: 'testController',
                    resolve: loadSequence(['test.js'])
                }
            }
        })
        /* .state('log', { //test log
          url: '/log',
          views: {
            "main": {
              templateUrl: 'pages/log/index.html',
              prefetchTemplate: false,
              controller: 'logController',
              resolve: loadSequence(['pages/log/index.js'])
            }
          }
        }) */
        .state('search', { //搜索文字
            url: '/search',
            views: {
                "main": {
                    templateUrl: 'pages/search/index.html',
                    prefetchTemplate: false,
                    controller: 'searchController',
                    resolve: loadSequence(['pages/search/index.js'])
                }
            },
            params: {
                searchKey: null
            }
        })
        .state('chooseCity', {
            url: '/chooseCity/:unionid/:nickname',
            views: {
                'main': {
                    templateUrl: 'templates/chooseCity.html',
                    prefetchTemplate: false,
                    controller: 'ChooseCityController',
                    resolve: loadSequence(['js/controllers/chooseCityCtrl.js'])
                }
            }
        })
        .state('flow', { //企业招商流程
            url: '/flow',
            views: {
                'main': {
                    templateUrl: 'templates/flow.html',
                    prefetchTemplate: false,
                    controller: 'FlowController',
                    resolve: loadSequence(['css/flow.css', 'js/controllers/flowCtrl.js'])
                }
            }
        })
        .state('convenienceService', {
            url: '/convenienceService',
            views: {
                'main': {
                    templateUrl: 'pages/convenience-service/index.html',
                    prefetchTemplate: false,
                    controller: 'convenienceServiceController',
                    resolve: loadSequence(['pages/convenience-service/index.js'])
                }
            }
        })
        .state('convenienceSList', {
            url: '/convenienceSList/:typeId',
            views: {
                'main': {
                    templateUrl: 'pages/convenience-service/list/index.html',
                    prefetchTemplate: false,
                    controller: 'convenienceSListController',
                    resolve: loadSequence(['pages/convenience-service/list/index.js'])
                }
            },
            params: { iconName: null }
        })
        .state('convenienceSDetail', {
            url: '/convenienceSDetail/:id',
            views: {
                'main': {
                    templateUrl: 'pages/convenience-service/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'BNServiceDtailController',
                    resolve: loadSequence(['pages/convenience-service/detail/index.js'])
                }
            }
        })
        .state('cv19NAT', { // 核酸检测
            url: '/cv19NAT',
            views: {
                "main": {
                    templateUrl: 'pages/cv19NAT/index.html',
                    prefetchTemplate: false,
                    controller: 'cv19NATController',
                    resolve: loadSequence(['pages/cv19NAT/index.css', 'pages/cv19NAT/index.js']) 
                }
            }
        })
        .state('cv19permit', { // 疫情电子通行码
            url: '/cv19permit',
            views: {
                "main": {
                    templateUrl: 'pages/cv19permit/index.html',
                    prefetchTemplate: false,
                    controller: 'cv19permitController',
                    resolve: loadSequence(['lib/jquery/qrcode.min.js','pages/cv19permit/index.css', 'pages/cv19permit/index.js']) 
                }
            }
        })
        .state('scTtbcv19', { // 通通办公共卫生
            url: '/scTtbcv19',
            // cache:false
            views: {
                "main": {
                    templateUrl: 'pages/ttb/cv19/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbDCV19Controller',
                    resolve: loadSequence(['css/mobiscroll/mobiscroll.custom-2.5.0.min.css', 'lib/mobiscroll/mobiscroll.custom-2.5.0.min.js', 'pages/ttb/index.css', 'pages/ttb/cv19/index.js'])  //日期选择控件
                }
            }
        })
        .state('scTtbCV19Handle', { //通通办公共卫生 管理
            url: '/scTtbCV19Handle',
            views: {
                "main": {
                    templateUrl: 'pages/ttb/cv19/handle/index.html',
                    prefetchTemplate: false,
                    controller: 'scTtbCV19HandleController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/ttb/index.css', 'pages/ttb/cv19/handle/index.js'])
                }
            },
            params: {
                region: null,
                roleLevel: null
            }
        })
        .state('ttbyiciban', {  // ttb 一次办
            url: '/ttbyiciban',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/yiciban/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbyicibanController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/yiciban/index.js'])
                }
            }
        })
        .state('ttbYCList', {
            url: '/ttbYCList',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/yiciban/list.html',
                    prefetchTemplate: false,
                    controller: 'ttbYCListController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/yiciban/list.js'])
                }
            },
            params: {
                thingType: null
                // , complete: false
            }
        })
        .state('ttbYCCreate', {
            url: '/ttbYCCreate',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/yiciban/create.html',
                    prefetchTemplate: false,
                    controller: 'ttbYCCreateController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/yiciban/create.js'])
                }
            },
            params: {
                thingType: null,
                thing: null
            }
        })
        .state('ttbYCReCreate', {
            url: '/ttbYCReCreate',
            cache: false,
            views: {
                'main': {
                    templateUrl: 'pages/ttb/yiciban/reCreate.html',
                    prefetchTemplate: false,
                    controller: 'ttbYCReCreateController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/yiciban/reCreate.js'])
                }
            },
            params: {
                thingType: null,
                thing: null
            }
        })
        //出生一次办
        .state('ttbOneProcess', {  // 出生一次办
            url: '/ttbOneProcess',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/oneProcess/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbOneProcessController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/oneProcess/index.js'])
                }
            },
            params: {
                // typeId: null,
                complete: false
            }
        })
        .state('ttbOPCreate', {  // ttb 一次办
            url: '/ttbOPCreate',
            cache: false,
            views: {
                'main': {
                    templateUrl: 'pages/ttb/oneProcess/create.html',
                    prefetchTemplate: false,
                    controller: 'ttbOPCreateController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/oneProcess/create.js'])
                }
            },
            params: {
                typeId: null,
                thing: null
            }
        })
        .state('ttbOPReCreate', {  // ttb 一次办
            url: '/ttbOPReCreate',
            cache: false,
            views: {
                'main': {
                    templateUrl: 'pages/ttb/oneProcess/reCreate.html',
                    prefetchTemplate: false,
                    controller: 'ttbOPReCreateController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/oneProcess/reCreate.js'])
                }
            },
            params: {
                thing: null
            }
        })
        .state('xinyongzhongguo', {
            url: '/xinyongzhongguo',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/xinyongzhongguo/index.html',
                    prefetchTemplate: false,
                    controller: 'xinyongzhongguoController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/xinyongzhongguo/index.js'])
                }
            }
        })
        .state('xinyongManual', {
            url: '/xinyongManual',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/xinyongManual/index.html',
                    prefetchTemplate: false,
                    controller: 'xinyongManualController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/xinyongManual/index.js'])
                }
            }
        })
        .state('ttbHomepage', {
            url: '/ttbHomepage',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbHomepageController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/index.js'])
                }
            }
        })
        .state('ttbProduct', {
            url: '/ttbProduct',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/product/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbProductController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/product/index.js'])
                }
            },
            params: {
                name: null
            }
        })
        .state('ttbHometown', {
            url: '/ttbHometown',
            views: {
                'main': {
                    templateUrl: 'pages/ttb/hometown/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbHometownController',
                    resolve: loadSequence(['pages/ttb/index.css', 'pages/ttb/hometown/index.js'])
                }
            },
            params: {
                initTab: null,
                hometownTypeId: null
            }
        })
        .state('ttbHometownDetail', { //家乡美详情
            url: '/ttbHometownDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/ttb/hometown-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'ttbHometownDetailController',
                    resolve: loadSequence(['pages/ttb/hometown-detail/index.js'])
                }
            }
        })
        .state('hometown', {
            url: '/hometown',
            views: {
                'main': {
                    templateUrl: 'pages/hometown/index.html',
                    prefetchTemplate: false,
                    controller: 'hometownController',
                    resolve: loadSequence(['pages/hometown/index.js'])
                }
            },
            params: {
                initTab: null
            }
        })
        .state('hometownDetail', { //家乡美详情
            url: '/hometownDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/hometown/hometown-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'HometownDetailController',
                    resolve: loadSequence(['pages/hometown/hometown-detail/index.js'])
                }
            }
        })
        .state('companyList', {
            url: '/companyList/:typeId',
            views: {
                'main': {
                    templateUrl: 'pages/hometown/company-list/index.html',
                    prefetchTemplate: false,
                    controller: 'companyListController',
                    resolve: loadSequence(['pages/hometown/company-list/index.js'])
                }
            },
            params: { iconName: null }
        })

        .state('tjCompanyDetail', {
            url: '/tjCompanyDetail/:id',
            views: {
                'main': {
                    templateUrl: 'pages/hometown/company-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'TjCompanyDtailController',
                    resolve: loadSequence(['pages/hometown/company-detail/index.js'])
                }
            }
        })
        .state('personal', {
            url: '/personal',
            cache: false,
            views: {
                'main': {
                    templateUrl: 'pages/personal/index.html',
                    prefetchTemplate: false,
                    controller: 'PersonalController',
                    resolve: loadSequence(['pages/personal/index.js'])
                }
            }
        })

        .state('newsDetail', { //新闻详情
            url: '/newsDetail/:id',
            views: {
                "main": {
                    templateUrl: 'templates/home-news-detail.html',
                    prefetchTemplate: false,
                    controller: 'NewsDetailController',
                    resolve: loadSequence(['js/controllers/homeNewsCtrl.js'])
                }
            }
        })
        .state('login', { //登录
            url: '/login',
            views: {
                "main": {
                    templateUrl: 'templates/user-login.html',
                    prefetchTemplate: false,
                    controller: 'LoginController',
                    resolve: loadSequence(['js/controllers/userCtrl.js'])
                }
            }
        })
        .state('register', { //注册
            url: '/register',
            views: {
                "main": {
                    templateUrl: 'templates/user-register.html',
                    prefetchTemplate: false,
                    controller: 'RegController',
                    resolve: loadSequence(['js/controllers/userCtrl.js', 'lib/jquery/Area.js'])
                }
            }
        })
        .state('forgetPassword', { //忘记密码
            url: '/forgetPassword',
            views: {
                "main": {
                    templateUrl: 'templates/user-forgetPassword.html',
                    prefetchTemplate: false,
                    controller: 'findPwdController',
                    resolve: loadSequence(['js/controllers/userCtrl.js'])
                }
            }
        })
        .state('userInfo', { //用户个人信息
            url: '/userInfo',
            views: {
                "main": {
                    templateUrl: 'pages/personal/user-info/index.html',
                    prefetchTemplate: false,
                    controller: 'userInfoController',
                    resolve: loadSequence(['pages/personal/user-info/index.js'])
                }
            },
            params: { formContent: false, editItem: null, region: null }
        })
        .state('policyElite', { //政策干货
            url: '/policyElite',
            views: {
                'main': {
                    templateUrl: 'pages/policy/policyElite/index.html',
                    prefetchTemplate: false,
                    controller: 'policyEliteController',
                    resolve: loadSequence(['pages/policy/policyElite/index.css', 'pages/policy/policyElite/index.js'])
                }
            }
        })
        .state('policyEliteDetail', { //政策干货详情
            url: '/policyEliteDetail',
            views: {
                'main': {
                    templateUrl: 'pages/policy/policyElite/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'policyEliteDetailController',
                    resolve: loadSequence(['pages/policy/policyElite/index.css', 'pages/policy/policyElite/detail/index.js'])
                }
            },
            params: {
                id: null,
                title: null
            }
        })
        .state('policy', { //政策首页
            url: '/policy/:typeflag',
            views: {
                'main': {
                    templateUrl: 'pages/policy/index.html',
                    prefetchTemplate: false,
                    controller: 'policyHomeController',
                    resolve: loadSequence(['pages/policy/index.js'])
                }
            }
        })
        .state('myPolicySubscribe', { //我的政策订阅
            url: '/myPolicySubscribe',
            views: {
                'main': {
                    templateUrl: 'pages/policy/mySubcribe/index.html',
                    prefetchTemplate: false,
                    controller: 'myPolicySubscribeController',
                    resolve: loadSequence(['pages/policy/mySubcribe/index.js'])
                }
            }
        })
        .state('policyList', { //政策列表页
            url: '/policyList/:categoryId',
            views: {
                'main': {
                    templateUrl: 'pages/policy/list/index.html',
                    prefetchTemplate: false,
                    controller: 'policyListController',
                    resolve: loadSequence(['pages/policy/list/index.js'])
                }
            },
            params: {
                // categoryId:null,
                categoryName: null
            }
        })
        .state('policyDetail', { //政策详情
            url: '/policyDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/policy/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'policyDetailController',
                    resolve: loadSequence(['pages/policy/detail/index.js'])
                }
            }
        })
        .state('sectionInspect', { 
            url: '/sectionInspect/:id',
            views: {
                'main': {
                    templateUrl: 'pages/inspection/section-inspect.html',
                    prefetchTemplate: false,
                    controller: 'SectionInspectController',
                    resolve: loadSequence(['pages/inspection/sectionInspectCtrl.js'])
                }
            }
        })
        .state('message', { //办事指南
            url: '/message',
            views: {
                "main": {
                    templateUrl: 'templates/forum-message.html',
                    prefetchTemplate: false,
                    controller: 'MessageController',
                    resolve: loadSequence(['js/controllers/forumMessageCtrl.js'])
                }
            }
        })
        .state('market', { //扶贫商品 特产商城
            url: '/market',
            views: {
                "main": {
                    templateUrl: 'pages/fupin/index.html',
                    prefetchTemplate: false,
                    controller: 'MarketController',
                    resolve: loadSequence(['pages/fupin/index.js'])
                }
            }
        })
        .state('dealDetail', { //商品详情
            url: '/dealDetail/:id',
            cache: 'false',
            views: {
                "main": {
                    templateUrl: 'templates/deal-detail.html',
                    prefetchTemplate: false,
                    controller: 'DealDetailController',
                    resolve: loadSequence(['js/controllers/dealDetailCtrl.js'])
                }
            }
        })
        .state('myself', { //我的视频
            url: '/myself',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/my/index.html',
                    prefetchTemplate: false,
                    controller: 'MyselfController',
                    resolve: loadSequence(['pages/vio-station/my/index.js'])
                }
            },
            params: { tabIndex: null }
        })
        .state('station', { //小知说事
            url: '/station',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/index.html',
                    prefetchTemplate: false,
                    controller: 'StationController',
                    resolve: loadSequence(['pages/vio-station/index.js'])
                }
            }
        })
        .state('activity', { //歌手大赛
            url: '/activity',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/activity/index.html',
                    prefetchTemplate: false,
                    controller: 'ActivityController',
                    resolve: loadSequence(['pages/vio-station/activity/index.js'])
                }
            }
        })
        .state('upload', { //上传视频
            url: '/upload',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/upload/index.html',
                    prefetchTemplate: false,
                    controller: 'uploadController',
                    resolve: loadSequence(['pages/vio-station/upload/index.js'])
                }
            }
        })
        .state('entertainDetail', { //上传视频
            url: '/entertainDetail/:id/:type/:userId',
            cache: 'false',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/vio-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'EntertainDetailController',
                    resolve: loadSequence(['pages/vio-station/vio-detail/index.js'])
                }
            }
        })
        .state('vioStationAuthor', { //关注用户详情
            url: '/vioStationAuthor',
            // cache: 'false',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/author/index.html',
                    prefetchTemplate: false,
                    controller: 'vioAuthorDetailsController',
                    resolve: loadSequence(['pages/vio-station/author/index.js'])
                }
            },
            params: {
                author: null
            }
        })
        .state('entertainAttentionDetail', { //关注用户视频娱乐详情
            url: '/entertainAttentionDetail/:id/:userId',
            // cache: 'false',
            views: {
                "main": {
                    templateUrl: 'pages/vio-station/author/details/index.html',
                    prefetchTemplate: false,
                    controller: 'entertainAttentionDetailController',
                    resolve: loadSequence(['pages/vio-station/author/details/index.js'])
                }
            }
        })
        .state('myLeaveMsg', { //我的留言板
            url: '/myLeaveMsg',
            cache: false,
            views: {
                "main": {
                    templateUrl: 'pages/msg/my/index.html',
                    prefetchTemplate: false,
                    controller: 'myLeaveMsgController',
                    resolve: loadSequence(['pages/msg/my/index.js'])
                }
            }
        })
        .state('leaveMsg', { //留言板
            url: '/leaveMsg/:areaID',
            views: {
                "main": {
                    templateUrl: 'pages/msg/index.html',
                    prefetchTemplate: false,
                    controller: 'LeaveMsgController',
                    resolve: loadSequence(['pages/msg/index.js'])
                }
            }
        })

        .state('leaveMsgDetail', { //留言详情
            url: '/leaveMsgDetail/:id/:areaID',
            views: {
                "main": {
                    templateUrl: 'pages/msg/details/index.html',
                    prefetchTemplate: false,
                    controller: 'LeaveMsgDetailController',
                    resolve: loadSequence(['pages/msg/details/index.js'])
                }
            },
            params: {
                queryUrl: null,
                readType: null
            }
        })

        .state('ours', { //关于我们
            url: '/ours',
            views: {
                "main": {
                    templateUrl: 'templates/ours.html',
                    prefetchTemplate: false,
                    controller: 'OursController',
                    resolve: loadSequence(['js/controllers/oursCtrl.js'])
                }
            }
        })
        .state('livelihood', { //民生纪事
            url: '/livelihood',
            views: {
                "main": {
                    templateUrl: 'pages/inspection/livelihood/index.html',
                    prefetchTemplate: false,
                    controller: 'livelihoodController',
                    resolve: loadSequence(['pages/inspection/livelihood/index.js'])
                }
            }, params: {
                item: null,
                formContent: null
            }
        })
        .state('feedBack', { //纪委反馈
            url: '/feedBack',
            views: {
                "main": {
                    templateUrl: 'pages/inspection/feedBack.html',
                    prefetchTemplate: false,
                    controller: 'feedBackController',
                    resolve: loadSequence(['pages/office-affairs/office.css', 'pages/inspection/feedBackCtrl.js'])
                }
            },
            params: {
                tabIndex: null
            }
        })
        .state('feedBackDetail', { //纪委反馈 查看
            url: '/feedBackDetail/:id/:areaID/:flag',
            views: {
                "main": {
                    templateUrl: 'pages/inspection/feedBackDetail.html',
                    prefetchTemplate: false,
                    controller: 'feedBackDetailController',
                    resolve: loadSequence(['pages/inspection/feedBackCtrl.js'])
                }
            }
        })
        .state('officeHome', { //办事大厅选择区域和部门
            url: '/officeHome',
            views: {
                "main": {
                    templateUrl: 'pages/office-affairs/index.html',
                    prefetchTemplate: false,
                    controller: 'officeHomeController',
                    resolve: loadSequence(['pages/office-affairs/office.css', 'pages/office-affairs/index.js'])
                }
            },
            params: {
                tabName: null
            }
        })
        .state('officeWangban', { //网办服务
            url: '/officeWangban',
            views: {
                "main": {
                    templateUrl: 'pages/office-affairs/wangban/index.html',
                    prefetchTemplate: false,
                    controller: 'officeWangbanController',
                    resolve: loadSequence(['pages/office-affairs/office.css', 'pages/office-affairs/wangban/index.js'])
                }
            }
        })
        .state('officeZhangban', { //掌办服务
            url: '/officeZhangban',
            views: {
                "main": {
                    templateUrl: 'pages/office-affairs/zhangban/index.html',
                    prefetchTemplate: false,
                    controller: 'officeZhangbanController',
                    resolve: loadSequence(['pages/office-affairs/office.css', 'pages/office-affairs/zhangban/index.js'])
                }
            }
        })
        .state('officeDepartmentList', { //部門--企业列表
            url: '/officeDepartmentList/:id',
            views: {
                'main': {
                    templateUrl: 'pages/office-affairs/depat/list/index.html',
                    prefetchTemplate: false,
                    controller: 'officeDepartmentListController',
                    resolve: loadSequence(['pages/office-affairs/depat/list/index.js'])
                }
            }
        })
        .state('officeDepartmentDetail', { //公司详情
            url: '/officeDepartmentDetail/:id',
            views: {
                'main': {
                    templateUrl: 'pages/office-affairs/depat/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'DepartmentJSDetailController',
                    resolve: loadSequence(['pages/office-affairs/depat/detail/index.js'])
                }
            },
            params: {
                queryUrl: null
            }
        })
        .state('officeAffairs', { //政务事项
            url: '/officeAffairs',
            views: {
                "main": {
                    templateUrl: 'pages/office-affairs/affairs/index.html',
                    prefetchTemplate: false,
                    controller: 'officeAffairsController',
                    resolve: loadSequence(['pages/office-affairs/affairs/index.js'])
                }
            },
            params: { showAllActions: 1, officeDeptId: null, tabIndex: 1 }
        })
        /* .state('cwgkHome', { //村务公开
            url: '/cwgkHome',
            views: {
                "main": {
                    templateUrl: 'pages/cwgk/index.html',
                    prefetchTemplate: false,
                    controller: 'cugkController',
                    resolve: loadSequence(['pages/cwgk/css/index.css', 'pages/cwgk/index.js'])
                }
            }
        }) */
        /* .state('cwgk', { //母版
            url: '/cwgk',
            views: {
                "main": {
                    templateUrl: 'pages/cwgk/mast.html',
                    prefetchTemplate: false,
                    controller: 'cwgkMastController',
                    resolve: loadSequence(['pages/cwgk/mast.js'])
                }
            },
            params: {
                rootIndex: null,
                navRoot: null
            }
        }) */
        /* .state('cwgk.funcList', { //5级 功能/文章列表
            url: '/funcList',
            views: {
                "list": {
                    templateUrl: 'pages/cwgk/functions/list/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkFuncListController',
                    resolve: loadSequence(['pages/cwgk/functions/list/index.js'])
                }
            }
        }) */
        /* .state('cwgk.glory', { //光荣榜
            url: '/glory',
            views: {
                "glory": {
                    templateUrl: 'pages/cwgk/functions/glory/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkGloryController',
                    resolve: loadSequence(['pages/cwgk/functions/glory/index.js'])
                }
            }
        }) */
        /* .state('cwgk.yxdy', { //优秀党员
            url: '/yxdy',
            views: {
                "yxdy": {
                    templateUrl: 'pages/cwgk/functions/yxdy/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkYxdyController',
                    resolve: loadSequence(['pages/cwgk/functions/yxdy/index.js'])
                }
            }
        }) */
        /* .state('cwgk.leaders', { // 部门负责人
            url: '/leaders',
            views: {
                "leaders": {
                    templateUrl: 'pages/cwgk/functions/leaders/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkLeadersController',
                    resolve: loadSequence(['pages/cwgk/functions/leaders/index.js'])
                }
            }
        }) */
        /* .state('cwgkArticleDetail', { //文章详情
            url: '/cwgkArticleDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/cwgk/article-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkArticleDetailController',
                    resolve: loadSequence(['pages/cwgk/css/index.css', 'pages/cwgk/article-detail/index.js'])
                }
            },
            params: {
                type: 'article',
                queryUrl: null,
                shareFlag: null
            }
        }) */
        /* .state('cwgkMsgboard', { //村务留言板
            url: '/cwgkMsgboard',
            views: {
                "main": {
                    templateUrl: 'pages/cwgk/msgboard/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkMsgboardController',
                    resolve: loadSequence(['pages/cwgk/msgboard/index.js'])
                }
            },
            params: {
                regionId: null,
                productId: null
            }
        }) */
        /* .state('cwgkHandle', { //审核
            url: '/cwgkHandle',
            views: {
                "main": {
                    templateUrl: 'pages/cwgk/handle/index.html',
                    prefetchTemplate: false,
                    controller: 'cwgkHandleController',
                    resolve: loadSequence(['pages/cwgk/css/index.css', 'pages/cwgk/handle/index.js'])
                }
            },
            params: {
                region: null,
                handleNav: null,
            }
        }) */
        /* .state('msgboard', { //公共留言板
            url: '/msgboard',
            views: {
                "main": {
                    templateUrl: 'pages/common/msgboard/index.html',
                    prefetchTemplate: false,
                    controller: 'msgboardController',
                    resolve: loadSequence(['pages/common/msgboard/index.js'])
                }
            },
            params: {
                regionId: null,
                productId: null
            }
        }) */
        /* .state('msgDetail', { //公共留言详情
            url: '/msgDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/common/msgboard/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'msgDetailController',
                    resolve: loadSequence(['pages/common/msgboard/detail/index.js'])
                }
            },
            params: {
                isRead: null,
                regionId: null,
                productId: null
            }
        }) */
        /* .state('villageAffairs', { //村务公开
            url: '/villageAffairs',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/home.html',
                    prefetchTemplate: false,
                    controller: 'villageAffairsController',
                    resolve: loadSequence(['js/controllers/village-affairs/home.js'])
                }
            }
        }) */
        /* .state('organization', { //组织机构 - 人员结构
            url: '/organization',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-organization.html',
                    prefetchTemplate: false,
                    controller: 'organizationController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAOrganizationCtrl.js'])
                }
            },
            params: {
                fromTab: null,
                toTab: null,
                workFlowId: null
            }
        }) */
        /* .state('departmentsLeaders', { //组织机构 - 部门详细页
            url: '/departmentsLeaders/:departmentsId',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-organization-departmentsLeaders.html',
                    prefetchTemplate: false,
                    controller: 'departmentsLeadersController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageDepartmentsLeadersCtrl.js'])
                }
            },
            params: {
                fromTab: null,
                departmentsName: null
            }
        }) */
        /* .state('popularizeLaw', { //普法内容
            url: '/popularizeLaw',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-popularizeLaw.html',
                    prefetchTemplate: false,
                    controller: 'popularizeLawController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAPopularizeLawCtrl.js'])
                }
            }
        }) */
        /* .state('projectPlan', { //规划计划
            url: '/projectPlan',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-projectPlan.html',
                    prefetchTemplate: false,
                    controller: 'projectPlanController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAProjectPlanCtrl.js'])
                }
            }
        }) */
        /* .state('partyConstruction', { //党建内容
            url: '/partyConstruction',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-partyConstruction.html',
                    prefetchTemplate: false,
                    controller: 'partyConstructionController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAPartyConstructionCtrl.js'])
                }
            },
            params: {
                tabIndex: 0
            }
        }) */
        /* .state('honorList', { //光荣榜
            url: '/honorList',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-honorList.html',
                    prefetchTemplate: false,
                    controller: 'honorListController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAHonorListCtrl.js'])
                }
            },
            params: {
                tabIndex: 0
            }
        }) */
        /* .state('activitieShows', { //活动展示
            url: '/activitieShows',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-activitieShows.html',
                    prefetchTemplate: false,
                    controller: 'activitieShowsController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAActivitieShowsCtrl.js'])
                }
            }
        }) */
        /* .state('informationOpen', { //信息公开
            url: '/informationOpen',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-informationOpen.html',
                    prefetchTemplate: false,
                    controller: 'informationOpenController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageAInformationOpenCtrl.js'])
                }
            }
        }) */
        /* .state('villageResources', { //村内资源
            url: '/villageResources',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-resources.html',
                    prefetchTemplate: false,
                    controller: 'villageResourcesController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageResourcesCtrl.js'])
                }
            },
            params: {
                tabIndex: null
            }
        }) */
        /* .state('villageMessageBoard', { //村务留言板
            url: '/villageMessageBoard',
            views: {
                "main": {
                    templateUrl: 'templates/village-affairs/villageAffairs-messageBoard.html',
                    prefetchTemplate: false,
                    controller: 'villageMessageBoardController',
                    resolve: loadSequence(['js/controllers/village-affairs/villageMessageBoardCtrl.js'])
                }
            }
        }) */
        .state('comArticle', { //文章内容页.公共页面.只显示文章
            url: '/comArticle/:articleQuery/:id',
            views: {
                "main": {
                    templateUrl: 'templates/comnmon-articles.html',
                    prefetchTemplate: false,
                    controller: 'comArticlesController',
                    resolve: loadSequence(['js/controllers/comArticlesCtrl.js'])
                }
            },
            params: {
                fromTab: null,
                whiteList: null,
                shareFlag: null
            }
        })
        .state('articles', { //公共文章页
            url: '/articles/',
            views: {
                "main": {
                    templateUrl: 'pages/common/articles/index.html',
                    prefetchTemplate: false,
                    controller: 'articlesController',
                    resolve: loadSequence(['pages/common/articles/index.js'])
                }
            },
            params: {
                url: null,
                data: null,
                shareFlag: null
            }
        })
        .state('comTitlesList', { //标题列表页.公共页面
            url: '/comTitlesList/:titlesQuery/',
            views: {
                "main": {
                    templateUrl: 'templates/comnmon-titles-list.html',
                    prefetchTemplate: false,
                    controller: 'comTitlesListController',
                    resolve: loadSequence(['js/controllers/comTitlesListCotrl.js'])
                }
            }
        })
        .state('comPerson', { //人物详情页.公共页面
            url: '/comPerson/:personQuery/:personId',
            views: {
                "main": {
                    templateUrl: 'templates/comnmon-person.html',
                    prefetchTemplate: false,
                    controller: 'comPersonController',
                    resolve: loadSequence(['js/controllers/comPersonCtrl.js'])
                }
            },
            params: {
                fromTab: null
            }
        })
        .state('yiqing', { //共抗疫情
            url: '/yiqing',
            views: {
                "main": {
                    templateUrl: 'pages/yiqing/index.html',
                    prefetchTemplate: false,
                    controller: 'yiqingHomeController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/yiqing/index.js'])
                }
            }
        })
        .state('yiqingDongtai', { //疫情动态
            url: '/yiqingDongtai',
            views: {
                "main": {
                    templateUrl: 'pages/yiqing/dongtai/index.html',
                    prefetchTemplate: false,
                    controller: 'yiqingDongtaiController',
                    resolve: loadSequence(['css/mobiscroll/mobiscroll.custom-2.5.0.min.css', 'pages/yiqing/index.css', 'lib/mobiscroll/mobiscroll.custom-2.5.0.min.js', 'lib/echarts/echarts.min.js', 'pages/yiqing/dongtai/index.js'])
                }
            }
        })
        .state('yiqingTianbao', { //入省车辆人员填报
            url: '/yiqingTianbao',
            views: {
                "main": {
                    templateUrl: 'pages/yiqing/tianbao/index.html',
                    prefetchTemplate: false,
                    controller: 'yiqingTianbaoController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/yiqing/tianbao/index.js'])
                }
            }
        })
        .state('yiqingJiageJubao', { //价格举报
            url: '/yiqingJiageJubao',
            views: {
                "main": {
                    templateUrl: 'pages/yiqing/jiagejubao/index.html',
                    prefetchTemplate: false,
                    controller: 'yiqingJiageJubaoController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/yiqing/jiagejubao/index.js'])
                }
            }
        })
        .state('yiqingWangban', { //网办政务
            url: '/yiqingWangban',
            views: {
                "main": {
                    templateUrl: 'pages/yiqing/wangban/index.html',
                    prefetchTemplate: false,
                    controller: 'yiqingWangbanController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/yiqing/wangban/index.js'])
                }
            }
        })
        .state('myJubao', { //我的举报
            url: '/myJubao',
            views: {
                "main": {
                    templateUrl: 'pages/personal/myJubao/index.html',
                    prefetchTemplate: false,
                    controller: 'myJubaoController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/personal/myJubao/index.js'])
                }
            }
        })
        .state('myJubaoDetail', { //我的举报详情
            url: '/myJubaoDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/personal/myJubao/detail.html',
                    prefetchTemplate: false,
                    controller: 'myJubaoDetailController',
                    resolve: loadSequence(['pages/yiqing/index.css', 'pages/personal/myJubao/detail.js'])
                }
            },
            params: {
                queryUrl: null,
                readType: null
            }
        })
        .state('intelligentDMy', { //我的智慧社区
            url: '/intelligentDMy',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/my/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDMyController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'css/ionic/fonts/font_zzv/font.css', 'pages/intelligent-division/my/index.js'])
                }
            }
        })
        .state('intelligentDHome', { //智慧街道社区
            url: '/intelligentDHome',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDHomeController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'css/ionic/fonts/font_zzv/font.css', 'pages/intelligent-division/index.js', 'pages/intelligent-division/location-rootnav/index.js'])
                }
            },
            params: { productId: 3, regionCode: null, regionName: null }
        })
        .state('intelligentD', { //智慧街道社区`母版
            url: '/intelligentD',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/mast.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDMastController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'css/ionic/fonts/font_zzv/font.css', 'pages/intelligent-division/location-rootnav/index.js', 'pages/intelligent-division/mast.js'])
                }
            },
            params: {
                activeNavRootIndex: null,
                communityList: null,
                productId: 3, regionCode: null, regionName: null
            }
        })
        .state('intelligentD.articleListLevel4', { //社区功能列表/文章列表
            url: '/articleListLevel4',
            views: {
                "list": {
                    templateUrl: 'pages/intelligent-division/functions/list/list-for-street.html',
                    prefetchTemplate: false,
                    controller: 'articleListLevel4Controller',
                    resolve: loadSequence(['pages/intelligent-division/functions/list/list-for-street.js'])
                }
            }
        })
        .state('intelligentD.funcList', { //社区功能列表/文章列表
            url: '/funcList',
            views: {
                "list": {
                    templateUrl: 'pages/intelligent-division/functions/list/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncListController',
                    resolve: loadSequence(['pages/intelligent-division/functions/list/index.js'])
                }
            }
        })
        .state('intelligentD.yiqing', { //填报
            url: '/yiqing',
            views: {
                "yiqing": {
                    templateUrl: 'pages/intelligent-division/functions/yiqing/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncYiqingController',
                    resolve: loadSequence(['pages/intelligent-division/functions/yiqing/index.js'])
                }
            }
        })
        .state('intelligentD.wish', { //微心愿
            url: '/wish',
            // cache: true,
            views: {
                "wish": {
                    templateUrl: 'pages/intelligent-division/functions/wish/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncWishController',
                    resolve: loadSequence(['pages/intelligent-division/functions/wish/index.js'])
                }
            }
        })
        .state('intelligentD.affairs', { //办事指南
            url: '/affairs',
            // cache: true,
            views: {
                "affairs": {
                    templateUrl: 'pages/intelligent-division/functions/affairs/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncAffairsController',
                    resolve: loadSequence(['pages/office-affairs/office.css', 'pages/intelligent-division/functions/affairs/index.js'])
                }
            }
        })
        .state('intelligentD.org', { // 组织结构/部门负责人
            url: '/org',
            // cache: true,
            views: {
                "org": {
                    templateUrl: 'pages/intelligent-division/functions/org/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncOrgController',
                    resolve: loadSequence(['pages/intelligent-division/functions/org/index.js'])
                }
            }
        })
        .state('intelligentD.personnel', { // 人员结构
            url: '/personnel',
            views: {
                "personnel": {
                    templateUrl: 'pages/intelligent-division/functions/personnel/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncPersonnelController',
                    resolve: loadSequence(['lib/echarts/echarts.min.js', 'pages/intelligent-division/functions/personnel/index.js'])
                }
            }
        })
        .state('intelligentD.property', { //物业列表
            url: '/property',
            views: {
                "property": {
                    templateUrl: 'pages/intelligent-division/functions/property/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncPropertyController',
                    resolve: loadSequence(['pages/intelligent-division/functions/property/index.js'])
                }
            }
        })
        .state('scProperty', { // 物业/员工
            url: '/scProperty',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/property/index.html',
                    prefetchTemplate: false,
                    controller: 'scPropertyController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/property/index.js'])
                }
            },
            params: { propid: null, isAdmin: null }
        })
        .state('intelligentD.service', { //服务
            url: '/service',
            views: {
                "service": {
                    templateUrl: 'pages/intelligent-division/functions/service/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncServiceController',
                    resolve: loadSequence(['pages/intelligent-division/functions/service/index.js'])
                }
            }
        })
        .state('intelligentD.lost', { //寻人寻物
            url: '/lost',
            views: {
                "lost": {
                    templateUrl: 'pages/intelligent-division/functions/lost/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncLostController',
                    resolve: loadSequence(['pages/intelligent-division/functions/lost/index.js'])
                }
            }
        })
        .state('intelligentD.activity', { //活动
            url: '/activity',
            views: {
                "activity": {
                    templateUrl: 'pages/intelligent-division/functions/activity/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncActivityController',
                    resolve: loadSequence(['pages/intelligent-division/functions/activity/index.js'])
                }
            }
        })
        .state('intelligentD.msg', { //留言板
            url: '/msg',
            views: {
                "msg": {
                    templateUrl: 'pages/intelligent-division/functions/msg/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDFuncMsgController',
                    resolve: loadSequence(['pages/intelligent-division/functions/msg/index.js'])
                }
            }
        })
        .state('intelligentDMsgDetail', { //社区留言详情
            url: '/intelligentDMsgDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/functions/msg/detail/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDMsgDetailController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/functions/msg/detail/index.js'])
                }
            },
            params: {
                readType: null
            }
        })
        .state('intelligentDArticleDetail', { //社区文章详情
            url: '/intelligentDArticleDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/article-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDArticleDetailController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/article-detail/index.js'])
                }
            },
            params: {
                queryUrl: null,
                shareFlag: null,
                adObj: null
            }
        })
        .state('scRepair', { //设施保修
            url: '/scRepair',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/repair/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDRepairController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/repair/index.js'])
                }
            },
            params: {
                formContent: false,
                region: null
            }
        })
        .state('scHandle', { //信息审核
            url: '/scHandle',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/handle/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDHandleController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/handle/index.js'])
                }
            },
            params: {
                region: null
            }
        })
        .state('scHandleWish', { //微心愿管理
            url: '/scHandleWish',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/handleWish/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDHandleWishController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/handleWish/index.js'])
                }
            },
            params: {
                region: null,
                roleLevel: null
            }
        })
        .state('intelligentDDispatch', { //人员信息报备
            url: '/intelligentDDispatch',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/dispatch/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDDispatchController',
                    resolve: loadSequence(['css/mobiscroll/mobiscroll.custom-2.5.0.min.css', 'lib/mobiscroll/mobiscroll.custom-2.5.0.min.js', 'pages/intelligent-division/css/index.css', 'pages/intelligent-division/dispatch/index.js'])
                }
            },
            params: {
                district: null
            }
        })
        .state('scDispatchAdmin', { //个人中心 - 报备信息
            url: '/scDispatchAdmin',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/dispatch-admin/index.html',
                    prefetchTemplate: false,
                    controller: 'scDispatchAdminController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/dispatch-admin/index.js'])
                }
            },
            params: {
                region: null,
                roleLevel: null
            }
        })
        .state('scCv19Handle', { //公共卫生突发事件 管理
            url: '/scCv19Handle',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/dispatch-admin/cv19/index.html',
                    prefetchTemplate: false,
                    controller: 'sccv19HandleController',
                    resolve: loadSequence(['pages/intelligent-division/css/index.css', 'pages/intelligent-division/dispatch-admin/cv19/index.js'])
                }
            },
            params: {
                region: null,
                roleLevel: null
            }
        })
        .state('intelligentDCV19', { //公共卫生信息报备
            url: '/intelligentDCV19',
            views: {
                "main": {
                    templateUrl: 'pages/intelligent-division/cv19/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDCV19Controller',
                    resolve: loadSequence(['css/mobiscroll/mobiscroll.custom-2.5.0.min.css', 'lib/mobiscroll/mobiscroll.custom-2.5.0.min.js', 'pages/intelligent-division/css/index.css', 'pages/intelligent-division/cv19/index.js'])  //日期选择控件
                }
            },
            params: {
                region: null
            }
        })
        .state('zhOlmap', { // 移动办公 地图
            url: '/zhOlmap',
            views: {
                "main": {
                    templateUrl: 'pages/zh-olmap/index.html',
                    prefetchTemplate: false,
                    controller: 'intelligentDHandleOlmapController',
                    resolve: loadSequence(['lib/ol/ol.css', 'pages/zh-olmap/map.css', 'lib/ol/ol.js', 'pages/zh-olmap/index.js'])
                }
            },
            params: {
                productId: null,
                region: null
            }
        })
        //智慧综治
        .state('zhzzHome', { //首页
            url: '/zhzzHome',
            views: {
                "main": {
                    templateUrl: 'pages/zhzz/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzHomeController',
                    resolve: loadSequence(['pages/zhzz/css/index.css', 'pages/zhzz/font/font.css', 'pages/zhzz/index.js', 'pages/zhzz/location-rootnav/index.js'])
                }
            },
            params: {
                regionCode: null, regionName: null
            }
        })
        .state('zhzz', { //母版
            url: '/zhzz',
            views: {
                "main": {
                    templateUrl: 'pages/zhzz/mast.html',
                    prefetchTemplate: false,
                    controller: 'zhzzMastController',
                    resolve: loadSequence(['pages/zhzz/css/index.css', 'pages/zhzz/location-rootnav/index.js', 'pages/zhzz/mast.js'])
                }
            },
            params: {
                activeNavRootIndex: null,
                communityList: null,
                regionCode: null, regionName: null
            }
        })
        .state('zhzz.articleListLevel4', { // 街道级: 功能/文章列表
            url: '/articleListLevel4',
            views: {
                "list": {
                    templateUrl: 'pages/zhzz/functions/list/list-for-street.html',
                    prefetchTemplate: false,
                    controller: 'articleListLevel4Controller',
                    resolve: loadSequence(['pages/zhzz/functions/list/list-for-street.js'])
                }
            }
        })
        .state('zhzz.funcList', { //社区级 功能/文章列表
            url: '/funcList',
            views: {
                "list": {
                    templateUrl: 'pages/zhzz/functions/list/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzFuncListController',
                    resolve: loadSequence(['pages/zhzz/functions/list/index.js'])
                }
            }
        })
        .state('zhzzArticleDetail', { //社区文章详情
            url: '/zhzzArticleDetail/:id',
            views: {
                "main": {
                    templateUrl: 'pages/zhzz/article-detail/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzArticleDetailController',
                    resolve: loadSequence(['pages/zhzz/css/index.css', 'pages/zhzz/article-detail/index.js'])
                }
            },
            params: {
                type: 'article',
                queryUrl: null,
                shareFlag: null
            }
        })
        .state('zhzz.report', { 
            url: '/report',
            views: {
                "report": {
                    templateUrl: 'pages/zhzz/functions/report/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzReportController',
                    resolve: loadSequence(['pages/zhzz/functions/report/index.js'])
                }
            }
        })
        .state('zhzz.dispatch', { 
            url: '/dispatch',
            views: {
                "dispatch": {
                    templateUrl: 'pages/zhzz/functions/dispatch/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzDispatchAdminController',
                    resolve: loadSequence(['pages/zhzz/functions/dispatch/index.js'])
                }
            }
        })
        .state('zhzz.railway', { 
            url: '/railway',
            views: {
                "railway": {
                    templateUrl: 'pages/zhzz/functions/railway/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzRailwayAdminController',
                    resolve: loadSequence(['pages/zhzz/functions/railway/index.js'])
                }
            }
        })
        .state('zhzz.glory', { //光荣榜
            url: '/glory',
            views: {
                "glory": {
                    templateUrl: 'pages/zhzz/functions/glory/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzGloryAdminController',
                    resolve: loadSequence(['pages/zhzz/functions/glory/index.js'])
                }
            }
        })
        .state('zhzzDispatch', { //报送
            url: '/zhzzDispatch',
            views: {
                "main": {
                    templateUrl: 'pages/zhzz/dispatch/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzDispatchController',
                    resolve: loadSequence(['pages/zhzz/css/index.css', 'pages/zhzz/dispatch/index.js'])
                }
            },
            params: {
                formContent: false,
                region: null
            }
        })
        .state('zhzzHandle', { //审核
            url: '/zhzzHandle',
            views: {
                "main": {
                    templateUrl: 'pages/zhzz/handle/index.html',
                    prefetchTemplate: false,
                    controller: 'zhzzHandleController',
                    resolve: loadSequence(['pages/zhzz/css/index.css', 'pages/zhzz/handle/index.js'])
                }
            },
            params: {
                region: null,
                handleNav: null,
            }
        })
        .state('jiweiHome', { //纪委网站 - 首页
            url: '/jiweiHome',
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiHomeController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/index.js'])
                }
            }
        })
        .state('jiwei', { // 纪委网站 - 母版
            url: '/jiwei',
            // cache: true,
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/mast.html',
                    prefetchTemplate: false,
                    controller: 'jiweiMastController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/mast.js'])
                }
            },
            params: {
                params: null
            }
        })
        /* .state('jiwei.home', { // 纪委网站 - 首页
            url: '/home',
            views: {
                "home": {
                    templateUrl: 'pages/jiwei/home.html',
                    prefetchTemplate: false,
                    controller: 'jiweiHomeController',
                    resolve: loadSequence(['pages/jiwei/home.js'])
                }
            }
        }) */
        .state('jiwei.list', { // 文章列表
            url: '/list',
            // cache: true,
            views: {
                "list": {
                    templateUrl: 'pages/jiwei/function/list/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiListController',
                    resolve: loadSequence(['pages/jiwei/function/list/index.js'])
                }
            },
            params: {
                mainNav: null,
                module: null,
                pageName: null
            }
        })
        .state('jiwei.submenu', { // 信息公开
            url: '/submenu',
            views: {
                "submenu": {
                    templateUrl: 'pages/jiwei/function/submenu/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiSubmenuController',
                    resolve: loadSequence(['pages/jiwei/function/submenu/index.js'])
                }
            },
            params: {
                mainNav: null,
                module: null
            }
        })
        .state('jiweiList', { // 文章列表
            url: '/jiweiList',
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/list/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiArtListController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/list/index.js'])
                }
            },
            params: {
                module: null,
                pageName: null
            }
        })
        .state('jiweiArticle', { // 文章详情
            url: '/jiweiArticle',
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/article/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiArticleController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/article/index.js'])
                }
            },
            params: {
                module: null,
                id: null,
                crumbs: null
            }
        })
        .state('jiweiLeadersTree', { // 领导机构
            url: '/jiweiLeadersTree',
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/leaders/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiLeadersTreeController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/leaders/index.js'])
                }
            },
            params: {
                module: null,
                pageName: null
            }
        })
        .state('jiweiSearch', { // 纪委搜索页
            url: '/jiweiSearch',
            views: {
                "main": {
                    templateUrl: 'pages/jiwei/search/index.html',
                    prefetchTemplate: false,
                    controller: 'jiweiSearchController',
                    resolve: loadSequence(['pages/jiwei/index.css', 'pages/jiwei/search/index.js'])
                }
            },
            params: {
                keywords: null
            }
        })
    $urlRouterProvider.otherwise('/home');
}])