angular.module('sv_district', [])
// appModule
.service('$svDistrict',['$ionicPopup',function($ionicPopup){
  /**
    * @description 判断页面是否在当前地区开放
    * @param  {[object]}   data     [当前城市id]
    * @param  {[array]}   whiteList  [城市白名单]
    * @param  {Function} alertDo [没有权限时,弹出默认弹窗后,跳转页面或其他动作]
    * @param  {Function} falseDo [没有权限时,如为空则弹出默认弹窗,否则执行falseDo]
    * @return {[bool]}   result  [是否开放]
  */
  this.isOpenAction = function(data,whiteList,alertDo,falseDo,alertOption){
    var result = false;
    if( !whiteList || !whiteList.length) return true;
    for(var i = 0; i < whiteList.length; i++){
      var item = whiteList[i];
      if ( data.cityId == item.cityId || data.distName == item.distName) {
        result = true;
      } 
    }
    var alertOption = alertOption || {
      title: '温馨提示',
      template: '地区未开通此功能，敬请期待！',
      okText:'确定'
    };
    if(!result && !falseDo) {
      $ionicPopup.alert(alertOption)
      .then(function (res) {
        alertDo && alertDo();
      });
    } else if(!result) falseDo && falseDo();
    return result;
  }
}]);