
var dvsChart = {
	ctx:$.lsmCtx,	
	// 饼图数值和百分比的显示
	itemStyle: {
        normal:{ 
          label:{ 
            show: false, 
            formatter: '{b} : {c} ({d}%)'
//            position:'inside',
//            textStyle:{color:'#000000'}
          }, 
          labelLine :{show:false} 
        } 
    },
	// 统计图图例样式
	legenStyle : { 
		itemGap:40,
		borderColor:"#333",
		itemHeight:10,
		itemWidth:10,
		textStyle:{
			color:"#333",
			fontWeight:'normal',
			fontSize:12
		}
	},
	// 统计图布局样式
	grid: {
        left: "6%",
        right: "4%",
        bottom: "12%",
        top: "20%",
        containLabel: true
    },
	// 轴样式
	axisStyle : {
		color:"#333",
		fontSize:12
	},
	// 地图名称对应关系
	nameMap : {
		"全国": "china"
	},
	chartMap:{},
	elementMap:{},
	e:{},
	init:function(element,chartId) { // optSetting：初始化option
		var chart = echarts.init(element);
		e = chart;
		 
		if(chartId){ //如果传入图表ID，则缓存起来供之后调用
			dvsChart.chartMap[chartId] = e;
			dvsChart.elementMap[chartId] = element;
		}
		return this;
	},
	//add by zhougz 轮循
	reloadChart : function(chartId){
		try{
			var ele = dvsChart.elementMap[chartId];
			var o = dvsChart.chartMap[chartId].getOption();
			var ne = echarts.init(ele);
			ne.setOption(o);
			return true;
		}catch(e){
			return false;
		}
	},
	setOption:function(option) {
		if(typeof e != "undefined") {
			
			if(option.DIME != undefined){
				for(var i = 0; i < option.series.length; i++) {
					option.series[i].barWidth = '15';
				}
			}

			
// 饼图显示数值和百分比
			if(option.series && option.series[0].type == "pie"){
				option.series[0].itemStyle = dvsChart.itemStyle;
				option.series[0].radius = '60%';
				option.color = [
								"#FF00FF",
								"#6600FF",
				                "#83ce29",
				                "#37d0fb",
				                "#ffc413",
				                "#ff7000",
				                "#689ae8",
				                '#C1232B','#B5C334','#27727B',
		                        '#FE8463','#9BCA63','#FAD860','#F3A43B','#60C0DD',
		                        '#D7504B','#C6E579','#F4E001','#F0805A','#26C0C0'
				            ];
			}
			// 终端定制，折线图折点放大。
			if(option.series && option.series[0].type == "line"){
				for(var i = 0; i < option.series.length; i++) {
					option.series[i].symbolSize = 8;
					option.series[i].symbol = 'circle'; 
				}
				option.series[0].itemStyle = dvsChart.itemStyle;
			}
			if(option.series && option.series[0].type == "form"){ //表单
				//$(e._dom).prev().remove();
				$(e._dom).formView(option);
				return;
			}
			
			// grid样式
			if(option.grid){ 
				option.grid = dvsChart.grid;
			}
			// x轴样式
			if(option.xAxis){ 
				option.xAxis[0].axisLabel = {'textStyle':dvsChart.axisStyle,'interval':'auto','rotate':25};
	option.xAxis[0].splitLine = {show:false};
				option.xAxis[0].axisLine = {lineStyle:{color:'#3CB371',width:1}};
				// 终端使用，横轴为时间段则自适应宽度
				
				if(option.xAxis[0].data != undefined && 
						option.xAxis[0].data.length != 0 && 
						option.xAxis[0].data[0].length == 10 &&
						option.xAxis[0].data[0].indexOf('-') == 4 && 
						option.xAxis[0].data[0].lastIndexOf('-') == 7) {
					option.xAxis[0].axisLabel.interval = 'auto';
					option.xAxis[0].axisLabel.rotate = 0;
					for(var i = 0; i < option.xAxis[0].data.length; i++) {
						option.xAxis[0].data[i] = option.xAxis[0].data[i].substring(5);
					}
				}
			}
			// y轴样式
			if(option.yAxis){ 
			for(var i = 0; i < option.yAxis.length; i++) {
					option.yAxis[i].axisLabel = {'textStyle':dvsChart.axisStyle};
					option.yAxis[i].splitLine = {show:true, lineStyle:{type:'dashed'}};
					option.yAxis[i].axisLine = {lineStyle:{color:'#3CB371',width:1}};
				}
			}
	// 终端定制，去掉指定的legend
//			if(option.legendShow != undefined) {
////				delete option.legend;
//				option.series[0].radius = '60%';
//				var label= {normal:{show:false}};
//				option.series[0].label=label;
//			}
			// 图例样式
			if(option.legend){ 
				option.legend.textStyle = dvsChart.legenStyle.textStyle;
				option.legend.itemWidth = dvsChart.legenStyle.itemWidth;
				option.legend.itemHeight = dvsChart.legenStyle.itemHeight;
			}
			
			e.setOption(option);
		}
	},
	getOption:function(){
		return e.getOption();
	},
	showTable:function(element, titleNames, resultList, css ,flag) {
		// 标题行 
		var titleHtml = "<div style='overflow:hidden;'><table class='normal' style='margin-top:0px;'><tbody><tr class='tbTitle'>"; 
		// 数据行
		var resultHtml = "<div style='height:200'><table class='normal' id='tableBody'>"; 
		// 拼写标题行
		for(var i = 0; i < titleNames.length; i++) { 
			titleHtml += "<th>";
			titleHtml += titleNames[i];	
			titleHtml += "</th>";	
		}
		titleHtml += "</tr></tbody></table></div>";	
		// 拼写数据内容
		for(var i = 0; i < resultList.length; i++) {
			resultHtml += "<tr class='tbContext'>";
			for(var j = 0; j < resultList[i].length; j++) {
				resultHtml += "<td>";
				resultHtml += resultList[i][j];	
				resultHtml += "</td>";	
			}
			resultHtml += "</tr>";	
		}
		resultHtml += "</table></div>";	
		
		element.html(titleHtml + resultHtml);
		
		if(css) {
			$(".normal td").css("color", css.listStyle.data_font_color.color);
			$(".tbTitle>th").css("background-color", css.listStyle.title_background_color.background_color);
			$(".tbTitle>th").css("color", css.listStyle.title_font_color.color);
			$(".tbContext:nth-child(2n+1)").css("background-color", css.listStyle.data_middle_color.background_color);
		}
		
	}
};


/**
 * 表单插件
 * Version: 1.1.0809
 * Date 20161025
 * Author: zhougz3
 */
(function($) {
	$.fn.formView = function(options) {
		var _self = this;
		//默认参数
		var defaults = {};
		var settings = $.extend(defaults, options || {});
		var formList = settings.series[0].data;
		var width = $(this).width();
		var rowMap = {};
		var returnHtml = "";
		$.each(formList,function(i){
			var item = formList[i];
			if(item.value && item.value != '未知'){
				if(!rowMap[item.jd[0]]){rowMap[item.jd[0]] = new Array();}
				rowMap[item.jd[0]].push(item);
			}
		});
		//遍历对象
		$.each(rowMap,function(k,list){
			var temp = "";
			var itemWidth = parseInt(width/list.length,10);
			$.each(list,function(i){
				var item = list[i];
					temp+='<td>';
					temp+= '<h5>'+item.title+'<span style="color:#ffffff;">:</span></h5>';
					item.value = item.unit == '%'? (item.value*100).toFixed(2) : item.value;
					item.value = item.unit.indexOf('万')>-1 ? (item.value/10000).toFixed(2) : item.value;
					temp+= '<p >'+item.value+item.unit+'<span style="color:#ffffff;">,</span></p>' ;
					temp+='</td>';
			});
			returnHtml+="<table class='imitateTable'><tbody><tr>"+temp+"</tr></tbody></table>";
		});
		$(_self).css({'min-height':'10px'});
		$(_self).html(returnHtml);  
	};
})(jQuery);

/**
 * 对外提供接口
 * @param chartId 图表ID
 * @param options 维度参数{
 * 	DIMA:'',
 *  DIMB:''
 * }
 * @date 20160604
 */
_dvsChart_isAddCss = false;
$.fn.dvsChart = function(chartId,options,callback){
		var _self = this;
		
		var dimb_child = '';
		var myOrgList = $.getOrgList();
		$.each(myOrgList,function(i){
			dimb_child += myOrgList[i][0]+',';
		});
		dimb_child = dimb_child +'DIMB99';
		
		var $self = $(this);
		   
	    //判断是否有地域权限
		if(options && options.AREA_CODE_ID && dimb_child.indexOf(options.AREA_CODE_ID) == -1 ){
			$self.html("<div class='no_privalige' style='text-align:center;color:rgba(123,123,123,.5);' class='nodata'>您没有此权限</div>");
			if(callback){callback();}
			return false;
		}
		var defaultAreaCode = myOrgList.length >30 ? 'DIMB99' : myOrgList[0][0] ;
		options = $.extend({
			textColor : '#333', //图例文字颜色
			chartId:chartId,	   //图表ID
			DIM_TIME_CODE:$.dateFormat($.getLastDate()),   //暂时的时间维度,后台修改即可
			AREA_CODE_ID :defaultAreaCode //用户权限中第一个省分 DIMB99
//			DIMB_CHILD:dimb_child,
//			DIMJ_CHILD:'DIMJ10070203,DIMJ12170040,DIMJ13350004,DIMJ12170092,DIMJ10050221,DIMJ12170096,DIMJ10010213,DIMJ10060245,DIMJ10380049,DIMJ12170097,DIMJ12170100,DIMJ10280119,DIMJ10290040,DIMJ10320055,DIMJ10060281,DIMJ10290038,DIMJ10070184,DIMJ10290056,DIMJ10060291,DIMJ10060347',
//			DIMA_CHILD:'DIMA217,DIMA007,DIMA006,DIMA029,DIMA335,DIMA005,DIMA038,DIMA028,DIMA032,DIMA001,DIMA009,DIMA430,DIMA568,DIMA257,DIMA342'
		},options);
		
		options.DIM_TIME_CODE = options.DIM_TIME_CODE.length == 6? (options.DIM_TIME_CODE+"01"):options.DIM_TIME_CODE;//如果是月数据，取本月1日的数据
		dvsChart.legenStyle.textStyle.color = options.textColor;//先把各种颜色弄成设置的颜色
		dvsChart.axisStyle.color =  options.textColor;//先把各种颜色弄成设置的颜色
	   
		
	   $.ajax({
			  type: 'POST',
			  url: dvsChart.ctx+'/rest/getCodeMode',
			  data: options,  
			  dataType:"json",
			  //contentType :'application/json; charset=utf-8',
			  success: function(jsonText){
					if(jsonText.status == 200 && jsonText.data && jsonText.data[0]){
						var chartOpts = jsonText.data[0];
						if(chartOpts.graphCode == 'list'){
							dvsChart.showTable($self, chartOpts.tableHeaderList, chartOpts.tableDataList, chartOpts.codeMode, 1)
						}else if(chartOpts.graphCode == 'map'){
							var echart = dvsChart.init($self[0],chartId);
							$self.append('<script type="type/javascript">'+ chartOpts.codeMode +"</script>");
							echart.setOption(option);
						}else{
							var echart = dvsChart.init($self[0],chartId);
							echart.setOption(chartOpts);
						}
					}else{
						$self.html("<div style='text-align:center;color:rgba(123,123,123,.5);' class='nodata'>暂无数据</div>");
					}
					if(callback){callback();}
			  }
		});
}
