appModule.controller('hometownController', ['$scope', 'appService', '$ionicScrollDelegate', '$state', '$stateParams', '$timeout',
  function ($scope, appService, $ionicScrollDelegate, $state, $stateParams, $timeout) {
    //data
    $scope.stateName = $state.current.name;
    $scope.tabIndex = $stateParams.initTab;
    $scope.searchKey;
    $scope.pageNext = []; //页面初始化前为 0 初始化后为1 加载更多时累加
    $scope.domore = [];
    $scope.companyTypeList;
    $scope.hometownList;
    $scope.areaId;
    //加载
    $scope.$on('$ionicView.loaded', function () {
    });
    //广播 - 地域变换
    $scope.$on('changeDistrict', function (e, data) {
      if ($scope.stateName == $state.current.name) {
        if ($scope.areaId != $scope.publicCityId) {
          $scope.companyTypeList = null;
          $scope.hometownList = null;
          $ionicScrollDelegate.scrollTop();
          $scope.queryArray($scope.tabIndex, 0);
        }
        $scope.areaId = $scope.publicCityId;
      }
    });
    /* watch */
    $scope.$watch('tabIndex', function (n, o) {
      $scope.searchKey = n == 0 ? 'tjcompany' : 'hometown';
      $scope.pageTitle = n == 0 ? '推介企业' : '大美' + $scope.curCityName;
      if (n == o) return;
      if (n == 0) {
        if (!$scope.companyTypeList) $scope.queryArray(n);
      }
      if (n == 1) {
        if (!$scope.hometownList) $scope.queryArray(n);
      }
      $ionicScrollDelegate.scrollTop();
    });
    $scope.queryArray = function (tabindex) {
      if (tabindex == 0) {
        $scope.getCompanyType();
      }
      if (tabindex == 1) {
        $scope.getHometownType();
      }
    };
    $scope.changeFlagHometown = function (id) {
      $scope.queryHometownList(id, 1, 'goSrcoll')
    }
    //大美家乡分类
    $scope.getHometownType = function () {
      $scope.$emit('loading', 'show');
      appService.getData(urlMap.hometownType, {},
        function (hometownItems) {
          $scope.navArrHometown = hometownItems.resultList;
          $scope.activeFlagHometown = $scope.navArrHometown[0].categoryId;
          $scope.queryHometownList($scope.activeFlagHometown, 0);
        });
    }
    $scope.setLogo = function (activeFlag) {
      switch (activeFlag) {
        case '1':
          return 'iconzz-xiaochi';
        case '2':
          return 'iconzz-gouwu1';
        case '3':
          return 'iconzz-zhufang';
        case '4':
          return 'iconzz-flagfold';
        case '5':
          return 'iconzz-lvyou';
        case '6':
          return 'iconzz-yule';
      }
    }
    $scope.queryHometownList = function (tabIndex, page, goSrcoll) {
      if (!tabIndex) return;
      $scope.activeFlagHometown = tabIndex;
      if (page < 2) {
        page = 1;
        $scope.hometownList = null;
        $scope.pageNext[1] = 1;
      }
      $scope.$emit('loading', 'show');
      appService.getData(urlMap.hometownList + tabIndex, { page: page, area_id: $scope.publicCityId },
        function (results) {
          $scope.$emit('loading', 'hide');
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
          console.log($scope.curCityName + '家乡美:', results);
          if (goSrcoll) {
            $timeout(function () {
              $scope.goTop('hometownScroll', $scope.navAnchorTop);
            })
          }
          $timeout(function(){
            $ionicScrollDelegate.resize();
          })
          if (page == 1) { $scope.hometownList = []; }
          var list = results.resultList, length = list.length, size = results.size;
          if (length < size) $scope.domore[1] = false;
          else { $timeout(function () { $scope.domore[1] = true; }, 200) }
          if (length > 0) {
            for (var i = 0; i < list.length; i++) {
              //增加默认新闻图片
              if (list[i]["pic_name"] == "" || list[i]["pic_name"] == "undefined") {
                list[i]["pic_name"] = urlMap.newImg;
              }
              var vio = list[i].pic_name;
              var type = list[i].type; // 图片1视频2
              var portrait = list[i].portrait;
              if (portrait != null && portrait != "") {
                list[i].portrait = $scope.pic + "/" + portrait;
              } else {
                list[i].portrait = $scope.pic + urlMap.defaultImg;
              }
              if (type == "1") {
                list[i].pic = vio;
              } else if (type == "2") {
                var pic = vio.substring(0, vio.length - 3);
                pic = pic + "jpg";
                list[i].vio = vio;
                list[i].pic = pic;
              } else if (type == "0") {
                list[i].pic = $scope.pic + urlMap.defaultUpload;
              }
              $scope.hometownList.push(list[i]);
            }
          }
        });
    }
    //企业分类
    $scope.getCompanyType = function () {
      $scope.$emit('loading', 'show');
      appService.getData(urlMap.queryTJCompanyType, { areaId: $scope.publicCityId },
        function (tjCompanyItems) {
          $scope.$emit('loading', 'hide');
          $scope.companyTypeList = tjCompanyItems.resultList;
          $timeout(function(){
            $ionicScrollDelegate.resize();
          })
          console.log($scope.companyTypeList);
        });
    }
    //下拉刷新
    $scope.doRefresh = function (tabindex) {
      if (tabindex == 1) $scope.queryHometownList($scope.activeFlagHometown, 1);
    }
    //上拉加载
    $scope.onInfinite = function (tabindex) {
      if (tabindex == 1) $scope.queryHometownList($scope.activeFlagHometown, ++$scope.pageNext[1]);
    }
    $scope.changeTab = function (i) {
      $scope.tabIndex = i;
    }

  }
])
