appModule.controller('feedBackController', ['$scope', '$ionicPopup', '$stateParams', 'appService', '$state', '$timeout', '$ionicScrollDelegate', '$sce', function ($scope, $ionicPopup, $stateParams, appService, $state, $timeout, $ionicScrollDelegate, $sce) {
    $scope.stateName = $state.current.name;//data
    $scope.tabIndex = $stateParams.tabIndex || 0;
    $scope.domore = {};
    $scope.allArrays = {}
    $scope.pageNext = {}
    $scope.$on('$ionicView.loaded', function () {
        $scope.bannerHeight = window.innerWidth ? {
            'height': (window.innerWidth * 0.6) + 'px'
        } : false;
        window.onresize = function () {
            $scope.$apply(function () {
                $scope.bannerHeight = window.innerWidth ? {
                    'height': (window.innerWidth * 0.6) + 'px'
                } : false;
            })
        }
    });
    $scope.$on('$ionicView.beforeEnter', function () {
        $scope.initBannerSwiper();
    });
    $scope.$on('$ionicView.afterLeave', function () {
        $scope.inspectionBannerSwiper && $scope.inspectionBannerSwiper.destroy(true, true);
    });
    $scope.$on('changeDistrict', function (e, data) {
        if ($scope.stateName == $state.current.name) {
            if (data.cityId == $scope.cityId) return;
            $scope.cityId = data.cityId || '';
            $scope.initBannerSwiper();
        }
    });
    /* watch */
    $scope.$watch('tabIndex', function (n, o) {
        var currentArray = $scope.allArrays['tab' + n];
        if (!currentArray) $scope.queryArray(n, 0);
        $ionicScrollDelegate.scrollTop();
    });
    $scope.changeTab = function (i) {
        $scope.tabIndex = i
    }
    $scope.queryArray = function (tabindex, page) {
        $scope.$emit('loading', 'show');
        if (tabindex < 2) $scope.feedBack(page)
        if (tabindex == 2) $scope.jishiList(page)
    }
    $scope.jishiList = function (page) {
        if (page < 2) { //页面刷新时为0,下拉刷新时为1
            page = $scope.pageNext[$scope.tabIndex] = 1;
            $scope.jishiArr = null
        }
        $scope.$emit('loading', 'show');
        var data = {
            page: page,
            areaID: $scope.publicCityId,
        }
        appService.getData(urlMap.jishiList, data,
            function (results) {
                $scope.$emit('loading', 'hide');
                $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                if (!results) return;
                var list = results.resultList, length = list.length, size = results.size,
                    articles = $scope.jishiArr || []
                    ;
                if (length < size) $scope.domore[$scope.tabIndex] = false;
                else {
                    $timeout(function () { $scope.domore[$scope.tabIndex] = true; }, 200)
                }
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.summary = item.content && $('<div>' + item.content + '</div>').text().replace(/\s+/g, ' ').slice(0, 500);
                        item.fileType = $scope.thisfileType(item.file);
                        if (item.fileType == 1) {
                            item.file = item.file && '900px_' + item.file;
                            item.thum = item.file && '200px_' + item.file;
                            item.file = $scope.evalRemotePath(item.file);
                            item.thum = $scope.evalRemotePath(item.thum);
                        }
                        if (item.fileType == 2) {
                            item.file = $scope.evalRemotePath(item.file, $.vio);
                            item.file = item.file && $sce.trustAsResourceUrl(item.file)
                        }
                        articles.push(item);
                    }
                }
                $scope.jishiArr = articles;
            });
    }
    $scope.showDetial = function (item) {
        $scope.goState('livelihood', { item: item })
    }
    $scope.setForm = function (b) {
        $scope.goState('livelihood', { formContent: b })
    }
    $scope.feedBack = function (page) {
        if (page < 2) {
            page = $scope.pageNext[$scope.tabIndex] = 1;
            $scope.allArrays['tab' + $scope.tabIndex] = null
        }
        var data = {
            page: page,
            area_id: $scope.publicCityId,
            backType: $scope.tabIndex + 1
        }
        appService.getData(urlMap.queryFeedBack, data,
            function (results) {
                results = results[0]
                $scope.$emit('loading', 'hide');
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                console.log(page, results.resultList);
                if (page == 1) {
                    $scope.allArrays['tab' + $scope.tabIndex] = null;
                }
                var list = results.resultList, length = list.length, size = results.size,
                    articles = $scope.allArrays['tab' + $scope.tabIndex] || []
                    ;
                if (length < size) $scope.domore[$scope.tabIndex] = false;
                else { $timeout(function () { $scope.domore[$scope.tabIndex] = true; }, 200) }
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.fileType = $scope.thisfileType(item.pic_name);
                        if (item.fileType == 1) {
                            item.file = $scope.evalRemotePath(item.pic_name);
                        }
                        if (item.fileType == 2) {
                            item.file = $scope.evalRemotePath(item.pic_name, $.vio);
                            item.file = item.file && $sce.trustAsResourceUrl(item.file)
                        }
                        articles.push(item);
                    }
                }
                $scope.allArrays['tab' + $scope.tabIndex] = articles;
            });
    }
    $scope.onInfinite = function () {
        var n = $scope.tabIndex;
        if (!$scope.pageNext[n]) return;
        $scope.queryArray(n, ++$scope.pageNext[n]);
    }
    $scope.initBannerSwiper = function () {
        $scope.inspectionBannerSwiper && $scope.inspectionBannerSwiper.destroy(true, true);
        // if (!!$scope.bannerArray && $scope.bannerArray.length > 1) {
        $timeout(function () {
            $scope.inspectionBannerSwiper = new Swiper('#inspectionBannerSwiper', {
                width: undefined,
                autoplay: {
                    disableOnInteraction: false,
                },
                loop: true,
                pagination: {
                    el: '.inspection-banner-pagination'
                }/* ,
                    on: {
                        tap: function (e) {
                            var _e = e || event;
                            $scope.goInfoDetail(_e.target.getAttribute('itemid'))
                        }
                    } */
            });
        });
        // }
    }
    //跳转到详情页面 
    $scope.goDetail = function (item) {
        $state.go('feedBackDetail', { "id": item.id, "areaID": $scope.publicCityId, "flag": $scope.tabIndex });
    }
    $scope.goLivelihood = function () {
        $scope.$emit('loginFirst', function () {
            $scope.goState('livelihood')
        })
    }
}
]);
appModule.controller('feedBackDetailController', ['$scope', '$stateParams', 'appService', '$state','$sce',
    function ($scope, $stateParams, appService, $state,$sce) {

        $scope.detailId = $stateParams.id;
        $scope.areaID = $stateParams.areaID;
        $scope.tabIndex = $stateParams.flag;
        //新闻详情
        appService.getData(urlMap.queryOneFeedBack, { id: $scope.detailId },
            function (jsonData) {
                if (jsonData.length > 0) {
                    var type = jsonData[0].type;
                    var pic_nameN = jsonData[0].pic_name.substring(0, jsonData[0].pic_name.length - 1);
                    new RTP.PinchZoom($('#pinchZoom'), { minZoom: 0.2 });
                    var winHeight = $(window).height();
                    var winWidth = $(window).width();
                    $('#pinchZoom').height(winHeight)
                        .parents('.pinch-zoom-container')
                        .width(winWidth)
                        .height(winHeight);
                    $scope.msgItem = jsonData[0];
                    if (pic_nameN) {
                        $scope.msgItem.files = []
                        var picList = pic_nameN.split(",");
                        for (var i = 0; i < picList.length; i++) {
                            $scope.msgItem.files[i] = {}
                            var fileType = $scope.msgItem.files[i].type = $scope.thisfileType(picList[i]);
                            if (fileType == 1) {
                                $scope.msgItem.files[i].name = $scope.evalRemotePath(picList[i]);
                            }
                            if (fileType == 2) {
                                var vio = $scope.evalRemotePath(picList[i], $.vio);
                                $scope.msgItem.files[i].name = vio && $sce.trustAsResourceUrl(vio)
                            }
                        }
                    }
                }
            });

        $scope.goMsgList = function () {
            $state.go('feedBack', { "flag": $scope.tabIndex });
            // window.location.href = "#/feedBack";
        }

        //点击放大图
        $scope.bigImage = false;
        $scope.showBigImage = function (imgSrcPath) {
            $scope.bigImage = true;
            // $scope.bigImageSrc = imgSrcPath + "?" + (new Date()).getTime();
            $scope.bigImageSrc = imgSrcPath;
        };
        $scope.hideBigImage = function () {
            $scope.bigImage = false;
            // $('#pinchZoom').parents('.pinch-zoom-container').hide();
        };
        /* $scope.loadBigImage = function () {
            // $('#pinchZoom').parents('.pinch-zoom-container').show();
        } */
    }
])
