
appModule.controller('intelligentDArticleDetailController', ['$scope', '$state', 'appService', '$stateParams', '$sce', '$compile',
  function ($scope, $state, appService, $stateParams, $sce, $compile) {
    //data
    $scope.queryUrl = $stateParams.queryUrl || 'intelligentDArticlesDetail';
    $scope.stateName = $state.current.name;
    $scope.articleId = $stateParams.id;
    $scope.shareFlag = $stateParams.shareFlag;
    $scope.adObjSc = $stateParams.adObj||[];
    $scope.articleInfo = {};
    var url = urlMap[$scope.queryUrl];
    $scope.articleHtml = $scope.favourId = $scope.queryUrl + $scope.articleId;
    $scope.bigImage;  //点击放大图
    $scope.isUpdateSize;
    /* root enterBefore */
    $scope.$on('changeDistrict', function (e, data) {
      if ($scope.stateName == $state.current.name) {
        $scope.getArticle();
      }
    });
    $scope.$on('$ionicView.beforeLeave', function () {
      $scope.imgsSwipe && $scope.imgsSwipe.destroy(true, true);
    });
    $scope.getArticle = function () {
      $scope.$emit('loading', 'show');
      appService.getData(url, { id: $scope.articleId },
        function (results) {
          $scope.$emit('loading', 'hide');
          article = results instanceof Array ? results[0] : results;
          console.log(article);
          article.title = article.title || article.TITLE;
          var content = article.textcontent || article.content|| article.contentText;
          article.picName = article.pic_name || article.picName;
          if (article.picName) article.picName = (/http/i).test(article.picName) ? article.picName : $scope.pic + '/' + article.picName;

          //找到<img标签
          var reg = /<img[^>]*>/gi;
          // 匹配出html中的src属性
          var images = content && content.match(reg);
          $scope.articleInfo = article;
          content = $sce.trustAsHtml(content).$$unwrapTrustedValue(); //过滤
          //包含图片
          if (images && images.length) {
            //解析拼接内容
            for (var i = 0; i < images.length; i++) {
              var image = images[i],
                first = image.substr(0, image.indexOf(' ') + 1),
                next = image.substr(image.indexOf(' ')),
                regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = image.match(regSrc)[1]
                ;
              if (i == 0) article.pic_name = article.pic_name || srcStr;
              // 将ng-click事件拼接到html中
              var final = first + ' ng-click="showBigImage(' + "'" + srcStr + "'" + ',' + i + ')"' + next;
              //为适应点击图片放大，因此将width和height属性过滤掉
              final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
              content = content.replace(image, final);
              // var $li = $('<li class="swiper-slide"><div class="article-zoom-img">' + image + '</div></li>');
              var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + image + '</div></li>');
              $('#articleImgs > ul').append($li);
            }
            $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
              zoom: {
                toggle: false,
              },
              pagination: {
                el: '.swiper-pagination',
                dynamicBullets: true
              },
            });
            content = $compile(content)($scope); //编译
          }
          $('#' + $scope.articleHtml).html(content);
        }, function () {
        }, function () {
        });
    }
    $scope.showBigImage = function (imgSrcPath, i) {
      $scope.imgsSwipe.slideTo(i, 0, false);
      $('#articleImgs').show();
      if (!$scope.isUpdateSize) { $scope.imgsSwipe.update(); $scope.isUpdateSize = true; }
      console.log(i)
    };
    $scope.hideBigImage = function () {
      $scope.imgsSwipe.zoom.out();
      $('#articleImgs').hide();
    };
    $scope.adClick = function(item) {
      if (item.remark == 'miniprogram') {
        var text = item.param && JSON.parse(item.param).title || ''
        var title = '即将打开' + text + '小程序，是否继续？'
        var miniId = item.param && JSON.parse(item.param).miniId
        $scope.goMinip(item.routPath, title, miniId)
      }
      if (item.remark == 'route') {
        var state = item.routPath
        var param = JSON.parse(item.param)
        $scope.goState(state, param)
      }
    }
    //分享
    $scope.shareWX = function (id, articleInfo) {
      console.log("shareFlag:  " + $scope.shareFlag);
      if (typeof Wechat === "undefined") {
        alert("Wechat plugin is not installed.");
        return;
      }
      var scene, params = {};
      switch (id) {
        case 'SESSION':
          scene = Wechat.Scene.SESSION;
          break;
        case 'TIMELINE':
          scene = Wechat.Scene.TIMELINE;
          break;
      }
      params.scene = scene;
      params.message = {
        title: "[TEST]",
        description: "[TEST]Sending from test application",
        mediaTagName: "TEST-TAG-001",
        messageExt: "这是第三方带的测试字段",
        messageAction: "<action>dotalist</action>",
        media: {}
      };
      params.message.title = articleInfo.title;//标题
      params.message.description = articleInfo.description || '';//副标题
      params.message.thumb = "https://cordova.apache.org/images/cordova_256.png";//微信分享 缩略图
      params.message.media.type = Wechat.Type.WEBPAGE || Wechat.Type.LINK; //网页链接
      // params.message.media.webpageUrl = $.shareUrl + '/8?id=' + articleInfo.id;
      // params.message.media.webpageUrl = "zz.xn--5bvz82b.com/thapp/share/doShare/8?id=" + articleInfo.id;
      params.message.media.webpageUrl = $.shareUrl + '/' + $scope.shareFlag + "?id=" + articleInfo.id;

      if (!!articleInfo.pic_name) {
        params.message.thumb = articleInfo.pic_name + "?" + (new Date()).getTime();
      }
      // alert('Wechat.share: ',Wechat.share);
      Wechat.share(params, function () {
        // alert("Share Success")
      }, function (reason) {
        // console.log("Share Failed" + reason);
        //  alert(reason)
      });
    }
  }
]);
