
appModule.controller('intelligentDCV19Controller', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$sce', '$ionicModal', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup, $ionicScrollDelegate, $sce, $ionicModal) {
  /* data */
  $scope.stateName = $state.current.name;
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.form = {};
  $scope.contentName = 'home';
  $scope.httpPath = '/zhzz/'
  $scope.filetype;
  $scope.maxWidth = 900;
  $scope.region = $stateParams.region
  /*  || {
    id: 133,
    name: '长安社区'
  }; */
  $scope.commitment //承诺书状态
  $scope.transaction //正在受理的事务
  $scope.formList //报备记录
  $scope.$on('$ionicView.enter', function () {
    $scope.initDateArr('hotelInTime');
    $scope.initDateArr('hotelOutTime');
    $scope.initDateArr('arriveTime');
    $scope.initDateArr('contactTime');
    $scope.getCommitment()
    $scope.getTransaction()
  });
  /* 获取正在处理的报备 */
  $scope.getTransaction = function (popOption) {
    $scope.transaction = 'loading'
    $scope.getMyFormed({ isGlUse: 1 }, function (formList) {
      console.log(formList)
      if (formList && formList.length) {
        $scope.transaction = formList[0]
        var state = $scope.transaction.glState, adminTel = $scope.transaction.adminTel;
        var title = state ? '您正处于隔离期间' : '您的报备暂未受理'
        var telStr = $scope.transaction.adminTel ? ('<div class="f14">您可以: <p>联系社区相关负责人 <a class="f18" href="tel:' + $scope.transaction.adminTel + '">' + $scope.transaction.adminTel + '</a></p></div>') : ''
        $scope.myPop = $ionicPopup.show(popOption || {
          title: title,
          template: telStr +
            '<div class="com-flex-line column">' +
            '<button ng-click="setContent(\'tiwen\')" class="button button-positive mt10" ng-if="!transaction.todayTiwen">登记今日体温</button>' +
            '<button ng-click="setContent(\'cailiao\')" class="button button-positive mt10">上传证明材料</button>' +
            '</div>',
          scope: $scope,
          buttons: [
            {
              text: '返回',
              onTap: function (e) {
                $scope.setContent('clear')
              }
            }
          ]
        });
        $scope.getTiwen({ reportId: $scope.transaction.id }, function (tiwen) {
          // $scope.tiwen = tiwen
        })
        $scope.getCailiao({ reportId: $scope.transaction.id })
      } else $scope.transaction = 'none'
    }, function () {
      $scope.transaction = null
    })
  }
  /* 获取我的报备信息 */
  $scope.getMyFormed = function (param, callback, errorBack) {
    var data = param || {}
    data.regionId = $scope.region.id;
    data.userId = $scope.user.id;
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.scCV19, data, function (res) {
      $scope.$emit('loading', 'hide');
      var formList = res.data && res.data || [], length = formList.length;
      for (var i = 0; i < length; i++) {
        var item = formList[i];
        item.jcTime = item.contactTime && item.contactTime.slice(0, 10);
        item.arriveTime = item.arriveTime && item.arriveTime.slice(0, 10);
        item.hotelInTime = item.hotelInTime && item.hotelInTime.slice(0, 10);
        item.hotelOutTime = item.hotelOutTime && item.hotelOutTime.slice(0, 10);
        item.cardType = $scope.select.cardType.options[item.cardType - 1];
        item.jnjw = $scope.select.jnjw.options[item.jnjw - 1];
        item.isFire = item.isFire ? '是' : '否';
        switch (item.glState) {
          case 1:
            item.glStateName = '居家隔离';
            break;
          case 2:
            item.glStateName = '重点隔离';
            break;
          case 3:
            item.glStateName = '解除隔离';
            break;
          case 4:
            item.glStateName = '无需隔离';
            break;
          default:
            item.glStateName = '未处理';
        }
        // formList[i] = item
      }
      callback && callback(formList)
    }, function () {
      errorBack && errorBack()
      /* $timeout(function () {
        $scope.getMyFormed(param, callback, 'again')
      }, 3000) */
    })
  }
  /* 获取材料信息 */
  $scope.getCailiao = function (param, callback, errorBack) {
    var data = param || {}
    data.regionId = $scope.region.id;
    data.userId = $scope.user.id;
    $scope.$emit('loading', 'show');
    $scope.transaction.cailiao = null
    appService.getData(urlMap.scCV19cailiao, data, function (res) {
      $scope.$emit('loading', 'hide');
      var cailiao = res.data && res.data || [], length = cailiao.length;
      for (var i = 0; i < length; i++) {
        var files = cailiao[i].imgUrl.split(',')
        var typeId = cailiao[i].dataType
        var typeName = $scope.select.cailiaoType.options[typeId - 1].name
        $scope.transaction.cailiao = $scope.transaction.cailiao || {}
        $scope.transaction.cailiao[typeName] = $scope.transaction.cailiao[typeName] || []
        $scope.transaction.cailiao[typeName] = $scope.transaction.cailiao[typeName].concat(files)
        console.log($scope.transaction.cailiao)
        // $scope.select.cailiaoType.options
      }
      callback && callback(cailiao)
    }, function () {
      errorBack && errorBack()
    })
  }
  /* 获取体温信息 */
  $scope.getTiwen = function (param, callback, errorBack) {
    var data = param || {}
    data.regionId = $scope.region.id;
    data.userId = $scope.user.id;
    $scope.$emit('loading', 'show');
    $scope.transaction.tiwen = {}
    appService.getData(urlMap.scCV19tiwen, data, function (res) {
      $scope.$emit('loading', 'hide');
      var tiwen = res.data && res.data || [], length = tiwen.length;
      for (var i = 0; i < length; i++) {
        var time = tiwen[i].createTime.slice(0, 10);
        if ($scope.timeToday == time) {
          $scope.transaction.todayTiwen = tiwen[i]
          $scope.tiwenForm = tiwen[i]
        }
      }
      callback && callback(tiwen)
    }, function () {
      errorBack && errorBack()
    })
  }
  /* 内容显示 */
  var commitmentTimer
  $scope.setContent = function(type, item, confirm) {
    /* if (($scope.contentName == 'my') && !confirm) {
      $ionicPopup.confirm({
        title: "离开将丢失已填内容, 是否继续",
        cancelText: '仍然离开',
        okText: '留在本页'
      }).then(function(stay) {
        if (!stay) $scope.setContent(type, item, true);
      });
      return
    } */
    $scope.myPop && $scope.myPop.close()
    $scope.$emit('realIdFirst', { formContent: true, editItem: 'idCard', region: $scope.region }, function () {
      $scope.goTop();
      var contentNameO = $scope.contentName;
      if (type == 'commitment') {
        if (!$scope.commitment) $scope.getCommitment()
        if (!$scope.transaction) {
          $scope.getTransaction()
          return
        }
        if ($scope.transaction && $scope.transaction != 'none') {
          $scope.alert('您有正在进行的报备业务, 暂时不能添加新的报备')
          return
        }
        $scope.contentName = type;
        $scope.commitmentModal.show()
        return
      }
      // $timeout.cancel(commitmentTimer);
      if (type == 'tiwen') {
        if (!$scope.transaction || $scope.transaction == 'none') {
          $scope.alert('请先点击"我要报备"登记基本信息')
          return
        }
        $scope.contentName = type;
        return
      }
      if (type == 'cailiao') {
        if (!$scope.transaction || $scope.transaction == 'none') {
          $scope.alert('请先点击"我要报备"登记基本信息')
          return
        }
        $scope.contentName = type;
        return
      }
      $scope.contentName = type;
      if (type == 'clear' || type == 'home') {
        $scope.form = {};
        $scope.formDetail = {};
        $scope.clearDate();
        $scope.selectClear();
        /* if (contentNameO == 'details') {
          $scope.contentName = 'history'
        }
        else $scope.contentName = 'home' */
        $scope.contentName = 'home'
        return
      }
      if (type == 'my') {
        $scope.commitmentModal.hide()
        $scope.form.phone = $scope.user.telephone
        return
      }
      if (type == 'history') {
        $scope.getMyFormed(null, function (formList) {
          if (formList.length > 1 || !formList.length) { $scope.formList = formList; return }
          var item = formList[0]
          $scope.setContent('details', item)
        });
        return
      }
      if (type == 'details') {
        $scope.formDetail = item
        /* $scope.getMyFormed({ id: item.id }, function (res) {
          $scope.formDetail = res[0]
        }) */
        return
      }
    })
  }
  /* 上传体温信息 */
  var formatDateTime = function () {
    var date = new Date();
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    m = m < 10 ? ('0' + m) : m;
    var d = date.getDate();
    d = d < 10 ? ('0' + d) : d;
    var h = date.getHours();
    h = h < 10 ? ('0' + h) : h;
    var minute = date.getMinutes();
    minute = minute < 10 ? ('0' + minute) : minute;
    var second = date.getSeconds();
    second = second < 10 ? ('0' + second) : second;
    // return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
    return y + '-' + m + '-' + d;

  };
  $scope.tiwenForm = {}
  $scope.timeToday = formatDateTime()
  $scope.submitTiwen = function () {
    var msg = $scope.ruleAll()
    if (msg != true) {
      $scope.alert(msg);
      return;
    }
    $scope.tiwenForm.perid = $scope.transaction.perid;
    $scope.tiwenForm.reportId = $scope.transaction.id;
    $scope.tiwenForm.userId = $scope.user.id;
    $scope.tiwenForm.regionId = $scope.region.id;
    // $scope.tiwenForm.pgmCommunityName = $scope.region.name;
    console.log($scope.tiwenForm);
    $scope.$emit('loading', 'show');
    appService.postData(urlMap.scCV19tiwen, $scope.tiwenForm, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        $scope.transaction.todayTiwen = $scope.tiwenForm
        $scope.alert('今日体温登记成功!', function () {
          $scope.setContent('clear')
        })
        return
      }
      $scope.alert('信息提交失败! 请联系管理员')
    })
  }
  /* 表单验证 */
  $scope.vertIdCard = function () {
    var isIdCard = function (card) {
      var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
      return reg.test(card);
    }
    if ($scope.form.cardType == 1) {
      var dataType = isIdCard($scope.form.cardNumber);
      if (!dataType) {
        $('#cardNumber').addClass("error")
        return false
      } return true
    }
  }
  /* 基础报备 */
  $scope.submit = function () {
    var msg = $scope.ruleAll()
    if (msg != true) {
      $scope.alert(msg);
      return;
    }
    /* if (!$scope.vertIdCard()) {
      $scope.alert('请输入正确的身份证号');
      return
    }; */
    // $scope.form.mid = 3;
    $scope.form.glState = 0;
    $scope.form.cardNumber = $scope.user.idCard;
    $scope.form.userId = $scope.user.id;
    $scope.form.regionId = $scope.region.id;
    $scope.form.regionName = $scope.region.name;
    $scope.form.pgmCommunityName = $scope.region.name;
    $scope.form.isSelf = $scope.contentName == 'my' ? 1 : 0;
    $scope.form.arriveTime = $('#arriveTime').val() || null;
    $scope.form.jcTime = $('#contactTime').val() || null;
    $scope.form.hotelInTime = $('#hotelInTime').val() || null;
    $scope.form.hotelOutTime = $('#hotelOutTime').val() || null;
    console.log($scope.form);
    $scope.$emit('loading', 'show');
    appService.postData(urlMap.scCV19, $scope.form, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        var telStr = res.adminTel ? ('<div class="f14">您可以: <p>联系社区相关负责人 <a class="f18" href="tel:' + res.adminTel + '">' + res.adminTel + '</a></p></div>') : ''
        $scope.getTransaction({
          title: '基本信息报备成功',
          template: telStr +
            '<div class="com-flex-line column">' +
            '<button ng-click="setContent(\'tiwen\')" class="button button-positive mt10">登记今日体温</button>' +
            '<button ng-click="setContent(\'cailiao\')" class="button button-positive mt10">上传证明材料</button>' +
            '</div>',
          scope: $scope,
          buttons: [
            {
              text: '返回',
              onTap: function (e) {
                $scope.setContent('clear')
              }
            }
          ]
        })
        // $scope.myPop = $ionicPopup.show();
        return
      }
      $scope.alert('信息提交失败! 请联系管理员')
    })
  }
  /* 上传材料 */
  /* 本地附件读取 */
  function readerfile(file, Binary) {
    return new Promise( function(resolve, reject) {
      var reader = new FileReader();
      reader.onload = function () {
        resolve(reader.result);
      };
      if (file) {
        // if (Binary) reader.readAsBinaryString(file)
        if (Binary) reader.readAsArrayBuffer(file)
        else reader.readAsDataURL(file)
      }
    })
  }
  $scope.fileChangeEvent = function () {
    var files = $('#localPhotoFile')[0].files;
    for (var i = 0; i < files.length; i++) {
      $scope.fileType = thisfileType(files[i].name);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.removeFile();
      try {
        readerfile(files[i]).then(function(e) {
          $scope.$apply(function () {
            if ($scope.fileType == 2) {
              $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
            }
            else $scope.showUploadFiles.push(e)
          })
        })
      } catch (e) {
        alert(e);
        $scope.$apply(function () {
          $scope.showUploadNames.push(files);
        })
      }
    }
  }
  $scope.removeFile = function (reset) {
    $scope.showUploadFiles = []; //预览
    $scope.showUploadNames = []; //预览失败 显示文件名
    if (reset) {
      $('#localPhotoFile').val(''); //本地
      $ionicScrollDelegate.scrollTop();
    }
  }
  $scope.submitCailiao = function () {
    var msg = $scope.ruleAll()
    if (msg != true) {
      $scope.alert(msg);
      return;
    }
    var fList = $('#localPhotoFile')[0].files, fileLength = fList.length;
    if(!fileLength) {
      $scope.alert('请先选择材料文件');
      return
    }
    for (var i = 0; i < fileLength; i++) {
      $scope.fileType = thisfileType(fList[i].name);
      if (!$scope.fileType == 'error') {
        return;
      }
    }
    /* 本地文件上传 */
    $timeout(function () {
      $("#files").ajaxSubmit({
        // url: urlMap.fileUpload,
        url: urlMap.fileBatch,
        type: "post",
        dataType: "json",
        success: function (res) {
          if (res.msg = "文件上传成功!") {
            $scope.removeFile('reset')
            console.log(res)
            var filesStr = ''
            for (var i = 0; i < fileLength; i++) {
              filesStr += i == 0 ? res[i] : ',' + res[i]
            }
            $scope.postCailiao(filesStr)
          } else {
            $scope.alert("文件上传失败，请联系客服人员！");
          }
        },
        error: function (xhr) {
          $scope.$emit('loading', 'hide');
          $scope.alert("媒体上传失败，请联系客服人员！");
        },
        beforeSerialize: function () {
        },
        beforeSend: function () {
          //$("#progressNumber").html('0%');
        },
        uploadProgress: function (event, position, total, percentComplete) {
        }
      });
    })
    /* try {
      readerfile(files[i], 'Binary').then(function(e) {
        var data = {
          httpPath: '/zhsq/cv19/',
          fileType: 1,
          maxWidth: 1080,
          file: e
        }
        appService.postData(urlMap.fileUpload, data, function (res) {
          console.log(res)
        })
      })
    } catch (e) {
      $scope.alert('文件上传失败, 请联系管理员');
    }
  } */
  }
  $scope.postCailiao = function (filesStr) {
    $scope.cailiaoForm.userId = $scope.user.id;
    $scope.cailiaoForm.regionId = $scope.region.id;
    // $scope.cailiaoForm.regionName = $scope.region.name;
    $scope.cailiaoForm.reportId = $scope.transaction.id
    $scope.cailiaoForm.perid = $scope.transaction.perid
    $scope.cailiaoForm.imgUrl = filesStr;
    // $scope.cailiaoForm.hotelOutTime = $('#hotelOutTime').val() || null;
    console.log($scope.cailiaoForm);
    $scope.$emit('loading', 'show');
    appService.postData(urlMap.scCV19cailiao, $scope.cailiaoForm, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        $scope.getCailiao({ reportId: $scope.transaction.id })
        $scope.alert('材料上传成功')
        return
      }
      $scope.alert('材料提交失败! 请联系管理员')
    })
  }
  function thisfileType(fileName) {
    var picExt = ".jpg|.jpeg|.png|";
    // var vioExt = ".mp4|.3gp|.avi|";
    if (!fileName) return null
    var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
    /* 检查文件类型  */
    if (picExt.indexOf(extName + "|") != -1) return 1;
    // if (vioExt.indexOf(extName + "|") != -1) return 2;
    $scope.alert("该文件类型不允许上传。");
    return 'error'
  }
  $scope.alert = function (info, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      callback && callback();
    });
  }
  $scope.viewGoback = function () {
    $scope.commitmentModal.hide()
    if ($scope.contentName != 'home') $scope.setContent('home');
    else $rootScopeViewGoback();
  }
  /* 实名认证 */
  $scope.writeIdcard = function () {
    $scope.$emit('loginFirst', function () {
      $scope.goState('userInfo', { formContent: true, editItem: 'idCard', region: $scope.region })
    })
  }
  /* 承诺书 */
  $ionicModal.fromTemplateUrl('commitment.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function (modal) {
    $scope.commitmentModal = modal;
  });
  $scope.getCommitment = function () {
    $scope.$emit('loading', 'show');
    appService.get(urlMap.scCv19Promise, { id: 1 }, function (res) {
      if (res.code == 200)
        $scope.commitment = res.data && res.data[0]
    })
  }
  /* 选项预设 */
  if ($scope.user && $scope.user.idCard) { $scope.form.cardType = 1; $scope.form.cardNumber = $scope.user.idCard }
  /* 性别 str */
  $scope.optSex = ['男', '女'];
  $scope.select = {};
  /* 证件类型 int*/
  $scope.select.cardType = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.cardType = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      if (!$scope.user.idCard)
        this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '二代身份证' },
      { id: 2, name: '港澳居民来往内地通行证' },
      { id: 3, name: '台湾居民来往大陆通行证' },
      { id: 4, name: '护照' },
      { id: 5, name: '外国人永久居留身份证' }
    ]
  };
  /* 来访目的 str */
  $scope.select.purpose = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.purpose = type.id == 6 ? '' : type.name;
      $scope.formPurpose = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '出差' },
      { id: 2, name: '中转' },
      { id: 3, name: '看病或陪同看病' },
      { id: 4, name: '工作或生活' },
      { id: 5, name: '旅游' },
      { id: 6, name: '其他' } //选其他时, 填写具体目的
    ]
  };
  /* 是否入住宾馆 int */
  $scope.select.isHotel = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isHotel = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 来源地 int */
  $scope.select.jnjw = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.jnjw = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '境内' },
      { id: 2, name: '境外' },
    ]
  };
  /* 是否发烧 int */
  $scope.select.isFire = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isFire = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 是否接触疫区 int */
  $scope.select.isContact = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isYqjc = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 材料类型 */
  $scope.cailiaoForm = {}
  $scope.select.cailiaoType = {
    value: '请选择材料类型', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.cailiaoForm.dataType = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '7日内核酸检测结果' },
      { id: 2, name: '健康通行码“绿码”' },
      { id: 3, name: '行程卡' },
      { id: 4, name: '吉祥码' },
      { id: 5, name: '车票' },
      { id: 6, name: '过路费, 加油费票据' },
      { id: 7, name: '居住证明' },
      { id: 8, name: '其他' },
    ]
  };
  $scope.selectBlur = function () {
    $scope.select.cardType.showOptions = false;
    $scope.select.purpose.showOptions = false
    $scope.select.isHotel.showOptions = false
    $scope.select.jnjw.showOptions = false
    $scope.select.isFire.showOptions = false
    $scope.select.isContact.showOptions = false
    $scope.select.cailiaoType.showOptions = false
  }
  /* 初始化日期插件 */
  $scope.initDateArr = function (id) {
    $("#" + id).mobiscroll().date();
    var currYear = (new Date()).getFullYear();
    //初始化日期控件
    var opt = {
      preset: 'date', //日期，可选：date\datetime\time\tree_list\image_text\select
      theme: 'android-ics light', //皮肤样式，可选：default\android\android-ics light\android-ics\ios\jqm\sense-ui\wp light\wp
      display: 'bottom', //显示方式 ，可选：modal\inline\bubble\top\bottom
      mode: 'scroller', //日期选择模式，可选：scroller\clickpick\mixed
      lang: 'zh',
      dateFormat: 'yyyy-mm-dd', // 日期格式
      setText: '确定', //确认按钮名称
      cancelText: '取消',//取消按钮名籍我
      dateOrder: 'yyyymmdd', //面板中日期排列格式
      dayText: '日', monthText: '月', yearText: '年', //面板中年月日文字
      showNow: false,
      nowText: "今",
      startYear: 2019, //开始年份  
      endYear: currYear //结束年份  
      //endYear:2099 //结束年份
    };
    $("#" + id).mobiscroll(opt);
  }
  $scope.clearDate = function (e) {
    $('#contactTime').val(null);
    $('#arriveTime').val(null);
    $('#hotelInTime').val(null);
    $('#hotelOutTime').val(null);
  }
  $scope.selectClear = function () {
    $scope.select.cardType.value = '请选择'
    $scope.select.purpose.value = '请选择'
    $scope.select.isHotel.value = '请选择'
    $scope.select.jnjw.value = '请选择'
    $scope.select.isFire.value = '请选择'
  }
}
]);
