
appModule.controller('sccv19HandleController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$sce', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup, $ionicScrollDelegate, $sce) {
  /* data */
  $scope.stateName = $state.current.name;
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.form = {};
  $scope.contentName = 'list';
  $scope.regionId = $stateParams.region && $stateParams.region.id;
  $scope.roleLevel = $stateParams.roleLevel;
  $scope.allArrays = [];
  $scope.pageNext = {};
  $scope.domore = {};
  $scope.handleNav = $stateParams.handleNav || [
    {
      id: 0, name: '本社区人员'
    },
    {
      id: 1, name: '非社区人员'
    }
  ];
  $scope.tabIndex = 0;
  $scope.$watch('tabIndex', function (n, o) {
    $scope.setContent('list')
    var delegate = $ionicScrollDelegate.$getByHandle('articlesListScroll');
    delegate.scrollTop();
    var currentArray = $scope.allArrays[n];
    if (n == 0) {
      if ($scope.roleLevel == 101 && !$scope.pgmRegionId) $scope.getUserPgmRid(function () {
        if (!currentArray) $scope.queryArray(n, 0);
      })
      else {
        if (!currentArray) $scope.queryArray(n, 0);
      }
      return
    }
    if (!currentArray) $scope.queryArray(n, 0);
  });
  $scope.$on('$ionicView.enter', function () {
    if (!$scope.wgList && $scope.roleLevel == 100) $scope.getWglist()
  });
  $scope.getUserPgmRid = function (callback) {
    var data = {
      regionId: $scope.regionId,
      userId: $scope.user.id,
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.userPgmRid, data, function (res) {
      $scope.pgmRegionId = res.pgm_region_id
      callback && callback()
    })

  }
  /* 网格列表 */
  $scope.getWglist = function () {
    var data = {
      regionId: $scope.regionId,
      userId: $scope.user.id,
    }
    appService.getData(urlMap.pgmWangge, data, function (results) {
      if (results.code == 200) $scope.wgList = results.data
    })
  }
  /* 获取列表 */
  $scope.queryArray = function (tabIndex, page) {
    var data = { regionId: $scope.regionId, page: page }
    if (tabIndex == 0) {
      if ($scope.roleLevel == 100) { /* 社管员 */
        data.regionId = $scope.regionId
        data.isPgmPerson = 1
      } else { /* 网格员 */
        data.pgmRegionId = $scope.pgmRegionId
      }
    }
    if (tabIndex == 1) {
      data.isPgmPerson = 0
    }
    if (page < 1) {
      $scope.pageNext[tabIndex] = 0;
      $scope.allArrays[tabIndex] = null;
    }
    $scope.domore[tabIndex] = false;
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.scCV19, data, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束

      if (results.code == 200) {
        var list = results.data, length = list.length, size = results.size,
          articles = $scope.allArrays[tabIndex] || [];
        $timeout(function () {
          if (length == size) $scope.domore[tabIndex] = true;
        }, 500)
        if (length > 0) {
          for (var i = 0; i < length; i++) {
            var item = list[i];
            item.jcTime = item.contactTime && item.contactTime.slice(0, 10);
            item.arriveTime = item.arriveTime && item.arriveTime.slice(0, 10);
            item.hotelInTime = item.hotelInTime && item.hotelInTime.slice(0, 10);
            item.hotelOutTime = item.hotelOutTime && item.hotelOutTime.slice(0, 10);
            item.cardType = $scope.select.cardType.options[item.cardType - 1];
            item.jnjw = $scope.select.jnjw.options[item.jnjw - 1];
            item.isFire = item.isFire ? '是' : '否';
            switch (item.glState) {
              case 1:
                item.glStateName = '居家隔离'; 
                break;
              case 2:
                item.glStateName = '重点隔离';
                break;
              case 3:
                item.glStateName = '解除隔离';
                break;
              case 4:
                item.glStateName = '无需隔离';
                break;
              default:
                item.glStateName = '未处理';
            }
            articles.push(item);
          }
        }
        $scope.allArrays[tabIndex] = articles;
      }
    })
  }
  $scope.changeHandleNav = function (navItem) {
    $scope.tabIndex = navItem.id;
  }
  $scope.doRefresh = function () {
    $scope.queryArray($scope.tabIndex, 0);
  }
  $scope.onInfinite = function () {
    var n = $scope.tabIndex;
    if ($scope.pageNext[n] == undefined) return;
    $scope.domore[n] = false;
    $scope.queryArray(n, ++$scope.pageNext[n]);
  }
  /* 内容显示 */
  $scope.setContent = function (type, item) {
    $scope.myPop && $scope.myPop.close()
    $scope.$emit('loginFirst', function () {
      $scope.goTop();
      $scope.contentName = type;
      if (type == 'clear') {
        $scope.form = {};
        $scope.formDetail = {};
        $scope.clearDate();
        $scope.selectClear();
        $scope.contentName = 'list'
        return
      }
      if (type == 'details') {
        $scope.formDetail = item
        $scope.getTiwen({ reportId: item.id }, function (tiwen, todayTiwen) {
          item.tiwen = tiwen
          item.todayTiwen = todayTiwen
        })
        $scope.getCailiao({ reportId: item.id }, function (tiwen) {
          item.cailiao = tiwen
        })
        return
      }
    })
  }
  /* 修改隔离状态 */
  $scope.changeStatevalue = function (formState) {
    console.log(formState)
    $scope.formState = formState
  }
  $scope.putState = function (item) {
    if (!$scope.formState) return
    var data = {
      id: item.id,
      glState: $scope.formState,
      regionId: $scope.regionId,
      userId: $scope.user.id
    }
    $scope.$emit('loading', 'show');
    appService.putData(urlMap.scCV19ChangeState, data, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        $scope.queryArray(0, 0)
      }
    })
    $scope.formState = null
  }
  $scope.changesState = function (item) {
    event.stopPropagation()
    $scope.mypop = $ionicPopup.show({
      title: '修改隔离状态',
      template:
        '<div class="com-flex-line column">' +
        '<div>用户姓名: ' + item.name + '</div>' +
        '<ion-radio ng-value="1" ng-model="formState" name="states" class="item-grow1" ng-change="changeStatevalue(formState)">' +
        '居家隔离' +
        '</ion-radio>' +
        '<ion-radio ng-value="2" ng-model="formState" name="states" class="item-grow1" ng-change="changeStatevalue(formState)">' +
        '重点隔离' +
        '</ion-radio>' +
        '<ion-radio ng-value="3" ng-model="formState" name="states" class="item-grow1" ng-change="changeStatevalue(formState)">' +
        '解除隔离' +
        '</ion-radio>' +
        '<ion-radio ng-value="4" ng-model="formState" name="states" class="item-grow1" ng-change="changeStatevalue(formState)">' +
        '无需隔离' +
        '</ion-radio>' +
        '</div>',
      scope: $scope,
      buttons: [
        {
          text: '取消',
          onTap: function (e) {
          }
        },
        {
          text: '确定',
          type: 'button-positive',
          onTap: function (e) {
            $scope.putState(item)
          }
        }
      ]
    });
  }
  /* 领取到网格 */
  $scope.changesWg = function (item) {
    event.stopPropagation()
    $scope.mypop = $ionicPopup.show({
      title: '分配网格',
      template:
        '<div class="com-flex-line column">' +
        '<div>用户姓名: ' + item.name + '</div>' +
        '<div class="com-flex-line wrap">' +
        '<ion-radio ng-value="wg.id" ng-model="wgid" ng-repeat="wg in wgList track by $index" name="wgs" class="item-grow1" ng-click="changeWgvalue(wgid)">' +
        '{{wg.name}}' +
        '</ion-radio>' +
        '</div>' +
        '</div>',
      scope: $scope,
      buttons: [
        {
          text: '取消',
          onTap: function (e) {
          }
        },
        {
          text: '确定',
          type: 'button-positive',
          onTap: function (e) {
            $scope.putWg(item)
          }
        }
      ]
    });
  }
  $scope.putWg = function (item) {
    if (!$scope.formWg) return
    var data = {
      id: item.id,
      regionId: $scope.regionId,
      userId: $scope.user.id,
      pgmRegionId: $scope.formWg,
      isClaim: 1
    }
    $scope.$emit('loading', 'show');
    appService.putData(urlMap.scCV19ChangeWg, data, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        $scope.queryArray(1, 0)
        $scope.queryArray(0, 0)
      }
    })
    $scope.formWg = null
  }
  $scope.changeWgvalue = function (wgid) {
    $scope.formWg = wgid
    console.log(wgid)
  }
  /* 获取材料信息 */
  $scope.getCailiao = function (param, callback, errorBack) {
    var data = param || {}
    data.regionId = $scope.regionId;
    data.userId = $scope.user.id;
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.scCV19cailiao, data, function (res) {
      $scope.$emit('loading', 'hide');
      var _cailiao;
      var cailiao = res.data && res.data || [], length = cailiao.length;
      for (var i = 0; i < length; i++) {
        var files = cailiao[i].imgUrl.split(',')
        var typeId = cailiao[i].dataType
        var typeName = $scope.select.cailiaoType.options[typeId - 1].name
        _cailiao = {}
        _cailiao[typeName] = _cailiao[typeName] || []
        _cailiao[typeName] = _cailiao[typeName].concat(files)
        console.log(_cailiao)
      }
      callback && callback(_cailiao)
    }, function () {
      errorBack && errorBack()
    })
  }
  /* 获取体温信息 */
  var formatDateTime = function () {
    var date = new Date();
    var y = date.getFullYear();
    var m = date.getMonth() + 1;
    m = m < 10 ? ('0' + m) : m;
    var d = date.getDate();
    d = d < 10 ? ('0' + d) : d;
    var h = date.getHours();
    h = h < 10 ? ('0' + h) : h;
    var minute = date.getMinutes();
    minute = minute < 10 ? ('0' + minute) : minute;
    var second = date.getSeconds();
    second = second < 10 ? ('0' + second) : second;
    // return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
    return y + '-' + m + '-' + d;

  };
  $scope.timeToday = formatDateTime()
  $scope.getTiwen = function (param, callback, errorBack) {
    var data = param || {}
    data.regionId = $scope.regionId;
    // data.userId = $scope.user.id;
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.scCV19tiwen, data, function (res) {
      $scope.$emit('loading', 'hide');
      var tiwen = res.data && res.data || [], length = tiwen.length;
      var todayTiwen
      for (var i = 0; i < length; i++) {
        var time = tiwen[i].createTime = tiwen[i].createTime.slice(0, 10);
        if ($scope.timeToday == time) {
          todayTiwen = tiwen[i]
        }
      }
      callback && callback(tiwen, todayTiwen)
    }, function () {
      errorBack && errorBack()
    })
  }
  /* 登记体温 */
  $scope.tiwenForm = {}
  $scope.changesTiwen = function (item) {
    event.stopPropagation()
    $scope.mypop = $ionicPopup.show({
      title: '登记今日体温',
      template:
        '<div class="com-flex-line column">' +
        '<div>用户姓名: ' + item.name + '</div>' +
        '<input class="item-grow1" type="number" ng-model="tiwenForm.imgUrl" placeholder="请输入今日体温(℃)" maxlength="5" />' +
        '</div>',
      scope: $scope,
      buttons: [
        {
          text: '取消',
          onTap: function (e) {
          }
        },
        {
          text: '确定',
          type: 'button-positive',
          onTap: function (e) {
            $scope.submitTiwen(item)
          }
        }
      ]
    });
  }
  $scope.submitTiwen = function (item) {
    if (!$scope.tiwenForm.imgUrl) {
      return;
    }
    $scope.tiwenForm.perid = item.perid;
    $scope.tiwenForm.reportId = item.id;
    $scope.tiwenForm.userId = item.userId;
    $scope.tiwenForm.regionId = $scope.regionId;
    // $scope.tiwenForm.pgmCommunityName = $scope.region.name;
    console.log($scope.tiwenForm);
    $scope.$emit('loading', 'show');
    appService.postData(urlMap.scCV19tiwen, $scope.tiwenForm, function (res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        item.todayTiwen = $scope.tiwenForm
        $scope.getTiwen({ reportId: item.id }, function (tiwen, todayTiwen) {
          item.tiwen = tiwen
          item.todayTiwen = todayTiwen
        })
        $scope.alert('今日体温登记成功!', function () { })
        return
      }
      $scope.alert('信息提交失败! 请联系管理员')
    })
  }
  $scope.viewGoback = function () {
    if ($scope.contentName != 'list') $scope.setContent('list');
    else $rootScopeViewGoback();
  }
  /* 选项预设 */
  if ($scope.user && $scope.user.idCard) { $scope.form.cardType = 1; $scope.form.cardNumber = $scope.user.idCard }
  /* 性别 str */
  $scope.optSex = ['男', '女'];
  $scope.select = {};
  /* 证件类型 int*/
  $scope.select.cardType = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.cardType = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      if (!$scope.user.idCard)
        this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '二代身份证' },
      { id: 2, name: '港澳居民来往内地通行证' },
      { id: 3, name: '台湾居民来往大陆通行证' },
      { id: 4, name: '护照' },
      { id: 5, name: '外国人永久居留身份证' }
    ]
  };
  /* 来访目的 str */
  $scope.select.purpose = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.purpose = type.id == 6 ? '' : type.name;
      $scope.formPurpose = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '出差' },
      { id: 2, name: '中转' },
      { id: 3, name: '看病或陪同看病' },
      { id: 4, name: '工作或生活' },
      { id: 5, name: '旅游' },
      { id: 6, name: '其他' } //选其他时, 填写具体目的
    ]
  };
  /* 是否入住宾馆 int */
  $scope.select.isHotel = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isHotel = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 来源地 int */
  $scope.select.jnjw = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.jnjw = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '境内' },
      { id: 2, name: '境外' },
    ]
  };
  /* 是否发烧 int */
  $scope.select.isFire = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isFire = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 是否接触疫区 int */
  $scope.select.isContact = {
    value: '请选择', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.form.isYqjc = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '是' },
      { id: 0, name: '否' },
    ]
  };
  /* 材料类型 */
  $scope.cailiaoForm = {}
  $scope.select.cailiaoType = {
    value: '请选择材料类型', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.name;
      $scope.cailiaoForm.dataType = type.id;
      $scope.selectBlur();
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    },
    options: [
      { id: 1, name: '7日内核酸检测结果' },
      { id: 2, name: '健康通行码“绿码”' },
      { id: 3, name: '行程卡' },
      { id: 4, name: '吉祥码' },
      { id: 5, name: '车票' },
      { id: 6, name: '过路费, 加油费票据' },
      { id: 7, name: '居住证明' },
      { id: 8, name: '其他' },
    ]
  };
  $scope.selectBlur = function () {
    $scope.select.cardType.showOptions = false;
    $scope.select.purpose.showOptions = false
    $scope.select.isHotel.showOptions = false
    $scope.select.jnjw.showOptions = false
    $scope.select.isFire.showOptions = false
    $scope.select.isContact.showOptions = false
    $scope.select.cailiaoType.showOptions = false
  }

  $scope.alert = function (info, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      callback && callback();
    });
  }
}
]);
