
appModule.controller('intelligentDFuncLostController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', function($scope, $state, appService, $timeout, $stateParams, $ionicPopup) {
  $mScope = $scope.$parent;
  $mScope.currentFun = 'lost';
  $scope.stateName = $state.current.name;
  $scope.lostList;
  $scope.pageNext = 1;
  $scope.domore;
  $scope.form = {}
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.lostType = {
    value: '选择类型', options: [],
    selecOption: function(o) {
      console.log(o)
      this.value = o.seekType;
      $scope.form.lostType = o.id;
      $scope.lostBlur();
    },
    onFocus: function() {
      this.showOptions = !this.showOptions;
    }
  };
  $scope.lostBlur = function() {
    $scope.lostType.showOptions = false
  }
  $scope.$on('$stateChangeStart',
    function(event, toState, toParams, fromState, fromParams) {
      // console.log($ionicHistory);
      $mScope.backState = $scope.stateName;
      $mScope.viewGoback = $rootScopeViewGoback;
    })
  $scope.queryArray = function(page) {
    if (page < 2) { //页面刷新时为0,下拉刷新时为1
      $scope.pageNext = 1;
      page = 1;
      $scope.lostList = null;
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.intelligentDLostList, {
      villageId: $scope.districtForFuncList.id,
      page: page
    }, function(results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('寻人寻物:', results);
      if (!results) return;
      var list = results.resultList, length = list.length, size = results.size,
        articles = $scope.lostList || []
        ;
      if (length < size) $scope.domore = false;
      else {
        $timeout(function() {
          $scope.domore = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.id = item.id;
          article.title = item.title;
          article.seekType = item.seekType;
          article.summary = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '').slice(0, 30);
          article.picName = item.picName;
          article.createTime = item.createTime;
          articles.push(article);
        }
      }
      $scope.lostList = articles;
    });
  }
  $scope.doRefresh = function() {
    $scope.queryArray(1);
  }
  $scope.onInfinite = function() {
    $scope.queryArray(++$scope.pageNext);
  }
  $scope.setForm = function(b) {
    $scope.$emit('loginFirst', function() {
      $scope.formContent = b;
      if (b) {
        $scope.form = {}
        $scope.lostType.value = '选择类型';
      }
      if (b && !$scope.lostType.options.length)
        $scope.getLostType();
    })
  }
  $scope.initForm = function(item) {
    $scope.form = item;
  }
  $scope.queryArray(0);
  $mScope.viewGoback = function() {
    if ($scope.formContent) $scope.formContent = false;
    else $rootScopeViewGoback();
  }
  $scope.alert = function(info, queryAgain, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function(res) {
      if (queryAgain)
        $scope.queryArray(1);
      callback && callback();
    });
  }
  $scope.getLostType = function() {
    appService.getData(urlMap.intelligentDLostTypeList, {}, function(jsonDataArr) {
      $scope.lostType.options = jsonDataArr.resultList;
    });
  }
  $scope.getArticleDetail = function(id) {
    $state.go('intelligentDArticleDetail', { id: id, shareFlag: null, queryUrl: 'intelligentDLostDetail' })
  }
  /* 照片文件 */
  $scope.fileChangeEvent = function() {
    $scope.$apply(function() {
      $scope.form.uploadPhotoPath = $('#localPhotoFile').val();
    })
  }
  $scope.removeFile = function() {
    $scope.form.uploadPhotoPath = null;
    $('#localPhotoFile').val('')
  }
  /***
   * 拍照
   */
  $scope.picCapture = function() {
    $scope.$emit('loginFirst', function() {
      // limit 拍照的张数  
      navigator.device.capture.captureImage(picSuccess, onError, { limit: 1 });
    });
    //照片拍摄成功
    function picSuccess(mediaFiles) {
      var i, path, len;
      //遍历获取录制的文件(iOS只支持一次录制一个视频或音频)
      for (i = 0, len = mediaFiles.length; i < len; i += 1) {
        path = mediaFiles[i].fullPath;
        $scope.removeFile();
        $scope.$apply(function() {
          $scope.form.uploadPhotoPath = mediaFiles[i].name;
        })
        $scope.cameraFile = mediaFiles[i];
      }
    }
    //录制失败
    function onError(error) {
      if (error.code != 3)
        $scope.alert('拍照失败！错误码:' + error.code);
    }
  }
  /***
   * 上传拍摄文件
   * type 1:图片 2：视频
   */
  $scope.uploadFile = function(fileName, path, url) {
    var params = {};
    params.villageId = $scope.districtForFuncList.id; //社区id
    params.userId = $scope.user.id; //userid 
    // params.userName = $scope.user.userName; //用户名
    params.type = $scope.form.fileType;
    params.title = $scope.form.title;
    params.seekTypeId = $scope.form.lostType;
    params.content = $scope.form.content;
    var ft = new FileTransfer();
    var options = new FileUploadOptions();
    options.fileKey = "file";
    options.mimeType = "multipart/form-data";
    options.fileName = fileName;
    options.params = params;
    //传输进度  
    ft.onprogress = function(progressEvent) {
      /* if (progressEvent.lengthComputable) {
        var percentComplete = Math.round(progressEvent.loaded * 100 / progressEvent.total);
        $("#progressNumber").html(percentComplete.toString() + '%');
        if (percentComplete.toString() == "100") {
          if (type == "1") {
            $("#progressNumber").html("图片上传成功");
          } else if (type == "2") {
            $("#progressNumber").html("视频上传成功");
          }
        }
      }
      else {
        $("#progressNumber").html('unable to compute');
      } */
    };
    ft.upload(path, url,
      function() {
        $scope.$emit('loading', 'hide');
        $scope.alert("信息提交成功！", true, function() {
          $scope.setForm(false);
        });
      },
      function() {
        $scope.alert("文件上传失败，请到留言板留言！");
      },
      options);
  };
  $scope.submitLost = function() {
    if (!($scope.form.title && $scope.form.content && $scope.form.lostType > -1)) {
      $scope.alert("请补全信息");
      return;
    }
    if ($scope.form.content.length > 1500) {
      $scope.alert("说明内容不能超过1500字！");
      return;
    }
    $scope.$emit('loading', 'show');
    var picExt = ".jpg|.jpeg|.png|";
    var vioExt = ".mp4|.3gp|.avi|";
    var ErrMsg;
    var file = $scope.form.uploadPhotoPath || '';
    var fileType;
    if (!file) {
      fileType = '0'
    } else {
      var extName = file.substring(file.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
      /* 检查文件类型  */
      if (picExt.indexOf(extName + "|") != -1) {
        fileType = '1';
      } else if (vioExt.indexOf(extName + "|") != -1) {
        fileType = '2';
      } else {
        /* 非法文件格式 */
        if (picExt.indexOf(extName + "|") == -1) {
          ErrMsg = "该文件类型不允许上传。请上传 " + picExt + " 类型的文件，当前文件类型为" + extName;
          $scope.alert(ErrMsg);
          return;
        } else if (vioExt.indexOf(extName + "|") == -1) {
          ErrMsg = "该文件类型不允许上传。请上传 " + vioExt + " 类型的文件，当前文件类型为" + extName;
          $scope.alert(ErrMsg);
          return;
        }
      }
    }
    $scope.form.fileType = fileType;
    $('#fileType').val(fileType);
    /* 拍摄上传 */
    if ($scope.cameraFile && $scope.cameraFile.name) {
      var ErrMsg;
      var file = $scope.cameraFile.name;
      var extName = file.substring(file.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写） 
      if (fileType > 0) $scope.uploadFile($scope.cameraFile.name, $scope.cameraFile.fullPath, urlMap.intelligentDLostInsertItem);
      return;
    }
    /* 非拍摄上传 */
    $scope.$emit('loading', 'show');
    $("#formDatas").ajaxSubmit({
      url: urlMap.intelligentDLostInsertItem,
      type: "post",
      dataType: "json",
      success: function(saveBoolean) {
        $scope.$emit('loading', 'hide');
        if (saveBoolean == 'true' || saveBoolean == true) {
          $scope.alert("发布消息成功！", true, function() {
            $scope.setForm(false);
          });
        } else {
          $scope.alert("提交失败，请联系客服人员！");
        }
      },
      error: function(xhr) {
        $scope.$emit('loading', 'hide');
        $scope.alert("信息发布失败! 请联系客服");
      },
      beforeSerialize: function() {
      },
      beforeSend: function() {
        //$("#progressNumber").html('0%');
      },
      uploadProgress: function(event, position, total, percentComplete) {
        $scope.removeFile();
      }
    });
  }
}]);

