

appModule.controller('intelligentDFuncPersonnelController', ['$scope', '$state', 'appService', '$timeout', '$ionicScrollDelegate', '$sce', '$document', function($scope, $state, appService, $timeout, $ionicScrollDelegate, $sce, $document) {
  $scope.stateName = $state.current.name;
  $mScope = $scope.$parent;
  $mScope.currentFun = 'personnel';
  $scope.domore = true;
  $scope.showPerson;
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.$on('$stateChangeStart',
    function(event, toState, toParams, fromState, fromParams) {
      //离开本页
      $mScope.backState = $scope.stateName;
      $mScope.viewGoback = $rootScopeViewGoback;
    })
  $scope.$watch('districtForFuncList', function(n) {
    if (!n) return
  });

  /* 组织人员 */
  $scope.getPersons = function(orgId) {
    $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
    $scope.domore = false
    var data = {
      regionId: $scope.districtForFuncList.id, //部门id
      mid: 1,
      pid: 0,
    };
    appService.getData(urlMap.orgPersonAll, data,
      function(results) {
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        var list = results.data;
        console.log(list)
        $scope.people = list;
        $timeout(function() {
          $scope.initTree()
        })
      })
  }
  $scope.initTree = function() {
    var treeWrap = $document[0].getElementById("idivPersonal")
    var iDivTree = window.iDivTree = echarts.init(treeWrap);
    // iDivTree.showLoading();
    var option = {
      // backgroundColor: "#4a38fe",
      series: [
        {
          type: 'tree',
          data: $scope.people,
          // orient: 'TB',
          orient: 'LR',
          top: '-20',
          left: '-60',
          bottom: '0',
          right: '0',
          zlevel: 1,
          symbol: function(v, params) {
            var data = params.data
            /* var res = 'image://data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAIAAACQd1PeAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAAEnQAABJ0Ad5mH3gAAAAMSURBVBhXY/j//z8ABf4C/qc1gYQAAAAASUVORK5CYII=' */
            var res = 'rect'
            return res
          },
          itemStyle: {
            color: '#fff',
            borderColor: '#f00',
            borderWidth: 0
          },
          symbolSize: function(v, params) {
            var data = params.data
            var size = [40, 28]
            if (data.name == 'line') {
              size = [60, 2]
            }
            if (data.name == 'root') {
              size = [260, 2]
            }
            return size
          },
          // symbolOffset: [-100, 0],
          // symbolOffset: ['50%', '50%'],
          edgeShape: 'polyline',
          edgeForkPosition: '40%',
          label: {
            position: [0, 0],
            // distance: -44,
            verticalAlign: 'top',
            align: 'left',
            fontSize: 12,
            // width:20,
            formatter: function(params) {
              var item = params['data']
              // console.log(params);
              var jobHtmlStr = ''
              var workHtmlStr = ''
              item.jobList && item.jobList.forEach(function(job) {
                var jobName = job.remark || job.name
                item.jobName = jobName.replace(/^\\n/g, '')
                item.jobName = item.jobName.replace(/\\n/g, '、')
                jobName = jobName.replace(/\\n/g, '\n')
                if (job.isDisplay != 0 && jobName != 'root' && jobName != 'line') {
                  if (!item.children || !item.children.length) jobHtmlStr += ' '
                  jobHtmlStr += jobName += ' '
                }
              })
              var res = '';
              if (/^[a-zA-Z]+$/g.test(item.name)) {
                item.name = ''
              }
              res += '{a|' + item.name + '}';
              if (item.children && item.children.length) res += '\n';
              res += '{b|' + jobHtmlStr + '}';
              if (item.name == 'line') {
                res += '{line|' + '' + '}';
              }
              return res;
            },
            rich: {
              a: {
                color: '#444',
                backgroundColor: '#fff',
                fontSize: 15,
                lineHeight: 20,
              },
              b: {
                color: '#1b84f1',
                // color: '#1a72b8',
                backgroundColor: '#fff',
                lineHeight: 15,
                // pading:15,
                fontSize: 12,
                fontWeight: 700
              },
              line: {
                backgroundColor: '#333',
                height: 0,
                width: 0,
              },
              /*  x: {
                 fontSize: 18,
                 fontFamily: 'Microsoft YaHei',
                 borderColor: '#449933',
                 borderRadius: 4
               }, */
            }
          },
          leaves: {
            label: {
              position: 'right',
              distance: -44,
              verticalAlign: 'middle',
              align: 'left',
              fontSize: 14
            }
          },
          lineStyle: {
            color:'#000',
            width: 0.5,
          },
          roam: true,
          zoom: 1,
          scaleLimit: { //滚轮缩放的极限控制
            min: 0.9,
            max: 1.8
          },
          initialTreeDepth: -1,
          expandAndCollapse: false,
          animationDuration: 550,
          animationDurationUpdate: 750
        }
      ]
    };
    iDivTree.setOption(option);
    var oH = treeWrap.clientHeight, oW = treeWrap.clientWidth;
    var elesArr = Array.from(new Set(iDivTree._chartsViews[0]._data._graphicEls));
    var dep = iDivTree._chartsViews[0]._data.tree.root.height - 1;//获取树高
    var layer_height = 120;     //层级之间的高度
    var treeH = layer_height * dep || layer_height;
    treeWrap.style.height = treeH + 'px';
    var min_width = 60; // 兄弟节点之间的距离
    var treeW = min_width * (elesArr.length / dep) || min_width;
    treeWrap.style.width = treeW + 'px';
    treeWrap.style.top = (oH - treeH)/2 + 'px'
    treeWrap.style.left = (oW - treeW)/2 + 'px'
    treeWrap.style.position = 'relative'
    iDivTree.resize();
    iDivTree.setOption(option);
    iDivTree.on('click', function(params) {
      console.log(params.data.name);
      var per = params.data
      per.introductions = per.introductions || $sce.trustAsHtml(per.details);
      $scope.$apply(function() {
        $scope.showPerson = true;
        $scope.person = per;
        $ionicScrollDelegate.scrollTop();
      })
      /* $scope.$emit('loading', 'show');
      var data = {
        orgId: 11, //部门id
        page: 0,
        size: 999
      };
      appService.getData(urlMap.scOrgPerson, data,
        function(results) {
          $scope.$emit('loading', 'hide');
          var list = results.data;
          $scope.members = list;
          $scope.getPersionDetail(list[0], 0)
        }) */
    });
  }
  $scope.getPersionDetail = function(per) {
  }
  $scope.onInfinite = function() {
    $scope.getPersons();
  }
  $mScope.viewGoback = function() {
    $scope.person = null;
    if ($scope.showPerson) $scope.showPerson = false;
    else $rootScopeViewGoback();
  }
}]);

