
appModule.controller('intelligentDFuncServiceController', ['$scope', '$rootScope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', function ($scope, $rootScope, $state, appService, $timeout, $stateParams, $ionicPopup) {
  $mScope = $scope.$parent;
  $mScope.currentFun = 'service';
  $scope.stateName = $state.current.name;
  $scope.serviceList;
  $scope.pageNext = 1;
  $scope.domore;
  $scope.form = {}
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.serviceType = {
    value: '选择类型', options: [],
    selecOption: function (type) {
      console.log(type)
      this.value = type.msgName;
      $scope.form.typeId = type.id
    },
    onFocus: function () {
      this.showOptions = !this.showOptions;
    }
  };
  $scope.$watch('districtForFuncList', function (n) {
    if (!n) return
    $scope.queryArray(0);
  })
  $scope.$on('$stateChangeStart',
    function (event, toState, toParams, fromState, fromParams) {
      // console.log($ionicHistory);
      $mScope.backState = $scope.stateName;
      $mScope.viewGoback = $rootScopeViewGoback;
    })
  /* 获取服务类型 */
  $scope.getServiceType = function () {
    appService.getData(urlMap.intelligentDServiceTypeList, {}, function (results) {
      $scope.serviceType.options = results && results.resultList || [];
    });
  }
  $scope.queryArray = function (page) {
    if (page < 2) { //页面刷新时为0,下拉刷新时为1
      $scope.pageNext = 1;
      page = 1;
      $scope.serviceList = null;
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.intelligentDServiceList, {
      villageId: $scope.districtForFuncList.id,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('服务列表:', results);
      if (!results) return;
      var list = results.resultList, length = list.length, size = results.size,
        articles = $scope.serviceList || []
        ;
      if (length < size) $scope.domore = false;
      else {
        $timeout(function () {
          $scope.domore = true;
        }, 200)
      }
      // $scope.domore = true;
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article.id = item.id;
          article.title = item.title;
          // article.subMenuName = item.subMenuName;
          article.summary = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '');
          // article.pic_name = item.picName || item.pic_name || $scope.pic + urlMap.defaultUpload;;
          article.typeName = item.msgName || '测试类型';
          article.createTime = item.createTime;
          articles.push(article);
        }
      }
      $scope.serviceList = articles;
    }, function (error, errorCode) {
      $scope.serviceList = [];
      // $scope.errorCode = errorCode;
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
    });
  }
  $scope.doRefresh = function () {
    $scope.queryArray(1);
  }
  $scope.onInfinite = function () {
    $scope.domore = false;
    $scope.queryArray(++$scope.pageNext);
  }
  $scope.setForm = function (b) {
    if (!b) {
      $scope.formContent = b;
      return;
    }
    $scope.$emit('loginFirst', function () {
      $scope.formContent = b;
      $scope.form = {}
      $scope.serviceType.value = '选择类型';
      if (!$scope.serviceType.options.length)
        $scope.getServiceType();
    })
  }
  $scope.initForm = function (item) {
    $scope.form = item;
  }
  $mScope.viewGoback = function () {
    if ($scope.formContent) $scope.formContent = false;
    else $rootScopeViewGoback();
  }
  $scope.alert = function (info, queryAgain, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      if (queryAgain)
        $scope.queryArray(1);
      callback && callback();
    });
  }
  $scope.insertServiceItem = function () {
    if (!($scope.form.typeId && $scope.form.title && $scope.form.content)) {
      $scope.alert("请完整填写表单信息");
      return;
    }
    $scope.$emit('loading', 'show');
    var data = {
      villageId: $scope.districtForFuncList.id,
      msgType: $scope.form.typeId,
      title: $scope.form.title,
      content: $scope.form.content,
      userId: $scope.user.id,
      userName: $scope.user.userName
    };
    appService.postData(urlMap.intelligentDerviceInsertItem, data,
      function (result) {
        $scope.$emit('loading', 'hide');
        if (result == true || result[0] == true) {
          $scope.alert("服务信息提交成功！等待社区管理员审核。", true, function () {
            $scope.setForm(false);
          });
        } else {
          $scope.alert("信息发布失败! 请联系客服");
        }
      }, function (data, status) {
        $scope.alert("请求失败，请检查网络");
      })
  }
  $scope.getArticleDetail = function (id) {
    $state.go('intelligentDArticleDetail', { id: id, shareFlag: null, queryUrl: 'intelligentDServiceItem' })
  }
}]);

