
appModule.controller('intelligentDHandleController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$sce', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup, $ionicScrollDelegate, $sce) {
  /* data */
  $scope.stateName = $state.current.name;
  $scope.allArrays = {};
  $scope.pageNext = {};
  $scope.domore = {};
  $rootScopeViewGoback = $scope.viewGoback;
  console.log($stateParams);
  $scope.regionId = $stateParams.region.id;
  $scope.handleNav = $stateParams.handleNav || [
    { name: '社区留言', menuIcon: '', url: 'intelligentDHandleMsg' },
    { name: '寻人寻物', menuIcon: '', url: 'intelligentDHandleLost' },
    { name: '服务信息', menuIcon: '', url: 'intelligentDHandleService' }
  ];
  $scope.tabName = $scope.handleNav && $scope.handleNav[0].url;
  $scope.$watch('tabName', function (n, o) {
    if (!n) return;
    $scope.showDetials = false
    var currentArray = $scope.allArrays[n];
    if (!currentArray) $scope.queryArray(n, 0);
    var delegate = $ionicScrollDelegate.$getByHandle('articlesListScroll');
    delegate.scrollTop();
  });
  $scope.changeHandleNav = function (navItem) {
    $scope.tabName = navItem.url;
  }
  $scope.queryArray = function (tabName, page) {
    if (!tabName) return;
    if (page == 0 || page == 1) { //页面刷新时为0,下拉刷新时为1
      $scope.pageNext[tabName] = 1;
      page = 1;
    }
    $scope.$emit('loading', 'show');
    if (tabName == 'intelligentDHandleMsg') {
      $scope.getMsg(tabName, page);
    }
    if (tabName == 'intelligentDHandleLost') {
      $scope.getLost(tabName, page);
    }
    if (tabName == 'intelligentDHandleService') {
      $scope.getService(tabName, page);
    }
  }
  $scope.getMsg = function (tabName, page) {
    if (page < 2) {
      $scope.allArrays[tabName] = null;
    }
    appService.getData(urlMap.intelligentDMsgList, {
      replyType: '-1',
      typeId: '-1',
      villageId: $scope.regionId,
      userId: $scope.user.id,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('留言列表: ', results);
      var list = results.resultList, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.autidUrl = 'intelligentDHandleMsg';
          article.leaveMessage = $sce.trustAsHtml(article.leaveMessage).$$unwrapTrustedValue();
          // article.replyContent = $sce.trustAsHtml(article.replyContent).$$unwrapTrustedValue();
          var portrait = item.portrait;
          article.portrait = !!portrait ? $scope.pic + "/" + portrait : article.portrait = $scope.pic + urlMap.defaultImg;
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    });
  }
  $scope.getLost = function (tabName, page) {
    if (page < 2) {
      $scope.allArrays[tabName] = null;
    }
    appService.getData(urlMap.intelligentDLostList, {
      villageId: $scope.regionId,
      userId: $scope.user.id,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('寻人寻物:', results);
      if (!results) return;
      var list = results.resultList, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.autidUrl = 'intelligentDHandleLost';
          article.stateUrl = 'intelligentDHandleStateLost';
          article.id = item.id;
          article.title = item.title;
          article.seekType = item.seekType;
          article.content = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '');
          article.summary = article.content.slice(0, 30);
          article.picName = item.picName;
          article.createTime = item.createTime;
          article.auditName = item.audit > 0 ? '已审核' : '未审核';
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    });
  }
  $scope.getService = function (tabName, page) {
    if (page < 2) {
      $scope.allArrays[tabName] = null;
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.intelligentDServiceList, {
      villageId: $scope.regionId,
      userId: $scope.user.id,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('服务列表:', results);
      if (!results) return;
      var list = results.resultList, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article.autidUrl = 'intelligentDHandleService';
          article.id = item.id;
          article.title = item.title;
          // article.subMenuName = item.subMenuName;
          article.content = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '');
          article.summary = article.content.slice(0, 30);
          // article.pic_name = item.picName || item.pic_name || $scope.pic + urlMap.defaultUpload;;
          article.typeName = item.msgName;
          article.verify = item.verify;
          article.verifyName = item.verify ? '已审核' : '未审核';
          article.createTime = item.createTime;
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    }, function (error, errorCode) {
      $scope.allArrays[tabName] = [];
      // $scope.errorCode = errorCode;
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
    });
  }
  $scope.doRefresh = function () {
    $scope.queryArray($scope.tabName, 1);
  }
  $scope.onInfinite = function () {
    var n = $scope.tabName;
    if (!$scope.pageNext[n]) return;
    $scope.domore[n] = false;
    $scope.queryArray(n, ++$scope.pageNext[n]);
  }
  $scope.showDetial = function (b, item) {
    $scope.showDetials = b;
    if (b) {
      var delegate = $ionicScrollDelegate.$getByHandle('articlesDetailScroll');
      delegate.scrollTop();
      item.audit = item.flag + 1 || item.audit + 1 || item.verify + 1;
      item.audit = item.audit > 1 ? 1 : 0;
      item.auditName = item.audit > 0 ? '已审核' : '未审核';
      $scope.detailItem = item;
      console.log(item)
    }
  }
  // 审核
  $scope.auditFun = function (audit, urlStr) {
    console.log($scope.detailItem.autidUrl);
    audit = audit > 0 ? 0 : 1;
    var data = {
      id: $scope.detailItem.id,
      verifyFlag: audit
    },
      opts = {
        method: "post",
        url: urlMap[$scope.detailItem.autidUrl],
        params: data,
      }
    appService.queryData(opts, function (result) {
      $scope.queryArray($scope.tabName, 0);
      if (result == true || result[0] == true) {
        $scope.detailItem.audit = audit;
        $scope.detailItem.auditName = audit > 0 ? '已审核' : '未审核';
      } else {
        $scope.alert("信息发布失败! 请联系客服");
      }
    })
  }
  $scope.replyMsg = function () {
    $scope.$emit('loginFirst', function () {
      var reply = $scope.detailItem.replyContent;
      $scope.$emit('loading', 'show');
      var data = {
        replyContent: reply,
        id: $scope.detailItem.id,
        replyUserName: $scope.user.userName
      },
        opts = {
          method: "post",
          url: urlMap.intelligentDHandleReplyMsg,
          params: data,
        }
      appService.queryData(opts,
        function (results) {
          $scope.$emit('loading', 'hide');
          if (results == true) {
            $scope.alert("回复成功", true);
          } else {
            $scope.alert("回复失败,请联系客服");
          }
        })
    })
  }
  // 处理
  $scope.stateFun = function (state) {
    console.log($scope.detailItem.autidUrl);
    state = state > 0 ? 0 : 1;
    var data = {
      id: $scope.detailItem.id,
      verifyFlag: state
    },
      opts = {
        method: "post",
        url: urlMap[$scope.detailItem.stateUrl],
        params: data,
      }
    appService.queryData(opts, function (result) {
      $scope.queryArray($scope.tabName, 0);
      if (result == true || result[0] == true) {
        $scope.detailItem.state = state;
        $scope.detailItem.stateName = state > 0 ? '已处理' : '未处理';
      } else {
        $scope.alert("信息发布失败! 请联系客服");
      }
    })
  }
  $scope.alert = function (info, queryAgain, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      if (queryAgain)
        $scope.queryArray($scope.tabName, 0);
      callback && callback();
    });
  }
  $scope.viewGoback = function () {
    if ($scope.showDetials) $scope.showDetials = false;
    else $rootScopeViewGoback();
  }
}
]);
