
angular.module("ngPublic", ['app_service', 'ionic'])
  /**
   * 请求初始化location json结构
   * 初始化当前定位
   */
  .directive("locationToCommunityNav", ['appService', '$rootScope', '$ionicScrollDelegate', '$timeout', '$ionicPopup', '$stateParams', function(appService, $rootScope, $ionicScrollDelegate, $timeout, $ionicPopup,$stateParams) {
    return {
      restrict: 'E',
      replace: true,
      scope: false,
      templateUrl: 'pages/intelligent-division/location-rootnav/index.html',
      link: function($scope, element, attrs) { //rootScope: idivVillage,idivTown
        var productName
        switch ($scope.productId) {
          case 4:
            productName = 'ZHXZ' // 乡镇
            break;
          case 5:
            productName = 'ZHCW' //村务 村社
            break;
          default:
            productName = 'ZHSQ' //社区
        }
        function error() {
          $ionicPopup.alert({
            title: '提示框',
            template: '该地区暂未开放, 敬请期待!'
          }).then(function() {
            $scope.viewGoback()
          });
        }
        $scope.regionCode = $stateParams.regionCode || $scope.publicCityId
        if ($scope.regionCode.length < 6) {
          error();
          return
        }
        var lsLocation = JSON.parse(localStorage.getItem('perpetual.' + productName + '.location'));
        if (lsLocation && (lsLocation.areaId != $scope.regionCode || lsLocation.productName != productName)) {
          lsLocation = $rootScope[productName + 'Town'] = $rootScope[productName + 'Village'] = null
        }
        $scope.activeDistrict = $scope.district = (lsLocation && lsLocation.data) || { id: $scope.regionCode, name: $scope.publicCityName, level: 3, pDistrict: {} }; //当前激活的单个地区
        $scope.showLocationToCommunity = $scope.district.level < 4;
        $scope.$watchGroup(['', 'province', 'city', 'dist', productName + 'Town', productName + 'Village'], function(newVal, oldVal) {
          for (var i = 0; i < newVal.length; i++) {
            newVal[i] = newVal[i] || { name: '请选择' };
          }
          $scope.locationNavIdiv = newVal;//['省', '市', '区', '镇', '村'];
        });
        $scope.navList = []; //完整行政区列表4&5
        $scope.positionList; //页面显示行政区列表4|5
        //获取eladmin地区
        $scope.regionLevel3 = function(id, callback) {
          var data = {
            code: id,
            midArr: '0,' + $scope.productId,
            state: 1
          }
          // $scope.$emit('loading', 'show');
          appService.getData(urlMap.region, data,
            function(results) {
              $scope.$emit('loading', 'hide');
              if (!results || !results.data[0]) {
                error(); return
              };
              callback && callback(results.data[0])
            })
        }
        $scope.regionLevel4 = function(dist, callback) {
          var _townList = dist.children;
          var townList = [];
          if (!_townList || !_townList.length) {
            var data = {
              pid: dist.id,
              midArr: '0,' + $scope.productId,
              state: 1
            }
            // $scope.$emit('loading', 'show');
            appService.getData(urlMap.region, data,
              function(results) {
                $scope.$emit('loading', 'hide');
                if (!results || !results.data) return;
                if (!results || !results.data[0]) {
                  error(); return
                };
                console.log('4级社区: ', results.data);
                var _townList = results.data;
                townList = evalTownList(_townList);
                callback && callback(townList)
              })
          }
          else {
            townList = evalTownList(_townList);
            callback && callback(townList);
          }
          function evalTownList(townList) {
            var _townList = []
            for (var i = 0; i < townList.length; i++) {
              var tobj = {
                id: townList[i].id,
                name: townList[i].name,
                pDistrict: $scope.dist,
                level: 4,
                hasSublevel: true
              }
              if (tobj.id == ($scope.district.pDistrict.id)) {
                $scope.selectItem(tobj, 'init');
              }
              _townList.push(tobj);
            }
            return _townList
          }

        }
        $scope.regionLevel5 = function(pitem, callback) {
          var data = {
            pid: pitem.id,
            midArr: '0,' + $scope.productId,
            state: 1
          }
          // $scope.$emit('loading', 'show');
          appService.getData(urlMap.region, data,
            function(results) {
              $scope.$emit('loading', 'hide');
              if (!results || !results.data) return;
              console.log('5级社区: ', results.data);
              var _townList = results.data;
              var townList = [];
              for (var i = 0; i < _townList.length; i++) {
                var tobj = {
                  id: _townList[i].id,
                  name: _townList[i].name,
                  pDistrict: pitem,
                  level: 5,
                  hasSublevel: false
                }
                townList.push(tobj);
              }
              $scope.navList[5] = townList;
              $scope.positionList = townList;
              callback && callback()
            })
        }
        $scope.changesRank = function(i) {
          if ($scope.showLocationToCommunity) {
            $timeout(function() {
              var delegate = $ionicScrollDelegate.$getByHandle('comPositionNav');
              delegate && delegate.scrollTop();
            })
          }
          if (i == 4 && $scope.rank != i) {
            $scope.navList[5] = null;
            $scope.rank = i;
            $scope.activeDistrict = $scope[productName + 'Town'];
            $scope.positionList = $scope.navList[$scope.rank];
          }
        }
        $scope.selectItem = function(item, init) {
          if (!$scope.navList[3]) {
            $scope.regionLevel3($scope.regionCode, function(regionDist) {
              regionDist.level = 3;
              regionDist.hasSublevel = true
              $scope.navList[3] = [regionDist];
              $scope.navList[4] = [];
              $scope.regionLevel4(regionDist, function(townList) {
                $scope.navList[4] = townList;
                $scope.positionList = townList;
                if (!$scope.navList[4].length) {
                  $scope.rank = 3;
                  return;
                }
                $scope.rank = 4
              });
            });
            return
          }
          if (!item.hasSublevel) {
            $scope.activeDistrict = item;
            $rootScope[productName + 'Village'] = item;
            $scope.submitPosition(item) //没有下一级, 即submit
            return;
          }
          $rootScope[productName + 'Town'] = item;
          $scope.regionLevel5(item, function() {
            var theItemAll = {
              id: item.id,
              name: item.name,
              level: 4,
              pDistrict: item,
              hasSublevel: 0,
              // theNameAll: '全' + item.name
              theNameAll: item.name
            }
            $scope.positionList = $scope.navList[5] = [theItemAll].concat($scope.positionList);
            $scope.rank = 5;
            if (init) {
              $scope.selectItem($scope.district);
            }
            if ($scope.showLocationToCommunity) {
              $timeout(function() {
                var delegate = $ionicScrollDelegate.$getByHandle('comPositionNav');
                delegate && delegate.scrollTop();
              })
            }
          });
        }
        $scope.lastRegion
        $scope.submitPosition = function(item) {
          if (($scope.lastRegion && $scope.lastRegion.id) != item.id) {
            console.log('更换地区:', item);
            $timeout(function() {
              item.code = $scope.regionCode
              $scope.lastRegion = item
              $scope.$emit('changeRegion', item, productName);
            });
          }
          $scope.goback('close');
        }
        $scope.locationToCommunity = function(show) {
          $scope.showLocationToCommunity = show;
          /* if(show && !$scope.navList[4]){
            $scope.selectItem($scope.district, 'init');
          } */
        }
        $scope.goback = function(isClose) {
          if (isClose) {
            $scope.locationToCommunity(false);
            return
          }
          if ($scope.district.level > 3) {
            $scope.selectItem($scope.district, 'init');
            $scope.locationToCommunity(false);
          }
          else $scope.viewGoback();
        }
        if (!$scope.navList[4] && $scope.stateName == 'intelligentDHome') {
          $scope.selectItem($scope.district, 'init');
        }
      }
    }
  }])
  /**
   * 一级导航初始化
   * @usage <nav-root-intelligentd></nav-root-intelligentd>
   */
  .directive("navRootIntelligentd", ['appService', '$rootScope', '$ionicScrollDelegate', '$state', '$timeout', '$ionicPopup', function(appService, $rootScope, $ionicScrollDelegate, $state, $timeout, $ionicPopup) {
    return {
      restrict: 'E',
      replace: true,
      scope: false,
      template: '<section class="com-nav-scroll bar bar-clear content-40">' +
        '<ion-scroll direction="x" scrollbar-x="false">' +
        '<ul>' +
        '<li ng-repeat="(index,item) in navRoot" ng-class="{\'active\':index==activeNavRootIndex}" ng-click="showContent(item.sort-1,item.id)"><i class="iconzzv" ng-class="\'iconzzv-\'+item.menuicon"></i><span>{{item.name}}</span></li>' +
        '</ul>' +
        '</ion-scroll>' +
        '</section>',
      link: function($scope, element, attrs) {
        $scope.$watch('district', function(n) {
          if (!n || n.level < 4) {
            return;
          }
          $scope.showCommunityList = !(n.level > 4);
          $scope.districtForFuncList = n;
          $scope.queryNavRoot(function() {
            $scope.activeNavRootIndex = $scope.paramsActiveNavRootIndex || 0; //活动一级菜单index(父)
            $scope.paramsActiveNavRootIndex = null
          });
          $scope.getAds()
        }, true);
        var productName
        switch ($scope.productId) {
          case 4:
            productName = 'ZHXZ'
            break;
          case 5:
            productName = 'ZHCW'
            break;
          default:
            productName = 'ZHSQ'
        }
        function error() {
          if ($scope.lastLocation && $scope.lastLocation != 'null') localStorage.setItem('perpetual.' + productName + '.location', $scope.lastLocation)
          $ionicPopup.alert({
            title: '提示框',
            template: '该地区暂未开放, 敬请期待!'
          }).then(function() {
            $scope.viewGoback();
          });
        }
        /* 广告位 */
        $scope.getAds = function() {
          var data = {
            regionId: $scope.district.id,
            state: 1
          }
          $scope.adObjSc = {}
          appService.getData(urlMap.adPlace, data, function(result) {
            var list = result.data, length = result.totalElements;
            if (length > 0) {
              for (var i = 0; i < length; i++) {
                var item = list[i];
                var adName = 'adType_' + item.adType
                $scope.adObjSc[adName] = $scope.adObjSc[adName] || []
                /* if (item.adType == "introVideo") {
                  item.vsrc = $sce.trustAsResourceUrl(item.url)
                  var ls_showOnce = $window.localStorage.getItem("adType_introVideo_showOnce");
                  $scope.regionList = ls_showOnce && JSON.parse(ls_showOnce).regionList || []
                  var showOnce
                  $scope.regionList.forEach(function(regionId) {
                    if (regionId == $scope.areaId) showOnce = true
                  })
                  if (!showOnce) {
                    $timeout(function() {
                      $scope.initVideo()
                    })
                  } else
                    $scope.closeVideo = true
                } */
                $scope.adObjSc[adName].push(item)
              }
            }
            console.log($scope.adObjSc)
          })
        }
        $scope.queryNavRoot = function(callback) {
          $scope.navRoot = [{
            name: $scope.districtForFuncList.name
          }];
          function initRootNav(results) {
            $scope.navRoot = [];
            var list = results;
            for (var i = 0; i < list.length; i++) {
              $scope.navRoot.push({
                id: list[i].id,
                name: list[i].menuname,
                sort: list[i].sort,
                // hasSubMenu: list[i].hassubMenu,
                hasSubMenu: list[i].children && list[i].children.length,
                menuicon: list[i].menuicon
              });
            }
          }
          if ($rootScope.idivCache && $rootScope.idivCache[$scope.districtForFuncList.id]) {
            $timeout(function() {
              initRootNav($rootScope.idivCache[$scope.districtForFuncList.id]);
              callback && callback();
            })
            return;
          }
          appService.getData(urlMap.intelligentDNavList, {
            'id': $scope.districtForFuncList.id/* ,
            'level': 1 */
          }, function(results) {
            console.log('root导航: ', results);
            if (!results.rootNav || !results.rootNav.length) {
              error();
              return;
            }
            $rootScope.idivCache = $rootScope.idivCache || {};
            $rootScope.idivCache[$scope.districtForFuncList.id] = results.rootNav;
            initRootNav(results.rootNav);
            callback && callback();
          });
        }
        $scope.nextDirectionEnter = function() {
          // if($scope.stateName == 'intelligentD.funcList') $ionicViewSwitcher.nextDirection("enter");
        }
        $scope.showContent = function(index, id) {
          if ($scope.stateName == 'intelligentDHome') {
            $state.go('intelligentD', { 
              communityList: $scope.positionList, 
              activeNavRootIndex: index, 
              productId: $scope.productId,
              regionCode: $scope.regionCode,
              regionName: $scope.regionName
            });
            $scope.nextDirectionEnter();
            return;
          }
          $scope.activeNavRootIndex = index;
          $ionicScrollDelegate.scrollTop();
        }
        $scope.goback = function(isClose) {
          $state.go()
        }
      }
    }
  }])
