
appModule.controller('scPropertyController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$sce', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup, $ionicScrollDelegate, $sce) {
  /* data */
  $scope.stateName = $state.current.name;
  $scope.curPage = [];
  $scope.form = {};
  $scope.domore = [];
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.regionId = $stateParams.regionId
  $scope.propid = $stateParams.propid
  $scope.isAdmin = $stateParams.isAdmin
  $scope.handleNav = [
    { name: '物业详情', menuicon: 'wuyebaoxiu' },
    { name: '物业成员', menuicon: 'person1' },
    { name: '设施报修', menuicon: 'sheshibaoxiu' }
  ]
  $scope.handleNav.forEach(function (nav) {
    nav.name = nav.name || nav.submenuname
  });
  $scope.tabIndex = 0;
  $scope.$watch('tabIndex', function (n, o) {
    if (n < 0) return;
    $scope.showPersonDetail(false)
    var delegate = $ionicScrollDelegate.$getByHandle('articlesListScroll');
    delegate.scrollTop();
    if (n == 0 && !$scope.propertyDetail) $scope.getPropertyDetail();
    if (n == 1 && !$scope.propertyStaff) $scope.getStaff(0);
    if (n == 2 && !$scope.repairList && $scope.isAdmin) $scope.getRepairList(0);

  });
  $scope.changeTab = function (i) {
    if (i == 2)
      $scope.$emit('loginFirst', function () {
        $scope.tabIndex = i
      })
    else $scope.tabIndex = i
  }
  $scope.getPropertyDetail = function () {
    $scope.$emit('loading', 'show');
    appService.get(urlMap.scProperty, {
      // userPhone: $scope.user.telephone,
      id: $scope.propid
    }, function (res) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete');
      $scope.propertyDetail = res.data && res.data[0]
      if ($scope.propertyDetail) {
        $scope.form.propertyId = $scope.propertyDetail.id
        $scope.propertyDetail.companyPhone = $scope.evalPhone($scope.propertyDetail.companyPhone) || []
        $scope.propertyDetail.profile = $sce.trustAsHtml($scope.propertyDetail.profile)
      }
    });
  }
  $scope.getStaff = function (page) {
    if (page < 1) {
      $scope.propertyStaff = [];
      $scope.curPage[$scope.tabIndex] = 0;
    }
    $scope.$emit('loading', 'show');
    $scope.domore[$scope.tabIndex] = false;
    appService.get(urlMap.scPropertyStaff, {
      propertyId: $scope.propid,
      state: 1,
      page: page
    }, function (res) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete');
      $scope.$broadcast('scroll.infiniteScrollComplete');
      var list = res.data, length = list.length, size = 10;
      if (length == size) $scope.domore[$scope.tabIndex] = true;
      list.forEach(function (item) {
        item.textContent = $sce.trustAsHtml(item.textContent);
      })
      $scope.propertyStaff = $scope.propertyStaff.concat(list)
    });
  }
  $scope.evalPhone = function (tel) {
    if (!tel) return
    var arr = tel.split(',');
    var json = []
    arr.forEach(function (str) {
      var res = str.match(/^(.+)\:([\w|\-|\－]+)$/)
      var name = res && res[1]
      var tnum = res && res[2]
      if (tnum) json.push({
        name: name,
        phone: tnum
      })
    })
    return json
  }
  $scope.doRefresh = function () {
    if ($scope.tabIndex == 0) $scope.getPropertyDetail();
    if ($scope.tabIndex == 1) $scope.getStaff(0);
    if ($scope.tabIndex == 2 && $scope.isAdmin) $scope.getRepairList(0);
    else
      $scope.$broadcast('scroll.refreshComplete');
  }
  $scope.onInfinite = function () {
    $scope.getStaff(++$scope.curPage[$scope.tabIndex]);
  }
  $scope.showPersonDetail = function (b, item) {
    $scope.showPersonDetails = b;
    if (b) {
      var delegate = $ionicScrollDelegate.$getByHandle('articlesDetailScroll');
      delegate.scrollTop();
      $scope.personDetail = item;
    }
    else $scope.personDetail = null
  }
  /* 报修tab */
  $scope.getRepairList = function (page) {
    if (page < 1) {
      $scope.curPage[$scope.tabIndex] = 0;
      $scope.repairList = null;
    }
    $scope.$emit('loading', 'show');
    $scope.domore[$scope.tabIndex] = false;
    appService.get(urlMap.scPropertyRepair, {
      propertyId: $scope.propid,
      state: 1,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log(results);
      if (!results) return;
      var list = results.data, length = list.length, size = 10,
        articles = $scope.repairList || []
        ;
      if (length == size) $scope.domore[$scope.tabIndex] = true;
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.summary = item.content.slice(0, 30);
          article.handleName = item.isHandle ? '已处理' : '未处理';
          articles.push(article);
        }
      }
      $scope.repairList = articles;
    });
  }
  $timeout(function () {
    $scope.setForm(!$scope.isAdmin);
  })
  $scope.setForm = function (b, init) {
    if (!b) {
      if ($stateParams.formContent && !init) {
        $rootScopeViewGoback();
        return;
      }
      $scope.formContent = b;
      $scope.showDetails = false;
      return
    }
    $scope.formContent = b;
    $scope.form = {}
    $scope.removeFile()
    $('#localPhotoFile').val('');
  }
  $scope.showDetail = function (b, item) {
    $scope.showDetails = b;
    if (b) {
      var delegate = $ionicScrollDelegate.$getByHandle('articlesDetailScroll');
      delegate.scrollTop();
      item.attachments = item.fileUrl && item.fileUrl.split(',');
      if (item.attachments && item.attachments.length) {
        var attachs = [];
        for (var i = 0; i < item.attachments.length; i++) {
          var type = thisfileType(item.attachments[i]);
          var attach
          if (type == 1) attach = $scope.evalRemotePath(item.attachments[i], $scope.pic + '/')
          if (type == 2) attach = $scope.evalRemotePath(item.attachments[i], ($scope.vio + '/'))
          attachs.push({
            type: type,
            path: $sce.trustAsResourceUrl(attach)
          })
        }
        item.attachments = attachs;
      }
      $scope.detailItem = item;
      console.log(item)
    }
  }
  // 处理
  $scope.handleFun = function (item) {
    if (item.isHandle > 0) return
    var data = {
      id: item.id,
      isHandle: 1
    }
    $ionicPopup.confirm({
      template: '确定将该报修改为已处理吗',
      okText: '确定',
      cancelText: '取消'
    }).then(function (res) {
      if (res) {
        appService.put(urlMap.scPropertyRepair, data, function (result) {
          if (result.code == 200) {
            $scope.getRepairList(0);
            $scope.detailItem.isHandle = 1;
            $scope.detailItem.handleName = '已处理';
          } else {
            $scope.alert("处理失败! 请联系客服");
          }
        })
      }
    })
  }
  $scope.removeFile = function (reset) {
    $scope.showUploadFiles = []; //预览
    $scope.showUploadNames = []; //预览失败 显示文件名
    if (!reset) {
      $('#localPhotoFile').val(''); //本地
      $scope.cameraFile = null; //拍摄
    }
  }
  /* 本地附件读取 */
  function readerfile(file) {
    return new Promise( function(resolve, reject) {
      var reader = new FileReader();
      reader.onload = function () {
        resolve(reader.result);
      };
      if (file) {
        reader.readAsDataURL(file)
      }
    })
  }
  $scope.fileChangeEvent = function () {
    var files = $('#localPhotoFile')[0].files;
    for (var i = 0; i < files.length; i++) {
      $scope.fileType = thisfileType(files[i].name);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.removeFile('reset');
      try {
        readerfile(files[i]).then(function(e) {
          $scope.$apply(function () {
            if ($scope.fileType == 2) {
              $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
            }
            else $scope.showUploadFiles.push(e)
          })
        })
      } catch (e) {
        alert(e);
        $scope.$apply(function () {
          $scope.showUploadNames.push(files);
        })
      }
    }
  }
  /***
   * use camera
   */
  $scope.useCamera = function (type) {
    //开始录像(最长录制时间:60秒)
    if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
    if (type == 2) navigator.device.capture.captureVideo(success, onError);
    function success(mediaFiles) {
      $scope.showUploadFiles = [];
      for (var i = 0; i < mediaFiles.length; i++) {
        var name = mediaFiles[i].name;
        var path = mediaFiles[i].fullPath;
        $scope.fileType = thisfileType(name);
        if (!$scope.fileType == 'error') {
          return;
        }
        $scope.removeFile('reset');
        $scope.$apply(function () {
          if ($scope.fileType == 2) {
            $scope.showUploadFiles.push($sce.trustAsResourceUrl(path))
          }
          else
            $scope.showUploadFiles.push(path)
        })
        $scope.cameraFile = mediaFiles[i];
      }
    }
    //录制失败
    function onError(error) {
      $scope.alert('未进行拍摄！错误码:' + error.code);
    }
  }
  function thisfileType(fileName) {
    var picExt = ".jpg|.jpeg|.png|";
    var vioExt = ".mp4|.3gp|.avi|";
    if (!fileName) return null
    var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
    /* 检查文件类型  */
    if (picExt.indexOf(extName + "|") != -1) return 1;
    if (vioExt.indexOf(extName + "|") != -1) return 2;
    $scope.alert("该文件类型不允许上传。");
    return 'error'
  }
  $scope.submit = function () {
    $scope.$emit('loginFirst', function () {
      if (!($scope.form.phone && $scope.form.content)) {
        $scope.alert("请完整填写表单信息");
        return;
      }
      if ($scope.form.content.length > 1500) {
        $scope.alert("内容不能超过1500字！");
        return;
      }
      var msg = $scope.ruleAll()
      if (msg != true) {
        $scope.alert(msg);
        return;
      }
      var file = $('#localPhotoFile').val() || ($scope.cameraFile && $scope.cameraFile.name) || '';
      $scope.fileType = thisfileType(file);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.$emit('loading', 'show');
      /* 拍摄上传 */
      if ($scope.cameraFile) {
        var file = $scope.cameraFile;
        var params = {};
        params.httpPath = $scope.httpPath;
        params.type = $scope.fileType;
        params.maxWidth = $scope.maxWidth;
        var ft = new FileTransfer();
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.mimeType = "multipart/form-data";
        options.fileName = file.name;
        options.params = params;
        //传输进度  
        ft.onprogress = function (progressEvent) {
        };
        ft.upload(file.fullPath, urlMap.fileUpload,
          function (res) {
            $scope.$emit('loading', 'hide');
            if (res.response) res = JSON.parse(res.response)
            var imgUrl = res.imgUrl || res.vioUrl;
            if (imgUrl) {
              $scope.postRepair(imgUrl)
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          },
          function () {
            $scope.alert("媒体上传失败，请联系客服人员！");
          },
          options);
        return;
      }
      /* 没有附件 */
      if (!$scope.fileType) {
        $scope.postRepair();
        return
      }
      /* 本地文件上传 */
      $timeout(function () {
        $("#files").ajaxSubmit({
          url: urlMap.fileUpload,
          type: "post",
          dataType: "json",
          success: function (res) {
            var imgUrl = res.imgUrl || res.vioUrl;

            if (imgUrl) {
              $scope.postRepair(imgUrl)
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          },
          error: function (xhr) {
            $scope.$emit('loading', 'hide');
            $scope.alert("媒体上传失败，请联系客服人员！");
          },
          beforeSerialize: function () {
          },
          beforeSend: function () {
            //$("#progressNumber").html('0%');
          },
          uploadProgress: function (event, position, total, percentComplete) {
            $scope.removeFile();
          }
        });
      })
    })
  }
  /***
   * 上传拍摄文件
   * type 1:图片 2：视频
   */
  $scope.postRepair = function (fileUrl) {
    var data = $scope.form;
    data.fileUrl = fileUrl;
    data.propertyId = $scope.propertyDetail.id;
    // data.fileType = $scope.fileType;
    data.userId = $scope.user && $scope.user.id;
    data.isVerify = 1;
    console.log(data)
    appService.postData(urlMap.scPropertyRepair, data,
      function (results) {
        $scope.$emit('loading', 'hide');
        if (results.code != 200)
          $scope.alert("提交出错，请联系客服人员！");
        else {
          if ($scope.isAdmin) {
            $scope.getRepairList(0);
          }
          $scope.alert("信息提交成功！管理员审核处理中...", function () {
            if (!$scope.isAdmin) {
              $scope.tabIndex = 0
              return
            }
            $scope.setForm(false)
          });
        }
      })
  }

  $scope.alert = function (info, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      callback && callback();
    });
  }
  $scope.viewGoback = function () {
    if ($scope.showPersonDetails) $scope.showPersonDetails = false;
    else $rootScopeViewGoback();
  }
}
]);
