appModule.controller('jiweiArticleController', ['$scope', 'appService', '$state', '$timeout', '$stateParams', '$ionicScrollDelegate', '$sce', '$compile', function($scope, appService, $state, $timeout, $stateParams, $ionicScrollDelegate, $sce, $compile) {
  $scope.module = $stateParams.module
  $scope.api = $scope.module.api
  $scope.params = $scope.module.param && JSON.parse($scope.module.param) || {}
  $scope.params.id = $stateParams.id || $scope.params.id
  $scope.crumbs = $stateParams.crumbs
  $scope.shareUrl = $scope.module.shareUrl && ($.jiweiShareUrl + $scope.module.shareUrl);
  $scope.stateName = $state.current.name;
  var baseUrl = 'http://www.ccdijl-thxjwjw.gov.cn/'
  $scope.article
  $scope.domore = true
  $scope.articleHtml = 'jiweiArticle' + ($scope.params && $scope.params.id);
  $scope.queryArt = function() {
    var api = $.ctxZz + $scope.api
    appService.getData(
      api, $scope.params,
      function(result) {
        $scope.domore = false
        $timeout(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        })
        $scope.article = result.data && result.data[0]
        if (!$scope.article) return
        $scope.article.publishtime = noralDate($scope.article.publishtime)
        $scope.article.headimage = $scope.article.headimage && $scope.evalRemotePath($scope.article.headimage, baseUrl)
        var content = $scope.article.content;//找到<img标签
        if ($scope.article.coverimage) $scope.article.coverimage = $scope.evalRemotePath($scope.article.coverimage, baseUrl)
        if ($scope.article.videourl) $scope.article.videourl = $sce.trustAsResourceUrl($scope.evalRemotePath($scope.article.videourl, baseUrl))
        if (content) {
          var reg = /<img[^>]*>/gi;
          // 匹配出html中的src属性
          content = htmlDecode(content)
          var images = content.match(reg);
          var videos = content.match(/<source[^>]*>/gi);
          if (videos && videos.length) {
            for (var i = 0; i < videos.length; i++) {
              var video = videos[i]
              var vioSrc = video.match(/src=[\'\"]?([^\'\"]*)[\'\"]?/i)[1]
              content.replace(vioSrc, $scope.evalRemotePath(vioSrc, baseUrl))
            }
          }
          content = $sce.trustAsHtml(content).$$unwrapTrustedValue(); //过滤
          //包含图片
          if (images && images.length) {
            //解析拼接内容
            for (var i = 0; i < images.length; i++) {
              var image = images[i],
                first = image.substr(0, image.indexOf(' ') + 1),
                next = image.substr(image.indexOf(' ')),
                regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = image.match(regSrc)[1]
                ;
              next = next.replace(srcStr, $scope.evalRemotePath(srcStr, baseUrl))
              srcStr = $scope.evalRemotePath(srcStr, baseUrl)
              if (i == 0) {
                $scope.shareImg = srcStr
              }
              var imagewhole = first + next
              // 将ng-click事件拼接到html中
              var final = first + ' ng-click="showBigImage(' + "'" + srcStr + "'" + ',' + i + ')"' + next;
              //为适应点击图片放大，因此将width和height属性过滤掉
              final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
              content = content.replace(image, final);
              var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + imagewhole + '</div></li>');
              $('#articleImgs > ul').append($li);
            }
            $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
              zoom: {
                toggle: false,
              },
              pagination: {
                el: '.swiper-pagination',
                dynamicBullets: true
              },
            });
            content = $compile(content)($scope); //编译
          }
          $('#' + $scope.articleHtml).html(content);
        }
      }
    );
  }
  function htmlDecode(html) {
    var temp = document.createElement("div");
    temp.innerHTML = html;
    var output = temp.innerText || temp.textContent;
    // var output = html
    return output;
  }
  $scope.showBigImage = function(imgSrcPath, i) {
    $scope.imgsSwipe.slideTo(i, 0, false);
    $('#articleImgs').show();
    if (!$scope.isUpdateSize) { $scope.imgsSwipe.update(); $scope.isUpdateSize = true; }
  };
  $scope.hideBigImage = function() {
    $scope.imgsSwipe.zoom.out();
    $('#articleImgs').hide();
  };
  function noralDate(timeStamp) {
    if (!timeStamp) return timeStamp
    var date = new Date(timeStamp * 1000)
    var YY = date.getFullYear() + '-'
    var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
    var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
    return YY + MM + DD
  }
  $scope.onInfinite = function() {
    $scope.queryArt()
  }
  //分享
  $scope.shareWX = function(id, articleInfo) {
    if ($scope.shareUrl.indexOf('?') > -1) {
      console.log($scope.shareUrl + "&id=" + articleInfo.id)
    }
    else console.log($scope.shareUrl + "?id=" + articleInfo.id)
    if (typeof Wechat === "undefined") {
      alert("Wechat plugin is not installed.");
      return;
    }
    var scene, params = {};
    switch (id) {
      case 'SESSION':
        scene = Wechat.Scene.SESSION;
        break;
      case 'TIMELINE':
        scene = Wechat.Scene.TIMELINE;
        break;
    }
    params.scene = scene;
    params.message = {
      title: "",
      description: "",
      mediaTagName: "TEST-TAG-001",
      messageExt: "这是第三方带的测试字段",
      messageAction: "<action>dotalist</action>",
      media: {}
    };
    params.message.title = articleInfo.title;//标题
    // params.message.description = articleInfo.description || '';//副标题
    params.message.thumb = $scope.shareImg || 'http://www.ccdijl-thxjwjw.gov.cn/Uploads/img/20201113/jiwei-shareimg.jpg';//微信分享 缩略图
    params.message.media.type = Wechat.Type.WEBPAGE || Wechat.Type.LINK; //网页链接
    if ($scope.shareUrl.indexOf('?') > -1) {
      params.message.media.webpageUrl = $scope.shareUrl + "&id=" + articleInfo.id;
    }
    else params.message.media.webpageUrl = $scope.shareUrl + "?id=" + articleInfo.id;
    if (!!articleInfo.coverimage) {
      params.message.thumb = articleInfo.coverimage + "?" + (new Date()).getTime();
    }
    Wechat.share(params, function() {
    }, function(reason) {
    });
  }
}
])