
appModule.controller('jiweiHomeController', ['$scope', 'appService', '$state', '$timeout', '$ionicScrollDelegate', '$ionicViewSwitcher', '$cordovaBrowser', '$cordovaToast', function($scope, appService, $state, $timeout, $ionicScrollDelegate, $ionicViewSwitcher, $cordovaBrowser, $cordovaToast) {
  $scope.stateName = $state.current.name;
  $scope.jiweiBase = 'http://www.ccdijl-thxjwjw.gov.cn/'
  $scope.moduleIndex = -1
  $scope.orginModules
  $scope.modules = []
  $scope.$on('$ionicView.loaded', function() {
    $scope.queryMenu(0)
  });
  $scope.$on('$ionicView.unloaded', function() {
    $scope.jiweiHomeBannerSwiper &&
      $scope.jiweiHomeBannerSwiper.destroy(true, true);
    $scope.jiweiHomeShipinSwiper &&
      $scope.jiweiHomeShipinSwiper.destroy(true, true);
  })
  $scope.navState = function() {
    $scope.showAllNav = !$scope.showAllNav
  }
  $scope.queryMenu = function(pid, callback) {
    appService.getData(
      urlMap.jiweiMenu,
      {
        pid: pid,
        state: 1
      },
      function(result) {
        var menu = result.data
        if (pid == 0) {
          $scope.jiweiMenu = menu
          menu.forEach(function(item) {
            if (item.type == 1) normalMainNav(item) // 主导航
            if (item.type == 6) normalhomeModules(item) // 首页模块集
          })
        }
        callback && callback(menu)
      }
    );
  }
  /* 主导航 */
  function normalMainNav(item) {
    $scope.queryMenu(item.id, function(menu) {
      $scope.mainNav = menu
      $scope.curMenuKey = menu[0].id
    })
  }
  /* 首页模块集 */
  function normalhomeModules(item) {
    $scope.homeModules = item
  }
  /* 选择主导航菜单 */
  $scope.selectMenu = function(item) {
    $scope.showAllNav = false
    var param = {
      mainNav: $scope.mainNav,
      module: item
    }
    // $ionicViewSwitcher.nextDirection("enter");
    /* 外链 */
    if (item.type == 7) {
      $scope.openUrl(item)
      return true
    }
    /* 常规文章列表 */
    if (item.type == 2) {
      $scope.goState('jiwei', { params: param })
      return true
    }
    /* 仅路由 */
    if (item.type == 5) {
      $scope.goState(item.route, param)
      return true
    }
    /* 目录页 信息公开 */
    if (item.type == 0) {
      $scope.goState('jiwei', { params: param })
      return true
    }
    return false
  }
  $scope.openUrl = function(item) {
    // $scope.showUrl = $sce.trustAsResourceUrl(item.address);
    $cordovaBrowser.open(item.url, '_blank',
      {
        title: {
          color: '#ffffff',
          showPageTitle: true,
          staticText: item.name
        },
        closeButton: {
          wwwImage: 'images/normal/icon-back.png',
          wwwImagePressed: 'images/normal/icon-back.png',
          staticText: '关闭',
          align: 'left',
          event: 'closePressed'
        },
        closePressed: function() {
        },
        toolbar: {
          height: 44,
          color: '#5769f1'
        },
        backButtonCanClose: false
      })
  }
  $scope.$watch('homeModules', function(n) {
    if (!n) return
    $scope.orginModules = n.children
    $scope.domore = true
  })
  $scope.$watch('moduleIndex', function(n) {
    if (!$scope.orginModules) return
    if (n >= $scope.orginModules.length) {
      $scope.domore = false
      return
    }
    var curModule = $scope.orginModules.slice(n, n + 1)
    function callback() {
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      $ionicScrollDelegate.resize();
    }
    curModule.forEach(function(module) {
      if (module.type == 4) $scope.initSlideMoulde(module, callback) // 轮播图
      if (module.type == 2) $scope.initArtsMoulde(module, null, callback) // 文章列表
      if (module.type == 8) $scope.initLitBanners(module, callback) // 小图片banner
      if (module.type == 9) $scope.initArtBanners(module, callback) // 文章列表banner
      if (module.type == 0) $scope.initLitMultileve(module, callback)// 目录, 带二级菜单
      if (module.type == 11) $scope.initFriendSite(module, callback) // 底部关联网站
      if (module.type == 13) $scope.initFooterQRcode(module, callback) // footer二维码
    })
    $scope.modules.push(curModule[0])
  })
  $scope.onInfinite = function() {
    $scope.moduleIndex++
  }

  /* 轮播图 */
  $scope.initSlideMoulde = function(info, callback) {
    $scope.bannerModule = info
    var api = $.ctxZz + info.api
    var param = info.param && JSON.parse(info.param)
    $scope.$emit('loading', 'show');
    appService.getData(
      api,
      param,
      function(results) {
        $scope.$emit('loading', 'hide');
        $scope.bannerArray = results.data;
        $scope.initBannerSwiper();
        callback && callback()
      }
    );
  };
  $scope.initBannerSwiper = function() {
    $scope.bannerHeight = window.innerWidth
      ? {
        height: window.innerWidth * 0.6 + 'px',
      }
      : false;
    window.onresize = function() {
      $scope.$apply(function() {
        $scope.bannerHeight = window.innerWidth
          ? {
            height: window.innerWidth * 0.6 + 'px',
          }
          : false;
      });
    };
    $scope.jiweiHomeBannerSwiper &&
      $scope.jiweiHomeBannerSwiper.destroy(true, true);
    $timeout(function() {
      $scope.jiweiHomeBannerSwiper = new Swiper('#jiweiHomeBannerSwiper', {
        // speed: 4000,
        effect: 'fade',
        autoplay: {
          disableOnInteraction: false,
        },
        loop: true,
        pagination: {
          el: '.jiwei-banner-pagination',
        }
      });
    });
  };
  $scope.goBannerDetail = function(article) {
    $scope.goState('jiweiArticle', { module: $scope.bannerModule, id: article.id })
  }
  $scope.initShipinSwiper = function() {
    $scope.jiweiHomeShipinSwiper &&
      $scope.jiweiHomeShipinSwiper.destroy(true, true);
    $timeout(function() {
      $scope.jiweiHomeShipinSwiper = new Swiper('#jiweiHomeShipinSwiper', {
        // speed: 4000,
        effect: 'fade',
        width: undefined,
        autoplay: {
          disableOnInteraction: false,
        },
        loop: true,
        pagination: {
          el: '.jiwei-shipin-pagination',
        }
      });
    });
    // }
  };
  /* 文章列表 */
  $scope.initArtsMoulde = function(module, parentName, callback) {
    var api = $.ctxZz + module.api
    module.stateRoute = 'jiweiList'
    var pageName = parentName ? parentName + ' > ' + module.name : module.name
    module.pageName = pageName
    var param = module.param && JSON.parse(module.param)
    appService.getData(
      api,
      param,
      function(results) {
        module.pageName = pageName
        module.children = results.data
        if (module.route == "outside") {
          module.children.forEach(function(item) {
            item.route = "outside"
          })
        }
        callback && callback()
      }
    );
  };
  $scope.goArtDetail = function(art, module) {
    $scope.goState('jiweiArticle', { module: module, id: art.id, crumbs: module.pageName })
  }
  /* 小banner组 */
  $scope.initLitBanners = function(module, callback) {
    $scope.queryMenu(module.id, function(list) {
      list.forEach(function(li) {
        if (li.remark == "background") {
          li.style = li.imgStr && JSON.parse(li.imgStr)
          li.imgStr = null
        }
      })
      module.children = list
      callback && callback()
    })
  }
  $scope.imgClick = function(bannerModule) {
    if (bannerModule.route == 'outside') {
      $scope.openUrl(bannerModule)
      return
    }
    if (bannerModule.route) {
      $scope.goState(bannerModule.route, { module: bannerModule, pageName: bannerModule.name })
      return
    }
  }
  /* 多级文章 */
  $scope.initLitMultileve = function(module, callback) {
    $scope.queryMenu(module.id, function(list) {
      var compleLength = 0
      var i = 0;
      function loadSub(i, list) {
        var li = list[i]
        if (li.type == 2) {
          $scope.initArtsMoulde(li, module.name, function() {
            compleLength++
            if (li.route == 'video') {
              $timeout(function() {
                $scope.initShipinSwiper()
              })
            }
            if (compleLength >= list.length) {
              console.log(compleLength)
              callback && callback()
            }
            else {
              loadSub(++i, list)
            }
          })
        }
      }
      if (list.length) loadSub(i, list)
      /* list.forEach(function(li) {
        if (li.type == 2) {
          $scope.initArtsMoulde(li, module.name, function() {
            compleLength++
            if (li.route == 'video') {
              $timeout(function() {
                $scope.initShipinSwiper()
              })
            }
            if (compleLength >= list.length) {
              console.log(compleLength)
              callback && callback()
            }
          })
        }
      }) */
      module.children = list
    })
  }
  /* 专题 */
  $scope.initArtBanners = function(module, callback) {
    $scope.queryMenu(module.id, function(list) {
      var compleLength = 0
      list.forEach(function(li) {
        if (li.remark == "background") {
          compleLength++
          li.style = li.imgStr && JSON.parse(li.imgStr)
          li.imgStr = null
          return
        }
        if (li.type == 9) {
          compleLength++
          $scope.initArtsMoulde(li, list.name, function() {
            if (compleLength >= list.length) {
              console.log(compleLength)
              callback && callback()
            }
          })
        }
      })
      module.children = list
      console.log(list)
    })
  }
  /* 底部关联网站 */
  $scope.selectFriendMenu = function(menu) {
    $scope.curFriendMenuKey = menu.param
    $timeout(function() {
      $ionicScrollDelegate.resize();
    })
  }
  $scope.initFriendSite = function(module, callback) {
    $scope.queryMenu(module.id, function(list) {
      module.children = list
      $scope.curFriendMenuKey = list[0] && list[0].param
      $timeout(function() {
        $ionicScrollDelegate.resize();
      })
    })
    $scope.queryFriendSites(module, callback)
  }
  $scope.queryFriendSites = function(module, callback) {
    var api = $.ctxZz + module.api
    var params = module.param && JSON.parse(module.param)
    appService.getData(
      api,
      params,
      function(result) {
        $scope.friendSites = result.data
        callback && callback()
      }
    );
  }
  $scope.initFooterQRcode = function(module, callback) {
    $scope.supportexec = !!window.canvas2ImagePlugin
    callback && callback()
  }
  $scope.downPhoto = function(photoPath) {
    var pictrueUrl = encodeURI(photoPath);
    function saveImageToPhone(url, success, error) {
      var canvas, context, imageDataUrl, imageData;
      var img = new Image();
      img.onload = function() {
        canvas = document.createElement('canvas');
        canvas.width = img.width;
        canvas.height = img.height;
        context = canvas.getContext('2d');
        context.drawImage(img, 0, 0);
        try {
          imageDataUrl = canvas.toDataURL('image/jpeg', 1.0);
          imageData = imageDataUrl.replace(/data:image\/jpeg;base64,/, '');
          cordova.exec(
            success,
            error,
            'Canvas2ImagePlugin',
            'saveImageDataToLibrary',
            [imageData]
          );
        }
        catch (e) {
          error(e.message);
        }
      };
      try {
        img.src = url;
      }
      catch (e) {
        error(e.message);
      }
    }
    var success = function(msg) {
      $cordovaToast.showShortCenter("已保存到本地相册");
    };
    var error = function(err) {
      $cordovaToast.showShortCenter(err);
    };
    saveImageToPhone(photoPath, success, error);
  }
}
])
