appModule.controller('LeaveMsgController', ['$scope', '$ionicPopup', 'appService', '$timeout', '$state', '$sce', '$ionicScrollDelegate', function($scope, $ionicPopup, appService, $timeout, $state, $sce, $ionicScrollDelegate) {
  $scope.stateName = $state.current.name;
  $scope.footerActiveFlag = 2;
  $scope.searchKey = 'leavemessage';
  $scope.allArrays;
  $scope.pageNext = 0; //页面初始化前为 0 初始化后为1 加载更多时累加
  $scope.domore = true;
  $scope.showNav;
  $scope.placeholder = '';
  $scope.leaveMsgShow;
  $scope.msgInput;
  // beforeEnter
  $scope.$on('changeDistrict', function(e, data) {
    // $scope.showNav = $scope.publicCityId == '220521' ? true : false;
  });
  $scope.$on('$ionicView.loaded', function() {
    $scope.getleaveMsgShow();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
  });
  $scope.getleaveMsgShow = function() {
    appService.getData(urlMap.leaveMsgShow, { type: '3' }, function(jsonData) {
      $scope.leaveMsgShow =
        jsonData.resultList &&
        jsonData.resultList[0] &&
        jsonData.resultList[0].contentCh;
    });
  };
  $scope.alert = function(info, queryAgain, title, subTitle) {
    $ionicPopup
      .alert({
        title: title || '提示框',
        subTitle: subTitle,
        template: info,
        buttons: [{ text: '知道了', type: 'button-positive' }],
      })
      .then(function(res) {
        if (queryAgain) $scope.queryArray(1);
      });
  };
  $scope.queryArray = function(page) {
    if (page == 0 || page == 1) {
      //页面刷新时为0,下拉刷新时为1
      $scope.pageNext = 1;
      page = 1;
    }
    var data = {
      page: page,
      replyType: -1,
    },
      opts = {
        method: 'post',
        url: urlMap.queryMessage,
        params: data,
      };
    appService.queryData(
      opts,
      function(results) {
        $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        console.log(page, results.resultList);
        if (page == 1) {
          $scope.allArrays = null;
        }
        var list = results.resultList,
          length = list.length,
          size = results.size,
          articles = $scope.allArrays || [];
        if (length < size) $scope.domore = false;
        else
          $timeout(function() {
            $scope.domore = true;
          }, 200);
        if (length > 0) {
          for (var i = 0; i < length; i++) {
            var item = list[i],
              article = {};
            article = item;
            article.leaveMessage = article.leaveMessage.replace(
              /(.{100}).+$/,
              '$1...'
            );
            article.leaveMessage =
              article.leaveMessage &&
              $sce.trustAsHtml(article.leaveMessage).$$unwrapTrustedValue();
            // article.replyContent = $sce.trustAsHtml(article.replyContent).$$unwrapTrustedValue();
            var portrait = item.portrait;
            article.portrait = !!portrait
              ? $scope.pic + '/' + portrait
              : (article.portrait = $scope.pic + urlMap.defaultImg);
            articles.push(article);
          }
        }
        $scope.allArrays = articles;
        $timeout(function() {
          $ionicScrollDelegate.resize();
        })
      },
      function() {
        $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        $scope.pageNext--
      }
    );
  };
  $scope.sendLeaveMsg = function() {
    $scope.$emit('loginFirst', function() {
      var pageIndex = 1;
      var msg = $scope.msgInput;
      if (!msg || !(msg = $.trim(msg))) {
        $scope.alert('请输入留言内容！');
        return;
      }
      $scope.$emit('loading', 'show');
      var data = {
        leaveMessage: msg,
        userId: $scope.user.id,
        userName: $scope.user.userName,
        areaID: $scope.publicCityId,
      },
        opts = {
          method: 'post',
          url: urlMap.insertMessage,
          params: data,
        };
      appService.queryData(opts, function(results) {
        $scope.$emit('loading', 'hide');
        $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        console.log(results[0]);
        if (results[0] == 1) {
          $scope.msgInput = '';
          var msg = { t: '提示框', c: '留言成功!' };
          if (!!results[1]) {
            msg.t = '留言成功！';
            msg.c = results[1];
          }
          $scope.alert(msg.c, true, msg.t, '该留言审核中，请您耐心等待');
        }
      });
    });
  };
  //下拉刷新
  $scope.doRefresh = function() {
    $scope.queryArray(1);
  };
  //上拉加载
  $scope.onInfinite = function() {
    // if (!$scope.pageNext && !$scope.domore) return;
    // $scope.domore = false;
    $scope.queryArray(++$scope.pageNext);
  };
  //跳转到详情页面
  $scope.goDetail = function(item) {
    var params = {
      id: item.id,
      areaID: item.areaID,
      readType: item.readType,
    };
    $state.go('leaveMsgDetail', params);
  };
  $scope.toFeedBack = function(flag) {
    $state.go('feedBack', { flag: flag });
  };
  $scope.toInspect = function() {
    $state.go('sectionInspect', { id: 0 });
  };
},
]);
