appModule.controller('officeAffairsController', ['$scope', '$ionicModal', '$ionicPopup', '$stateParams', 'appService', '$state', '$cordovaDatePicker', '$sce', '$timeout', '$ionicScrollDelegate', '$svDistrict', '$ionicHistory', function($scope, $ionicModal, $ionicPopup, $stateParams, appService, $state, $cordovaDatePicker, $sce, $timeout, $ionicScrollDelegate, $svDistrict, $ionicHistory) {
    $scope.stateName = $state.current.name;
    $scope.fullscreenZoomImgs = 'has';
    $scope.showAllActions = $stateParams.showAllActions;
    $scope.officeDeptId = $stateParams.officeDeptId// 部门Id
    $scope.tabIndex = $stateParams.tabIndex; // 部门Id
    $scope.deptList = {};  //政务大厅
    $scope.navs = [
        { name: '零见面网上办' },
        { name: '到大厅一次办' },
        { name: $scope.publicCityId == '2205' ? '多次办理' : '其他事项办理' }
    ];
    $scope.affairsLists = []; // 事项列表
    $scope.affairsList = null; // 单tab事项列表
    $scope.itemsSelected = { id: 0 }; // 事项选中对象Id
    $scope.guideItem = { id: 0, itemsSelectedId: 0 }; // 事项指南对象
    $scope.guideAttachList = {}; // 填报附件列表
    $scope.itemClassifyId; // 事项分类 1零见面 2到大厅一次 3其他事项办理
    $scope.h5ModalAttr = { h5Type: 1 }; // 1编辑 2查看
    var whiteList = [
        /* {
            cityId: '2205',
            distName: '通化市'
        },
        {
            cityId: '220524',
            distName: '柳河县'
        } */
    ];
    function eventBackButton() {
        $scope.hideBigImage();
    }
    $scope.$on('$ionicView.loaded', function() {
        document.addEventListener("backbutton", eventBackButton, false);
    });
    $scope.$on('$ionicView.unloaded', function() {
        $scope.appointModal.remove();
        $scope.guideModal.remove();
        $scope.fillModal.remove();
        $scope.resultModal.remove();
        $scope.fillApplyModal && $scope.fillApplyModal.remove();
        $scope.h5Modal.remove();
        document.removeEventListener("backbutton", eventBackButton, false);
    });
    $scope.$on('$destroy', function() {
    });
    $scope.$on('changeDistrict', function(e, data) {
        if ($scope.stateName == $state.current.name) {
            if ($scope.distNow && $scope.publicCityId != $scope.distNow) {
                goPage();
                return;
            }
            /* $scope.isOpen = $scope.isOpenAction({ cityId: $scope.publicCityId });
            if (!$scope.isOpen) return; */
            $scope.distNow = $scope.publicCityId;
        }
    });
    /* watch> changeDistrict */
    $scope.$watch('tabIndex', function(n, o) {
        $scope.itemClassifyId = n + 1;
        $scope.page = 1;
        $scope.domore = true;
        // if (!$scope.isOpen) return;
        $scope.goTop();
        $scope.changeItem();
        if ($scope.affairsLists[n]) {
            $scope.affairsList = $scope.affairsLists[n];
            return
        };
        $scope.queryAffairsLists();
    });
    
    $scope.queryAffairsLists = function() {
        if ($scope.officeDeptId) {
            /* 载入事项列表 */
            $scope.$emit('loading', 'show');
            var data = {
                itemClassifyId: $scope.itemClassifyId,
                deptId: $scope.officeDeptId,
                parentId: 0
            }, opts = {
                method: "post",
                url: urlMap.officeItemList,
                params: data,
            }
            appService.queryData(opts,
                function(rs) {
                    $scope.$emit('loading', 'hide');
                    console.log('事项列表:', rs.data.list)
                    $scope.affairsLists[$scope.tabIndex] = rs.data.list || [];
                    $scope.affairsList = $scope.affairsLists[$scope.tabIndex];
                });
        }
    }
    $scope.onInfinite = function() {
        if ((++$scope.page) * 20 >= $scope.affairsList.length)
            $scope.domore = false;
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
    }
    //method
    $scope.isOpenAction = function(data) {
        var goPage = function() {
            $state.go('officeHome', {
                tabName: 'zhzw'
            })
        };
        return $svDistrict.isOpenAction(data, whiteList, goPage);
    }
    // $scope.isOpen = $scope.isOpenAction({ cityId: $scope.publicCityId });
    $scope.changeTab = function(i) {
        $scope.tabIndex = i;
    }
    /* 是否选择了事项 */
    $scope.checkSelectedItem = function() {
        if ($scope.itemsSelected.id < 1) {
            $scope.alert('请选择事项');
            return false;
        };
        return true;
    }
    /***
     * 切换事项
    */
    $scope.changeItem = function(item, index) {
        console.log(index);
        $scope.itemsSelected.obj = item;
        $scope.guideItem = {};
        if (!item) {
            $scope.itemsSelected = { id: 0 };
            return;
        }
        console.log(item);
        /***
         * 载入当前事项子类
        */
        if (!!item.parentId) return;
        var data = {
            itemClassifyId: $scope.itemClassifyId,
            deptId: $scope.officeDeptId,
            parentId: item.id
        }, opts = {
            method: "post",
            url: urlMap.officeItemList,
            params: data,
        }
        var itemId = item.id;
        // $scope.$emit('loading', 'show');
        appService.queryData(opts,
            function(rs) {
                // $scope.$emit('loading', 'hide');
                if (!(rs.data && rs.data.list && rs.data.list.length)) return;
                var newItem = [];
                for (var i = 0; i < $scope.affairsList.length; i++) {
                    if ($scope.affairsList[i].parentId == 0) {
                        newItem.push($scope.affairsList[i]);
                    }
                    if ($scope.affairsList[i].id == item.id) {
                        newItem = newItem.concat(rs.data.list);
                    }
                }
                if (itemId == $scope.itemsSelected.id) $scope.affairsList = newItem; //防止网络重延迟
            });
    }
    /***
     *  指南
     **/
    $ionicModal.fromTemplateUrl('guide-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.guideModal = modal;
    });
    $scope.loadGuide = function(callback) {
        $scope.guideItem = {};
        var data = {
            itemId: $scope.itemsSelected.id,
            deptId: $scope.officeDeptId
        }, opts = {
            method: "post",
            url: urlMap.officeItemGuide,
            params: data
        };
        $scope.$emit('loading', 'show');
        appService.queryData(opts,
            function(rs) {
                $scope.$emit('loading', 'hide');
                if (!rs.data) {
                    $ionicPopup.alert({
                        title: '提示框',
                        template: '当前事项没有配置指南！'
                    });
                } else {
                    var result = rs.data;
                    // $scope.guideItem.serviceFlowHtml = $sce.trustAsHtml(result.serviceFlow);
                    $scope.guideItem.id = result.id;
                    $scope.guideItem.itemsSelectedId = $scope.itemsSelected.id;
                    $scope.guideItem.approveFlowHtml = $sce.trustAsHtml(result.approveFlow);

                    $scope.guideItem.items = [
                        { key: '事项名称', value: result.itemTitle },
                        { key: '申请材料', value: $sce.trustAsHtml(result.serviceFlow), type: 'html' },
                        { key: '办理地点', value: result.handleAddress },
                        { key: '咨询方式', value: formatPhone(result.phone), type: 'html' },
                        { key: '审批流程', value: result.approveFlow, type: 'img' },
                        { key: '事项类型', value: result.itemTypeName },
                        /* { key: '实施主体性质', value: result.implementationDeptType }, */
                        { key: '实施主体', value: result.implementationDeptName },
                        /* { key: '实施编码', value: result.implementationCode },
                        { key: '实施主体编码', value: result.implementationDeptCode }, */
                        { key: '服务对象', value: result.serviceObject },
                        { key: '办理形式', value: result.handlingForm },
                        { key: '行使层级', value: result.itemLevelName },
                        { key: '法定办结时限', value: result.timeLimit },
                        { key: '承诺办结时限', value: result.commitmentTimeLimit },
                        { key: '办件类型', value: result.handlingType },
                        { key: '办理时间', value: result.handlingTime },
                        { key: '是否收费', value: result.isCharge },
                        { key: '到办事现场次数', value: result.numberOfVisits },
                        { key: '特别程序', value: result.specialProcedure },
                        // { key: '咨询方式', value: result.consultationMethod, type: 'phone' },
                        { key: '监督投诉方式', value: formatPhone(result.complaintMethod), type: 'html' }
                    ];
                    console.log('指南:', $scope.guideItem);
                    callback && callback();
                }
            });
    }
    function formatPhone(str) {
        if (!str) return str
        console.log(str);
        var html = '',
            mobileReg = /^(\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+$/,
            telhtml,
            matched
            ;
        telhtml = str.replace(/(电话[:：]?\s*)?(((\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+)|(\d{3,}))/g, function(word) {
            if (/(电话[:：]?\s?)/.test(word)) {
                matched = true;
                return word.replace(/\d.*\d$/, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (mobileReg.test(word)) {
                matched = true;
                return word.replace(mobileReg, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (/^((953\d{2})|(955\d{2})|(123\d{2})|(400\d{7}))$/.test(word)) {
                matched = true;
                return word.replace(/\d.*\d$/, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (/^\d{7,}$/.test(word)) {
                matched = true;
                return '<a class="f16" href="tel:' + word + '">' + word + '</a>';
            }
            return word;
        });
        if (!matched && /\d+/.test(str)) telhtml = '<a href="tel:' + str + '">' + str + '</a>';
        telhtml = telhtml.replace(/\w{1,2}\s{0,1}\u3001/g, 'splitflag$&'); //1、
        var list = telhtml.split('splitflag'); //1、
        for (var i = 0; i < list.length; i++) {
            if (!list[i]) continue;
            html += '<p class="mb8">' + list[i] + '</p>';
        }
        return html;
    }
    $scope.guideModalOpen = function() {
        if (!$scope.checkSelectedItem()) return;
        $scope.guideModal.show();
        if ($scope.guideItem.itemsSelectedId != $scope.itemsSelected.id) $scope.loadGuide();
    }
    /***
     * 预约
     **/
    $ionicModal.fromTemplateUrl('appoint-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.appointModal = modal;
    });
    $scope.appointOpen = function() {
        if (!$scope.checkSelectedItem()) return;
        /* 查看当前事项是否已经预约 */
        var data = {
            itemId: $scope.itemsSelected.id,
            applyId: $scope.user.id
        }, opts = {
            method: "post",
            url: urlMap.officeAppointProgress,
            params: data,
        };
        appService.queryData(opts,
            function(rs) {
                if (rs.data && rs.data.id > 0) {
                    $scope.appointItem = rs.data;
                } else {
                    $scope.appointItem = {
                        itemId: $scope.itemsSelected.id,
                        itemClassifyId: $scope.itemsSelected.obj.itemClassifyId,
                        itemTitle: $scope.itemsSelected.obj.itemTitle,
                        applyId: $scope.user.id,
                        createBy: $scope.user.userName,
                        deptId: $scope.itemsSelected.obj.deptId,
                    };
                }
            });
        $scope.appointModal.show();
    }
    /***
     * 提交/更新预约
     */
    $scope.appointApply = function() {
        if ($.trim($scope.appointItem.applyName) == "") {
            $scope.alert("请填写申请人姓名！");
            return false;
        }
        if (!$scope.phoneCheck($scope.appointItem.applyMobile)) {
            return false;
        }
        var data = JSON.stringify($scope.appointItem),
            opts = {
                method: "post",
                url: urlMap.officeAppointUpdate,
                data: data,
            }
        appService.queryData(opts,
            function(rs) {
                var msg = rs.errno == 0 ? '预约成功！' : '预约失败！请重新尝试或联系客服。';
                $scope.alert(msg, function() {
                    $scope.appointModal.hide();
                });
            });
    }
    /***
     * 填报 
     * hasHandleMaterialExample 是否有样例
     * hasHandleMaterialFill 是否有填报
     **/
    $ionicModal.fromTemplateUrl('fill-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.fillModal = modal;
    });
    $scope.fillApplyOpen = function() {
        if (!$scope.checkSelectedItem()) return;
        /* 校验是否配置了指南 */
        if ($scope.guideItem.itemsSelectedId != $scope.itemsSelected.id) $scope.loadGuide(callback);
        else callback();
        function callback() {
            if ($scope.guideItem.id < 1) {
                $scope.alert('当前事项没有配置指南,无法填报！');
                return;
            }
            $scope.itemFill = { id: 0 };
            $scope.submitSuccess = false;
            /* 处理填报信息,判断是否存在有正在进行的填报 */
            $scope.fillhandleMaterialLoad();
        }
    }
    /* 载入材料 */
    $scope.fillhandleMaterialLoad = function() {
        // 填报附件列表
        $scope.exampleAttachList = [];
        $scope.fillAttachListIng = [];
        $scope.guideAttachList = {};
        if (!$('#officeAffairsResultModal').parent().length) {
            $scope.resultModal.show();
            $timeout(function() {
                $scope.resultModal.hide();
            })
        }
        $scope.fillModal.show();
        $scope.queryGuideAttachList();
        // $scope.queryFillAttachList();
    }
    /* 材料 - 样例 & 填报 附件列表 */
    $scope.queryGuideAttachList = function() {
        var data = {
            itemId: $scope.itemFill.itemId || $scope.itemsSelected.id,
            deptId: $scope.itemFill.deptId || $scope.officeDeptId
        }, opts = {
            method: "post",
            url: urlMap.officeGuideAttachList,
            params: data,
        }
        $scope.$emit('loading', 'show');
        appService.queryData(opts,
            function(rs) {
                $scope.$emit('loading', 'hide');
                console.log('样例', rs.data.list);
                if (!rs.data.list) return;
                var list = rs.data.list, exampleList = [], fillList = [];
                for (var i = 0; i < list.length; i++) {
                    /* 有填报 */
                    if (list[i].hasHandleMaterialFill) {
                        fillList.push(list[i]);
                    }
                    /* 只有样例 */
                    else {
                        exampleList.push(list[i]);
                    }
                    $scope.guideAttachList = {
                        fillList: fillList,
                        exampleList: exampleList
                    }
                }
            });
    }
    /* 材料 - 用户上传的 附件列表 */
    $scope.queryFillAttachList = function() {
        var data = {
            itemFillId: $scope.itemFill.id
        }, opts = {
            method: "post",
            url: urlMap.officeFillAttachList,
            params: data,
        }
        $scope.$emit('loading', 'show');
        appService.queryData(opts,
            function(rs) {
                $scope.$emit('loading', 'hide');
                console.log('填报', rs.data.list);
                $scope.exampleAttachList = rs.data.list;
            });
    }
    /* 重新编辑填报 */
    $scope.editChecking = function(fillId) {
        // $scope.resultModal.hide();
        // 填报附件列表
        $scope.exampleAttachList = [];
        $scope.fillAttachListIng = [];
        $scope.guideAttachList = {};
        $scope.fillModal.show();
        // 查看填报附件列表
        $scope.$emit('loading', 'show');
        $.ajax({
            type: "post",
            async: false,
            url: urlMap.officeFillHandle,
            data: {
                fillId: fillId
            },
            success: function(rs) {
                $scope.itemFill = rs.data;
                /* 查看填报附件列表 */
                $scope.queryGuideAttachList();
                $scope.queryFillAttachList();
            }
        });
    }
    /* 提交填报表单 */
    $scope.fillApplyInfoOnlyUpdate = function() {
        if ($scope.itemFill.applyName == '' || $scope.itemFill.applyName == null) {
            $scope.alert('填报人姓名不能为空！')
            return;
        }
        if (!$scope.phoneCheck($scope.itemFill.applyMobile)) {
            return false;
        }
        /* 校验有样例,没填报的需要上传附件 */
        if ($scope.guideAttachList.exampleList) {
            var errorMsg = "";
            for (var i = 0; i < $scope.guideAttachList.exampleList.length; i++) {
                var hasAttach = false, item = $scope.guideAttachList.exampleList[i];
                $scope.fillAttachListIng.forEach(function(aItem) {
                    if (aItem.guideAttachId == item.id) {
                        hasAttach = true;
                    }
                })
                if (!hasAttach) $scope.exampleAttachList.forEach(function(aItem) {
                    if (aItem.guideAttachId == item.id) {
                        hasAttach = true;
                    }
                })
                if (!hasAttach) {
                    errorMsg = item.handleMaterialExampleName + "附件没有上传!";
                    break;
                }
            }
            if (!!errorMsg) {
                $scope.alert(errorMsg)
                return;
            }
        }
        function checkFillAndSubmit() {
            /* *同步*请求远程, 判断是否存在有没有填报的资料 */
            if ($scope.guideAttachList.fillList) {
                var whetherFlowUpdate = true;
                $.ajax({
                    type: "post",
                    async: false,
                    url: urlMap.officeFillWhetherFlowUpdate, //遗留问题
                    data: {
                        itemFillId: $scope.itemFill.id
                    },
                    success: function(rs) {
                        if (rs.errno == 0 && rs.data > 0) {
                            whetherFlowUpdate = false;
                        }
                    }
                });
                if (!whetherFlowUpdate) {
                    $ionicPopup.alert({
                        title: '提示框',
                        template: '有填报表格没有提交'
                    });
                    return;
                }
            }
            $ionicPopup.confirm({
                title: '提示',
                template: '请确保您提供的信息真实有效，否则将追究您的法律责任',
                cancelText: '取消',
                okText: '确定'
            }).then(function(res) {
                if (res) {
                    $scope.itemFill.enabled = 1;
                    $.ajax({
                        type: "post",
                        url: urlMap.officeFillItemUpdate,
                        contentType: "application/json",
                        data: JSON.stringify($scope.itemFill),
                        success: function(rs) {
                            if (rs.errno == 0) {
                                $scope.alert('提交成功');
                                $scope.submitSuccess = true;
                            }
                        }
                    });
                    /* 同步上传附件 */
                    $scope.$emit('loading', 'show');
                    $scope.fillAttachListIng.forEach(function(value, index, selfArray) {
                        $scope.officeFillAttachSave(value.guideAttachId, value.attachUrl, value.attachName);
                    })
                    $scope.fillAttachListIng = [];
                    $scope.queryFillAttachList();
                } else {
                    console.log('返回！');
                }
            });
        }
        if ($scope.itemFill.id < 1) {
            $scope.createFill(function() {
                checkFillAndSubmit();
            });
            return;
        }
        checkFillAndSubmit()
    }
    /* 创建未提交表单对象 */
    $scope.createFill = function(callback) {
        var data = {
            itemId: $scope.itemsSelected.id,
            deptId: $scope.officeDeptId,
            applyId: $scope.user.id,
            createBy: $scope.user.userName,
            applyName: $scope.itemFill.applyName,
            applyMobile: $scope.itemFill.applyMobile
        }, opts = {
            method: "post",
            url: urlMap.officeFillHandleAdd,
            params: data,
        };
        appService.queryData(opts,
            function(rs) {
                if (rs.errno == 0) {
                    rs.data.applyName = $scope.itemFill.applyName;
                    rs.data.applyMobile = $scope.itemFill.applyMobile;
                    $scope.itemFill = rs.data;
                    console.log('获取填报预设:', $scope.itemFill);
                    callback && callback();
                } else {
                    $scope.alert('业务暂时无法办理！');
                }
            });
    }
    /* 打开样例/填报 */
    $scope.fillOpen = function(attachId) {
        if ($scope.itemFill.id < 1) {
            if ($scope.itemFill.applyName == '' || $scope.itemFill.applyName == null) {
                $scope.alert('姓名不能为空！', function() {
                    $scope.goTop('officeReport');
                }, '请先完善填报人信息')
                return;
            }
            if (!$scope.phoneCheck($scope.itemFill.applyMobile)) {
                return false;
            }
            $scope.createFill(function() {
                $scope.editDoc(attachId)
            });
            return;
        }
        $scope.editDoc(attachId);
    }
    /* 载入远程填报 */
    $scope.editDoc = function(attachId) {
        $scope.h5modalTitle = '填报';
        var richTxtUrl = urlMap.officeGuideAttachEdit + "?attachId=" + attachId + '&fillId=' + $scope.itemFill.id + "&_t=" + new Date().getTime();
        console.log(richTxtUrl);
        // alert(richTxtUrl);
        $scope.richUrl = $sce.trustAsResourceUrl(richTxtUrl);
        $scope.h5ModalAttr.h5Type = 1;// 编辑
        $scope.h5Modal.show();
        var iframe = document.getElementById("iframeh5");
        iframe.height = ($(window).height() - 50) + 'px';
    }
    /* 填报关闭 */
    $scope.fillModalClose = function() {
        if (!$scope.submitSuccess)
            $ionicPopup.confirm({
                title: '提示',
                template: '关闭页面将清空已填信息, 您确定要关闭吗?',
                cancelText: '取消',
                okText: '确定'
            }).then(function(res) {
                if (res) {
                    $scope.fillModal.hide();
                } else {
                    console.log('返回！');
                }
            });
        else $scope.fillModal.hide();
    }
    /* 填报样例 */
    $scope.lookDoc = function(attachId) {
        $scope.h5modalTitle = '样例';
        $.ajax({
            type: "get",
            url: urlMap.officeGuideAttachInfo + "/" + attachId,
            success: function(rs) {
                $scope.$apply(function() {
                    var handleMaterialExampleHtml = rs.data.handleMaterialExampleHtml;
                    $scope.h5ModalAttr.h5Type = 2; // 查看
                    $scope.h5Modal.show();
                    $scope.htmlTest = function() {
                        return $sce.trustAsHtml(handleMaterialExampleHtml);
                    };
                    $timeout(function() {
                        $ionicScrollDelegate.$getByHandle("h5Handle").resize();
                        var height = screen.height - 50;
                        var htmlHeight = document.getElementById("htmlId").offsetHeight;
                        var htmlWidth = document.getElementById("htmlId").offsetWidth;
                        if (height < htmlHeight) {
                            $scope.h5HeightStyle = {
                                height: '' + (height - 2) + 'px',
                                width: '' + (htmlWidth - 2) + 'px'
                            };
                        }
                        $scope.h5BrStyle = {
                            'line-height': '' + '10px'
                        };
                        $('#htmlId img').parent().addClass('fix-width');
                    }, 200);
                });
            }
        })
    }
    $scope.lookDocClose = function() {
        $scope.h5ModalAttr.h5Type = 1; // 编辑
        $scope.htmlTest = function() {
            return $sce.trustAsHtml("");
        };
        $scope.h5Modal.hide();
    }
    /* 添加附件 - local*/
    $scope.tapForUpload = function() {
        if ($scope.itemFill.id < 1) {
            if ($scope.itemFill.applyName == '' || $scope.itemFill.applyName == null) {
                $scope.alert('姓名不能为空！', function() {
                    $scope.goTop('officeReport');
                }, '请先完善填报人信息')
                return event.preventDefault();
            }
            if (!$scope.phoneCheck($scope.itemFill.applyMobile)) {

                return event.preventDefault();
            }
            $scope.createFill();
        }
    }
    /* 文件上传 */
    $scope.uploadFillAttach = function(file) {
        var itemid = parseInt(file.getAttribute('itemid'));
        var fileObj = document.getElementById("uploadFile-" + itemid).files[0], fileName = fileObj.name;
        if (!fileObj) return;
        var formData = new FormData();
        formData.append("file", fileObj);
        $.ajax({
            type: "POST",
            url: urlMap.officeAttachUpload,
            data: formData,
            cache: false,
            /**
             * 必须false才会避开jQuery对 formdata 的默认处理
             * XMLHttpRequest会对 formdata 进行正确的处理
             */
            processData: false,
            /**
             *必须false才会自动加上正确的Content-Type
             */
            contentType: false,
        }).success(function(rs) {
            document.getElementById("uploadFile-" + itemid).value = "";
            $scope.$apply(function() {
                $scope.fillAttachListIng.push({
                    itemFillId: $scope.itemFill.id,
                    attachName: fileName,
                    guideAttachId: itemid,
                    attachUrl: rs.data,
                    enabled: 1
                });
            });
        }).error(function(err) {
            console.log('上传失败 err:' + err);
        });
    }
    /* 删除 附件 - local*/
    $scope.removeFileLocal = function(attach, index) {
        $scope.officeFillAttachDelete(attach);
        /* var fillAttachListIngTemp = $scope.fillAttachListIng.filter(function (value, i) {
            return i != index;
        })
        $scope.$applyAsync(function () {
            $scope.fillAttachListIng = fillAttachListIngTemp;
        }); */
    }
    /* 附件删除 */
    $scope.officeFillAttachDelete = function(attach) {
        console.log(JSON.stringify(attach))
        if (attach.id) {
            $.ajax({
                type: "post",
                url: urlMap.officeFillAttachDelete,
                contentType: "application/x-www-form-urlencoded",
                data: {
                    id: attach.id,
                },
                success: function(rs) {
                    $scope.alert('删除成功！');
                    $scope.queryFillAttachList($scope.itemFill.id);
                }
            });
            return;
        } else {
            var fillAttachListIngTemp = $scope.fillAttachListIng.filter(function(value, index) {
                return value.attachUrl != attach.attachUrl;
            })
            $scope.$applyAsync(function() {
                $scope.fillAttachListIng = fillAttachListIngTemp;
                $scope.alert('删除成功！');
            });
        }
    }
    /* 上传附件列表名 */
    $scope.officeFillAttachSave = function(guideAttachId, url, fileName) {
        $.ajax({
            type: "post",
            async: false,
            url: urlMap.officeFillAttachSave,
            contentType: "application/json",
            data: JSON.stringify({
                itemFillId: $scope.itemFill.id,
                attachName: fileName,
                guideAttachId: guideAttachId,
                attachUrl: url,
                enabled: 1
            }),
            success: function(rs) {
            }
        });
    }
    /***
     * 结果公示
     **/
    $ionicModal.fromTemplateUrl('result-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.resultModal = modal;
    });
    $scope.resultModelOpen = function() {
        $scope.resultModal.show();
        $scope.fillList = [];
        $.ajax({
            type: "post",
            url: urlMap.officeFillResultList,
            data: {
                itemClassifyId: $scope.itemClassifyId,
                applyId: $scope.user.id,
                deptId: $scope.officeDeptId
            },
            success: function(rs) {
                console.log('结果公示', rs && rs.data && rs.data.list);
                $scope.fillList = rs.data.list;
            }
        });
    }
    /* 接受视频 */
    $scope.videocheck = function(itemFillId, roomId) {
        // alert("itemFillId:" + itemFillId);
        // var videoCallUrl = urlMap.officeVideoCall + "?userId=" + $scope.user.id + "&fillId=" + itemFillId;
        var userId = 'zhizheng_' + $scope.user.id;
        $.ajax({
            type: "POST",
            url: urlMap.officeFillVideoSgin,
            data: {
                roomId: roomId,
                userId: userId
            },
            success: function(json) {
                if (json && json.errno === 0) {
                    //一会儿进入房间要用到
                    var userSig = json.data.userSig;
                    var privateMapKey = json.data.privMapEncrypt;
                    var sdkappid = json.data.sdkappid;
                    var accountType = json.data.accountType;
                    RoomWebRTC.videoCall(userId, userSig, sdkappid, accountType, roomId);
                } else {
                    console.error(json);
                }
            },
            error: function(err) {
                console.error(err);
            }
        })
    }
    // 填报word
    $ionicModal.fromTemplateUrl('h5-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.h5Modal = modal;
    });
    /* 电话校验 */
    $scope.phoneCheck = function(phone) {
        var mobileReg = /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,7,8]|8[0-9]|9[1,8,9])\d{8}$/;
        var fixedReg = /0\d{2}-\d{7,8}/;
        if (!phone || phone == "") {
            $scope.alert("请填写联系电话", function() {
                $scope.goTop('officeReport');
            }, '请先完善填报人信息');
            return false;
        } else if (!mobileReg.test(phone)) {
            if (!fixedReg.test(phone)) {
                $scope.alert('联系电话无效！', function() {
                    $scope.goTop('officeReport');
                }, '请先完善填报人信息');
                return false;
            }
            else {
                return true;
            }
        }
        return true;
    };
    $scope.alert = function(info, then, title) {
        $ionicPopup.alert({
            title: title || '提示框',
            template: info
        }).then(function() {
            then && then();
        });
    }
}
])