appModule.controller('officeHomeController',
  ['$scope', '$ionicPopup', '$stateParams', 'appService', '$state', '$ionicModal', '$ionicScrollDelegate', '$timeout', '$document', '$sce', '$cordovaBrowser',
    function($scope, $ionicPopup, $stateParams, appService, $state, $ionicModal, $ionicScrollDelegate, $timeout, $document, $sce, $cordovaBrowser) {
      //data
      $scope.stateName = $state.current.name;
      $scope.tabName = $stateParams.tabName;
      $scope.departmentList;  //部门介绍
      $scope.deptList = {};  //政务大厅
      $scope.navArr;  //办事指南
      $scope.deptSelected = { deptId: '' };// 部门选中对象Id
      $scope.areaId;
      $scope.domore = true;
      $rootScopeViewGoback = $scope.viewGoback
      var delegate = $ionicScrollDelegate.$getByHandle('officeHomeScroll');
      $scope.$on('$ionicView.loaded', function() {
        // $scope.videoCalling();
      });
      /* root enterBefore */
      $scope.$on('changeDistrict', function(e, data) {
        if ($scope.stateName == $state.current.name) {
          if ($scope.areaId && ($scope.areaId != $scope.publicCityId)) {
            if ($scope.tabName == 'wbfw' && $scope.tabName != 'zbfw') $scope.tabName = null;
            $scope.init();
          }
          $scope.areaId = $scope.publicCityId;
        }
      });
      /* watch */
      $scope.$watch('tabName', function(n, o) {
        if (!n) return;
        $scope.deptSelected = { deptId: '' };
        $timeout(function() {
          $scope.queryArray(n, 0);
          delegate.resize();
        }, 100)
      });
      $scope.getServiceList = function() {
        var data = {
          areaId: $scope.publicCityId,
          serviceId: 2 //1网办 2掌办
        }
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.wangzhangDept, data, function(result) {
          $scope.$emit('loading', 'hide');
          var list = result.data || [];
          $timeout(function() {
            delegate.resize();
          })
        })
      }
      $scope.init = function() {
        $ionicScrollDelegate.scrollTop();
        $scope.departmentList = null;  //部门介绍
        $scope.deptList = {};  //服务部门列表
        // $scope.navArr = null;  //办事指南
        $scope.deptSelected = { deptId: '' };
        $scope.queryArray($scope.tabName, 0);
      }
      $scope.viewGoback = function() {
        if (!$scope.tabName) {
          $rootScopeViewGoback()
          return
        }
        $scope.tabName = null
        delegate && delegate.scrollTop();
      }
      $scope.queryArray = function(tabName, page) {
        /* 网办服务 */
        if (tabName == 'wbfw') {
          if (!$scope.webDepList) $scope.webDepListFn()
          return
        }
        /* 掌办服务 */
        if (tabName == 'zbfw') {
          if (!$scope.mobileDep) $scope.mobileDepListFn()
          return
        }
        /* 部门介绍 */
        if (tabName == 'bmjs') {
          return
          // 建设中
          $scope.departmentList = [];
          $scope.getDeptListTab0();
          return
        }
        /* 智慧政务 */
        if (tabName == 'zhzw') {
          $scope.deptList = null;
          $scope.getDeptList();
          return
        }
      };
      $scope.webDepList;
      /* 网办政务 */
      $scope.webDepListFn = function() {
        var data = {
          areaId: $scope.publicCityId,
          serviceId: 1 //1网办 2掌办
        }
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.wangzhangDept, data, function(results) {
          $scope.$emit('loading', 'hide');
          var list = results.data || [];
          var ulArr = [], ul = [];
          for (i = 1; i <= list.length; i++) {
            ul.push(list[i - 1]);
            if (i % 3 == 0 || i == list.length && i % 3 > 0) {
              var obj = { ul: ul };
              if ((ulArr.length + 1) % 2 == 1) obj.bg = 'e1f8ff';
              ulArr.push(obj);
              ul = [];
            }
          }
          $scope.webDepList = ulArr;
          $timeout(function() {
            delegate.resize();
          })
        })
      }
      $scope.mobileDep;
      /* 掌办政务 */
      $scope.mobileDepListFn = function() {
        var data = {
          areaId: $scope.publicCityId,
          serviceId: 2 //1网办 2掌办
        }
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.wangzhangDept, data, function(results) {
          $scope.$emit('loading', 'hide');
          var list = results.data || [];
          var ulArr = [], ul = [];
          for (i = 1; i <= list.length; i++) {
            ul.push(list[i - 1]);
            if (i % 3 == 0 || i == list.length && i % 3 > 0) {
              var obj = { ul: ul };
              if ((ulArr.length + 1) % 2 == 1) obj.bg = 'e1f8ff';
              ulArr.push(obj);
              ul = [];
            }
          }
          $scope.mobileDep = ulArr;
          $timeout(function() {
            delegate.resize();
          })
        })
      }
      /* 产品列表 */
      $scope.getProducts = function() {
        var data = {
          regionCode: $scope.publicCityId,
          size: 999,
          isOpen: -1
        }
        appService.getData(urlMap.productList, data, function(result) {
          var list = result.data
          list.unshift({
            name: '服务概况',
            onColor: '#387ef5',
            iconName: 'products',
            route: '{"route":"ttbProduct"}'
          })
          list.forEach(function(item) {
            Obj = item.route && JSON.parse(item.route)
            item.routeName = Obj && Obj.route
            item.routeParams = Obj && Obj.params || {}
            item.routeParams.name = item.name
          });
          $scope.products = list;
          $scope.domore = false
          $timeout(function() {
            delegate.resize();
          })
        })
      }
      $scope.goProduct = function(item) {
        if (!item.route) return
        $scope.goState(item.routeName, item.routeParams)
      }
      /* 部门介绍 */
      $scope.getDeptListTab0 = function() {
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.departmentJS, { "areaId": $scope.publicCityId },
          function(department) {
            $scope.$emit('loading', 'hide');
            var list = department.resultList;
            console.log('部门介绍', list);
            var ulArr = [], ul = [];
            for (i = 1; i <= list.length; i++) {
              ul.push(list[i - 1]);
              if (i % 3 == 0 || i == list.length && i % 3 > 0) {
                var obj = { ul: ul };
                if ((ulArr.length + 1) % 2 == 1) obj.bg = 'oldlace';
                // if ((ulArr.length + 1) % 2 == 0) obj.bg = 'colorf0f9eb';
                // if ((ulArr.length + 1) % 4 == 3) obj.bg = 'colorf0f9eb';
                ulArr.push(obj);
                ul = [];
              }
            }
            $scope.departmentList = ulArr;
            // console.log($scope.departmentList);
            $timeout(function() {
              delegate.resize();
            })
          });
      }
      /* 政务大厅 */
      $scope.getDeptList = function() {
        $scope.deptSelected.deptId = '';
        var data = {
          province: $scope.proName,
          city: $scope.cityName,
          district: $scope.distName || ''
        }
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.officeDeptList, data, function(results) {
          $scope.$emit('loading', 'hide');
          $scope.deptList = results.data || [];
          $scope.isOpenOffice = $scope.deptList && $scope.deptList.length;
          console.log('政务大厅', results.data);
          $timeout(function() {
            delegate.resize();
          })
        })
      }
      /* 信息公开 */
      /* 打开外部链接iframe */
      $ionicModal.fromTemplateUrl('gkyj-modal.html', {
        scope: $scope,
        // animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.openModal = modal;
      });
      $scope.openUrl = function(item) {
        $scope.frameTitle = '政府信息公开'
        $scope.showUrl = $sce.trustAsResourceUrl('http://xxgk.tonghua.gov.cn/thsrmzf/thsrmzf1/gkyj/');
        $scope.openModal.show();
      }
      /* get办事指南 - 部门列表 */
      $scope.getGuide = function() {
        if (!!$scope.navArr) return;
        appService.getData(urlMap.section, {}, function(newItems) {
          console.log('办事指南', newItems);
          $scope.navArr = newItems;
        });
      }
      //办事指南 - 详情
      $scope.goToForum = function(item) {
        window.localStorage.setItem("departmentId", item.id);
        var goState = function() {
          $state.go('message');
          // window.location.href = item.url;
        }
        $scope.$emit("loginFirst", goState);
      }
      $scope.changeItem = function(item) {
        $scope.deptSelected.deptName = item.name;
      }
      $scope.goOfficeAffairs = function() {
        if (!$scope.deptSelected.deptId) {
          $scope.alert('请选择部门');
          return;
        }
        var goState = function() {
          $state.go('officeAffairs', { officeDeptId: $scope.deptSelected.deptId, tabName: 'zhzw' });
        }
        $scope.$emit("loginFirst", goState);
      }
      $scope.alert = function(info) {
        $ionicPopup.alert({
          title: '提示框',
          template: info
        });
      }
      /**
       * 查看当前登陆人是否有视频审核
       */
      $scope.videoCalling = function() {
        //console.log('fff:   ');
        //console.log($rootScope.user);
        if (null == $scope.user) {
          // $state.go('login');
        } else {
          var userId = 'zhizheng_' + $scope.user.id;
          if ($scope.user && $scope.user.id) {
            $.ajax({
              type: "post",
              url: urlMap.officeFillVideoCalling,
              data: {
                applyId: $scope.user.id
              },
              success: function(rs) {
                if (rs.data && rs.data.id) {
                  //  confirm 对话框
                  var confirmPopup = $ionicPopup.confirm({
                    title: '你将接受视频验证',
                    cancelText: '取消',
                    okText: '确定'
                  });
                  confirmPopup.then(function(conf) {
                    if (conf) {
                      $scope.openVideoCalling(userId, rs.data.videoSign);
                      // window.open(videoCallUrl);
                      // cordova.InAppBrowser.open(videoCallUrl, '_system', 'location=no');
                    }
                  });
                }
              }
            });
          }

        }

      }
      $scope.openVideoCalling = function(userId, roomId) {
        $.ajax({
          type: "POST",
          url: urlMap.officeFillVideoSgin,
          data: {
            roomId: roomId,
            userId: userId
          },
          success: function(json) {
            if (json && json.errno === 0) {
              //一会儿进入房间要用到
              var userSig = json.data.userSig;
              var privateMapKey = json.data.privMapEncrypt;
              var sdkappid = json.data.sdkappid;
              var accountType = json.data.accountType;
              RoomWebRTC.videoCall(userId, userSig, sdkappid, accountType, roomId);
            } else {
              console.error(json);
            }
          },
          error: function(err) {
            console.error(err);
          }
        })
      }
      /* 事项搜索 */
      $scope.clearComplete = 1;
      /* $scope.cancle = function () {
        if ($scope.history && !$scope.showResult) {
          $scope.history = null;
          $scope.showResult = true;
          $scope.searchKey = $scope.searchTypeLast;
          $scope.keywords = $scope.keywordsLast;
          return;
        }
        $scope.viewGoback(); console.log('goback');
        return;
      } */
      $scope.searchClear = function(e) {
        $scope.keywords = '';
        var ele = e.target.previousElementSibling.getElementsByTagName('input')[0];
        $scope.clearComplete = 0;
        $timeout(function() {
          ele.focus();
          $scope.clearComplete = 1;
        }, 0)
      }
      $scope.searchFocus = function() {
        $scope.searchOnFocus = true;
        $scope.showResult = false;
        $scope.searchTypeLast = $scope.searchKey;
        $scope.keywordsLast = $scope.keywords != '' ? $scope.keywords : $scope.keywordsLast;
        $scope.cancelChangeDist();
      }
      $scope.searchBlur = function() {
        if ($scope.clearComplete)
          $scope.searchOnFocus = false;
      }
      $scope.searchKeyup = function(e) {
        var keycode = window.event ? e.keyCode : e.which;
        //回车事件
        if (keycode == 13) {
          if (!$scope.keywords.trim()) return
          $scope.searchSubmit();
        }
      }
      $scope.goCompany = function(deptId) {
        $state.go("officeDepartmentList", { id: deptId });
      };
      $scope.changeTab = function(name, isTTB) {
        if (name == 'bmjs') {
          $scope.alert('建设中，敬请期待。')
          return
        }
        if (isTTB) {
          $scope.openUrl({ url: 'http://tonghua.onewindow.cn/#/guideSys' })
          return
        }
        if (name == 'zbfw') { $scope.goState('officeZhangban'); name = null }
        if (name == 'wbfw') { $scope.goState('officeWangban'); name = null }
        $scope.tabName = name;
        $scope.scrollOrientation(name)
      }
      $scope.openUrl = function(item) {
        // $scope.showUrl = $sce.trustAsResourceUrl(item.address);
        $cordovaBrowser.open(item.url, '_blank',
          {
            title: {
              color: '#ffffff',
              showPageTitle: true,
              staticText: item.name
            },
            closeButton: {
              wwwImage: 'images/normal/icon-back.png',
              wwwImagePressed: 'images/normal/icon-back.png',
              staticText: '关闭',
              align: 'left',
              event: 'closePressed'
            },
            closePressed: function() {
            },
            toolbar: {
              height: 44,
              color: '#5769f1'
            },
            backButtonCanClose: false
          })
      }
      /* 滚动到锚点 */
      $scope.scrollOrientation = function(idStr) {
        if (!idStr) {
          delegate && delegate.scrollTop();
          delegate.resize();
          return
        }
        //滚动到省锚点
        var hash = idStr;
        var elm = hash && $document[0].getElementById(hash);
        var scrollTop = elm.offsetTop - 10;
        delegate && delegate.scrollTo(null, scrollTop);
        delegate.resize();
      }
      $scope.onInfinite = function() {
        $scope.getProducts()
      }
    }])
