/****************************************
 * @description  更新用户信息
 * -----------------------------------------------------------------------------------------------------
 */
appModule.controller('userInfoController', ['$scope', '$timeout', 'appService', '$ionicPopup', '$stateParams', '$state', '$sce', function ($scope, $timeout, appService, $ionicPopup, $stateParams, $state, $sce) {
    $scope.filetype;
    $scope.formContent = $stateParams.formContent;
    $scope.editItem = $stateParams.editItem;
    $scope.region = $stateParams.region;
    $rootScopeViewGoback = $scope.viewGoback;
    $scope.form = {
        /* realName: '迟金生',
        idCard: '22052119570318003X' */
    };
    /* enter */
    $scope.$on('$ionicView.beforeEnter', function () {
        $scope.$emit('loginFirst', null, function () {
            $scope.viewGoback()
        })
    });
    $scope.alert = function (info, showPhone, callback) {
        if (showPhone) {
            info = '<p class="bold">' + info + '</p><p>如果您有任何问题，请随时联系我们的客服人员<p><a href="tel:0435-5725999" class="f18">0435-5725999</a>。</p></p>'
        }
        $ionicPopup.alert({
            title: '提示框',
            template: info
        }).then(function () {
            callback && callback()
        })

    }
    $scope.viewGoback = function () {
        if ($scope.formContent) $scope.setForm(false);
        else if ($scope.showDetials) $scope.showDetial(false);
        else $rootScopeViewGoback();
    }
    $scope.setForm = function (b, editItem) {
        if ($scope.editItem == 'idCard')/* 测试 */ {
            $rootScopeViewGoback();
            return
        }
        $scope.editItem = editItem;
        if (!b) {
            $scope.formContent = b;
            return
        }
        $scope.formContent = b;
        $scope.form = {}
        $scope.removeFile()
    }
    $scope.removeFile = function (reset) {
        $scope.showUploadFiles = []; //预览
        $scope.showUploadNames = []; //预览失败 显示文件名
        if (!reset) {
            $('#localPhotoFile').val(''); //本地
            $scope.cameraFile = null; //拍摄
        }
    }/* 本地附件读取 */
    function readerfile(file) {
        return new Promise( function(resolve, reject) {
            var reader = new FileReader();
            reader.onload = function () {
                resolve(reader.result);
            };
            if (file) {
                reader.readAsDataURL(file)
            }
        })
    }
    $scope.fileChangeEvent = function () {
        var files = $('#localPhotoFile')[0].files;
        for (var i = 0; i < files.length; i++) {
            $scope.fileType = thisfileType(files[i].name);
            if (!$scope.fileType == 'error') {
                return;
            }
            $scope.removeFile('reset');
            try {
                readerfile(files[i]).then(function(e) {
                    $scope.$apply(function () {
                        if ($scope.fileType == 2) {
                            $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
                        }
                        else $scope.showUploadFiles.push(e)
                    })
                })
            } catch (e) {
                alert(e);
                $scope.$apply(function () {
                    $scope.showUploadNames.push(files);
                })
            }
        }
    }
    /***
     * use camera
     */
    $scope.useCamera = function (type) {
        // $scope.$emit('loginFirst', function () {
        //开始录像(最长录制时间:60秒)
        if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
        if (type == 2) navigator.device.capture.captureVideo(success, onError);
        // });
        function success(mediaFiles) {
            $scope.showUploadFiles = [];
            for (var i = 0; i < mediaFiles.length; i++) {
                var name = mediaFiles[i].name;
                var path = mediaFiles[i].fullPath;
                $scope.fileType = thisfileType(name);
                if (!$scope.fileType == 'error') {
                    return;
                }
                $scope.removeFile('reset');
                $scope.$apply(function () {
                    if ($scope.fileType == 2) {
                        $scope.showUploadFiles.push($sce.trustAsResourceUrl(path))
                    }
                    else
                        $scope.showUploadFiles.push(path)
                })
                $scope.cameraFile = mediaFiles[i];
            }
        }
        //录制失败
        function onError(error) {
            $scope.alert('未进行拍摄！错误码:' + error.code);
        }
    }
    function thisfileType(fileName) {
        var picExt = ".jpg|.jpeg|.png|";
        var vioExt = ".mp4|.3gp|.avi|";
        if (!fileName) return null
        var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
        /* 检查文件类型  */
        if (picExt.indexOf(extName + "|") != -1) return 1;
        if (vioExt.indexOf(extName + "|") != -1) return 2;
        $scope.alert("该文件类型不允许上传。");
        return 'error'
    }
    $scope.submitPortrait = function () {
        var file = $('#localPhotoFile').val() || ($scope.cameraFile && $scope.cameraFile.name) || '';
        $scope.fileType = thisfileType(file);
        if (!$scope.fileType == 'error') {
            return;
        }
        /* 没有附件 */
        if (!$scope.fileType) {
            $scope.alert('请先选择一张图片上传')
            return
        }
        $scope.$emit('loading', 'show');
        /* 拍摄上传 */
        if ($scope.cameraFile) {
            var file = $scope.cameraFile;
            var params = {};
            params.id = $scope.user.id;
            params.oldPic = $scope.user.portraitOrgin;
            var ft = new FileTransfer();
            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.mimeType = "multipart/form-data";
            options.fileName = file.name;
            options.params = params;
            //传输进度  
            ft.onprogress = function (progressEvent) {
            };
            ft.upload(file.fullPath, urlMap.portraitUrl,
                function (res) {
                    // var imgUrl = res.responseText;
                    if (res) {
                        $scope.alert("头像更新成功");
                    } else {
                        $scope.alert("文件上传失败，请联系客服人员！");
                    }
                },
                function () {
                    $scope.alert("图片上传失败，请联系客服人员！");
                },
                options);
            return;
        }
        /* 本地文件上传 */
        $timeout(function () {
            $("#files").ajaxSubmit({
                url: urlMap.portraitUrl,
                type: "post",
                dataType: "json",
                success: function (res) {
                    $scope.$emit('loading', 'hide');
                    // var imgUrl = res.responseText;
                    if (res) {
                        $scope.alert("头像更新成功");
                        $scope.setForm(false);
                        $scope.$emit("updateUserInfo");
                    } else {
                        $scope.alert("文件上传失败，请联系客服人员！");
                    }
                },
                error: function (res) {
                    $scope.$emit('loading', 'hide');
                    // var imgUrl = res.responseText;
                    if (res) {
                        $scope.alert("头像更新成功");
                        $scope.setForm(false);
                        $scope.$emit("updateUserInfo");
                    } else {
                        $scope.alert("文件上传失败，请联系客服人员！");
                    }
                },
                beforeSerialize: function () {
                },
                beforeSend: function () {
                    //$("#progressNumber").html('0%');
                },
                uploadProgress: function (event, position, total, percentComplete) {
                    // $scope.removeFile();
                }
            });
        })
    }
    function onprogress(evt) {
        //侦查附件上传情况
        //通过事件对象侦查
        //该匿名函数表达式大概0.05-0.1秒执行一次
        console.log(evt.loaded); //已经上传大小情况

        var loaded = evt.loaded;
        var tot = evt.total;
        var per = Math.floor(100 * loaded / tot); //已经上传的百分比
        var son = document.getElementById('progressBar');
        son.innerHTML = per + "%";
        son.style.width = per + "%";
    }
    $scope.putUserInfo = function (params) {
        appService.postData(urlMap.updateUser, params,
            function (jsonData) {
                $scope.$emit("updateUserInfo");
                $scope.alert("更新成功");
                $scope.setForm(false);
                return
            });
    }
    // 实名认证
    $scope.authIdcard = function (params) {
        /* var opts = {
            method: "post",
            url: urlMap.authIdcard,
            params: params
        } */
        // appService.queryData(opts,
        appService.postData(urlMap.authIdcard, params,
            function (res) {
                /* if (res.code == 200) {
                } */
                $scope.$emit("updateUserInfo");
                $scope.alert(res.msg, 'showPhone', function () {
                    $scope.setForm(false);
                    $scope.viewGoback()
                });
                return
            });
    }
    $scope.submit = function () {
        if ($scope.form.nickName == $scope.user.nickName) {
            $scope.alert("更新成功");
            $scope.setForm(false);
            return
        }
        if ($scope.editItem == 'nickName') {
            if (!$scope.form.nickName || !$scope.form.nickName.trim()) {
                $scope.alert("请输入新昵称");
                return
            }
            appService.getData(urlMap.checkNickName, { id: $scope.user.id, nickName: $scope.form.nickName },
                function (jsonData) {
                    if (jsonData[0]) {
                        $scope.alert("该昵称已存在");
                        return
                    }
                    $scope.putUserInfo({ id: $scope.user.id, nickName: $scope.form.nickName })
                });
            return
        }
        if ($scope.editItem == 'portrait') {
            $scope.submitPortrait();
            return
        }
        if ($scope.editItem == 'idCard') {
            var res = $scope.verifyIdcard($scope.form.idCard);
            if (!res) { $scope.alert('请输入正确的身份证号'); return }
            $scope.authIdcard({ userId: $scope.user.id, realName: $scope.form.realName, idCard: $scope.form.idCard, regionName: $scope.region.name, regionId: $scope.region.id })
            return
        }
    }
    $scope.verifyIdcard = function (num) {
        if (!num) return false;
        var rel = /^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/;
        return !!num.match(rel)
    }

}
])