appModule.controller('policyHomeController', ['$scope', 'appService', '$state', '$timeout', '$stateParams', '$ionicScrollDelegate', '$location', '$document', function($scope, appService, $state, $timeout, $stateParams, $ionicScrollDelegate, $location, $document) {
    /* datas */
    // $scope.user.app_flag = 1; //测试预览账户
    $scope.stateName = $state.current.name;
    $scope.searchKey = 'policy';
    $scope.categoryCubsidies = null;
    $scope.isLogin;
    $scope.policyNavLevel = { now: 0 };
    $scope.filterData = {};
    $scope.tabIndex = 0
    $scope.allArrays = {}
    $scope.pageNext = [0, 0];
    $scope.domore = [true, true];
    $scope.$on('$ionicView.loaded', function() {
        $scope.getPolicyYearsList();
        $scope.getCategory();
    });
    /* root enterBefore */
    $scope.$on('changeDistrict', function(e, data) {
        if ($scope.stateName == $state.current.name) {
            if (data.type == 'selectDist') {
                $scope.getCategory();
                $ionicScrollDelegate.scrollTop();
                $scope.allArrays[0] = $scope.allArrays[1] = null
                $scope.pageNext = [0, 0];
                $scope.domore = [true, true];
            }
            $scope.filterYear.value = "选择时间";
        }
        $scope.regionId = $scope.publicCityId
    });
    $scope.$on('$stateChangeSuccess',
        function(event, toState, toParams, fromState, fromParams) {
            if (fromState.name == "myPolicySubscribe" && $scope.tabIndex == 1) {
                $scope.allArrays[1] = null
                $scope.pageNext[1] = 0;
                $scope.domore[1] = true;
            }
        })
    $scope.filterYear = {
        value: '选择时间', options: [],
        selecOption: function(o) {
            this.value = o;
            $scope.filterData.timeId = o > 0 ? o : 0;
            $scope.changesTimeSection(o);
            $scope.queryLastArticles(0);
            $scope.selectBlur();
        },
        onFocus: function() {
            this.showOptions = !this.showOptions;
        }
    };
    $scope.selectBlur = function() {
        $scope.filterYear.showOptions = false;
    }
    $scope.changesTimeSection = function(d, isyear, isCancle) {
        var _d = d;
        switch (d) {
            case '近三月':
                d = 3;
                break;
            case '近半年':
                d = 6;
                break;
            case '近一年':
                d = 12;
                break;
            case '全部政策':
                isCancle = true;
            default:
                isyear = 'isyear';
        }
        // var isCancle = $scope.filterData.timeId == d ? true : false;
        var currDate = new Date(),
            year = currDate.getFullYear(),
            month = currDate.getMonth() + 1,
            date = currDate.getDate(),
            endTime = year + '-' + month + '-' + date;
        if (isCancle) {
            $scope.filterData.timeId = null;
            $scope.filterData.startTime = $scope.filterData.endTime = null;
            return;
        }
        if (isyear) {
            $scope.filterData.startTime = d + '-' + 1 + '-' + 1;
            $scope.filterData.endTime = d + '-' + 12 + '-' + 31;
            $scope.filterData.timeId = 0;
            console.log('startTime:' + $scope.filterData.startTime + ', endTime:' + $scope.filterData.endTime);
            return;
        } else {
            $scope.filterData.endTime = endTime;
            year = month - d > 0 ? year : year - 1;
            month = month - d > 0 ? month - d : month + 12 - d;
            date = date > 29 ? 29 : date;
            $scope.filterData.startTime = year + '-' + month + '-' + date;
            $scope.filterData.timeId = d;
            $scope.filterYear.value = _d;
        }
        console.log('startTime:' + $scope.filterData.startTime + ', endTime:' + $scope.filterData.endTime);
    }
    $scope.getPolicyYearsList = function() {
        appService.getData(urlMap.queryPolicyYearsList, {}, function(jsonDataArr) {
            if (jsonDataArr.resultList && jsonDataArr.resultList[0]) {
                jsonDataArr.resultList.unshift('近一年');
                jsonDataArr.resultList.unshift('近半年');
                jsonDataArr.resultList.unshift('近三月');
                jsonDataArr.resultList.unshift('全部政策');
            }
            $scope.filterYear.options = jsonDataArr.resultList;
        });
    }
    $scope.getCategory = function() {
        $scope.categoryCubsidies = [];
        appService.getData(urlMap.policyAll, { areaId: $scope.publicCityId }, function(jsonDataArr) {
            $scope.categoryCubsidies = jsonDataArr.resultList;
            $timeout(function() {
                $scope.initdNavLevel();
            });
        });
    }
    $scope.queryLastArticles = function(page) {
        if (page < 2) { //页面刷新时为0,下拉刷新时为1
            $scope.pageNext[0] = 1;
            $scope.allArrays[0] = null
            page = 1;
        }
        var data = {
            startTime: $scope.filterData && $scope.filterData.startTime,
            endTime: $scope.filterData && $scope.filterData.endTime,
            areaID: $scope.publicCityId,
            app_flag: $scope.user && $scope.user.app_flag,
            page: page
        }
        appService.getData(urlMap.lastPolicyList, data,
            function(results) {
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                console.log(page, results.resultList);

                var list = results.resultList,
                    length = list.length,
                    size = results.size,
                    articles = $scope.allArrays[0] || [];
                if (length < size) $scope.domore[0] = false;
                else {
                    $timeout(function() {
                        $scope.domore[0] = true
                    }, 200)
                }
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.picName = item.pic_name || item.picName || ($scope.pic + urlMap.defaultUpload); //缩略图
                        if (!(/http:\/\//.test(item.picName)))
                            item.picName = $scope.pic + '/' + item.picName
                        switch (item.level) {
                            case '1':
                                item.levelName = "中央"
                                break;
                            case '2':
                                item.levelName = "省部"
                                break;
                            case '3':
                                item.levelName = "地市"
                                break;
                            case '4':
                                item.levelName = "县区"
                                break;

                        }
                        articles.push(item);
                    }
                }
                $scope.allArrays[0] = articles
                $timeout(function() {
                    $ionicScrollDelegate.resize();
                })
            });
    }
    $scope.onInfinite = function() {
        var n = $scope.tabIndex;
        $scope.queryArray(n, ++$scope.pageNext[n]);
    }
    $scope.gotoPolicyDetail = function(id) {
        if (!$scope.isLogin) {
            $scope.$emit('loginFirst', function() {
                $state.go('policyDetail', { id: id });
                $scope.isLogin = true;
            })
        } else
            $state.go('policyDetail', { id: id });
    }
    $scope.gotoPolicyList = function(id, name) {
        if (!id) { /* 实时政策 */
            $scope.tabIndex = 0
            var anchorTop = $document[0].getElementById('lastPNav').offsetTop;
            $scope.goTop(null, anchorTop);
            return;
        }
        if (id == 5) { /* 我的订阅 */
            $scope.$emit('loginFirst', function() {
                $scope.tabIndex = 1
                var anchorTop = $document[0].getElementById('lastPNav').offsetTop;
                $scope.goTop(null, anchorTop);
                /* if (!$scope.allArrays[1]) $scope.queryMySub(0, function() {
                    $scope.goTop(null, anchorTop);
                }) */
            })
            return;
        }
        $state.go('policyList', { categoryId: id, categoryName: name })
    }
    $scope.addMySubscribe = function() {
        $scope.goState('myPolicySubscribe')
    }
    $scope.queryArray = function(tabindex, page) {
        if (tabindex == 0) $scope.queryLastArticles(page)
        if (tabindex == 1) $scope.queryMySub(page)
    }
    /* 我的订阅 */
    $scope.initdNavLevel = function() {
        var elm1 = $document[0].getElementById('policyListLast');
        $scope.policyNavLevel.level1 = elm1.offsetTop - 50;
    }
    $scope.ionScroll = function() {
        var scrollTop = event.detail && event.detail.scrollTop,
            $gotop = $(event.target).parents('ion-view').children('.goTop');
        if (scrollTop < 20) $gotop.hide();
        else $gotop.show();
        if (scrollTop < $scope.policyNavLevel.level1) $scope.$apply(function() {
            $scope.policyNavLevel.now = 0;
        });
        if (scrollTop >= $scope.policyNavLevel.level1) $scope.$apply(function() {
            $scope.policyNavLevel.now = 1;
        });
        // console.log(scrollTop);
    }
    $scope.queryMySub = function(page, callback) {
        if (page == 0 || page == 1) { //页面刷新时为0,下拉刷新时为1
            $scope.pageNext[1] = 1;
            $scope.allArrays[1] = null
            page = 1;
        }
        $scope.$emit('loading', 'show');
        var data = {
            userId: $scope.user.id,
            areaID: $scope.publicCityId,
            page: page
            /* startTime:
                endTime: */
        }
        appService.getData(urlMap.myLabelPolicy, data,
            function(results) {
                $scope.$emit('loading', 'hide');
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                console.log(page, results.resultList);
                var list = results.resultList,
                    length = list.length,
                    size = results.size,
                    articles = $scope.allArrays[1] || [];
                if (length < size) $scope.domore[1] = false;
                else {
                    $timeout(function() {
                        $scope.domore[1] = true
                    }, 200)
                }
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.categoryName = item.categoryName || $scope.myParams.categoryName
                        item.picName = item.pic_name || item.picName || ($scope.pic + urlMap.defaultUpload); //缩略图
                        if (!(/http:\/\//.test(item.picName)))
                            item.picName = $scope.pic + '/' + item.picName
                        switch (item.level) {
                            case '1':
                                item.levelName = "中央"
                                break;
                            case '2':
                                item.levelName = "省部"
                                break;
                            case '3':
                                item.levelName = "地市"
                                break;
                            case '4':
                                item.levelName = "县区"
                                break;

                        }
                        articles.push(item);
                    }
                }
                $scope.allArrays[1] = articles
                $timeout(function() {
                    $ionicScrollDelegate.resize();
                })
                callback && callback()
            });
    }
}
])