appModule.controller('policyListController', ['$scope', 'appService', '$state', '$timeout', '$stateParams', '$ionicScrollDelegate', function ($scope, appService, $state, $timeout, $stateParams, $ionicScrollDelegate) {
    /* datas */
    $scope.stateName = $state.current.name;
    $scope.searchKey = 'policy';
    $scope.categoryId = $stateParams.categoryId;
    $scope.showQuxian = ($scope.categoryId == 2 || $scope.categoryId == 1) && $scope.city.id == '2205';
    $scope.filterData = {};
    $scope.categoryName = $stateParams.categoryName;
    $scope.level = 0;
    $scope.time = { id: null, startTime: null, endTime: null };
    $scope.levels = [
        { id: 0, name: '全部' },
        { id: 1, name: '中央' },
        { id: 2, name: '省部' },
        { id: 3, name: '地市' },
        { id: 4, name: '县区' }
    ];
    $scope.regions = {
        value: ($scope.distName || $scope.cityName), options: [],
        selecOption: function (dist) {
            $scope.selectDist(dist);
            this.value = dist.name;
            $scope.selectBlur();
        },
        onFocus: function () {
            this.showOptions = !this.showOptions;
        }
    };
    $scope.filterYear = {
        value: '更多年份', options: [],
        selecOption: function (o) {
            this.value = o;
            $scope.filterData.timeId = 0;
            $scope.changesTimeSection(o, 'isyear');
            $scope.selectBlur();
        },
        onFocus: function () {
            this.showOptions = !this.showOptions;
        }
    };
    $scope.selectBlur = function () {
        $scope.regions.showOptions = false;
        $scope.filterYear.showOptions = false;
    }
    $scope.pageNext;
    $scope.domore;
    $scope.showFilter;
    $scope.isLogin;
    $scope.$on('$ionicView.enter', function () {
        // $scope.isLogin = false;
        $scope.getPolicyYearsList();
    });
    /* root enterBefore */
    $scope.$on('changeDistrict', function (e, data) {
        if ($scope.stateName == $state.current.name) {
            if ($scope.regionId != $scope.publicCityId) {
                $scope.getCategory();
                $scope.queryPolicyList(0);
                $ionicScrollDelegate.scrollTop();
            }
            $scope.regionId = $scope.publicCityId
        }
    });

    $scope.getPolicyYearsList = function () {
        appService.getData(urlMap.queryPolicyYearsList, {}, function (jsonDataArr) {
            $scope.filterYear.options = jsonDataArr.resultList;
        });
    }
    $scope.getCategory = function () {
        $scope.categoryCubsidies = [];
        appService.getData(urlMap.policyAll, { areaId: $scope.publicCityId }, function (jsonDataArr) {
            $scope.categoryCubsidies = jsonDataArr.resultList;
        });
    }
    $scope.changeLevel = function (id) {
        $scope.filterData.level = id;
        console.log('level: ' + id)
    }
    $scope.changesTimeSection = function (d, isyear) {
        var isCancle = $scope.filterData.timeId == d ? true : false;
        var currDate = new Date(),
            year = currDate.getFullYear(),
            month = currDate.getMonth() + 1,
            date = currDate.getDate(),
            endTime = year + '-' + month + '-' + date;
        if (isyear) {
            $scope.filterData.startTime = d + '-' + 1 + '-' + 1;
            $scope.filterData.endTime = d + '-' + 12 + '-' + 31;
            $scope.filterData.timeId = 0;
            return;
        } else {
            $scope.filterData.endTime = endTime;
            year = month - d > 0 ? year : year - 1;
            month = month - d > 0 ? month - d : month + 12 - d;
            date = date > 29 ? 29 : date;
            $scope.filterData.startTime = year + '-' + month + '-' + date;
            $scope.filterData.timeId = d;
            $scope.filterYear.value = "更多年份";
        }
        if (isCancle) {
            $scope.filterData.timeId = null;
            $scope.filterData.startTime = $scope.filterData.endTime = null;
        }
        console.log('startTime:' + $scope.filterData.startTime + ', endTime:' + $scope.filterData.endTime);
    }
    $scope.changeCategory = function (id, name) {
        $scope.filterData.categoryId = id;
        $scope.filterData.categoryName = name;
    }
    $scope.openFilter = function () {
        if (!$scope.showFilter) $scope.filterReset();
        var delegate = $ionicScrollDelegate.$getByHandle('policyFilterScroll');
        delegate.scrollTop();
        $scope.showFilter = !$scope.showFilter;
    }
    $scope.filterReset = function (forClose) {
        $scope.filterData = {
            level: $scope.level,
            timeId: $scope.time.id,
            startTime: $scope.time.startTime,
            endTime: $scope.time.endTime,
            categoryId: $scope.categoryId,
            categoryName: $scope.categoryName
        }
        if (forClose) $scope.showFilter = false;
    }
    $scope.filterSubmit = function () {
        var data = {
            level: $scope.filterData.level,
            startTime: $scope.filterData.startTime,
            endTime: $scope.filterData.endTime,
            categoryId: $scope.filterData.categoryId,
            app_flag: $scope.user && $scope.user.app_flag,
            areaID: $scope.publicCityId,
            page: 1
        }
        $scope.queryPolicyList(0, data, function () {
            $scope.categoryName = null;
            $timeout(function () {
                $scope.categoryName = $scope.filterData.categoryName;
            })
            $scope.level = $scope.filterData.level;
            $scope.time.id = $scope.filterData.timeId;
            $scope.time.startTime = $scope.filterData.startTime;
            $scope.time.endTime = $scope.filterData.endTime;
            $scope.categoryId = $scope.filterData.categoryId;
            // $scope.categoryName = $scope.filterData.categoryName;
            $scope.showFilter = false;
            var delegate = $ionicScrollDelegate.$getByHandle('policyListScroll');
            delegate.scrollTop();
        });
    }
    $scope.queryPolicyList = function (page, data, filterSubmitSuccess) {
        if (page == 0 || page == 1) { //页面刷新时为0,下拉刷新时为1
            $scope.pageNext = 1;
            page = 1;
        }
        $scope.$emit('loading', 'show');
        var data = data || {
            level: $scope.level,
            startTime: $scope.time.startTime,
            endTime: $scope.time.endTime,
            categoryId: $scope.categoryId,
            areaID: $scope.publicCityId,
            app_flag: $scope.user && $scope.user.app_flag,
            page: page
        }
        appService.getData(urlMap.queryPolicyList, data,
            function (results) {
                $scope.$emit('loading', 'hide');
                $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                console.log(page, results.resultList);
                filterSubmitSuccess && filterSubmitSuccess();
                if (page == 1) {
                    $scope.policyList = null;
                }
                var list = results.resultList,
                    length = list.length,
                    size = results.size,
                    articles = $scope.policyList || [];
                if (length < size) $scope.domore = false;
                else {
                    $timeout(function () {
                        $scope.domore = true
                    }, 200)
                }
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.picName = item.pic_name || item.picName || ($scope.pic + urlMap.defaultUpload); //缩略图
                        if (!(/http:\/\//.test(item.picName)))
                            item.picName = $scope.pic + '/' + item.picName
                        switch (item.level) {
                            case '1':
                                item.levelName = "中央"
                                break;
                            case '2':
                                item.levelName = "省部"
                                break;
                            case '3':
                                item.levelName = "地市"
                                break;
                            case '4':
                                item.levelName = "县区"
                                break;

                        }
                        articles.push(item);
                    }
                }
                $scope.policyList = articles;
            });
    }
    $scope.doRefresh = function () {
        $scope.queryPolicyList(1);
    }
    $scope.onInfinite = function () {
        if (!$scope.pageNext) return;
        $scope.queryPolicyList(++$scope.pageNext);
    }
    $scope.gotoPolicyDetail = function (id) {
        if (!$scope.isLogin) {
            $scope.$emit('loginFirst', function () {
                $state.go('policyDetail', { id: id });
                $scope.isLogin = true;
            })
        } else
            $state.go('policyDetail', { id: id });
    }
}
])