appModule.controller('myPolicySubscribeController', ['$scope', 'appService', '$state', '$timeout', '$ionicPopup', '$ionicScrollDelegate', function($scope, appService, $state, $timeout, $ionicPopup, $ionicScrollDelegate) {
    /* datas */
    $scope.stateName = $state.current.name;
    $scope.myTags = []
    $scope.policyTags = {}
    /* root enterBefore */
    $scope.$on('changeDistrict', function(e, data) {
        if ($scope.stateName == $state.current.name) {
        }
    });
    $scope.$on('$ionicView.loaded', function() {
        $scope.getMyPolicyTags($scope.getPolicyTags)
    });
    /* 订阅标签 */
    $scope.addMySubscribe = function(item, index, arr) {
        var data = {
            userId: $scope.user.id,
            policyLabelId: item.policyLabelId
        }
        appService.postData(urlMap.policyLabelUser, data,
            function(results) {
                if (results.code == 200) {
                    arr.splice(index, 1)
                    myItem = JSON.parse(JSON.stringify(item))
                    myItem.id = results.data.id
                    $scope.myTags.push(myItem)
                } else {
                    var msg = (results && results.msg) || '订阅失败, 请联系管理员'
                    $scope.alert(msg)
                }
            });
    }
    /* 移除订阅标签 */
    $scope.removeMySubscribe = function(item, index) {
        var data = {
            id: item.id,
        }
        appService.deleteData(urlMap.policyLabelUser, data,
            function(results) {
                if (results.code == 200) {
                    $scope.myTags.splice(index, 1)
                    if (item.type == 1) $scope.policyTags.geren && $scope.policyTags.geren.push(item);
                    if (item.type == 2) $scope.policyTags.qiye && $scope.policyTags.qiye.push(item);
                    $timeout(function() {
                        $ionicScrollDelegate.resize();
                    })
                } else {
                    var msg = (results && results.msg) || '修改订阅失败, 请联系管理员'
                    $scope.alert(msg)
                }
            });
    }
    /* 政策标签 */
    $scope.getPolicyTags = function() {
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.policyLabel, { size: 999 },
            function(results) {
                var list = results.data,
                    length = list.length,
                    articles = {
                        geren: [],
                        qiye: []
                    };
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        var item = list[i];
                        item.policyLabelId = item.id
                        var subed = false
                        for (var j = 0; j < $scope.myTags.length; j++) {
                            if (item.id == $scope.myTags[j].policyLabelId) subed = true
                        }
                        if (!subed) {
                            if (item.type == 1) articles.geren.push(item);
                            if (item.type == 2) articles.qiye.push(item);
                        }
                    }
                }
                $scope.policyTags = articles
                $timeout(function() {
                    $scope.$emit('loading', 'hide');
                    $ionicScrollDelegate.resize();
                })
            });
    }
    /* 我的政策标签 */
    $scope.getMyPolicyTags = function(callback) {
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.policyLabelUser, { userId: $scope.user.id },
            function(results) {
                $scope.myTags = results.data
                callback && callback()
            });
    }
    $scope.alert = function(info) {
        $ionicPopup.alert({
            title: '提示框',
            template: info
        });
    }

}
])