appModule.controller('policyEliteDetailController', ['$scope', '$stateParams', 'appService', '$timeout', '$sce', function($scope, $stateParams, appService, $timeout, $sce) {
    $scope.typeId = $stateParams.id
    $scope.title = $stateParams.title
    $scope.$on('$ionicView.loaded', function() {
        $scope.getPolicyDetail(0)
    });
    $scope.getPolicyDetail = function(page) {
        if (page < 1) {
            $scope.pageNext = 0;
        }
        var data = {
            page: page,
            typeId: $scope.typeId,
            state: 1,
        }
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.policyGanhuo, data, function(results) {
            $scope.$emit('loading', 'hide');
            $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
            $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
            if (page < 1) {
                $scope.policyList = null;
            }
            var list = results.data,
                length = list.length,
                size = results.size,
                articles = $scope.policyList || [];
            if (length < size) $scope.domore = false;
            else {
                $timeout(function() {
                    $scope.domore = true
                }, 200)
            }
            if (length > 0) {
                for (var i = 0; i < length; i++) {
                    var item = list[i];
                    item.supportMode = item.supportMode && $sce.trustAsHtml(item.supportMode);
                    item.policyzx = formatPhone(item.policyzx);
                    articles.push(item);
                }
            }
            $scope.policyList = articles
        })
    }
    function formatPhone(str) {
        if(!str) return str
        console.log(str);
        var html = '',
            mobileReg = /^(\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+$/,
            telhtml,
            matched
            ;
        telhtml = str.replace(/(电话[:：]?\s*)?(((\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+)|(\d{3,}))/g, function(word) {
            if (/(电话[:：]?\s?)/.test(word)) {
                matched = true;
                return word.replace(/\d.*\d$/, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (mobileReg.test(word)) {
                matched = true;
                return word.replace(mobileReg, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (/^((953\d{2})|(955\d{2})|(123\d{2})|(400\d{7}))$/.test(word)) {
                matched = true;
                return word.replace(/\d.*\d$/, '<a class="f16" href="tel:$&">$&</a>');
            }
            if (/^\d{7,}$/.test(word)) {
                matched = true;
                return '<a class="f16" href="tel:' + word + '">' + word + '</a>';
            }
            return word;
        });
        if (!matched && /\d+/.test(str)) telhtml = '<a href="tel:' + str + '">' + str + '</a>';
        telhtml = telhtml.replace(/\w{1,2}\s{0,1}\u3001/g, 'splitflag$&'); //1、
        var list = telhtml.split('splitflag'); //1、
        for (var i = 0; i < list.length; i++) {
            if (!list[i]) continue;
            html += '<p class="mb8">' + list[i] + '</p>';
        }
        return html;
    }
    $scope.doRefresh = function() {
        $scope.getPolicyDetail(0);
    }
    $scope.onInfinite = function() {
        $scope.getPolicyDetail(++$scope.pageNext);
    }
}]);