appModule.controller('searchController', ['$scope', '$stateParams', 'appService', '$state', '$timeout', '$ionicScrollDelegate', '$document', '$sce', '$ionicPopup', function ($scope, $stateParams, appService, $state, $timeout, $ionicScrollDelegate, $document, $sce, $ionicPopup) {
    //data
    $scope.stateName = $state.current.name;
    $scope.userId = $scope.user && $scope.user.id;
    $scope.searchPlaceholder = "请输入关键字";
    $scope.anchorStates;
    $scope.searchKey = $stateParams.searchKey || 'all';
    $scope.allArrays;
    // $scope.showModulesId; //显示的模块
    $scope.hasListModulesSearchKey; //有文章的模块
    $scope.queryDoneModulesId = []; //获取过搜索结果的模块
    $scope.searchTypeLast;
    $scope.keywordsLast;
    $scope.distName;
    $scope.keywords = "";
    $scope.showResult;
    $scope.history;
    $scope.pageNext = []; //页面初始化前为 0 初始化后为1 加载更多时累加
    $scope.domore = [];
    $scope.showNumber = 10;
    $scope.showNumberSelf = 20;
    $scope.clearComplete = 1;
    $scope.hotKeywords = [];
    $scope.hotWordsPage = 0;
    $scope.keywordsHistory;
    $scope.isEmpty;
    /* root enterBefore */
    $scope.$on('changeDistrict', function (e, data) {
        if ($scope.stateName == $state.current.name) {
            if (!!$scope.showResult) $scope.searchSubmit();
        }
    });
    $scope.$on('$ionicView.enter', function () {
        var json = JSON.parse(window.localStorage.getItem('perpetual.searchKeywordsHistory'));
        $scope.keywordsHistory = json && json.value || [];
        $scope.queryHotKeywords();
    });
    $scope.$watch('publicCityName', function (n) {
        $scope.distName = $scope.publicCityName || n;
        $scope.anchorStates = {
            all: { id: '-1', name: '全部' },
            policy: { id: 'policy', name: '政策法规', state: 'policyDetail' },
            tjcompany: { id: 'tjcompany', name:  $scope.curCityName + '推介', state: 'tjCompanyDetail' },
            hometown: { id: 'hometown', name: '大美' +  $scope.curCityName, state: 'hometownDetail' },
            bnservice: { id: 'bnservice', name: '便民服务', state: 'convenienceSDetail' },
            leavemessage: { id: 'leavemessage', name: '咨询投诉', state: 'leaveMsgDetail' },
            detailec: { id: 'detailec', name: '精品推荐', state: 'newsDetail' },
            commodity: { id: 'commodity', name: '扶贫商品', state: 'dealDetail', isLoginFirst: true },
            multimedia: { id: 'multimedia', name: '视频图片', isLoginFirst: true, state: 'entertainDetail' },
            guide: { id: 'guide', name: '用户指南', state: 'comArticle', params: { articleQuery: 'queryGuideArticle' } },
            key: ['all', 'policy', 'tjcompany', 'hometown', 'bnservice', 'leavemessage', 'detailec', 'commodity', 'multimedia', 'guide']
        };
    });
    $scope.$watch('keywords', function (nkey) {
        $scope.inputError = !(/^[\u4e00-\u9fa5\a-zA-Z0-9\s]{0,20}$/.test(nkey));
    });
    $scope.$watch('showResult', function (show, o) {
        var delegate = $ionicScrollDelegate.$getByHandle('resultTypeTabs');
        if (show) {
            $scope.history = 'result';
            $timeout(function () {
                //搜索模块滚动到对应锚点
                var hash = $scope.searchKey != null ? 'type' + $scope.searchKey : null;
                var elm = hash && $document[0].getElementById(hash);
                var scrollLeft = elm.offsetLeft - (elm.offsetParent.offsetWidth / 2 - elm.offsetWidth / 2);
                delegate && delegate.scrollTo(scrollLeft, null, true);
            }, 100);
            return;
        }
        delegate && delegate.scrollTop();
    });
    $scope.$watch('searchKey', function (key) {
        if ($scope.showResult) {
            $ionicScrollDelegate.$getByHandle('resultContent').scrollTop();
            var moduleId = $scope.anchorStates[key].id;
            $scope.isEmpty = ($scope.hasListModulesSearchKey.indexOf(key) < 0 && key != 'all') ? true : false;
            if ($scope.queryDoneModulesId.indexOf(moduleId) > -1) {
                return
            };
            if (moduleId == -1) {
                if ($scope.queryDoneModulesId.length < $scope.anchorStates.key.length - 1) {
                    $scope.querySearchResult();
                }
                return;
            }
            $scope.querySearchResult(null, moduleId);
            return;
        }
        if (!$scope.keywords.trim()) return
        $scope.searchSubmit();
    });
    //method
    $scope.navScrollTop = function () {
        var delegate = $ionicScrollDelegate.$getByHandle('resultTypeTabs');
        delegate && delegate.scrollTop(300);
    }
    $scope.navScrollBottom = function () {
        var delegate = $ionicScrollDelegate.$getByHandle('resultTypeTabs');
        delegate && delegate.scrollBottom(300);
    }
    $scope.gotoSelf = function (id) {
        $scope.searchKey = id;
        //搜索模块滚动到对应锚点
        var hash = 'type' + id;
        var elm = hash && $document[0].getElementById(hash);
        var scrollLeft = elm.offsetLeft - (elm.offsetParent.offsetWidth / 2 - elm.offsetWidth / 2);
        var delegate = $ionicScrollDelegate.$getByHandle('resultTypeTabs');
        delegate && delegate.scrollTo(scrollLeft, null, true);
    }
    $scope.clearKeywordsHistory = function () {
        $ionicPopup.confirm({
            title: '<span>确定清空全部历史记录?</span>',
            // template: '',
            okText: '确定',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                $scope.keywordsHistory = [];
                window.localStorage.removeItem('perpetual.searchKeywordsHistory')
            }
        });
    }
    $scope.queryHotKeywords = function () {
        if ($scope.hotWordsPage != 'all')
            appService.getData(urlMap.queryHotKeywords, { page: (++$scope.hotWordsPage) }, function (result) {
                if (!result.keywordsName) {
                    $scope.hotWordsPage = 'all';
                    var tar = $scope.hotKeywords.toString().split(',');
                    $scope.hotKeywords = tar.concat(tar.splice(0, 10));
                    return;
                }
                var tar = $scope.hotKeywords.toString().split(',');
                $scope.hotKeywords = result.keywordsName.concat(tar);
                console.log($scope.hotKeywords);
            });
        else {
            var tar = $scope.hotKeywords.toString().split(',');
            $scope.hotKeywords = tar.concat(tar.splice(0, 10));

        }
    }
    $scope.clearKeywords = function () {
        $scope.keywords = '';
    }
    $scope.cancle = function () {
        if ($scope.history && !$scope.showResult) {
            $scope.history = null;
            $scope.showResult = true;
            $scope.searchKey = $scope.searchTypeLast;
            $scope.keywords = $scope.keywordsLast;
            return;
        }
        $scope.viewGoback(); console.log('goback');
        return;
    }
    $scope.searchClear = function (e) {
        $scope.keywords = '';
        var ele = e.target.previousElementSibling.getElementsByTagName('input')[0];
        $scope.clearComplete = 0;
        $timeout(function () {
            ele.focus();
            $scope.clearComplete = 1;
        }, 0)
    }
    $scope.searchFocus = function () {
        $scope.searchOnFocus = true;
        $scope.showResult = false;
        $scope.searchTypeLast = $scope.searchKey;
        $scope.keywordsLast = $scope.keywords != '' ? $scope.keywords : $scope.keywordsLast;
        $scope.cancelChangeDist();
    }
    $scope.searchBlur = function () {
        if ($scope.clearComplete)
            $scope.searchOnFocus = false;
    }
    $scope.changeSearchKey = function (key) {
        $scope.searchKey = key;
    }
    $scope.resultTypeOnScroll = function () {
        /* var delegate = $ionicScrollDelegate.$getByHandle('resultTypeTabs');
        var left = delegate.getScrollPosition().left;
        if(left <1) {$scope.toLeft = true;$scope.toRight = false;}
        else if() */
    }
    $scope.selectKeywordsAndSubmit = function (words, isHistory) {
        $scope.keywords = words;
        $scope.searchSubmit();
    }
    $scope.searchKeyup = function (e) {
        var keycode = window.event ? e.keyCode : e.which;
        //回车事件
        if (keycode == 13) {
            if (!$scope.keywords.trim()) return
            $scope.searchSubmit();
        }
    }
    $scope.searchSubmit = function (page) {
        var matchArr = $scope.keywords.match(/[\u4e00-\u9fa5\a-zA-Z0-9\s]/g) || [], testBool = /^[\u4e00-\u9fa5\a-zA-Z0-9\s]*$/g.test($scope.keywords), matchStr = '', template = '';
        for (var i = 0; i < matchArr.length; i++) {
            matchStr += matchArr[i];
            if (matchStr.length > 20) {
                matchStr = matchStr.slice(0, 19);
                template = '您输入的关键字过长, 建议您搜索：“' + matchStr + '”'
                break;
            }
        }
        matchStr = matchStr ? matchStr : $scope.hotKeywords[0] || '政策';
        template = template.length ? template : !testBool ? '您输入的关键字含有规定外的字符,建议您搜索：“' + matchStr + '”' : template;
        $scope.keywords = matchStr;
        if (template.length)
            $ionicPopup.confirm({
                title: '<strong>提示</strong>',
                template: template,
                okText: '<span class="f14">接受搜索建议</span>',
                cancelText: '<span class="f14">取消</span>'
            }).then(function (res) {
                $scope.keywords = matchStr;
                if (res) {
                    $scope.querySearchResult(page);
                }
            });
        else $scope.querySearchResult(page);
    }
    $scope.watchKeywordsHistory = function () {
        for (var i = 0; i < $scope.keywordsHistory.length; i++) {
            if ($scope.keywordsHistory[i] == $scope.keywords) {
                $scope.keywordsHistory.splice(i, 1);
                break;
            }
        }
        $scope.keywordsHistory.unshift($scope.keywords);
        var hisArr = $scope.keywordsHistory;
        if (!hisArr.length) return;
        if (hisArr.length > 10) hisArr.pop();
        var str = JSON.stringify({ value: hisArr });
        window.localStorage.setItem('perpetual.searchKeywordsHistory', str);
        console.log(window.localStorage.getItem('perpetual.searchKeywordsHistory'))
    }
    $scope.querySearchResult = function (page, moduleId, index) {
        var isNewKeywords = $scope.lastKeywords == $scope.keywords ? false : !!($scope.lastKeywords = $scope.keywords);
        if (isNewKeywords || !moduleId) {
            $scope.watchKeywordsHistory();
            $scope.allArrays = [];
            $scope.queryDoneModulesId = [];
            $scope.hasListModulesSearchKey = null;
            $scope.isEmpty = null;
        }
        $scope.showResult = true;
        document.getElementById('searchKeywords').blur();
        if (!index) $ionicScrollDelegate.$getByHandle('resultContent').scrollTop();
        var data = {
            areaId: $scope.publicCityId || $scope.distId || $scope.cityId,
            keywordsName: $scope.keywords,
            searchModuleId: moduleId || $scope.anchorStates[$scope.searchKey].id,
        };
        $scope.$emit('loading', 'show');
        appService.getData(urlMap.search, data, function (results) {
            $scope.$emit('loading', 'hide');
            console.log(results);
            $scope.allArrays = $scope.allArrays || [];
            $scope.hasListModulesSearchKey = $scope.hasListModulesSearchKey || [];
            var onePageResultSum = 0;
            for (var i = 0; i < results.length; i++) {
                var articles = results[i].resultList, length = articles && articles.length || 0;
                onePageResultSum += length, curModuleId = results[i].searchModuleId;
                $scope.queryDoneModulesId.push(curModuleId);
                if (length) {
                    var searchKey = curModuleId == -1 ? 'all' : curModuleId,
                        searchType = $scope.anchorStates[searchKey],
                        stateStr = searchType && searchType.state,
                        stateParams = searchType && searchType.params,
                        isLoginFirst = searchType && searchType.isLoginFirst;
                    for (var j = 0; j < articles.length; j++) {
                        var article = articles[j];
                        var title = article && article.title,
                            params;
                        try {
                            params = Object.assign(stateParams, { id: article.id })
                        } catch (e) {
                            params = $.extend(stateParams, { id: article.id })
                        }
                        article.state = { name: stateStr, params: params };
                        article = $scope.individualityForModuleArticle(article, searchKey);
                        if (isLoginFirst) article.isLoginFirst = true;
                        if (!title) return;
                        article.title = $sce.trustAsHtml(title);
                    }
                    $scope.hasListModulesSearchKey.push(searchKey);
                    $scope.allArrays.push(results[i]);
                }
            }
            if (onePageResultSum > 20) $scope.showNumber = 5;
            console.log($scope.queryDoneModulesId, $scope.hasListModulesSearchKey);
        });
    }
    $scope.individualityForModuleArticle = function (article, searchKey) {
        /* 图片绝对路径统一处理*/
        var picDomain = article.picType == 2 ? $scope.vio : $scope.pic;
        if (article.picName) {
            var has_src = article.picName.indexOf('_src') < 0 ? false : true;
            if (has_src) {
                // var regArr = article.picName.match(/(http:\/\/){1}[^\"\']+/);
                var url = article.picName.split('_src');
                url = url && url[0];
                article.picName = url.replace('"', '').replace(/\s*$/g, '');
                // article.picName = regArr && regArr[0];
            }
            if (!(/http:\/\//.test(article.picName))) article.picName = picDomain + '/' + article.picName
        }
        else article.picName = picDomain + $scope.defaultUpload;

        switch (searchKey) {
            case 'multimedia':
                var _userId = article.userId, _type = _userId == $scope.userId ? 1 : article.type;
                article.state.params = article.state.params ||{};
                article.state.params.type = _type;
                article.state.params.userId = _userId;
                break;
            case 'leaveMsgDetail':
                var _readType = article.readType;
                article.state.params.readType = _readType;
                break;
        }
        return article;
    }
    $scope.showMoreForModule = function (index, moduleId, self) {
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        console.log(index, ':', moduleId);
        var currentModule = $scope.allArrays[index];
        if (self) {
            var showNumberSelf = currentModule.showNumberSelf < currentModule.showNumber ? currentModule.showNumber : (currentModule.showNumberSelf || $scope.showNumberSelf);
            $scope.allArrays[index].showNumberSelf = showNumberSelf + $scope.showNumberSelf;
            return;
        }
        var showNumber = currentModule.showNumber < $scope.showNumber ? $scope.showNumber : (currentModule.showNumber || $scope.showNumber);
        $scope.allArrays[index].showNumber = showNumber + $scope.showNumberSelf;
        $ionicScrollDelegate.resize();
    }
    $scope.onInfinite = function (i) {
        // if ($scope.searchKey == 'all') return;
        // console.log(i)
        $scope.showMoreForModule(i, $scope.searchKey, true);
    }
    $scope.articleDetail = function (article, searchModuleName) {
        var state = article.state;
        if (!state) return;
        var goState = function () {
            $state.go(state.name, state.params);
        }
        if (article.isLoginFirst) {
            var option = {
                title: '请先登录',
                template: '您登陆后才可以浏览' + '“<span class="green">' + searchModuleName + '</span>”版块的内容',
                okText: '去登录',
                cancelText: '返回'
            };
            $scope.$emit('loginFirst', goState, null, option);
            return;
        }
        goState();
    }
}
])