appModule.controller('ttbHometownController', ['$scope', 'appService', '$ionicScrollDelegate', '$state', '$stateParams', '$timeout',
  function($scope, appService, $ionicScrollDelegate, $state, $stateParams, $timeout) {
    //data
    $scope.scopeId = $scope.$id
    $scope.stateName = $state.current.name;
    $scope.tabIndex = $stateParams.initTab || 1;
    $scope.hometownTypeId = $stateParams.hometownTypeId;
    $scope.searchKey;
    $scope.pageNext = 0; //页面初始化前为 0 初始化后为1 加载更多时累加
    $scope.domore = true;
    $scope.companyTypeList; //企业类型列表
    $scope.recommendList; // 推荐大美
    $scope.hometownList; //非推荐大美
    $scope.cRegion = '2205' // 当前选择地区
    $scope.cRegionName = $scope.curCityName
    $scope.cMainType // 当前选择主类型
    $scope.areaId;
    $scope.filterRegions = ttbRegion
    var delegateWrap = $ionicScrollDelegate.$getByHandle('ttbHometownScroll');
    //加载
    $scope.$on('$ionicView.loaded', function() {
      $scope.getMainType();
      $timeout(function() {
        $scope.initFilterSwiper1()
      })
    });
    $scope.$on('$ionicView.unloaded', function() {
      $scope.regionSwiper && $scope.regionSwiper.destroy(true, true);
      $scope.mainTypeSwiper && $scope.mainTypeSwiper.destroy(true, true);
      $scope.subTypeSwiper && $scope.subTypeSwiper.destroy(true, true);
    });
    //广播 - 地域变换
    $scope.$on('changeDistrict', function(e, data) {
      if ($scope.stateName == $state.current.name) {
        if ($scope.areaId != $scope.publicCityId) {
          $scope.companyTypeList = null;
          $ionicScrollDelegate.scrollTop();
        }
        $scope.areaId = $scope.publicCityId;
      }
    });
    /* watch */
    $scope.$watch('tabIndex', function(n, o) {
      $scope.searchKey = n == 0 ? 'tjcompany' : 'hometown';
      $scope.pageTitle = n == 0 ? '推介企业' : '大美' + $scope.curCityName;
      if (n == o) return;
      if (n == 0) {
        if (!$scope.companyTypeList) $scope.getCompanyType()
      }
      $ionicScrollDelegate.scrollTop();
    });
    /* filter */
    $scope.initFilterSwiper1 = function() {
      $scope.regionSwiper && $scope.regionSwiper.destroy(true, true);
      var id = '#htFilterRegionSwiper' + $scope.scopeId
      $scope.regionSwiper = new Swiper(id, {
        slidesPerView: 'auto',
        resistanceRatio: 0
      })
    }
    $scope.initFilterSwiper2 = function() {
      $scope.mainTypeSwiper && $scope.mainTypeSwiper.destroy(true, true);
      $timeout(function() {
        var id = '#htFilterMainTypeSwiper' + $scope.scopeId
        $scope.mainTypeSwiper = new Swiper(id, {
          slidesPerView: 'auto',
          resistanceRatio: 0
        })
      })
    }
    $scope.initFilterSwiper3 = function() {
      $scope.subTypeSwiper && $scope.subTypeSwiper.destroy(true, true);
      $timeout(function() {
        var id = '#htFilterSubTypeSwiper' + $scope.scopeId
        $scope.subTypeSwiper = new Swiper(id, {
          slidesPerView: 'auto',
          resistanceRatio: 0
        })
      })
    }
    $scope.selectRegion = function(item) {
      $scope.cRegion = item.code
      $scope.cRegionName = item.name
    }
    $scope.selectMainType = function(index) {
      $scope.cMainTypeIndex = index
    }
    $scope.selectSubType = function(id) {
      $scope.cSubType = id
      $scope.initPage()
    }
    // 四县三区
    $scope.getGroupByRegion = function() {
      var data = {
        areaId: $scope.cRegion,
        hometownId: $scope.cSubType || $scope.cMainType,
        page: 0,
        size: 999
      }
      appService.getData(urlMap.hometownTTB, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          var list = result.data
          var hasList = false
          $scope.groupLength = 0
          list.forEach(function(group) {
            if(group.list.length) hasList = true
          })
          if(hasList) $scope.groupLength = 1
          $scope.ttbHometown = list
          $scope.domore = false
        });
    }
    // 红色景点 topHome
    $scope.queryRedScenic = function() {
      var data = {
        areaId: $scope.cRegion,
        topHome: 1,
        hometownId: $scope.cMainType,
        page: 0,
        size: 999
      }
      appService.getData(urlMap.getHometown, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          var list = result.data
          list.forEach(function(article) {
            var content = article.content_rt || article.content;//找到<img标签
            var reg = /<img[^>]*>/gi;
            var images = content && content.match(reg);
            if (images) {
              var regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = images[0].match(regSrc)[1]
              article.picName = article.picName || srcStr
            }
            article.summary = article.titleEn
            if (!article.titleEn) {
              article.summary = $('<div>' + article.contentRt + '</div>').text();
              article.summary = article.summary.replace(/\s+/g, '').slice(0, 60);
            }
          })
          $scope.redScenic = list
        });
    }
    // 推荐景点
    $scope.queryRecommendList = function() {
      var data = {
        areaId: $scope.cRegion,
        isTop: 1,
        hometownId: $scope.cSubType || $scope.cMainType,
        page: 0,
        size: 999
      }
      appService.getData(urlMap.getHometown, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          var list = result.data
          list.forEach(function(article) {
            var content = article.content_rt || article.content;//找到<img标签
            var reg = /<img[^>]*>/gi;
            var images = content && content.match(reg);
            if (images) {
              var regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = images[0].match(regSrc)[1]
              article.picName = article.picName || srcStr
            }
            article.summary = article.titleEn
            if (!article.titleEn) {
              article.summary = $('<div>' + article.contentRt + '</div>').text();
              article.summary = article.summary.replace(/\s+/g, '').slice(0, 60);
            }
          })
          $scope.recommendList = list
        });
    }
    // 特色玩法
    $scope.querySpecial = function() {
      var data = {
        regionId: $scope.publicCityId,
        page: 0,
        size: 10
      }
      appService.getData(urlMap.hometownSpecial, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          var list = result.data
          /* list.forEach(function(article) {
            var content = article.content_rt || article.content;//找到<img标签
            var reg = /<img[^>]*>/gi;
            var images = content && content.match(reg);
            if (images) {
              var regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = images[0].match(regSrc)[1]
              article.picName = article.picName || srcStr
            }
            article.summary = article.titleEn
            if (!article.titleEn) {
              article.summary = $('<div>' + article.contentRt + '</div>').text();
              article.summary = article.summary.replace(/\s+/g, '').slice(0, 60);
            }
          }) */
          $scope.specialList = list
        });
    }
    // 更多推介
    $scope.queryHometownList = function(page) {
      if (page < 1) $scope.hometownList = null
      var data = {
        areaId: $scope.cRegion,
        isTop: 0,
        hometownId: $scope.cSubType || $scope.cMainType,
        page: page
      }
      appService.getData(urlMap.getHometown, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          $scope.hometownList = $scope.hometownList || []
          var list = result.data, length = list.length, size = result.size
          if (length < size) $scope.domore = false
          $scope.hometownList = $scope.hometownList.concat(list)
        });
    }
    //企业分类
    $scope.getCompanyType = function() {
      $scope.$emit('loading', 'show');
      appService.getData(urlMap.queryTJCompanyType, { areaId: $scope.publicCityId },
        function(tjCompanyItems) {
          $scope.$emit('loading', 'hide');
          $scope.companyTypeList = tjCompanyItems.resultList;
          $timeout(function() {
            $ionicScrollDelegate.resize();
          })
          console.log($scope.companyTypeList);
        });
    }
    // 6大主分类
    $scope.getMainType = function() {
      appService.getData(urlMap.hometownTypeAll, {
        pid: 0
      },
        function(hometownItems) {
          $scope.filterMainType = hometownItems.data;
          $scope.initFilterSwiper2()
          // $scope.cMainType = $scope.filterMainType[0].categoryId;
          $scope.cMainTypeIndex = 0;
          $scope.filterMainType.forEach(function(mt, i) {
            if (mt.id == $scope.hometownTypeId)
              $scope.cMainTypeIndex = i
          })
        });
    }
    /* 页面重置 */
    $scope.initPage = function() {
      $scope.recommendList = null
      $scope.hometownList = null
      $scope.groupLength = null
      $scope.ttbHometown = null
      $scope.redScenic = null
      $scope.pageNext = 0
      $scope.domore = false
      delegateWrap.resize()
      $timeout(function() {
        $scope.domore = true
      }, 100)
    }
    // 更新查询条件 - 地区
    $scope.$watch('cRegion', function(n, o) {
      /* if (n == '2205') {
      } else {
      } */
      $scope.initPage()
    })
    // 更新查询条件 - 父子分类
    $scope.$watch('cMainTypeIndex', function(n, o) {
      if (n == undefined) return
      $scope.cMainType = $scope.filterMainType[n] && $scope.filterMainType[n].id;
      $scope.filterSubType = $scope.filterMainType[n].subMenuList
      $scope.cSubType = null
      // $scope.cSubType = $scope.filterSubType[0] && $scope.filterSubType[0].id
      $scope.initFilterSwiper3()
      // console.log($scope.cMainType)
      $scope.initPage()
    })
    //下拉刷新
    /* $scope.doRefresh = function(tabindex) {
    } */
    //上拉加载
    $scope.onInfinite = function() {
      if (!$scope.cMainType || !($scope.cMainTypeIndex > -1)) {
        $scope.$broadcast('scroll.infiniteScrollComplete');
        return
      }
      if ($scope.cRegion == '2205') {
        if ($scope.cMainType == '5' && !$scope.cSubType) { // 游
          if (!$scope.redScenic) { // 红色景点
            $scope.queryRedScenic();
            return
          }
        }
        // hometownTTB
        $scope.getGroupByRegion()
        return
      }
      if (!$scope.recommendList) {
        $scope.queryRecommendList();
        return
      }
      $scope.queryHometownList($scope.pageNext++)
    }
    $scope.changeTab = function(i) {
      $scope.tabIndex = i;
    }

  }
])
