appModule.controller('ttbYCListController', ['$scope', '$state', 'appService', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$timeout', '$cordovaToast',
  function($scope, $state, appService, $stateParams, $ionicPopup, $ionicScrollDelegate, $timeout, $cordovaToast) {
    console.log('ttbYCListController')
    $scope.thingType = $stateParams.thingType
    $scope.pageTitle = $scope.thingType.name
    $scope.list = null
    $scope.nextPage = 0
    $scope.showDetail = false;
    $scope.tab = 'nomal'
    $scope.form = {
      searchIdCard: null
    }
    $rootScopeViewGoback = $scope.viewGoback;
    //data
    $scope.stateName = $state.current.name;
    //加载
    $scope.$on('$ionicView.loaded', function() {
      /*  $scope.$emit('loginFirst', function() {
         $scope.domore = true
       }, $scope.viewGoback) */
    });
    $scope.$on('$ionicView.beforeEnter', function() {
      $scope.current && ($scope.current.correction = $stateParams.complete)
      $scope.$emit('loginFirst', function() {
        $scope.showDetail = false;
        $scope.tab = 'nomal'
        $scope.clearSearch()
      }, $scope.viewGoback)
    });
    $scope.searchKeyup = function(e) {
      var keycode = window.event ? e.keyCode : e.which;
      //回车事件
      if (keycode == 13) {
        if (!$scope.form.searchIdCard.trim()) return
        $scope.init()
      }
    }
    $scope.clearSearch = function() {
      $scope.form.searchIdCard = null
      $scope.init()
    }
    $scope.init = function() {
      $scope.list = null
      $scope.nextPage = 0
      $scope.domore = false
      $ionicScrollDelegate.resize()
      $timeout(function() {
        $scope.domore = true
      }, 100)
    }
    $scope.normalList = function() {
      $scope.showDetail = false; $scope.current = null
      $scope.tab = 'nomal'
      $scope.init()
    }
    /* 待办 */
    $scope.backlog = function() {
      $scope.showDetail = false; $scope.current = null
      $scope.tab = 'backlog'
      $scope.init()
    }
    $scope.sendMsg = function() {
      $scope.msgForm = {
        name: $scope.current.name,
        type: $scope.current.type,
        phone: $scope.current.phone,
        id: $scope.current.id
      }
      if ($scope.current.isMail) {
        $ionicPopup.show({
          template: '<div class="list">' +
            '<label class="item item-input item-stacked-label">' +
            '<span class="input-label">快递公司</span>' +
            '<input type="text" ng-model="msgForm.mailType">' +
            '</label>' +
            '<label class="item item-input item-stacked-label">' +
            '<span class="input-label">快递单号</span>' +
            '<input type="text" ng-model="msgForm.mailCode">' +
            '</label>' +
            '</div> ',
          title: '请填写邮寄信息',
          subTitle: '申请人选择的结果告知方式为“邮寄”，请填写邮寄信息并点击“告知”按钮',
          scope: $scope,
          buttons: [
            { text: '取消' },
            {
              text: '<b>告知</b>',
              type: 'button-positive',
              onTap: function(e) {
                if (!$scope.msgForm.mailType) {
                  $cordovaToast.showShortCenter("请填写快递名称！");
                  e.preventDefault();
                  return
                }
                if (!$scope.msgForm.mailCode) {
                  $cordovaToast.showShortCenter("请填写快递名单号！");
                  e.preventDefault();
                  return
                } else {
                  $scope.postMsg()
                }
              }
            },
          ]
        });
      }
      else {
        $ionicPopup.show({
          title: '告知申请人',
          subTitle: '申请人选择的结果告知方式为“自取”，点击“告知”按钮向申请人发送告知短信',
          scope: $scope,
          buttons: [
            { text: '取消' },
            {
              text: '<b>告知</b>',
              type: 'button-positive',
              onTap: function(e) {
                $scope.postMsg()
              }
            },
          ]
        });
      }
    }
    $scope.postMsg = function() {
      if ($scope.current.isMail) {
        var formData = new FormData();
        for (key in $scope.msgForm) {
          formData.append(key, $scope.msgForm[key]);
        }
        $.ajax({
          type: "POST",
          url: urlMap.ttbOPPostMail,
          data: formData,
          cache: false,
          processData: false,
          contentType: false,
        }).success(function(result) {
          console.log(result.msg)
          if (result.code == 0) {
            $scope.$apply(function() {
              $scope.current.msgSended = true
              $scope.alert('快递信息已通过短信形式告知申请人，当前申请已办结。', '已办结', function() {
                $scope.viewGoback()
                $scope.clearSearch()
              })
            })
          } else {
            $scope.alert(result.msg)
          }
        }).error(function(err) {
          $scope.alert(err)
        });
      }
      else {
        var formData = new FormData();
        for (key in $scope.msgForm) {
          formData.append(key, $scope.msgForm[key]);
        }
        $.ajax({
          type: "POST",
          url: urlMap.ttbOPPostShortMail,
          data: formData,
          cache: false,
          processData: false,
          contentType: false,
        }).success(function(result) {
          console.log(result.msg)
          if (result.code == 0) {
            $scope.$apply(function() {
              $scope.current.msgSended = true
              $scope.alert('办结信息已通过短信形式告知申请人，当前申请已办结。', '已办结', function() {
                $scope.viewGoback()
                $scope.clearSearch()
              })
            })
          } else {
            $scope.alert(result.msg)
          }
        }).error(function(err) {
          $scope.alert(err)
        });
      }
    }
    $scope.onInfinite = function() {
      if ($scope.tab == 'nomal') $scope.getList(++$scope.nextPage)
      if ($scope.tab == 'backlog') $scope.backlogList(++$scope.nextPage)
    }
    $scope.getList = function(page) {
      var data = {
        limit: 10,
        userId: $scope.user.id,
        type: $scope.thingType.id,
        page: page
      }
      if ($scope.form.searchIdCard) {
        delete data.userId
        data.idCard = $scope.form.searchIdCard
      }
      appService.getData(urlMap.ttbYCget, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          if (page < 2) $scope.list = []
          var list = result.data.list, length = list.length, size = 10
            ;
          if (length != size) $scope.domore = false;
          else $scope.domore = true;
          if (length > 0) {
            for (var i = 0; i < length; i++) {
              var item = list[i]
              item.createTime = (item.createTime + '').slice(0, 19)
              // 是否关闭 0.未关闭 1.待办 2.数据异常 3.关闭
              switch (item.isClose) {
                case 0:
                  item.closeName = '未关闭'
                  break;
                case 1:
                  item.closeName = '待办'
                  break;
                case 2:
                  item.closeName = '数据异常'
                  break;
                case 3:
                  item.closeName = '办结已告知'
                  break;
              }
              item.progressList.forEach(function(step) {
                switch (step.progressState) {
                  case 3:
                    step.stateName = '数据异常'
                    item.cStep = item.cStep || {
                      deptId: step.deptId,
                      name: step.deptName,
                      stateName: step.stateName
                    }
                    break
                  case 1:
                    step.stateName = '进行中'
                    item.cStep = item.cStep || {
                      deptId: step.deptId,
                      name: step.deptName,
                      stateName: step.stateName
                    }
                    break
                  case 0:
                    step.stateName = '未开始'
                    item.cStep = item.cStep || {
                      deptId: step.deptId,
                      name: step.deptName,
                      stateName: step.stateName
                    }
                    break
                  case 2:
                    step.stateName = '已完成'
                    break
                }
              })
              if (!item.cStep) {
                var last = item.progressList[item.progressList.length - 1]
                last && (item.cStep = {
                  deptId: last.deptId,
                  name: last.deptName,
                  stateName: last.stateName
                })
              }
              if (item.cStep && $scope.user.ttbRole && item.cStep.deptId == $scope.user.ttbRole.permission) item.myStep = true
            }
          }
          $scope.list = $scope.list.concat(list);
        });
    }
    $scope.backlogList = function(page) {
      var data = {
        limit: 10,
        userId: $scope.user.id,
        type: $scope.thingType.id,
        page: page
      }
      if ($scope.form.searchIdCard) {
        delete data.userId
        data.idCard = $scope.form.searchIdCard
      }
      appService.getData(urlMap.ttbYCgetDb, data,
        function(result) {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $ionicScrollDelegate.resize();
          })
          var list = result.data.list, length = list.length, size = 10
            ;
          if (length != size) $scope.domore = false;
          else $scope.domore = true;
          if (length > 0) {
            for (var i = 0; i < length; i++) {
              var item = list[i]
              // 是否关闭 0.未关闭 1.待办 2.数据异常 3.关闭
              switch (item.isClose) {
                case 0:
                  item.closeName = '未关闭'
                  break;
                case 1:
                  item.closeName = '待办'
                  break;
                case 2:
                  item.closeName = '数据异常'
                  break;
                case 3:
                  item.closeName = '关闭'
                  break;
              }
              item.progressList.forEach(function(step) {
                if (step.progressState == 0) step.stateName = '未开始'
                if (step.progressState == 1) {
                  item.cStep = {
                    name: step.deptName,
                    stateName: '进行中'
                  }
                  step.stateName = '进行中'
                }
                if (step.progressState == 2) {
                  step.stateName = '已完成'
                }
                if (step.progressState == 3) step.stateName = '数据异常'
              })
              if (!item.cStep) {
                var last = item.progressList[item.progressList.length - 1]
                item.cStep = {
                  name: last.deptName,
                  stateName: last.stateName
                }
              }
            }
          }
          $scope.list = list;
        });
    }
    $scope.alert = function(info, title, callback) {
      $ionicPopup.alert({
        title: title || '提示框',
        template: info,
        okText: '确定'
      }).then(function(res) {
        callback && callback();
      });
    }
    $scope.goCreate = function(continu) {
      if (!$scope.user.ttbRole) {
        $scope.alert('请联系“一件事窗口”工作人员办理')
        return
      }
      if (continu) {
        $scope.goState('ttbYCCreate', { thing: $scope.current, thingType: $scope.thingType }, 'reload')
        return
      }
      $scope.goState('ttbYCCreate', { thingType: $scope.thingType }, 'reload')
    }
    $scope.showDetailFn = function(item) {
      $scope.showDetail = true
      item.isMailName = item.isMail == 1 ? '邮寄' : '自取'
      $scope.current = item
      $timeout(function() {
        $ionicScrollDelegate.scrollTop()
      })
    }
    $scope.viewGoback = function() {
      if ($scope.showDetail) { $scope.showDetail = false; $scope.current = null }
      else $rootScopeViewGoback();
    }
  }
])
