appModule.controller('ActivityController', ['$scope', 'appService', '$state', '$ionicScrollDelegate',
    function ($scope, appService, $state, $ionicScrollDelegate) {
        $scope.stateName = $state.current.name;
        $scope.searchKey = 'multimedia';
        $scope.footerActiveFlag = 1;
        $scope.stationIndex = 2;
        $scope.tabIndex = 0;
        $scope.allArrays = {};
        $scope.pageNext = [];
        $scope.domore = [];
        $scope.lastRegionId;
        //加载
        $scope.$on('$ionicView.loaded', function () {
        });
        $scope.$on('changeDistrict', function (e, data) {
            if ($scope.stateName == $state.current.name) {
                if ($scope.lastRegionId != $scope.publicCityId) {
                    $scope.queryVideo(0, $scope.tabIndex);
                }
                $scope.lastRegionId = $scope.publicCityId
            }
        });
        /* watch */
        $scope.$watch('tabIndex', function (n, o) {
            var currentArray = $scope.allArrays['tab' + n];
            if (!currentArray) $scope.queryVideo(0, n);
            $ionicScrollDelegate.scrollTop();
        });
        $scope.changeTab = function (i) {
            $scope.tabIndex = i
        }
        $scope.queryVideo = function (page, tabIndex) {
            if (page < 2) {
                page = 1;
                $scope.pageNext[tabIndex] = 1;
                $scope.allArrays['tab' + tabIndex] = null;
                $scope.domore[tabIndex] = false;
            }
            var url;
            if (tabIndex == 0) {
                url = urlMap.activityFavourList;
            } else {
                url = urlMap.activityScoreList;
            }
            appService.getData(
                url,
                {
                    'state': 2, 'area_id': $scope.publicCityId, 'isActivity': "1", 'page': page, 'isShare': 1
                },
                function (results) {
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    var list = results.resultList, length = list.length, size = results.size,
                        articles = $scope.allArrays['tab' + tabIndex] || []
                        ;
                    if (length < size) $scope.domore[tabIndex] = false;
                    if (length > 0) {
                        for (var i = 0; i < list.length; i++) {
                            var vio = list[i].name;
                            var type = list[i].type; // 图片1视频2
                            var portrait = list[i].portrait;
                            if (portrait != null && portrait != "") {
                                list[i].portrait = $scope.pic + "/" + portrait;
                            } else {
                                list[i].portrait = $scope.pic + urlMap.defaultImg;
                            }
                            if (type == "1") {
                                list[i].pic = $scope.pic + "/" + vio;
                            } else if (type == "2") {
                                var pic = vio.substring(0, vio.length - 3);
                                pic = pic + "jpg";
                                list[i].vio = $scope.vio + "/" + vio;
                                list[i].pic = $scope.vio + "/" + pic;
                            }
                            articles.push(list[i]);
                        }
                    }
                    $scope.allArrays['tab' + tabIndex] = articles;
                });
        }
        //下拉刷新
        $scope.doRefresh = function () {
            $scope.queryVideo(1, $scope.tabIndex);
        }
        //上拉加载
        $scope.onInfinite = function () {
            var n = $scope.tabIndex;
            if (!$scope.pageNext[n]) return;
            $scope.queryArray(n, ++$scope.pageNext[n]);
        }
        //跳转到详情页面 
        $scope.goDetail = function (item) {
            $scope.$emit('loginFirst', function () {
                $state.go('entertainDetail', { id: item.id, type: 3, userId: item.userId })
            })
        }

    }
])
