appModule.controller('MyselfController', ['$scope', 'appService', '$state', '$stateParams', function ($scope, appService, $state, $stateParams) {
    $scope.searchKey = 'multimedia';
    $scope.pageNext = 0;
    $scope.tabIndex = $stateParams.tabIndex;
    $scope.footerActiveFlag = 1;
    $scope.stationIndex = 0;
    $scope.isLogin;
    $scope.$on('$ionicView.beforeEnter', function () {
         $scope.$emit('loginFirst',function(){
            $scope.isLogin = true;
         },function(){
            $scope.isLogin = false;
            $scope.viewGoback();
        })
    });
    $scope.$on('$ionicView.enter', function () {
        if($scope.isLogin && !$scope.videoItemArr) $scope.queryVideo(1, $scope.tabIndex);
    });
    $scope.queryVideo = function (page, tabIndex) {
        $scope.tabIndex = tabIndex;
        var url, stateId;
        if (tabIndex == 1) {
            stateId = -1;
            url = urlMap.videoList;
        } else {
            stateId = 2;
            url = urlMap.attentionUrl;
        }
        if (page == 0 || page == 1) { //页面刷新时为0,下拉刷新时为1
            $scope.pageNext = 1;
            page = 1;
        }
        $scope.$emit('loading', 'show');
        appService.getData(url, { userId: $scope.user.id, state: stateId, page: page },
            function (jsonDataArr) {
                $scope.$emit('loading', 'hide');
                $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
                $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
                console.log(jsonDataArr[0]);
                if (page == 1) {
                    $scope.videoItemArr = [];
                }
                var jsonData = jsonDataArr[0];
                var list = jsonData.resultList, length = list.length, size = jsonData.size;
                if (length < size) $scope.domore = false;
                else { $timeout(function () { $scope.domore = true; }, 200) }
                if (jsonData.resultList.length != 0) {
                    var dataItemArr = jsonData.resultList;
                    if (tabIndex == 1) {
                        for (var i = 0; i < dataItemArr.length; i++) {
                            var vio = dataItemArr[i].name;
                            var type = dataItemArr[i].type; // 图片1视频2
                            var portrait = dataItemArr[i].portrait;
                            if (portrait != null && portrait != "") {
                                dataItemArr[i].portrait = $scope.pic + "/" + portrait;
                            } else {
                                dataItemArr[i].portrait = $scope.pic + urlMap.defaultImg;
                            }
                            if (type == "1") {
                                dataItemArr[i].pic = $scope.pic + "/" + vio;
                            } else if (type == "2") {
                                var pic = vio.substring(0, vio.length - 3);
                                pic = pic + "jpg";
                                dataItemArr[i].vio = $scope.vio + "/" + vio;
                                dataItemArr[i].pic = $scope.vio + "/" + pic;
                            }
                            //增加默认新闻图片
                            $scope.videoItemArr.push(dataItemArr[i]);
                        }
                    } else {
                        for (var i = 0; i < dataItemArr.length; i++) {
                            var portrait = dataItemArr[i].portrait;
                            if (portrait != null && portrait != "") {
                                dataItemArr[i].portrait = $scope.pic + "/" + portrait;
                            } else {
                                dataItemArr[i].portrait = $scope.pic + urlMap.defaultImg;
                            }
                            $scope.videoItemArr.push(dataItemArr[i]);
                        }
                    }
                }
            });
    }
    //下拉刷新
    $scope.doRefresh = function () {
        $scope.queryVideo(1, $scope.tabIndex);
    }
    //上拉加载
    $scope.onInfinite = function () {
        $scope.queryVideo(++$scope.pageNext, $scope.tabIndex);
    }
    //跳转到详情页面 
    $scope.goDetail = function (item) {
        window.location.href = "#/entertainDetail/" + item.id + "/1/" + item.userId;
    }
    //取消关注
    $scope.deleteAttention = function ($event, attentionObj) {
        appService.getData(urlMap.deleteAttention, {
            userId: $scope.user.id, //点赞人id,
            attentionUserId: attentionObj.attentionUserId
        },
            function (jsonData) {
                console.log("取消关注!!!");
                //   $($event.target).parents(".attention-box").remove();
            });

    }
    $scope.goToUpLoad = function () {
        $scope.$emit('loginFirst', function () {
            $state.go('upload')
        })
    }


}
])
