
//文件上传
appModule.controller('uploadController', ['$scope', 'appService', '$ionicPopup',
  function($scope, appService, $ionicPopup) {
    $scope.footerActiveFlag = 1;
    $scope.stationIndex = 3;
    $("#area_id").val($scope.user.cityId);

    // 摄像头文件保存
    $scope.cameraFile = null;
    //活动分类
    $.get(urlMap.activityType, function(result) {
      $scope.typeArr = result.resultList;
    })
    $scope.alert = function(info, turn) {
      var alertPopup = $ionicPopup.alert({
        title: '提示框',
        template: info
      });
      if (turn == 1) {
        alertPopup.then(function(res) {
          window.location.href = "#/station";
        });
      }
    }
    $scope.upload = function() {
      var local = $.trim($("#uploadFile").val());
      var picExt = ".jpg|.jpeg|.png|";
      var vioExt = ".mp4|.3gp|.avi|";
      var titleCh = $("#titleCh").val()
      if ($.trim(titleCh) == "") {
        $scope.alert("请填写标题！");
        return false;
      }
      if (titleCh.length > 25) {
        $scope.alert("标题长度不能大于25个字符！");
        return false;
      }
      if (local != "") { // 本地上传
        $scope.cameraFile = null;
        $("#multimediaFlag").val("");
        var ErrMsg;
        var file = $("#uploadFile").val();
        var extName = file.substring(file.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）          
        if (picExt.indexOf(extName + "|") != -1) {
          $("#multimediaFlag").val("1");
        } else if (vioExt.indexOf(extName + "|") != -1) {
          $("#multimediaFlag").val("2");
        } else {
          if ($("#multimediaFlag").val() == "1" && picExt.indexOf(extName + "|") == -1) {
            ErrMsg = "该文件类型不允许上传。请上传 " + picExt + " 类型的文件，当前文件类型为" + extName;
            $scope.alert(ErrMsg);
            return;
          } else if ($("#multimediaFlag").val() == "2" && vioExt.indexOf(extName + "|") == -1) {
            ErrMsg = "该文件类型不允许上传。请上传 " + vioExt + " 类型的文件，当前文件类型为" + extName;
            $scope.alert(ErrMsg);
            return;
          }
          ErrMsg = "该文件类型不允许上传。 "
          $scope.alert(ErrMsg);
          return;
        }
        $("#userName").val($scope.user.userName);
        $("#up").ajaxSubmit({
          url: urlMap.uploadUrl,
          type: "post",
          dataType: "json",
          success: function(data) {
            console.log(data.result);
            if (data.result != "success") {
              $scope.alert("文件审核失败，请到留言板留言！" + data.result);
            }
            if (data.result == "success") {
              // $scope.showHint();
              // alert("文件处理完毕");
              $("#progressNumber").html("文件处理完毕");
              $("#up")[0].reset();
            } else {
              //		                	$scope.showFail();
              //alert("文件上传失败");
              $("#progressNumber").html("文件上传失败");
            }
          },
          error: function(xhr) {
            console.log(xhr.responseText);
          },
          complete: function(xhr) {//完成
            //		            	$("#progressNumber").html("视频上传成功，请提示视频处理完毕后观看！");
          },
          beforeSubmit: function() {
            if ($.trim($("#uploadFileText").val()) == "") {
              $scope.alert("请选择上传文件！");
              return false;
            }

            var filesize = $("input[type='file']")[0].files[0].size + '';
            var len = filesize.length;
            // console.log(filesize.length);
            // console.log(filesize.substring(0,5));
            if (len >= 6) {
              if (filesize.substring(0, 5) > 200000) {
                $scope.alert("文件大小超过200M限制，请重新选择！");
                return false;
              }
            }
            //直接
            // $scope.alert("您已上传成功，请耐心等待后台审核！", 1);
          },
          beforeSerialize: function() {
            //alert("表单数据序列化前执行的操作！");
            //$("#txt2").val("java");//如：改变元素的值
          },
          beforeSend: function() {
            $("#progressNumber").html('0%');
          },
          uploadProgress: function(event, position, total, percentComplete) {//上传的过程
            $scope.clear();
            //position 已上传了多少
            //total 总大小
            //已上传的百分数
            var percentVal = percentComplete + '%';
            // bar.width(percentVal)
            // percent.html(percentVal);
            // console.log(percentVal, position, total);
            $("#progressNumber").html(percentComplete.toString() + '%');
            if (percentComplete.toString() == "100") {
              $("#progressNumber").html("文件上传成功，请耐心等待后台审核!");
            }
          }
        });
      } else if ($scope.cameraFile != null) { //　摄像头上传
        var ErrMsg;
        var file = $scope.cameraFile.name;
        var extName = file.substring(file.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）  

        if (picExt.indexOf(extName + "|") != -1) {
          $scope.uploadFile($scope.cameraFile.name, $scope.cameraFile.fullPath, urlMap.uploadUrl, 1);
          // $scope.clear();
        } else if (vioExt.indexOf(extName + "|") != -1) {
          $scope.uploadFile($scope.cameraFile.name, $scope.cameraFile.fullPath, urlMap.uploadUrl, 2);
          // $scope.clear();
        } else {
          if ($("#multimediaFlag").val() == "1" && picExt.indexOf(extName + "|") == -1) {
            ErrMsg = "该文件类型不允许上传。请上传 " + picExt + " 类型的文件，当前文件类型为" + extName;
            //$scope.alert(ErrMsg);
            return;
          } else if ($("#multimediaFlag").val() == "2" && vioExt.indexOf(extName + "|") == -1) {
            ErrMsg = "该文件类型不允许上传。请上传 " + vioExt + " 类型的文件，当前文件类型为" + extName;
            // $scope.alert(ErrMsg);
            return;
          }
        }
      } else {
        $scope.alert("请选择文件！");
        return;
      }
    }
    //视频上传成功提示框
    $scope.showHint = function() {
      var alertPopup = $ionicPopup.alert({
        title: '提示框',
        template: '文件上传成功'
      });
    }

    //视频上传失败提示框
    $scope.showFail = function() {
      var alertPopup = $ionicPopup.alert({
        title: '提示框',
        template: '文件上传失败,请联系管理员。'
      });
    }

    $scope.picCapture = function() {
      // limit 拍照的张数  
      navigator.device.capture.captureImage(picSuccess, onError, { limit: 1 });

      //照片拍摄成功
      function picSuccess(mediaFiles) {
        var i, path, len;
        //遍历获取录制的文件(iOS只支持一次录制一个视频或音频)
        for (i = 0, len = mediaFiles.length; i < len; i += 1) {
          path = mediaFiles[i].fullPath;
          //    		                alert("录制成功！\n\n"
          //    		                             + "文件名:" + mediaFiles[i].name + "\n"
          //    		                             + "大小:" + mediaFiles[i].size + "\n\n"
          //    		                             + "localURL地址:" + mediaFiles[i].localURL + "\n\n"
          //    		                             + "fullPath地址:" + path);
          //	   				$scope.uploadFile(mediaFiles[i].name, path, urlMap.uploadUrl, 1);
          //	   				alert("照片【" + mediaFiles[i].name + "】已保存至本地，请选择本地文件上传。");
          $scope.removeFile();
          $("#uploadFileText").val(mediaFiles[i].name);
          $scope.cameraFile = mediaFiles[i];
        }
      }
      //录制失败
      function onError(error) {
        if (error.code != 3)
          alert('拍照失败！错误码:' + error.code);
      }
    }

    $scope.vioCapture = function() {
      //开始录像(最长录制时间:15秒)

      var duration = 17;
      if ($("#activityId").val() != '0') {
        duration = 30;
      }
      navigator.device.capture.captureVideo(vioSuccess, onError, { duration: duration });

      //视频录制成功
      function vioSuccess(mediaFiles) {
        var i, path, len;
        //遍历获取录制的文件(iOS只支持一次录制一个视频或音频)
        for (i = 0, len = mediaFiles.length; i < len; i += 1) {
          path = mediaFiles[i].fullPath;
          //	                alert("录制成功！\n\n"
          //	                             + "文件名:" + mediaFiles[i].name + "\n"
          //	                             + "大小:" + mediaFiles[i].size + "\n\n"
          //	                             + "localURL地址:" + mediaFiles[i].localURL + "\n\n"
          //	                             + "fullPath地址:" + path);
          //	   				$scope.uploadFile(mediaFiles[i].name, path, urlMap.uploadUrl, 2);
          //	   				alert("录像【" + mediaFiles[i].name + "】已保存至本地，请选择本地文件上传。");
          $scope.removeFile();
          $("#uploadFileText").val(mediaFiles[i].name);
          $scope.cameraFile = mediaFiles[i];
        }
      }

      //录制失败
      function onError(error) {
        if (error.code != 3)
          alert('录制视频失败！错误码:' + error.code);
      }
    }
    // type 1:图片 2：视频
    $scope.uploadFile = function(fileName, path, url, type) {

      var flag = 0;
      // $scope.alert("您已上传成功，请耐心等待后台审核！", 1);
      var ft = new FileTransfer();
      var options = new FileUploadOptions();
      var params = {
        multimediaFlag: type,
        userId: $("#userId").val(),
        area_id: $("#area_id").val(),
        area_name: $("#area_name").val(),
        userName: $scope.user.userName,
        titleCh: $("#titleCh").val(),
        contentCh: $("#contentCh").val(),
        activityId: $("#activityId").val()
      };
      options.fileKey = "file";
      //       		if(type == 1) {
      //       			options.mimeType = "image/jpeg";
      //       		}else if(type == 2) {
      //       			options.mimeType = "video/mp4";
      //       		}
      options.mimeType = "multipart/form-data";
      options.fileName = fileName;
      options.params = params;
      options.chunkedMode = false;

      //传输进度  
      ft.onprogress = function(progressEvent) {
        if (progressEvent.lengthComputable) {
          var percentComplete = Math.round(progressEvent.loaded * 100 / progressEvent.total);
          $("#progressNumber").html(percentComplete.toString() + '%');
          if (percentComplete.toString() == "100") {
            if (type == "1") {
              $("#progressNumber").html("图片上传成功，请等待图片处理完毕后观看");
            } else if (type == "2") {
              $("#progressNumber").html("视频上传成功，请等待视频处理完毕后观看");
            }
          }
        }
        else {
          $("#progressNumber").html('视频格式异常，请到留言板留言');
        }
      };
      ft.upload(path, url,
        function() {
						//$scope.alert("您已上传成功，后台正在审核，请在5分钟后观看！");
						//window.location.href = "#/station";
//						if (type!=1 && type!=2){
//							$scope.alert("文件审核失败，请到留言板留言！");
//						}
       					/*
       					if(type == "1") {
       						alert("图片处理完毕");
       					}else if(type == "2") {
       						alert("视频处理完毕");
       					}
       					$("#progressNumber").html("");
       				*/},
        function(error) {
          if (type == "1") {
            alert("图片上传失败");
          } else if (type == "2") {
            alert("视频上传失败");
            // alert(error.toString());
            //console.log(error);
          }
          $("#progressNumber").html("");

          // alert(error.code);
          //console.log("aaaa:     "+err.code);
          //$scope.alert("文件审核失败，请到留言板留言！");
        },
        options)
      $scope.clear();
    }

    $scope.removeFile = function() {
      var file = $("#uploadFile");
      //       		file.replaceWith(file.clone());
      //IE，Safari，chrome
      //            if(file.outerHTML){
      //            	file.outerHTML=file.outerHTML;
      //            }
      //            else{      //FF
      //            	file.value="";
      //            }
      $("#uploadFileText").val("");
    }

    $scope.clear = function() {
      $scope.removeFile();
      $("#activityId").val("0");
      $("#titleCh").val("");
      $("#contentCh").val("");
      $("#uploadFile").val("");
    }

    //文件上传 
    $scope.fileChangeEvent = function() {
      $("#uploadFileText").val($("#uploadFile").val());
    }

  }])
