
appModule.controller('yiqingJiageJubaoController', ['$scope', '$ionicPopup', '$state', '$sce', '$ionicLoading', function($scope, $ionicPopup, $state, $sce, $ionicLoading) {
  $scope.stateName = $state.current.name;
  $scope.fileType = 0
  $scope.userId = $scope.user.id
  $scope.userAreaId = $scope.publicCityId
  $scope.addMessage = function() {
    $scope.$emit('loginFirst', function() {
      if ($scope.content == undefined) {
        $scope.alert("举报内容不能为空！");
        return;
      }
      if ($scope.content != undefined) {
        if ($scope.content.length > 1500) {
          $scope.alert("内容不能超过1500字！");
          return;
        }
      }
      $ionicPopup.confirm({
        title: '提示',
        template: '请勿虚假举报，否则将追究您的法律责任。',
        cancelText: '取消',
        okText: '确定'
      }).then(function(res) {
        if (res) {
          /* $("#userAreaId").val($scope.publicCityId);
          $("#userId").val($scope.user.id); */
          /* 拍摄上传 */
          if ($scope.cameraFile) {
            $scope.uploadFile($scope.cameraFile.name, $scope.cameraFile.fullPath, urlMap.submitYiqingJubao, $scope.fileType);
            return;
          }
          // $scope.$emit('loading', 'show');
          $("#messageForm").ajaxSubmit({
            url: urlMap.submitYiqingJubao,
            type: "post",
            dataType: "json",
            success: function(saveBoolean) {
              $ionicLoading.hide();
              if (saveBoolean == 'true') {
                $scope.alert("您的举报后台已受理！", null, function() {
                  $scope.viewGoback()
                });
              } else {
                $scope.alert("内容提交失败，请联系客服人员反馈问题！");
              }
            },
            error: function(xhr) {
              alert(xhr.responseText);
            },
            beforeSerialize: function() {
            },
            beforeSend: function() {
              // $("#progressNumber").html('0%');
            },
            uploadProgress: function(event, position, total, percentComplete) {
              /*  $("#progressNumber").html(percentComplete.toString() + '%');
                            if(percentComplete.toString() == "100") {
                         $("#progressNumber").html("文件上传成功");
                       } */
              $ionicLoading.show({
                template: "附件上传：" + percentComplete.toString() + '%',
                duration: 50000
              });
              if (percentComplete > 99) {
                $ionicLoading.show({
                  template: "举报内容提交中...",
                  duration: 50000
                });
              }
            }
          });
        }
      });
    });
  }
  /***
   * type 1:图片 2：视频
   */
  $scope.uploadFile = function(fileName, path, url, type) {
    var params = {};
    params.content = $scope.content; //举报内容
    params.userId = $scope.user.id; //userid
    params.informant = $scope.informant; //举报人姓名
    params.telephone = $scope.telephone; //举报人电话
    params.userAreaId = $scope.publicCityId; //地区
    params.areaID = $scope.areaId; //所在地区
    params.address = $scope.address; //现居住地址
    params.theInformant = $scope.theInformant; //被举报人姓名
    params.company = $scope.company; //单位
    params.post = $scope.post;//职务
    params.postAddress = $scope.postAddress; //单位地址
    params.type = type;
    var ft = new FileTransfer();
    var options = new FileUploadOptions();
    options.fileKey = "file";
    options.mimeType = "multipart/form-data";
    options.fileName = fileName;
    options.params = params;
    //传输进度  
    ft.onprogress = function(progress) {
      var downloadProgress = (progress.loaded / progress.total) * 100;
      $ionicLoading.show({
        template: "附件上传：" + Math.floor(downloadProgress) + "%",
        duration: 50000
      });
      if (downloadProgress > 99) {
        $ionicLoading.show({
          template: "举报内容提交中...",
          duration: 50000
        });
      }
      /*
                  if (progressEvent.lengthComputable) { 
                       var percentComplete = Math.round(progressEvent.loaded * 100 / progressEvent.total);
                      $("#progressNumber").html(percentComplete.toString() + '%');
                      if(percentComplete.toString() == "100") {
                        if(type == "1") {
                          $("#progressNumber").html("图片上传成功");
                      }else if(type == "2") {
                        $("#progressNumber").html("视频上传成功");
                      }
                      }
                      }
                      else {
                        $("#progressNumber").html('unable to compute');
                      }
                */
    };
    ft.upload(path, url,
      function(saveBoolean) {
        $ionicLoading.hide();
        if (saveBoolean.response == '[true]') {
          $scope.alert("您的举报后台已受理！", null, function() {
            $scope.viewGoback()
          });
        } else {
          $scope.alert("内容提交失败，请联系客服人员反馈问题！");
        }
      },
      function() { },
      options);
  };

  $scope.removeFile = function(reset) {
    $scope.showUploadFiles = []; //预览
    $scope.showUploadNames = []; //预览失败 显示文件名
    if (!reset) {
      $('#localPhotoFile').val(''); //本地
      $scope.cameraFile = null; //拍摄
      $scope.fileType = 0
    }
  }
  /* 本地附件读取 */
  function readerfile(file) {
    return new Promise( function(resolve, reject) {
      var reader = new FileReader();
      reader.onload = function() {
        resolve(reader.result);
      };
      if (file) {
        reader.readAsDataURL(file)
      }
    })
  }
  $scope.fileChangeEvent = function() {
    var files = $('#localPhotoFile')[0].files;
    for (var i = 0; i < files.length; i++) {
      $scope.fileType = thisfileType(files[i].name);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.removeFile('reset');
      try {
        readerfile(files[i]).then(function(e) {
          $scope.$apply(function() {
            if ($scope.fileType == 2) {
              $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
            }
            else $scope.showUploadFiles.push(e)
          })
        })
      } catch (e) {
        alert(e);
        $scope.$apply(function() {
          $scope.showUploadNames.push(files);
        })
      }
    }
  }
  /***
   * use camera
   */
  $scope.useCamera = function(type) {
    //开始录像(最长录制时间:60秒)
    if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
    if (type == 2) navigator.device.capture.captureVideo(success, onError);
    function success(mediaFiles) {
      $scope.showUploadFiles = [];
      for (var i = 0; i < mediaFiles.length; i++) {
        var name = mediaFiles[i].name;
        var path = mediaFiles[i].fullPath;
        $scope.fileType = thisfileType(name);
        if (!$scope.fileType == 'error') {
          return;
        }
        $scope.removeFile('reset');
        $scope.$apply(function() {
          if ($scope.fileType == 2) {
            $scope.showUploadFiles.push($sce.trustAsResourceUrl(path))
          }
          else
            $scope.showUploadFiles.push(path)
        })
        $scope.cameraFile = mediaFiles[i];
      }
    }
    //录制失败
    function onError(error) {
      $scope.alert('未进行拍摄！错误码:' + error.code);
    }
  }
  function thisfileType(fileName) {
    var picExt = ".jpg|.jpeg|.png|.gif|";
    var vioExt = ".mp4|.3gp|.avi|";
    if (!fileName) return null
    var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
    /* 检查文件类型  */
    if (picExt.indexOf(extName + "|") != -1) return 1;
    if (vioExt.indexOf(extName + "|") != -1) return 2;
    $scope.alert("该文件类型不允许上传。");
    return 'error'
  }

}
]);
