
appModule.controller('intelligentDHandleOlmapController', ['$scope', '$state', '$stateParams', 'appService', '$timeout', '$document', '$ionicPopup', '$ionicScrollDelegate', '$window', function($scope, $state, $stateParams, appService, $timeout, $document, $ionicPopup, $ionicScrollDelegate, $window) {
  var $zhmap = {
    ol: $window.ol,
    olLoaded: function (_olLoaded) {
        testOl(this);
        function testOl(zhmap) {
            if ($window.ol) {
                console.log('已载入ol');
                zhmap.ol = $window.ol;
                _olLoaded && _olLoaded()
            }
            else $timeout(function () {
                console.log('尝试载入ol');
                testOl()
            }, 500)
        }
    },
    buildMap: function (sourse) {
        var zhmap = this;
        /* import package */
        var ol = this.ol;
        var Map = ol.Map;
        var View = ol.View;
        var { getWidth, getTopLeft } = ol.extent;
        var TileLayer = ol.layer.Tile;
        var { get, toLonLat, fromLonLat, transformExtent } = ol.proj;
        var getProjection = get;
        var WMTS = ol.source.WMTS;
        var WMTSTileGrid = ol.tilegrid.WMTS;
        var GeoJSON = ol.format.GeoJSON;
        var VectorLayer = ol.layer.Vector;
        var VectorSource = ol.source.Vector;
        var { Fill, Stroke, Style, Text } = ol.style;
        var { bbox } = ol.loadingstrategy;
        var Overlay = ol.Overlay;
        var { toStringHDMS } = ol.coordinate;
        /* core code */
        var matrixSet = 'EPSG:3857';
        var projection = getProjection(matrixSet);
        var projectionExtent = projection.getExtent();
        var size = getWidth(projectionExtent) / 256;
        var matrixIds = [];
        var matrixId = 'EPSG:3857';
        var hasZoomLevel = '21';
        var resolutions = [];
        for (var z = 0; z < hasZoomLevel; ++z) {
            resolutions[z] = size / Math.pow(2, z);
            matrixIds[z] = matrixId + ':' + z;
        }
        var vectorStyle = new Style({
            fill: new Fill({
                color: 'rgba(255, 255, 255, 0)'
            }),
            stroke: new Stroke({
                color: 'rgba(255, 255, 255, 0.1)',
                width: 1
            })
        });
        var vectorLayer = new VectorLayer({
            opacity: 1,
            source: new VectorSource({
                url: function (extent) {
                    return sourse.olVector +
                        'bbox=' + extent.join(',') + ',EPSG:3857';
                },
                // projection: projection,
                format: new GeoJSON(),
                strategy: bbox
            }),
            style: vectorStyle
        });
        var tileLayer = new TileLayer({
            opacity: 1,
            source: new WMTS({
                url: sourse.olTileUrl,
                // layer: 'tonghua:changan-road--bd-group',
                layer: sourse.olTile,
                matrixSet: matrixSet,
                format: 'image/png',
                projection: projection,
                tileGrid: new WMTSTileGrid({
                    origin: getTopLeft(projectionExtent), // 原点（左上角）
                    resolutions: resolutions, // 分辨率数组
                    matrixIds: matrixIds // 矩阵ID，就是瓦片坐标系z维度各个层级的标识
                }),
                style: '',
                wrapX: true
            })
        });
        var container = document.getElementById('popup');
        var closer = document.getElementById('popup-closer');
        var overlay = new Overlay({
            element: container,
            autoPan: true,
            autoPanAnimation: {
                duration: 250
            }
        });
        closer.onclick = function () {
            selectedFeatures.clear();
            overlay.setPosition(undefined);
            closer.blur();
            return false;
        };
        var map = new Map({
            layers: [
                tileLayer, vectorLayer
            ],
            target: 'map',
            overlays: [overlay],
            view: new View({
                center: sourse.center,
                extent: sourse.extents,
                minZoom: sourse.minZoom || 15,
                maxZoom: sourse.maxZoom || 21,
                zoom: sourse.zoom || 16.5
            })
        });
        var select = new ol.interaction.Select();
        map.addInteraction(select);
        var selectedFeatures = select.getFeatures();
        map.on('singleclick', function (evt) {
            var coordinate = evt.coordinate;
            var hdms = toStringHDMS(toLonLat(coordinate));
            console.log(hdms, coordinate)
        });
        select.on('select', function (e) {
            if (!e.selected[0]) { closer.onclick(); return };
            var bd = e.selected[0].getProperties();
            var coordinate = e.mapBrowserEvent.coordinate;
            zhmap.selectFeature(bd)
            overlay.setPosition(coordinate);
        });
    },
    selectFeature: null,
    smapping: function (rid, callback) {
        var data = {
            regionId: rid
        }
        appService.get(urlMap.pgmMap, data,
            function (res) {
                if(!res.data[0]) return;
                var obj = res.data[0];
                obj.center = obj.center && obj.center.split(',')
                obj.center =  obj.center && obj.center.map(s=>{return s*1})
                obj.extents = obj.extents && obj.extents.split(',')
                obj.extents = obj.extents &&obj.extents.map(s=>{return s*1})
                callback(obj)
            })
    }
}
  /* data */
  $scope.stateName = $state.current.name;
  $scope.mid = 1;
  $scope.regionId = $stateParams.region.id;
  $scope.mapFileUrl;
  $scope.cacheDatas = {};
  $scope.housePage = 0;
  $scope.compPage = 0;
  $scope.personPage = 0;
  $scope.domorePerson;
  $scope.pages = { now: 0 };
  $scope.filter = {};
  $scope.filter.unitRoom;
  $scope.filter.unitPerson;
  $scope.HCType = [
    /* {
      id: 0,
      name: '全部'
    }, */
    {
      id: 1,
      name: '全部房间'
    },
    {
      id: 2,
      name: '单位'
    }
  ];
  $scope.buildingPhotoHeight = window.innerWidth ? {
    'height': ((window.innerWidth * 0.5) * 0.8) + 'px',
    'width': ((window.innerWidth * 0.5)) + 'px'
  } : false;
  $scope.$on('$ionicView.enter', function() {
    /* navigator.geolocation.getCurrentPosition(function () {
      console.log(arguments)
    }, function () {
      console.log(arguments)
    }, { enableHighAccuracy: true }); */
  })
  $scope.$on('$ionicView.afterEnter', function() {
    $zhmap.selectFeature = function(bd) {
      $scope.$apply(function() {
        $scope.buildingDetail = {
          id: bd.buildingid || bd.buildingId || bd.BuildingId || bd.id || bd.Id,
          name: bd.name || bd.Name
        };
      });
      console.log($scope.buildingDetail);
    }
    $zhmap.olLoaded(function() {
      $zhmap.smapping($scope.regionId, function(sourse) {
        $scope.mapFileUrl = sourse.fileUrl + '/'
        $zhmap.buildMap(sourse)
      });

    });
  })
  $scope.$on('$ionicView.afterLeave', function() {
    $scope.goTop();
    $scope.buildingPhotoSwiper && $scope.buildingPhotoSwiper.destroy(true, true);
  });
  $scope.init = function() {
    $scope.goTop();
    $scope.tabIndex = null;
    $scope.showSearch = null;
    $scope.buildKeywords = null;
    $scope.buildingDetail = {
      id: $scope.buildingDetail.id,
      name: $scope.buildingDetail.name
    };
    $scope.houseList = $scope.companyList = $scope.personList = $scope.specialList = null;
    $scope.houseDetail = $scope.person = $scope.compDetail = null;
    $scope.resultInBuilding = null;
    $scope.filter.unitRoom = $scope.filter.unitPerson = null;

  }
  $scope.initPosition = function() {
    // var ele1 = $document[0].getElementById('roomModule'), ele2 = $document[0].getElementById('personModule');
    /* var ele1 = $document[0].getElementById('tabContent');
    $scope.pages.level1 = ele1 && ele1.offsetTop; */
  }
  /* 展开楼体 */
  $scope.showBuilding = function() {
    $scope.init();
    $scope.getBuildingDetail(function() {
      $scope.showPopUp = true;
    });

  }
  $scope.getBuildingDetail = function(popup) {
    var data = {
      id: $scope.buildingDetail.id,
      userId: $scope.user.id,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapBuildingDetail, data, function(result) {
      console.log(result)
      // if (!result || result.code < 1 || result.code == 10002) {
      if (!result || result.code < 1 || result.code != 200) {
        $scope.buildingDetail.msg = result.msg;
        return;
      }
      if (!result || result.code < 1) {
        return;
      }
      else $scope.buildingDetail = result;
      popup && popup();
      /* 楼栋图片 */
      $scope.buildingDetail.buidingImgs = result.bdimg; /* && result.bdimg.split(',') */
      // $scope.buildingDetail.ldzImg = 'http://xn--5bvz82b.com:81/llhuatonghua1_v1558486230613f.jpg';
      // $scope.initBuildingPhotoSwiper();
      $scope.buildingDetail.unitList.unshift({
        id: 0,
        name: '全部'
      });
      $scope.filter.unitRoom = $scope.filter.unitPerson = $scope.buildingDetail.unitList[0];
    })
  }
  $scope.hideBuilding = function() {
    $scope.init();
    $scope.showPopUp = false;
    $scope.filter.unitRoom = null;
    $scope.filter.unitPerson = null;
  }
  /* 初始化楼体图片 */
  $scope.initBuildingPhotoSwiper = function() {
    $scope.buildingPhotoSwiper && $scope.buildingPhotoSwiper.destroy(true, true);
    if ($scope.buildingDetail.buidingImgs && $scope.buildingDetail.buidingImgs.length > 1) {
      $timeout(function() {
        $scope.buildingPhotoSwiper = new Swiper('#buildingPhotoSwiper', {
          width: undefined,
          pagination: {
            el: '.zhOlmap-banner-pagination'
          }
        });
      });
    }
  }
  /* 获取全部房间 */
  $scope.getHouseList = function(page) {
    if (page < 2) {
      $scope.cacheDatas.house = $scope.houseList = [];
      $scope.housePage = 1;
      page = 1;
    }
    if ($scope.filter.unitRoom.id < 1) {
      var data = {
        bid: $scope.buildingDetail.id,
        page: page,
        mid: $scope.mid,
        rids: $scope.regionId
      }
    } else var data = {
      uid: $scope.filter.unitRoom.id,
      page: page,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapHouse, data, function(result) {
      if (result.code != 200) return;
      console.log('房间', result);
      result = result.data;
      $scope.houseList = $scope.houseList.concat(result);
      if ($scope.filter.unitRoom.id < 1)
        $scope.cacheDatas.house = $scope.houseList;
      else $scope.cacheDatas[$scope.filter.unitRoom.id] = { house: $scope.houseList };
      $timeout(function() {
        $scope.initPosition()
      })
    })
  }
  /* 获取单位 */
  $scope.getCompanyList = function(page) {
    if (page < 2) {
      $scope.cacheDatas.company = $scope.companyList = [];
      $scope.compPage = 1;
      page = 1;
    }
    if ($scope.filter.unitRoom.id < 1) {
      var data = {
        bid: $scope.buildingDetail.id,
        page: page,
        mid: $scope.mid,
        rids: $scope.regionId
      }
    } else var data = {
      uid: $scope.filter.unitRoom.id,
      page: page,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapCompanyList, data, function(result) {
      if (result.code != 200) return;
      console.log('房间', result);
      result = result.data;
      $scope.companyList = $scope.companyList.concat(result);
      if ($scope.filter.unitRoom.id < 1)
        $scope.cacheDatas.company = $scope.companyList;
      else $scope.cacheDatas[$scope.filter.unitRoom.id] = { company: $scope.companyList };
      $timeout(function() {
        $scope.initPosition()
      })
    })
  }
  /* 人员 */
  $scope.getpersonList = function(page) {
    if (page < 2) {
      $scope.personList = [];
      $scope.pageNextP = 1;
      page = 1;
    }
    if ($scope.filter.unitPerson.id < 1) {
      var data = {
        bid: $scope.buildingDetail.id,
        page: page,
        mid: $scope.mid,
        rids: $scope.regionId
      }
    } else var data = {
      uid: $scope.filter.unitPerson.id,
      page: page,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapPersonList, data, function(result) {
      console.log('人员', $scope.pageNextP, result);
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      if (result.code != 200) {
        $scope.personList = { msg: result.msg };
        return;
      };
      if (!result.data.length) {
        $scope.personList = { msg: '暂无人员' };
        return;
      };
      var list = result.data, length = list.length, size = result.size,
        articles = $scope.personList || []
        ;
      if (length < size) $scope.domorePerson = false;
      else {
        $scope.domorePerson = true;
      }
      $scope.personList = articles.concat(result.data);
      $timeout(function() {
        var delegate = $ionicScrollDelegate.$getByHandle('idivPopupScroll');
        delegate.resize();
      })
    })
  }
  $scope.hideSpecialListAll = function() {
    $scope.showSpecialListAll = false
  }
  $scope.showSpecial = function() {
    if (!$scope.specialListAll) $scope.getSpecialListAll()
    $scope.showSpecialListAll = true
  }
  /* 楼内特殊人群 */
  $scope.getSpecialList = function() {
    $scope.specialList = [];
    var data = {
      bid: $scope.buildingDetail.id,
      // page: page,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapSpecialList, data, function(result) {
      console.log('特殊人群', result);
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      if (result.code != 200) {
        $scope.specialList = { msg: result.msg };
        return;
      };
      var list = result.data;
      list.forEach(function(category) {
        for (var key in category) {
          if (key != 'count') {
            category.key = key
            category.value = category[key]
          }
        }
      })
      $scope.specialList = list;
      console.log($scope.specialList)
      $timeout(function() {
        var delegate = $ionicScrollDelegate.$getByHandle('idivPopupScroll');
        delegate.resize();
      })
    })
  }
  /* 管理范围特殊人群 */
  $scope.getSpecialListAll = function() {
    $scope.specialListAll = [];
    var data = {
      userId: $scope.user.id,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.zhmapSpecialList, data, function(result) {
      $scope.$emit('loading', 'hide');
      console.log('特殊人群All', result);
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      if (result.code != 200) {
        $scope.specialListAll = { msg: result.msg };
        return;
      };
      var list = result.data;
      list.forEach(function(category) {
        for (var key in category) {
          if (key != 'count') {
            category.key = key
            category.value = category[key]
          }
        }
      })
      $scope.specialListAll = list;
      $scope.wgList = result.wgList;
      $scope.specialRegionName = result.regionName;
      console.log($scope.specialListAll)
    })
  }
  $scope.hideSpecialListAllDetail = function(lst) {
    $scope.specialListAllDetail = false
    $scope.person = null
  }
  $scope.showSpecialListAllDetail = function(list, key) {
    $scope.specialListAllDetail = true
    $scope.specialAllDetailList = list
    $scope.specialAllDetailList.key = key
  }
  $scope.hideSpecialListDetail = function(lst) {
    $scope.specialListDetail = false
  }
  $scope.showSpecialListDetail = function(list, key) {
    $scope.specialListDetail = true
    $scope.specialDetailList = list
    $scope.specialDetailList.key = key
  }
  $scope.onInfinite = function() {
    // $scope.domorePerson = false;
    $scope.getpersonList(++$scope.pageNextP);
  }
  /* 获取房间人员 */
  $scope.getpersonListByHid = function(id, page) {
    $scope.houseDetail.personList = [];
    var data = {
      hid: id,
      page: page,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    $scope.$emit('loading', 'show');
    appService.getData(urlMap.zhmapPersonList, data, function(result) {
      $scope.$emit('loading', 'hide');
      console.log('人员', result);
      if (result.code != 200) {
        $scope.houseDetail.personList = { msg: result.msg };
        return;
      };
      if (!result.data.length) {
        $scope.houseDetail.personList = { msg: '暂无人员' };
        return;
      };
      $scope.houseDetail.personList = result.data;

    })
  }
  /* 房屋切换单元 */
  $scope.changeFilterUnitRoom = function(u) {
    $scope.houseDetail = $scope.compDetail = null;
    // console.log(u);
    if ($scope.filter.HCType.id == 1) {
      $scope.getHouseList(0);
    } else $scope.getCompanyList(0);
  }
  /* 人员切换单元 */
  $scope.changeFilterUnitPer = function(u) {
    $scope.getpersonList(0);
  }
  /* 切换房屋类型 */
  $scope.changeFilterHCType = function(u, init) {
    $scope.filter.HCType = u;
    // $scope.filter.unitRoom = $scope.buildingDetail.unitList[0];
    $scope.tabIndex = $scope.pages.now = u.id;
    console.log(u);
    if (u.id == 1) //house
    {
      $scope.compDetail = null;
      if (init) {
        if (!$scope.houseList) $scope.getHouseList(0);
        return;
      }
      $scope.getHouseList(0);
    } else {
      $scope.houseDetail = null;
      if (init) {
        if (!$scope.companyList) $scope.getCompanyList(0);
        return;
      }
      $scope.getCompanyList(0);
      // $scope.getCompanyList(++$scope.housePage);
    }
  }
  /* 展开房屋 */
  $scope.selectHouse = function(house) {
    $scope.selectedHouse = house;
    var _house = [
      { key: '房屋编号', value: house.name },
      { key: '备注', value: house.desction, type: 'textArea' },
      { key: '房屋地址', value: house.address },
      { key: '物管单位名', value: house.wgunit },
      { key: '代表人/业主', value: house.yezhu },
      { key: '代表人电话', value: house.yztel },
      { key: '身份证号', value: house.yzcardid },
      { key: '房屋户型', value: house.hutype },
      { key: '建成', value: house.years },
      { key: '本户建筑面积', value: house.area },
      { key: '房屋结构', value: house.jiegou },
      { key: '平安家庭', value: house.safefamily },
      { key: '用途', value: house.yongtu },
      { key: '性质', value: house.useTid },
      { key: '房屋来源', value: house.housecome },
      { key: '房屋凭证', value: house.housecard },
      { key: '房屋权证号', value: house.housecardno },
      { key: '发证时间', value: house.fztime },
      { key: '土地凭证', value: house.tdcard },
      { key: '土地权证号', value: house.tdcardno },
      { key: '发证时间', value: house.tdtotime },
      { key: '产权人类型', value: house.cqpertype },
      { key: '产权人姓名', value: house.cqpername },
      { key: '产权人证件类型', value: house.cqpercardtype },
      { key: '产权人证件号码', value: house.cqpercardid },
      { key: '产权人电话', value: house.cqpertel },
      { key: '联系手机', value: house.cqperphone, type: 'phone' },
      { key: '隐患等级', value: house.dangerlevels },
    ];
    $scope.houseDetail = {
      id: house.id,
      name: house.name,
      format: _house
    };
    $scope.getpersonListByHid(house.id, 1)
    $timeout(function() {
      $scope.showContent('houseDetail');
    })
  }
  function formatDate(date) {
    if (!date) return '';
    var date = new Date(date);
    var YY = date.getFullYear();
    var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1);
    var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
    var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
    var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()) + ':';
    var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
    // return YY + MM + DD +" "+hh + mm + ss;
    return `${YY}年${MM}月${DD}日`;
  }
  /* 展开单位 */
  $scope.selectCompany = function(company) {
    $scope.selectedCompany = company;
    var _company = [
      { key: '单位名称', value: company.name },
      { key: '备注', value: company.destion, type: 'textArea' },
      { key: '单位地址', value: company.address },
      { key: '营业执照号码', value: company.no },
      { key: '组织机构代码', value: company.partyno },
      { key: '单位类别', value: company.enttype },
      { key: '是否重点单位', value: company.iszdian },
      { key: '法人代表', value: company.legal },
      { key: '身份证号', value: company.cardid },
      { key: '单位电话', value: company.unittel },
      { key: '单位传真', value: company.unitcz },
      { key: '注册资本', value: company.zijin },
      { key: '经济性质', value: company.xingzhi },
      { key: '有效期至', value: company.totime },
      { key: '经营范围', value: company.fanwei },
      { key: '注册地址', value: company.zcaddress },
      { key: '从业人数', value: company.count },
      { key: '主管部门', value: company.bumen },
      { key: '管理级别', value: company.gljibie },
      { key: '管理部门', value: company.glbumen },
      { key: '消防等级', value: company.dengji },
      { key: '治安负责人', value: company.zaper }
    ];
    $scope.compDetail = {
      id: company.id,
      name: company.name,
      format: _company
    };
    $timeout(function() {
      $scope.showContent('compDetail');
    })
  }
  /* 展开人员 */
  $scope.showPersonDetail = function(person) {
    var delegate = $ionicScrollDelegate.$getByHandle('personDetail');
    delegate.scrollTop();
    var data = {
      id: person.id,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapPersonDetail, data, function(result) {
      console.log(result);
      if (!result.data) {
        person.msg = '失败';
        return;
      }
      person = {};
      person.basic = result.data;
      var pstatus = '未设置';
      switch (person.basic.status) {
        case 'czper':
          pstatus = '常住人口';
          break;
        case 'ldper':
          pstatus = '流动人口';
          break;
        case 'hjper':
          pstatus = '户籍人口';
          break;
        case 'wlhper':
          pstatus = '未落户人口';
          break;
        case 'jwper':
          pstatus = '境外人口';
          break;
      }
      var _person = [
        /*  {key:'所属网格',value:person.}, */
        { key: '照片', value: person.basic.img, type: 'img' },
        { key: '姓名', value: person.basic.name },
        { key: '人员类型', value: pstatus },
        { key: '所属网格', value: person.basic.regionName },
        { key: '性别', value: person.basic.sex },
        { key: '身份证', value: person.basic.idcard || person.basic.idCard },
        { key: '备注', value: person.basic.desction, type: "textArea" },
        { key: '曾用名/别名', value: person.basic.cyname },
        { key: '联系手机', value: person.basic.phone, type: 'phone' },
        { key: '固定电话', value: person.basic.tel },
        { key: '出生日期', value: person.basic.birthday && person.basic.birthday.year && `${person.basic.birthday.year}-${person.basic.birthday.month}-${person.basic.birthday.day}` || '' },
        // { key: '出生日期', value: formatDate(person.basic.birthday)},
        { key: '民族', value: person.basic.nation },
        { key: '政治面貌', value: person.basic.political },
        { key: '文化程度', value: person.basic.education },
        { key: '职业', value: person.basic.zhiye },
        { key: '工作单位', value: person.basic.companyWork },
        { key: '婚姻状况', value: person.basic.maritaltid },
        { key: '结婚日期', value: person.basic.marryDate && person.basic.marryDate.year && `${person.basic.marryDate.year}-${person.basic.marryDate.month}-${person.basic.marryDate.day}` || '' },
        { key: '身高', value: person.basic.high },
        { key: '血型', value: person.basic.bloodtid },
        { key: '电子邮箱', value: person.basic.email },
        { key: '所在国家', value: person.basic.country },
        { key: '户籍地', value: person.basic.huadres },
        { key: '户籍地详址', value: person.basic.address },
        { key: '有无固定地', value: person.basic.youwu },
        { key: '房屋编号', value: person.basic.houseno },
        { key: '现居地址', value: person.basic.newaddress },
        { key: '其它地址', value: person.basic.otheraddress },
        { key: '户口性质', value: person.basic.nature },
        { key: '抵达时间', value: person.basic.livetime && person.basic.livetime.year && `${person.basic.livetime.year}-${person.basic.livetime.month}-${person.basic.livetime.day}` || '' },
        { key: '离开时间', value: person.basic.lktime && person.basic.lktime.year && `${person.basic.lktime.year}-${person.basic.lktime.month}-${person.basic.lktime.day}` || '' }
      ], xingShi, jiaoZheng, drug, shangFang, jingShenBing, xinFang, familyCy, guarantee, kongChao, kongChao, jiuZhu, shiYe, yongJun, zhiYuanZhe, sanWu, wuBao;
      var xingShi = result.data.xingShi && (
        [
          { key: '人员类别', value: result.data.xingShi.pertype },
          { key: '原罪名（错）', value: result.data.xingShi.zuiming },
          { key: '原判刑期', value: result.data.xingShi.xingqi },
          { key: '劳教(服刑)场所', value: result.data.xingShi.changsuo },
          { key: '解教（刑释）日', value: result.data.xingShi.time },
          { key: '是否累犯', value: result.data.xingShi.isleifan },
          { key: '犯罪行为', value: result.data.xingShi.xingwei },
          { key: '原职业', value: result.data.xingShi.zhiye },
          { key: '本年度是否重犯', value: result.data.xingShi.zhongfan },
          { key: '安置日期', value: result.data.xingShi.aztime },
          { key: '未安置原因', value: result.data.xingShi.question }
        ]
      );
      var jiaoZheng = result.data.jiaoZheng && (
        [
          { key: '刑法执行类别', value: result.data.jiaoZheng.type },
          { key: '原判刑期', value: result.data.jiaoZheng.xingqi },
          { key: '社区矫正开始时间', value: result.data.jiaoZheng.jzbegtime && result.data.jiaoZheng.jzbegtime.year && `${result.data.jiaoZheng.jzbegtime.year}-${result.data.jiaoZheng.jzbegtime.month}-${result.data.jiaoZheng.jzbegtime.day}` || '' },
          { key: '社区矫正结束时间', value: result.data.jiaoZheng.jzendtime && result.data.jiaoZheng.jzendtime.year && `${result.data.jiaoZheng.jzendtime.year}-${result.data.jiaoZheng.jzendtime.month}-${result.data.jiaoZheng.jzendtime.day}` || '' },
          { key: '近况描述', value: result.data.jiaoZheng.destion }
        ]
      );
      var drug = result.data.drug && (
        [
          { key: '吸毒状态', value: result.data.drug.status },
          { key: '首吸时间', value: result.data.drug.sxtime },
          { key: '查获日期', value: result.data.drug.chtime },
          { key: '管控现状', value: result.data.drug.zhuangkuang },
          { key: '吸毒原因', value: result.data.drug.question },
          { key: '毒品来源', value: result.data.drug.come },
          { key: '戒毒情况	', value: result.data.drug.qingkuang },
          { key: '是否服美沙酮戒毒', value: result.data.drug.isjiedu }
        ]
      );
      var shangFang = result.data.shangFang && (
        [
          { key: '上访状态', value: result.data.shangFang.status },
          { key: '上访原因', value: result.data.shangFang.question }
        ]
      );
      var jingShenBing = result.data.jingShenBing && (
        [
          { key: '患病名称', value: result.data.jingShenBing.name },
          { key: '危险程度', value: result.data.jingShenBing.chengdu },
          { key: '是否接受过治疗', value: result.data.jingShenBing.iszhiliao }
        ]
      );
      var xinFang = result.data.xinFang && (
        [
          { key: '诉求主题', value: result.data.xinFang.zhuti },
          { key: '上访次数', value: result.data.xinFang.count },
          { key: '目前思想动态', value: result.data.xinFang.dongtai },
          { key: '风险级别', value: result.data.xinFang.jiebie },
          { key: '责任领导', value: result.data.xinFang.manager }
        ]
      );
      var familyCy = result.data.familyCy && (
        [
          { key: '户编号', value: result.data.familyCy.huno },
          { key: '与户主关系', value: result.data.familyCy.hzrelate },
          { key: '是否外出', value: result.data.familyCy.iswaichu },
          { key: '家庭称号', value: result.data.familyCy.chegnhao }
        ]
      );
      var guarantee = result.data.guarantee && (
        [
          { key: '低保证号码', value: result.data.guarantee.no },
          { key: '户月保障金额', value: result.data.guarantee.amount },
          { key: '备注', value: result.data.guarantee.destion }
        ]
      );
      var kongChao = result.data.kongChao && (
        [
          { key: '老年人证号', value: result.data.kongChao.cardid },
          { key: '人员类型', value: result.data.kongChao.pertype },
          { key: '当前状况', value: result.data.kongChao.zhuangkuang },
          { key: '居住情况', value: result.data.kongChao.liveinfo },
          { key: '配偶情况', value: result.data.kongChao.peiouinfo },
          { key: '经济来源', value: result.data.kongChao.jingjicome },
          { key: '参加工作日期', value: result.data.kongChao.gztime },
          { key: '离退休单位', value: result.data.kongChao.lxunit },
          { key: '离退休日期', value: result.data.kongChao.txtime },
          { key: '原单位职务', value: result.data.kongChao.zhiwu },
          { key: '退休金', value: result.data.kongChao.txj }
        ]
      );
      var disability = result.data.disability && (
        [
          { key: '残疾原因', value: result.data.disability.question },
          { key: '残疾时间', value: result.data.disability.cjtime },
          { key: '残疾类别', value: result.data.disability.tid },
          { key: '残疾等级', value: result.data.disability.level },
          { key: '是否有残疾证', value: result.data.disability.iscjcard },
          { key: '残疾证号', value: result.data.disability.idcard },
          { key: '技能特长', value: result.data.disability.techang },
          { key: '劳动能力', value: result.data.disability.nengli },
          { key: '监护人', value: result.data.disability.jhper },
          { key: '救助金', value: result.data.disability.jiuzhujin }
        ]
      );
      var jiuZhu = result.data.jiuZhu && (
        [
          { key: '救助原因', value: result.data.jiuZhu.question },
          { key: '是否低保户', value: result.data.jiuZhu.isdibao },
          { key: '保障金', value: result.data.jiuZhu.baozhangjin }
        ]
      );
      var shiYe = result.data.shiYe && (
        [
          { key: '人员类型', value: result.data.shiYe.pertype },
          { key: '登记证号', value: result.data.shiYe.cardno },
          { key: '失业时间', value: result.data.shiYe.sytime && result.data.shiYe.sytime.year && `${result.data.shiYe.sytime.year}-${result.data.shiYe.sytime.month}-${result.data.shiYe.sytime.day}` || '' },
          { key: '失业原因', value: result.data.shiYe.question },
          { key: '参加工作时间', value: result.data.shiYe.jobtime && result.data.shiYe.jobtime.year && `${result.data.shiYe.jobtime.year}-${result.data.shiYe.jobtime.month}-${result.data.shiYe.jobtime.day}` || '' },
          { key: '原单位名称', value: result.data.shiYe.unitname },
          { key: '原单位类型', value: result.data.shiYe.unittype },
          { key: '职称', value: result.data.shiYe.zhicheng },
          { key: '技术等级', value: result.data.shiYe.dengji },
          { key: '技能特长', value: result.data.shiYe.techang },
          { key: '拟就业意向', value: result.data.shiYe.jyyx },
          { key: '拟参加培训意向', value: result.data.shiYe.pxyx },
          { key: '参加过的培训项目及时间', value: result.data.shiYe.other },
        ]
      );
      var yongJun = result.data.yongJun && (
        [
          { key: '优待证号', value: result.data.yongJun.yfcard },
          { key: '优抚类型', value: result.data.yongJun.type },
          { key: '劳动能力', value: result.data.yongJun.nengli },
          { key: '生活能力', value: result.data.yongJun.shnl },
          { key: '就业情况', value: result.data.yongJun.jyqkuang },
          { key: '供养情况', value: result.data.yongJun.gyqkuang },
          { key: '月生活费', value: result.data.yongJun.shenghuofei },
          { key: '退役证件号', value: result.data.yongJun.txzcardno },
          { key: '入伍时间', value: result.data.yongJun.indate && result.data.yongJun.indate.year && `${result.data.yongJun.indate.year}-${result.data.yongJun.indate.month}-${result.data.yongJun.indate.day}` || '' },
          { key: '退伍时间', value: result.data.yongJun.odate && result.data.yongJun.odate.year && `${result.data.yongJun.odate.year}-${result.data.yongJun.odate.month}-${result.data.yongJun.odate.day}` || '' },
          { key: '服义务兵役终止时间', value: result.data.yongJun.byzztime && result.data.yongJun.byzztime.year && `${result.data.yongJun.byzztime.year}-${result.data.yongJun.byzztime.month}-${result.data.yongJun.byzztime.day}` || '' },
          { key: '服役部队名称(番号)	', value: result.data.yongJun.fanhao },
          { key: '服役部队代号', value: result.data.yongJun.daihao },
        ]
      );
      var sheBao = result.data.sheBao && (
        [
          { key: '个人缴费额', value: result.data.sheBao.pertax },
          { key: '特殊参保群体', value: result.data.sheBao.specgroup },
          { key: '企业职工基本养老保险', value: result.data.sheBao.unityanglao },
          { key: '开始时间', value: result.data.sheBao.unitstart && result.data.sheBao.unitstart.year && `${result.data.sheBao.unitstart.year}-${result.data.sheBao.unitstart.month}-${result.data.sheBao.unitstart.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.unitend && result.data.sheBao.unitend.year && `${result.data.sheBao.unitend.year}-${result.data.sheBao.unitend.month}-${result.data.sheBao.unitend.day}` || '' },
          { key: '新型农村社会养老保险', value: result.data.sheBao.ncyanglao },
          { key: '开始时间', value: result.data.sheBao.ncstart && result.data.sheBao.ncstart.year && `${result.data.sheBao.ncstart.year}-${result.data.sheBao.ncstart.month}-${result.data.sheBao.ncstart.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.ncend && result.data.sheBao.ncend.year && `${result.data.sheBao.ncend.year}-${result.data.sheBao.ncend.month}-${result.data.sheBao.ncend.day}` || '' },
          { key: '被征收地农民社会保障', value: result.data.sheBao.baozhang },
          { key: '开始时间', value: result.data.sheBao.bzstart && result.data.sheBao.bzstart.year && `${result.data.sheBao.bzstart.year}-${result.data.sheBao.bzstart.month}-${result.data.sheBao.bzstart.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.bzend && result.data.sheBao.bzend.year && `${result.data.sheBao.bzend.year}-${result.data.sheBao.bzend.month}-${result.data.sheBao.bzend.day}` || '' },
          { key: '老农保', value: result.data.sheBao.nongbao },
          { key: '开始时间', value: result.data.sheBao.nbstart && result.data.sheBao.nbstart.year && `${result.data.sheBao.nbstart.year}-${result.data.sheBao.nbstart.month}-${result.data.sheBao.nbstart.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.nbend && result.data.sheBao.nbend.year && `${result.data.sheBao.nbend.year}-${result.data.sheBao.nbend.month}-${result.data.sheBao.nbend.day}` || '' },
          { key: '其他', value: result.data.sheBao.other },
          { key: '开始时间', value: result.data.sheBao.otherstart && result.data.sheBao.otherstart.year && `${result.data.sheBao.otherstart.year}-${result.data.sheBao.otherstart.month}-${result.data.sheBao.otherstart.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.otherend && result.data.sheBao.otherend.year && `${result.data.sheBao.otherend.year}-${result.data.sheBao.otherend.month}-${result.data.sheBao.otherend.day}` || '' },
          { key: '离休退休保证金', value: result.data.sheBao.limoney },
          { key: '开始时间', value: result.data.sheBao.libtime && result.data.sheBao.libtime.year && `${result.data.sheBao.libtime.year}-${result.data.sheBao.libtime.month}-${result.data.sheBao.libtime.day}` || '' },
          { key: '截至时间', value: result.data.sheBao.liendtime && result.data.sheBao.liendtime.year && `${result.data.sheBao.liendtime.year}-${result.data.sheBao.liendtime.month}-${result.data.sheBao.liendtime.day}` || '' },

        ]
      );
      var zhiYuanZhe = result.data.zhiYuanZhe && (
        result.data.zhiYuanZhe
      );
      var sanWu = result.data.sanWu && (
        [
          { key: '目前状况', value: result.data.sanWu.curstatus },
          { key: '备注', value: result.data.sanWu.remark }
        ]
      );
      var wuBao = result.data.wuBao && (
        [
          { key: '户月保障金额', value: result.data.wuBao.amount },
          { key: '备注', value: result.data.wuBao.remark }
        ]
      );
      $scope.person = {
        id: result.data.id,
        bisic: _person,
        xingShi: xingShi,  //xing'shi
        jiaoZheng: jiaoZheng,
        drug: drug,
        shangFang: shangFang,
        xinFang: xinFang,
        jingShenBing: jingShenBing,
        familyCy: familyCy,
        guarantee: guarantee,
        kongChao: kongChao,
        disability: disability,
        jiuZhu: jiuZhu,
        shiYe: shiYe,
        yongJun: yongJun,
        sheBao: sheBao,
        zhiYuanZhe: zhiYuanZhe,
        sanWu: sanWu,
        wuBao: wuBao,
      };
      console.log($scope.person)
      for (var key in $scope.person) {
        if (key == 'bisic' || key == 'id') continue;
        var pros = $scope.person[key];
        if (!pros) continue;
        for (var pro of pros) {
          if (pro.value === 0) pro.value = '否';
          if (pro.value === 1) pro.value = '是';
        }
      }
    })
  }
  /* 楼内搜索 */
  $scope.searchBuilding = function(page) {
    $scope.resultInBuilding = [];
    var data = {
      bid: $scope.buildingDetail.id,
      keywords: $scope.buildKeywords,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.getData(urlMap.zhmapSearchInBuilding, data, function(result) {
      console.log('搜索结果', result);
      /* if (result.code != 200) {
        $scope.resultInBuilding = { msg: result.msg };
        return;
      };
      if (!result.resultList.length) {
        $scope.resultInBuilding = { msg: '没有查询到结果' };
        return;
      }; */
      $scope.resultInBuilding = result;
    })


  }
  /* 更新属性 */
  $scope.updateHouse = function(id, remark) {
    console.log(id, remark);
    var data = {
      id: id,
      remark: remark,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.putData(urlMap.zhmapHouse, data, function(result) {
      console.log(result);
      if (result.code == 200) $scope.selectedHouse.desction = remark;
      if (result.msg) {
        $ionicPopup.alert({
          template: result.msg
        })
        return;
      }
    })
  }
  $scope.updateCompany = function(id, remark) {
    console.log(id, remark);
    var data = {
      id: id,
      remark: remark,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.putData(urlMap.zhmapCompany, data, function(result) {
      console.log(result);
      if (result.code == 200) $scope.selectedCompany.destion = remark;
      if (result.msg) {
        $ionicPopup.alert({
          template: result.msg
        })
        return;
      }
    })
  }
  $scope.updateBuilding = function(item) {
    var data = {
      id: item.id,
      remark: item.destion,
      mid: $scope.mid,
      rids: $scope.regionId
    }
    appService.putData(urlMap.zhmapUpdateBuilding, data, function(result) {
      console.log(result);
      if (result.msg) {
        $ionicPopup.alert({
          template: result.msg
        })
        return;
      }
    })
  }
  $scope.updatePerson = function(id, remark) {
    var data = {
      id: id,
      remark: remark,
      mid: $scope.mid,
      rids: $scope.regionId
    };
    appService.putData(urlMap.zhmapPerson, data, function(result) {
      console.log(result);
      if (result.msg) {
        $ionicPopup.alert({
          template: result.msg
        })
        return;
      }
    })
  }
  /* 锚点 & 滚动 */
  var delegate = $ionicScrollDelegate.$getByHandle('idivPopupScroll');
  $scope.showContent = function(hash, i) {
    if (!$scope.pages.level1) {
      $timeout(function() {
        var ele1 = $document[0].getElementById('tabContent');
        $scope.pages.level1 = ele1 && ele1.offsetTop;
      })
    }
    $scope.person = null;
    if (i > -1) {
      if (i == 1) {
        $scope.changeFilterHCType($scope.HCType[0], 'init');
        $scope.compDetail = null;
      }
      if (i == 2) {
        $scope.changeFilterHCType($scope.HCType[1], 'init');
        $scope.houseDetail = null;
      }
      if (i == 3) {
        if (!$scope.personList) $scope.getpersonList(0);
      }
      if (i == 4) {
        if (!$scope.specialList) $scope.getSpecialList();
      }
      if (i == 5) {
        if (!$scope.buildKeywords) {
          $ionicPopup.alert({
            template: '请输入关键字'
          })
          return;
        }
        $scope.searchBuilding();
        $scope.houseDetail = $scope.compDetail = null;
      }
      $scope.tabIndex = i;
    }
    delegate.resize();
    $timeout(function() {
      // $scope.initPosition();
      //滚动到省锚点
      var elm = hash && $document[0].getElementById(hash);
      var scrollTop = elm.offsetTop;
      delegate && delegate.scrollTo(null, scrollTop);
    });
  }
  $scope.ionScroll = function(notScroll) {
    var scrollTop = event.detail && event.detail.scrollTop,
      $gotop = $(event.target).parents('ion-view').children('.goTop');
    if (scrollTop < 20) $gotop.hide();
    else $gotop.show();
    var now;
    if (!$scope.pages.level1 || scrollTop < $scope.pages.level1 - 50) now = 0;
    if ($scope.pages.level1 && scrollTop >= $scope.pages.level1 - 50) {
      now = $scope.tabIndex;
    }
    // if ($scope.pages.level3 && scrollTop >= $scope.pages.level3 - 50) now = 3;
    $scope.$apply(function() {
      $scope.pages.now = now;
    });
  }

}
]);
