
appModule.controller('zhzzReportController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup','$sce', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup,$sce) {
  $mScope = $scope.$parent;
  $mScope.currentFun = 'report';
  $scope.stateName = $state.current.name;
  $scope.httpPath = '/zhzz/report/'
  $scope.dataArray;
  $scope.fileType;
  $scope.maxWidth = 900;
  $scope.pageNext = 0;
  $scope.domore;
  $scope.form = {};
  $rootScopeViewGoback = $scope.viewGoback;
  $scope.$on('$stateChangeStart',
    function (event, toState, toParams, fromState, fromParams) {
      $mScope.backState = $scope.stateName;
      $mScope.viewGoback = $rootScopeViewGoback;
    })
  $scope.setForm = function (b) {
    $scope.form = {}
    $scope.removeFile();
  }
  $mScope.viewGoback = function () {
    if ($scope.formContent) $scope.formContent = false;
    else $rootScopeViewGoback();
  }
  $scope.alert = function (info, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      callback && callback();
    });
  }
  $scope.removeFile = function (reset) {
    $scope.showUploadFiles = []; //预览
    $scope.showUploadNames = []; //预览失败 显示文件名
    if (!reset) {
      $('#localPhotoFile').val(''); //本地
      $scope.cameraFile = null; //拍摄
    }
  }
  /* 本地附件读取 */
  function readerfile (file) {
    return new Promise( function(resolve, reject) {
      var reader = new FileReader();
      reader.onload = function () {
        resolve(reader.result);
      };
      if (file) {
        reader.readAsDataURL(file)
      }
    })
  }
  $scope.fileChangeEvent = function () {
    var files = $('#localPhotoFile')[0].files;
    for (var i = 0; i < files.length; i++) {
      $scope.fileType = thisfileType(files[i].name);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.removeFile('reset');
      try {
        readerfile(files[i]).then(function(e) {
          $scope.$apply(function () {
            if ($scope.fileType == 2) {
              $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
            }
            else $scope.showUploadFiles.push(e)
          })
        })
      } catch (e) {
        alert(e);
        $scope.$apply(function () {
          $scope.showUploadNames.push(files);
        })
      }
    }
  }
  /***
   * use camera
   */
  $scope.useCamera = function (type) {
    //开始录像(最长录制时间:60秒)
    if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
    if (type == 2) navigator.device.capture.captureVideo(success, onError);
    function success (mediaFiles) {
      $scope.showUploadFiles = [];
      for (var i = 0; i < mediaFiles.length; i++) {
        var name = mediaFiles[i].name;
        var path = mediaFiles[i].fullPath;
        $scope.fileType = thisfileType(name);
        if (!$scope.fileType == 'error') {
          return;
        }
        $scope.removeFile('reset');
        $scope.$apply(function () {
          if ($scope.fileType == 2) {
            $scope.showUploadFiles.push($sce.trustAsResourceUrl(path))
          }
          else
            $scope.showUploadFiles.push(path)
        })
        $scope.cameraFile = mediaFiles[i];
      }
    }
    //录制失败
    function onError (error) {
      $scope.alert('未进行拍摄！错误码:' + error.code);
    }
  }
  function thisfileType (fileName) {
    var picExt = ".jpg|.jpeg|.png|";
    var vioExt = ".mp4|.3gp|.avi|";
    if (!fileName) return null
    var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
    /* 检查文件类型  */
    if (picExt.indexOf(extName + "|") != -1) return 1;
    if (vioExt.indexOf(extName + "|") != -1) return 2;
    $scope.alert("该文件类型不允许上传。");
    return 'error'
  }
  $scope.submit = function () {
    $scope.$emit('loginFirst', function () {
      if (!($scope.form.content)) {
        $scope.alert("请填写举报内容");
        return;
      }
      if ($scope.form.content.length > 1500) {
        $scope.alert("内容不能超过1500字！");
        return;
      }
      var file = $('#localPhotoFile').val() || ($scope.cameraFile && $scope.cameraFile.name) || '';
      $scope.fileType = thisfileType(file);
      if (!$scope.fileType == 'error') {
        return;
      }
      $scope.$emit('loading', 'show');
      /* 拍摄上传 */
      if ($scope.cameraFile) {
        var file = $scope.cameraFile;
        var params = {};
        params.httpPath = $scope.httpPath;
        params.type = $scope.fileType;
        params.maxWidth = $scope.maxWidth;
        var ft = new FileTransfer();
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.mimeType = "multipart/form-data";
        options.fileName = file.name;
        options.params = params;
        //传输进度  
        ft.onprogress = function (progressEvent) {
        };
        ft.upload(file.fullPath, urlMap.fileUpload,
          function (res) {
            $scope.$emit('loading', 'hide');
            if (res.response) res = JSON.parse(res.response)
            var imgUrl = res.imgUrl || res.vioUrl;
            if (imgUrl) {
              $scope.postReport(imgUrl)
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          },
          function () {
            $scope.alert("媒体上传失败，请联系客服人员！");
          },
          options);
        return;
      }
      /* 没有附件 */
      if (!$scope.fileType) {
        $scope.postReport();
        return
      }
      /* 本地文件上传 */
      $timeout(function () {
        $("#files").ajaxSubmit({
          url: urlMap.fileUpload,
          type: "post",
          dataType: "json",
          success: function (res) {
            var imgUrl = res.imgUrl || res.vioUrl;
            
            if (imgUrl) {
              $scope.postReport(imgUrl)
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          },
          error: function (xhr) {
            $scope.$emit('loading', 'hide');
            $scope.alert("媒体上传失败，请联系客服人员！");
          },
          beforeSerialize: function () {
          },
          beforeSend: function () {
            //$("#progressNumber").html('0%');
          },
          uploadProgress: function (event, position, total, percentComplete) {
            $scope.removeFile();
          }
        });
      })
    })
  }
  $scope.postReport = function (fileStr) {
    var data = $scope.form;
    data.file = fileStr;
    data.fileType = $scope.fileType;
    data.regionId = $scope.districtForFuncList.id;
    data.userId = $scope.user.id;
    appService.postData(urlMap.zhzzReport, data,
      function (results) {
        $scope.$emit('loading', 'hide');
        if (results.code != 200)
          $scope.alert("提交出错，请联系客服人员！");
        else
          $scope.alert("信息提交成功！", function () {
            $scope.setForm(false)
          });
      })
  }
}]);

