
appModule.controller('zhzzHandleController', ['$scope', '$state', 'appService', '$timeout', '$stateParams', '$ionicPopup', '$ionicScrollDelegate', '$sce', function ($scope, $state, appService, $timeout, $stateParams, $ionicPopup, $ionicScrollDelegate, $sce) {
  /* data */
  $scope.stateName = $state.current.name;
  $scope.allArrays = {};
  $scope.pageNext = {};
  $scope.domore = {};
  $rootScopeViewGoback = $scope.viewGoback;
  console.log($stateParams);
  $scope.region = $stateParams.region;
  /* $scope.region = $stateParams.region || {
    id: 6,
    name: "长安社区"
  } */
  $scope.handleNav = $stateParams.handleNav || [
    { name: '报送信息', menuIcon: '', url: 'zhzzHandleDispatch' },
    { name: '铁路联防', menuIcon: '', url: 'zhzzHandleRailway' },
    { name: '举报信息', menuIcon: '', url: 'zhzzHandleReport' }
  ];
  $scope.tabName = $scope.handleNav && $scope.handleNav[0].url;
  $scope.$watch('tabName', function (n, o) {
    if (!n) return;
    $scope.showDetials = false
    var currentArray = $scope.allArrays[n];
    if (!currentArray) $scope.queryArray(n, 0);
    var delegate = $ionicScrollDelegate.$getByHandle('articlesListScroll');
    delegate.scrollTop();
  });
  $scope.changeHandleNav = function (navItem) {
    $scope.tabName = navItem.url;
  }
  /* 分流 */
  $scope.queryArray = function (tabName, page) {
    if (!tabName) return;
    if (page < 1) {
      page = 0;
    }
    $scope.$emit('loading', 'show');
    if (tabName == 'zhzzHandleReport') {
      $scope.getReport(tabName, page);
    }
    if (tabName == 'zhzzHandleDispatch') {
      $scope.getDispatch(tabName, page);
    }
    if (tabName == 'zhzzHandleRailway') {
      $scope.getRailway(tabName, page);
    }
  }
  /* 百姓上报 zhzzDispatch*/
  $scope.getDispatch = function (tabName, page) {
    if (page < 1) {
      $scope.allArrays[tabName] = null;
    }
    appService.getData(urlMap.zhzzDispatch, {
      regionId: $scope.region.id,
      adminId: $scope.user.id,
      state: -1,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('报送列表: ', results);
      var list = results.data, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.summary = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '').slice(0, 30);
          // article.messageUser = item.messageUser.replace(/(.).+/, '$1**');
          article.messageTypeName = item.msgType && item.msgType.name;
          article.depName = item.dep && item.dep.depName;
          article.verifyName = item.verifyType ? '已审核' : '未审核';
          article.handleName = item.handleType ? '已处理' : '未处理';
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    });
  }
  /* 铁路联防 zhzzRailWay*/
  $scope.getRailway = function (tabName, page) {
    if (page < 1) {
      $scope.allArrays[tabName] = null;
    }
    appService.get(urlMap.zhzzRailWay, {
      regionId: $scope.region.id,
      adminId: $scope.user.id,
      state: -1,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('铁路联防: ', results);
      var list = results.data, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.summary = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '').slice(0, 30);
          article.verifyName = item.verifyType ? '已审核' : '未审核';
          article.handleName = item.handleType ? '已处理' : '未处理';
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    });
  }
  /*  一键举报 zhzzReport*/
  $scope.getReport = function (tabName, page) {
    if (page < 1) {
      $scope.allArrays[tabName] = null;
    }
    appService.get(urlMap.zhzzReport, {
      regionId: $scope.region.id,
      adminId: $scope.user.id,
      state: -1,
      page: page
    }, function (results) {
      $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      console.log('一键举报: ', results);
      var list = results.data, length = list.length, size = results.size,
        articles = $scope.allArrays[tabName] || []
        ;
      if (length < size) $scope.domore[tabName] = false;
      else {
        $timeout(function () {
          $scope.domore[tabName] = true;
        }, 200)
      }
      if (length > 0) {
        for (var i = 0; i < length; i++) {
          var item = list[i], article = {};
          article = item;
          article.summary = $('<div>' + item.content + '</div>').text().replace(/\s+/g, '').slice(0, 30);
          article.handleName = item.handleType ? '已处理' : '未处理';
          articles.push(article);
        }
      }
      $scope.allArrays[tabName] = articles;
    });
  }
  $scope.doRefresh = function () {
    $scope.queryArray($scope.tabName, 0);
  }
  $scope.onInfinite = function () {
    var n = $scope.tabName;
    if (!$scope.pageNext[n]) return;
    $scope.domore[n] = false;
    $scope.queryArray(n, ++$scope.pageNext[n]);
  }
  $scope.showDetial = function (b, item) {
    $scope.showDetials = b;
    if (b) {
      var delegate = $ionicScrollDelegate.$getByHandle('articlesDetailScroll');
      delegate.scrollTop();
      item.attachments = (item.imgUrl && item.imgUrl.split(',')) || (item.file && item.file.split(','));
      if (item.attachments && item.attachments.length) {
        var attach = [];
        for (var i = 0; i < item.attachments.length; i++) {
          var _type = thisfileType(item.attachments[i]);
          var _attach = _type == 1 ? $scope.pic + '/' + item.attachments[i] : $scope.vio + '/' + item.attachments[i];
          attach.push({
            type: _type,
            path: $sce.trustAsResourceUrl(_attach)
          })
        }
        item.attachments = attach;
      }
      $scope.detailItem = item;
      console.log(item)
    }
  }
  function thisfileType (fileName) {
    var picExt = ".jpg|.jpeg|.png|";
    var vioExt = ".mp4|.3gp|.avi|";
    if (!fileName) return null
    var extName = fileName.substring(fileName.lastIndexOf(".")).toLowerCase();//（把路径中的所有字母全部转换为小写）   
    /* 检查文件类型  */
    if (picExt.indexOf(extName + "|") != -1) return 1;
    if (vioExt.indexOf(extName + "|") != -1) return 2;
    $scope.alert("该文件类型不允许上传。");
    return 'error'
  }
  // 审核
  $scope.verifyFun = function (item, tabName) {
    var url;
    if (tabName == 'zhzzHandleDispatch') {
      url = urlMap.zhzzDispatch
    }
    if (tabName == 'zhzzHandleRailway') {
      url = urlMap.zhzzRailWay
    }
    if (tabName == 'zhzzHandleReport') {
      url = urlMap.zhzzReport
    }
    var data = item;
    var data = {
      id: data.id,
      verifyType: data.verifyType
    }
    data.verifyType = data.verifyType > 0 ? 0 : 1;
    appService.putData(url, data, function (result) {
      $scope.queryArray($scope.tabName, 0);
      if (result.code == 200) {
        $scope.detailItem.verifyType = data.verifyType;
        $scope.detailItem.verifyName = data.verifyType > 0 ? '已审核' : '未审核';
      } else {
        $scope.alert("信息审核! 请联系客服");
      }
    })
  }
  // 处理
  $scope.handleFun = function (item, tabName) {
    var url;
    if (tabName == 'zhzzHandleDispatch') {
      url = urlMap.zhzzDispatch
    }
    if (tabName == 'zhzzHandleRailway') {
      url = urlMap.zhzzRailWay
    }
    if (tabName == 'zhzzHandleReport') {
      url = urlMap.zhzzReport
    }
    var data = item;
    var data = {
      id: data.id,
      handleType: data.handleType
    }
    data.handleType = data.handleType > 0 ? 0 : 1;
    appService.putData(url, data, function (result) {
      $scope.queryArray($scope.tabName, 0);
      if (result.code == 200) {
        $scope.detailItem.handleType = data.handleType;
        $scope.detailItem.handleName = data.handleType > 0 ? '已处理' : '未处理';
      } else {
        $scope.alert("信息处理! 请联系客服");
      }
    })
  }
  $scope.alert = function (info, queryAgain, callback) {
    $ionicPopup.alert({
      title: '提示框',
      template: info
    }).then(function (res) {
      if (queryAgain)
        $scope.queryArray($scope.tabName, 0);
      callback && callback();
    });
  }
  /* $scope.replyMsg = function () {
    $scope.$emit('loginFirst', function () {
      var reply = $scope.detailItem.replyContent;
      $scope.$emit('loading', 'show');
      var data = {
        replyContent: reply,
        id: $scope.detailItem.id,
        replyUserName: $scope.user.userName
      },
        opts = {
          method: "post",
          url: urlMap.intelligentDHandleReplyMsg,
          params: data,
        }
      appService.queryData(opts,
        function (results) {
          $scope.$emit('loading', 'hide');
          if (results == true) {
            $scope.alert("回复成功", true);
          } else {
            $scope.alert("回复失败,请联系客服");
          }
        })
    })
  } */
  $scope.viewGoback = function () {
    if ($scope.showDetials) $scope.showDetials = false;
    else $rootScopeViewGoback();
  }
}
]);
