
angular.module("ngPublic", ['app_service', 'ionic'])
  /**
   * 请求初始化location json结构
   * 初始化当前定位
   */
  .directive("zhzzLocationNav", ['appService', '$rootScope', '$ionicScrollDelegate', '$timeout', '$ionicPopup', '$stateParams', function(appService, $rootScope, $ionicScrollDelegate, $timeout, $ionicPopup, $stateParams) {
    return {
      restrict: 'E',
      replace: true,
      scope: false,
      templateUrl: 'pages/zhzz/location-rootnav/index.html',
      link: function($scope, element, attrs) {
        function error() {
          $ionicPopup.alert({
            title: '提示框',
            template: '该地区暂未开放, 敬请期待!'
          }).then(function() {
            $scope.viewGoback()
          });
        }
        $scope.regionCode = $stateParams.regionCode || $scope.regionCode || $scope.publicCityId
        $scope.regionName = $stateParams.regionName || $scope.publicCityName
        if ($scope.regionCode.length < 6) {
          error();
          return
        }
        var lsLocation = JSON.parse(localStorage.getItem('perpetual.zhzz.location'));
        if (lsLocation && lsLocation.areaId != $scope.regionCode) {
          lsLocation = null
        }
        $scope.showLocationToCommunity = lsLocation && lsLocation.data.level > 3;
        $scope.activeDistrict = $scope.district = (lsLocation && lsLocation.data) || { id: $scope.regionCode, name: $scope.regionName, pDistrict: {} }; //当前激活的单个地区
        $scope.$watchGroup(['', 'province', 'city', 'dist', 'zhzzTown', 'zhzzVillage'], function(newVal, oldVal) {
          for (var i = 0; i < newVal.length; i++) {
            newVal[i] = newVal[i] || { name: '请选择' };
          }
          $scope.locationNav = newVal;//['省', '市', '区', '镇', '村'];
        });
        $scope.navList = []; //完整行政区列表4&5
        $scope.positionList; //页面显示行政区列表4|5
        //获取eladmin地区
        $scope.regionLevel3 = function(id, callback) {
          var data = {
            code: id,
            midArr: '0,1',
            state: 1
          }
          $scope.$emit('loading', 'show');
          appService.getData(urlMap.region, data,
            function(results) {
              $scope.$emit('loading', 'hide');
              if (!results || !results.data[0]) {
                error(); return
              };
              callback && callback(results.data[0])
            })
        }
        $scope.regionLevel4 = function(dist, callback) {
          var _townList = dist.children;
          var townList = [];
          for (var i = 0; i < _townList.length; i++) {
            var tobj = {
              id: _townList[i].id,
              name: _townList[i].name,
              pDistrict: $scope.dist,
              level: 4,
              hasSublevel: true
            }
            if (tobj.id == ($scope.district.pDistrict.id)) {
              $scope.selectItem(tobj, 'init');
            }
            townList.push(tobj);
          }
          callback && callback(townList);
        }
        $scope.regionLevel5 = function(pitem, callback) {
          var data = {
            pid: pitem.id,
            midArr: '0,1',
            state: 1
          }
          $scope.$emit('loading', 'show');
          appService.getData(urlMap.region, data,
            function(results) {
              $scope.$emit('loading', 'hide');
              if (!results || !results.data) return;
              console.log('5级社区: ', results.data);
              var _townList = results.data;
              var townList = [];
              for (var i = 0; i < _townList.length; i++) {
                var tobj = {
                  id: _townList[i].id,
                  name: _townList[i].name,
                  pDistrict: pitem,
                  level: 5,
                  hasSublevel: false
                }
                townList.push(tobj);
              }
              $scope.navList[5] = townList;
              $scope.positionList = townList;
              callback && callback()
            })
        }
        $scope.changesRank = function(i) {
          if ($scope.showLocationToCommunity) {
            $timeout(function() {
              var delegate = $ionicScrollDelegate.$getByHandle('comPositionNav');
              delegate && delegate.scrollTop();
            })
          }
          if (i == 4 && $scope.rank != i) {
            $rootScope.zhzzVillage = null;
            $scope.navList[5] = null;
            $scope.rank = i;
            $scope.activeDistrict = $rootScope.zhzzVillage || $rootScope.zhzzTown;
            $scope.positionList = $scope.navList[$scope.rank];
          }
        }
        $scope.selectItem = function(item, init) {
          if (!$scope.navList[3]) {
            $scope.regionLevel3($scope.regionCode, function(regionDist) {
              regionDist.level = 3;
              regionDist.hasSublevel = !!(regionDist.children && regionDist.children.length);
              $scope.navList[3] = [regionDist];
              if (!regionDist.hasSublevel) {
                $scope.submitPosition(regionDist)
                return;
              }
              $scope.showLocationToCommunity = true;
              $scope.navList[4] = [];
              $scope.regionLevel4(regionDist, function(townList) {
                $scope.navList[4] = townList;
                $scope.positionList = townList;
                if (!$scope.navList[4].length) {
                  $scope.rank = 3;
                  return;
                }
                $scope.rank = 4
              });
            });
            return;
          }
          if (!item.hasSublevel) {
            $scope.activeDistrict = item;
            $rootScope.zhzzVillage = item;
            $scope.submitPosition(item) //没有下一级, 即submit
            return;
          }
          $rootScope.zhzzTown = item;
          $scope.regionLevel5(item, function() {
            /* var theItemAll = {
              id: item.id,
              name: item.name,
              level: 4,
              pDistrict: item,
              hasSublevel: false,
              // theNameAll: '全' + item.name
              theNameAll: item.name
            } 
             $scope.positionList = $scope.navList[5] = [theItemAll].concat($scope.positionList);*/
            $scope.positionList = $scope.navList[5];
            $scope.rank = 5;
            if (init) {
              $scope.selectItem($scope.district);
            }
            if ($scope.showLocationToCommunity) {
              $timeout(function() {
                var delegate = $ionicScrollDelegate.$getByHandle('comPositionNav');
                delegate && delegate.scrollTop();
              })
            }
          });
        }
        $scope.submitPosition = function(item) {
          console.log('更换地区:', item);
          $timeout(function() {
            $scope.$emit('changeRegion', item, 'zhzz');
          });
          $scope.goback('close');
        }
        $scope.locationToCommunity = function(show) {
          $scope.showLocationToCommunity = show;
        }
        $scope.goback = function(isClose) {
          if (isClose) {
            $scope.locationToCommunity(false);
            return
          }
          if ($scope.district.level > 3) {
            $scope.selectItem($scope.district, 'init');
            $scope.locationToCommunity(false);
          }
          else $scope.viewGoback();
        }
        if (!$scope.navList[3] && $scope.stateName == 'zhzzHome') {
          $scope.selectItem($scope.district);
        }
      }
    }
  }])
  /**
   * 全导航初始化
   * @usage <nav-all-zhzz></nav-all-zhzz>
   */
  .directive("navAllZhzz", ['appService', '$rootScope', '$ionicScrollDelegate', '$state', '$ionicViewSwitcher', '$timeout', '$ionicPopup', function(appService, $rootScope, $ionicScrollDelegate, $state, $ionicViewSwitcher, $timeout, $ionicPopup) {
    return {
      restrict: 'E',
      replace: true,
      scope: false,
      template: '<section ng-if="stateName==\'zhzzHome\'" ng-class="{\'com-nav-scroll bar bar-clear content-44\':stateName!=\'zhzzHome\'}">' +
        '<ion-scroll direction="x" scrollbar-x="false">' +
        '<ul>' +
        '<li ng-repeat="(index, item) in navRoot" ng-click="showContent(index)">' +
        '<i class="iconzz-zhzz" ng-class="\'iconzz-zhzz\'+item.iconName"></i><span>{{item.name}}</span></li>' +
        '<li class="item-grow-empty" ng-if="stateName==\'zhzzHome\'"></li>' +
        '<li class="item-grow-empty" ng-if="stateName==\'zhzzHome\'"></li>' +
        '<li class="item-grow-empty" ng-if="stateName==\'zhzzHome\'"></li>' +
        '</ul>' +
        '</ion-scroll>' +
        '</section>',
      link: function($scope, element, attrs) {
        function error() {
          $ionicPopup.alert({
            title: '提示框',
            template: '该地区暂未开放, 敬请期待!'
          }).then(function() {
            $scope.viewGoback();
          });
        }
        $scope.$watch('district', function(n) {
          if (!n || !n.level) {
            return;
          }
          console.log('district:', n);
          $scope.showCommunityList = !(n.level > 4);
          $scope.districtForFuncList = n;
          $scope.queryNavRoot(function() {
            $timeout(function() {
              $scope.$parent.$broadcast('isOpen');
            });
            $scope.activeNavRootIndex = $scope.paramsActiveNavRootIndex || 0; //活动一级菜单index(父)
            $scope.paramsActiveNavRootIndex = null
          });
        }, true);
        $scope.queryNavRoot = function(callback) {
          $scope.navRoot = [{
            name: $scope.districtForFuncList.name
          }];
          function initRootNav(results) {
            $scope.navRoot = [];
            var list = results;
            for (var i = 0; i < list.length; i++) {
              $scope.navRoot.push({
                id: list[i].id,
                name: list[i].name,
                sort: list[i].sort == undefined ? i + 1 : list[i].sort,
                hasSubMenu: list[i].children && list[i].children.length,
                iconName: list[i].iconName
              });
            }
          }
          if ($rootScope.zhzzCache && $rootScope.zhzzCache[$scope.districtForFuncList.id]) {
            $timeout(function() {
              initRootNav($rootScope.zhzzCache[$scope.districtForFuncList.id]);
              callback && callback();
            })
            return;
          }
          appService.getData(urlMap.comArtMenus, {
            mid: 1,
            regionId: $scope.districtForFuncList.id,
            productId: 1,
            state: 1,
            pid: 0
          }, function(results) {
            console.log('root导航: ', results);
            if (!results.data || !results.data.length) {
              error();
              return;
            }
            $rootScope.zhzzCache = $rootScope.zhzzCache || {};
            $rootScope.zhzzCache[$scope.districtForFuncList.id] = results.data;
            initRootNav(results.data);
            callback && callback();
          });
        }
        $scope.nextDirectionEnter = function() {
          // if($scope.stateName == 'zhzz.funcList') $ionicViewSwitcher.nextDirection("enter");
        }
        $scope.showContent = function(index) {
          /* if ($scope.activeNavRootIndex>-1) {
            $scope.activeNavRootIndex = index;
            return;
          } */
          if ($scope.stateName == 'zhzzHome') {
            $state.go('zhzz', {
              communityList: $scope.positionList,
              activeNavRootIndex: index,
              regionCode: $scope.regionCode,
              regionName: $scope.regionName
            });
            $scope.nextDirectionEnter();
            return;
          }
          $scope.activeNavRootIndex = index;
        }
        $scope.goback = function(isClose) {
          $state.go()
        }
      }
    }
  }])
